/**
 * vis-network
 * https://visjs.github.io/vis-network/
 *
 * A dynamic, browser-based visualization library.
 *
 * @version 7.6.9
 * @date    2020-05-20T21:19:12.766Z
 *
 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
 *
 * @license
 * vis.js is dual licensed under both
 *
 *   1. The Apache 2.0 License
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *   and
 *
 *   2. The MIT License
 *      http://opensource.org/licenses/MIT
 *
 * vis.js may be distributed under either license.
 */
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?e(exports):"function"==typeof define&&define.amd?define(["exports"],e):e((t=t||self).vis=t.vis||{})}(this,(function(t){"use strict";var e="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:"undefined"!=typeof global?global:"undefined"!=typeof self?self:{};function i(){throw new Error("Dynamic requires are not currently supported by rollup-plugin-commonjs")}function n(t){return t&&t.__esModule&&Object.prototype.hasOwnProperty.call(t,"default")?t.default:t}function o(t,e){return t(e={exports:{}},e.exports),e.exports}var r=function(t){return t&&t.Math==Math&&t},s=r("object"==typeof globalThis&&globalThis)||r("object"==typeof window&&window)||r("object"==typeof self&&self)||r("object"==typeof e&&e)||Function("return this")(),a=function(t){try{return!!t()}catch(t){return!0}},h=!a((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),l={}.propertyIsEnumerable,d=Object.getOwnPropertyDescriptor,u={f:d&&!l.call({1:2},1)?function(t){var e=d(this,t);return!!e&&e.enumerable}:l},c=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},f={}.toString,p=function(t){return f.call(t).slice(8,-1)},v="".split,g=a((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==p(t)?v.call(t,""):Object(t)}:Object,y=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},m=function(t){return g(y(t))},b=function(t){return"object"==typeof t?null!==t:"function"==typeof t},w=function(t,e){if(!b(t))return t;var i,n;if(e&&"function"==typeof(i=t.toString)&&!b(n=i.call(t)))return n;if("function"==typeof(i=t.valueOf)&&!b(n=i.call(t)))return n;if(!e&&"function"==typeof(i=t.toString)&&!b(n=i.call(t)))return n;throw TypeError("Can't convert object to primitive value")},_={}.hasOwnProperty,k=function(t,e){return _.call(t,e)},x=s.document,O=b(x)&&b(x.createElement),S=function(t){return O?x.createElement(t):{}},E=!h&&!a((function(){return 7!=Object.defineProperty(S("div"),"a",{get:function(){return 7}}).a})),D=Object.getOwnPropertyDescriptor,M={f:h?D:function(t,e){if(t=m(t),e=w(e,!0),E)try{return D(t,e)}catch(t){}if(k(t,e))return c(!u.f.call(t,e),t[e])}},C=/#|\.prototype\./,T=function(t,e){var i=N[P(t)];return i==A||i!=I&&("function"==typeof e?a(e):!!e)},P=T.normalize=function(t){return String(t).replace(C,".").toLowerCase()},N=T.data={},I=T.NATIVE="N",A=T.POLYFILL="P",F=T,j={},z=function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function");return t},B=function(t,e,i){if(z(t),void 0===e)return t;switch(i){case 0:return function(){return t.call(e)};case 1:return function(i){return t.call(e,i)};case 2:return function(i,n){return t.call(e,i,n)};case 3:return function(i,n,o){return t.call(e,i,n,o)}}return function(){return t.apply(e,arguments)}},R=function(t){if(!b(t))throw TypeError(String(t)+" is not an object");return t},L=Object.defineProperty,H={f:h?L:function(t,e,i){if(R(t),e=w(e,!0),R(i),E)try{return L(t,e,i)}catch(t){}if("get"in i||"set"in i)throw TypeError("Accessors not supported");return"value"in i&&(t[e]=i.value),t}},W=h?function(t,e,i){return H.f(t,e,c(1,i))}:function(t,e,i){return t[e]=i,t},Y=M.f,V=function(t){var e=function(e,i,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,i)}return new t(e,i,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},U=function(t,e){var i,n,o,r,a,h,l,d,u=t.target,c=t.global,f=t.stat,p=t.proto,v=c?s:f?s[u]:(s[u]||{}).prototype,g=c?j:j[u]||(j[u]={}),y=g.prototype;for(o in e)i=!F(c?o:u+(f?".":"#")+o,t.forced)&&v&&k(v,o),a=g[o],i&&(h=t.noTargetGet?(d=Y(v,o))&&d.value:v[o]),r=i&&h?h:e[o],i&&typeof a==typeof r||(l=t.bind&&i?B(r,s):t.wrap&&i?V(r):p&&"function"==typeof r?B(Function.call,r):r,(t.sham||r&&r.sham||a&&a.sham)&&W(l,"sham",!0),g[o]=l,p&&(k(j,n=u+"Prototype")||W(j,n,{}),j[n][o]=r,t.real&&y&&!y[o]&&W(y,o,r)))},G=[].slice,q={},X=function(t,e,i){if(!(e in q)){for(var n=[],o=0;o<e;o++)n[o]="a["+o+"]";q[e]=Function("C,a","return new C("+n.join(",")+")")}return q[e](t,i)},$=Function.bind||function(t){var e=z(this),i=G.call(arguments,1),n=function(){var o=i.concat(G.call(arguments));return this instanceof n?X(e,o.length,o):e.apply(t,o)};return b(e.prototype)&&(n.prototype=e.prototype),n};U({target:"Function",proto:!0},{bind:$});var K=function(t){return j[t+"Prototype"]},Z=K("Function").bind,Q=Function.prototype,J=function(t){var e=t.bind;return t===Q||t instanceof Function&&e===Q.bind?Z:e};function tt(t,e,i,n){t.beginPath(),t.arc(e,i,n,0,2*Math.PI,!1),t.closePath()}function et(t,e,i,n,o,r){var s=Math.PI/180;n-2*r<0&&(r=n/2),o-2*r<0&&(r=o/2),t.beginPath(),t.moveTo(e+r,i),t.lineTo(e+n-r,i),t.arc(e+n-r,i+r,r,270*s,360*s,!1),t.lineTo(e+n,i+o-r),t.arc(e+n-r,i+o-r,r,0,90*s,!1),t.lineTo(e+r,i+o),t.arc(e+r,i+o-r,r,90*s,180*s,!1),t.lineTo(e,i+r),t.arc(e+r,i+r,r,180*s,270*s,!1),t.closePath()}function it(t,e,i,n,o){var r=n/2*.5522848,s=o/2*.5522848,a=e+n,h=i+o,l=e+n/2,d=i+o/2;t.beginPath(),t.moveTo(e,d),t.bezierCurveTo(e,d-s,l-r,i,l,i),t.bezierCurveTo(l+r,i,a,d-s,a,d),t.bezierCurveTo(a,d+s,l+r,h,l,h),t.bezierCurveTo(l-r,h,e,d+s,e,d),t.closePath()}function nt(t,e,i,n,o){var r=o*(1/3),s=n/2*.5522848,a=r/2*.5522848,h=e+n,l=i+r,d=e+n/2,u=i+r/2,c=i+(o-r/2),f=i+o;t.beginPath(),t.moveTo(h,u),t.bezierCurveTo(h,u+a,d+s,l,d,l),t.bezierCurveTo(d-s,l,e,u+a,e,u),t.bezierCurveTo(e,u-a,d-s,i,d,i),t.bezierCurveTo(d+s,i,h,u-a,h,u),t.lineTo(h,c),t.bezierCurveTo(h,c+a,d+s,f,d,f),t.bezierCurveTo(d-s,f,e,c+a,e,c),t.lineTo(e,u)}function ot(t,e,i,n,o,r){t.beginPath(),t.moveTo(e,i);for(var s=r.length,a=n-e,h=o-i,l=h/a,d=Math.sqrt(a*a+h*h),u=0,c=!0,f=0,p=+r[0];d>=.1;)(p=+r[u++%s])>d&&(p=d),f=Math.sqrt(p*p/(1+l*l)),e+=f=a<0?-f:f,i+=l*f,!0===c?t.lineTo(e,i):t.moveTo(e,i),d-=p,c=!c}var rt={circle:tt,dashedLine:ot,database:nt,diamond:function(t,e,i,n){t.beginPath(),t.lineTo(e,i+n),t.lineTo(e+n,i),t.lineTo(e,i-n),t.lineTo(e-n,i),t.closePath()},ellipse:it,ellipse_vis:it,hexagon:function(t,e,i,n){t.beginPath();var o=2*Math.PI/6;t.moveTo(e+n,i);for(var r=1;r<6;r++)t.lineTo(e+n*Math.cos(o*r),i+n*Math.sin(o*r));t.closePath()},roundRect:et,square:function(t,e,i,n){t.beginPath(),t.rect(e-n,i-n,2*n,2*n),t.closePath()},star:function(t,e,i,n){t.beginPath(),i+=.1*(n*=.82);for(var o=0;o<10;o++){var r=o%2==0?1.3*n:.5*n;t.lineTo(e+r*Math.sin(2*o*Math.PI/10),i-r*Math.cos(2*o*Math.PI/10))}t.closePath()},triangle:function(t,e,i,n){t.beginPath(),i+=.275*(n*=1.15);var o=2*n,r=o/2,s=Math.sqrt(3)/6*o,a=Math.sqrt(o*o-r*r);t.moveTo(e,i-(a-s)),t.lineTo(e+r,i+s),t.lineTo(e-r,i+s),t.lineTo(e,i-(a-s)),t.closePath()},triangleDown:function(t,e,i,n){t.beginPath(),i-=.275*(n*=1.15);var o=2*n,r=o/2,s=Math.sqrt(3)/6*o,a=Math.sqrt(o*o-r*r);t.moveTo(e,i+(a-s)),t.lineTo(e+r,i-s),t.lineTo(e-r,i-s),t.lineTo(e,i+(a-s)),t.closePath()}};var st=o((function(t){function e(t){if(t)return function(t){for(var i in e.prototype)t[i]=e.prototype[i];return t}(t)}t.exports=e,e.prototype.on=e.prototype.addEventListener=function(t,e){return this._callbacks=this._callbacks||{},(this._callbacks["$"+t]=this._callbacks["$"+t]||[]).push(e),this},e.prototype.once=function(t,e){function i(){this.off(t,i),e.apply(this,arguments)}return i.fn=e,this.on(t,i),this},e.prototype.off=e.prototype.removeListener=e.prototype.removeAllListeners=e.prototype.removeEventListener=function(t,e){if(this._callbacks=this._callbacks||{},0==arguments.length)return this._callbacks={},this;var i,n=this._callbacks["$"+t];if(!n)return this;if(1==arguments.length)return delete this._callbacks["$"+t],this;for(var o=0;o<n.length;o++)if((i=n[o])===e||i.fn===e){n.splice(o,1);break}return 0===n.length&&delete this._callbacks["$"+t],this},e.prototype.emit=function(t){this._callbacks=this._callbacks||{};for(var e=new Array(arguments.length-1),i=this._callbacks["$"+t],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(i){n=0;for(var o=(i=i.slice(0)).length;n<o;++n)i[n].apply(this,e)}return this},e.prototype.listeners=function(t){return this._callbacks=this._callbacks||{},this._callbacks["$"+t]||[]},e.prototype.hasListeners=function(t){return!!this.listeners(t).length}})),at={},ht=s["__core-js_shared__"]||function(t,e){try{W(s,t,e)}catch(i){s[t]=e}return e}("__core-js_shared__",{}),lt=Function.toString;"function"!=typeof ht.inspectSource&&(ht.inspectSource=function(t){return lt.call(t)});var dt,ut,ct,ft=ht.inspectSource,pt=s.WeakMap,vt="function"==typeof pt&&/native code/.test(ft(pt)),gt=o((function(t){(t.exports=function(t,e){return ht[t]||(ht[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),yt=0,mt=Math.random(),bt=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++yt+mt).toString(36)},wt=gt("keys"),_t=function(t){return wt[t]||(wt[t]=bt(t))},kt={},xt=s.WeakMap;if(vt){var Ot=new xt,St=Ot.get,Et=Ot.has,Dt=Ot.set;dt=function(t,e){return Dt.call(Ot,t,e),e},ut=function(t){return St.call(Ot,t)||{}},ct=function(t){return Et.call(Ot,t)}}else{var Mt=_t("state");kt[Mt]=!0,dt=function(t,e){return W(t,Mt,e),e},ut=function(t){return k(t,Mt)?t[Mt]:{}},ct=function(t){return k(t,Mt)}}var Ct,Tt,Pt,Nt={set:dt,get:ut,has:ct,enforce:function(t){return ct(t)?ut(t):dt(t,{})},getterFor:function(t){return function(e){var i;if(!b(e)||(i=ut(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return i}}},It=function(t){return Object(y(t))},At=!a((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),Ft=_t("IE_PROTO"),jt=Object.prototype,zt=At?Object.getPrototypeOf:function(t){return t=It(t),k(t,Ft)?t[Ft]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?jt:null},Bt=!!Object.getOwnPropertySymbols&&!a((function(){return!String(Symbol())})),Rt=Bt&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Lt=gt("wks"),Ht=s.Symbol,Wt=Rt?Ht:Ht&&Ht.withoutSetter||bt,Yt=function(t){return k(Lt,t)||(Bt&&k(Ht,t)?Lt[t]=Ht[t]:Lt[t]=Wt("Symbol."+t)),Lt[t]},Vt=(Yt("iterator"),!1);[].keys&&("next"in(Pt=[].keys())?(Tt=zt(zt(Pt)))!==Object.prototype&&(Ct=Tt):Vt=!0),null==Ct&&(Ct={});var Ut,Gt={IteratorPrototype:Ct,BUGGY_SAFARI_ITERATORS:Vt},qt=Math.ceil,Xt=Math.floor,$t=function(t){return isNaN(t=+t)?0:(t>0?Xt:qt)(t)},Kt=Math.min,Zt=function(t){return t>0?Kt($t(t),9007199254740991):0},Qt=Math.max,Jt=Math.min,te=function(t,e){var i=$t(t);return i<0?Qt(i+e,0):Jt(i,e)},ee=function(t){return function(e,i,n){var o,r=m(e),s=Zt(r.length),a=te(n,s);if(t&&i!=i){for(;s>a;)if((o=r[a++])!=o)return!0}else for(;s>a;a++)if((t||a in r)&&r[a]===i)return t||a||0;return!t&&-1}},ie={includes:ee(!0),indexOf:ee(!1)},ne=ie.indexOf,oe=function(t,e){var i,n=m(t),o=0,r=[];for(i in n)!k(kt,i)&&k(n,i)&&r.push(i);for(;e.length>o;)k(n,i=e[o++])&&(~ne(r,i)||r.push(i));return r},re=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],se=Object.keys||function(t){return oe(t,re)},ae=h?Object.defineProperties:function(t,e){R(t);for(var i,n=se(e),o=n.length,r=0;o>r;)H.f(t,i=n[r++],e[i]);return t},he=function(t){return"function"==typeof t?t:void 0},le=function(t,e){return arguments.length<2?he(j[t])||he(s[t]):j[t]&&j[t][e]||s[t]&&s[t][e]},de=le("document","documentElement"),ue=_t("IE_PROTO"),ce=function(){},fe=function(t){return"<script>"+t+"<\/script>"},pe=function(){try{Ut=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;pe=Ut?function(t){t.write(fe("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Ut):((e=S("iframe")).style.display="none",de.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(fe("document.F=Object")),t.close(),t.F);for(var i=re.length;i--;)delete pe.prototype[re[i]];return pe()};kt[ue]=!0;var ve=Object.create||function(t,e){var i;return null!==t?(ce.prototype=R(t),i=new ce,ce.prototype=null,i[ue]=t):i=pe(),void 0===e?i:ae(i,e)},ge={};ge[Yt("toStringTag")]="z";var ye="[object z]"===String(ge),me=Yt("toStringTag"),be="Arguments"==p(function(){return arguments}()),we=ye?p:function(t){var e,i,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),me))?i:be?p(e):"Object"==(n=p(e))&&"function"==typeof e.callee?"Arguments":n},_e=ye?{}.toString:function(){return"[object "+we(this)+"]"},ke=H.f,xe=Yt("toStringTag"),Oe=function(t,e,i,n){if(t){var o=i?t:t.prototype;k(o,xe)||ke(o,xe,{configurable:!0,value:e}),n&&!ye&&W(o,"toString",_e)}},Se=Gt.IteratorPrototype,Ee=function(){return this},De=Object.setPrototypeOf||("__proto__"in{}?function(){var t,e=!1,i={};try{(t=Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set).call(i,[]),e=i instanceof Array}catch(t){}return function(i,n){return R(i),function(t){if(!b(t)&&null!==t)throw TypeError("Can't set "+String(t)+" as a prototype")}(n),e?t.call(i,n):i.__proto__=n,i}}():void 0),Me=function(t,e,i,n){n&&n.enumerable?t[e]=i:W(t,e,i)},Ce=Gt.IteratorPrototype,Te=Gt.BUGGY_SAFARI_ITERATORS,Pe=Yt("iterator"),Ne=function(){return this},Ie=function(t,e,i,n,o,r,s){!function(t,e,i){var n=e+" Iterator";t.prototype=ve(Se,{next:c(1,i)}),Oe(t,n,!1,!0),at[n]=Ee}(i,e,n);var a,h,l,d=function(t){if(t===o&&g)return g;if(!Te&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new i(this,t)}}return function(){return new i(this)}},u=e+" Iterator",f=!1,p=t.prototype,v=p[Pe]||p["@@iterator"]||o&&p[o],g=!Te&&v||d(o),y="Array"==e&&p.entries||v;if(y&&(a=zt(y.call(new t)),Ce!==Object.prototype&&a.next&&(Oe(a,u,!0,!0),at[u]=Ne)),"values"==o&&v&&"values"!==v.name&&(f=!0,g=function(){return v.call(this)}),s&&p[Pe]!==g&&W(p,Pe,g),at[e]=g,o)if(h={values:d("values"),keys:r?g:d("keys"),entries:d("entries")},s)for(l in h)!Te&&!f&&l in p||Me(p,l,h[l]);else U({target:e,proto:!0,forced:Te||f},h);return h},Ae=Nt.set,Fe=Nt.getterFor("Array Iterator");Ie(Array,"Array",(function(t,e){Ae(this,{type:"Array Iterator",target:m(t),index:0,kind:e})}),(function(){var t=Fe(this),e=t.target,i=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==i?{value:n,done:!1}:"values"==i?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values");at.Arguments=at.Array;var je=Yt("toStringTag");for(var ze in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Be=s[ze],Re=Be&&Be.prototype;Re&&we(Re)!==je&&W(Re,je,ze),at[ze]=at.Array}var Le=function(t){return function(e,i){var n,o,r=String(y(e)),s=$t(i),a=r.length;return s<0||s>=a?t?"":void 0:(n=r.charCodeAt(s))<55296||n>56319||s+1===a||(o=r.charCodeAt(s+1))<56320||o>57343?t?r.charAt(s):n:t?r.slice(s,s+2):o-56320+(n-55296<<10)+65536}},He={codeAt:Le(!1),charAt:Le(!0)}.charAt,We=Nt.set,Ye=Nt.getterFor("String Iterator");Ie(String,"String",(function(t){We(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=Ye(this),i=e.string,n=e.index;return n>=i.length?{value:void 0,done:!0}:(t=He(i,n),e.index+=t.length,{value:t,done:!1})}));var Ve,Ue,Ge=Yt("iterator"),qe=function(t){if(null!=t)return t[Ge]||t["@@iterator"]||at[we(t)]},Xe=function(t){var e=qe(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return R(e.call(t))},$e=qe,Ke=Array.isArray||function(t){return"Array"==p(t)},Ze=function(t,e,i){var n=w(e);n in t?H.f(t,n,c(0,i)):t[n]=i},Qe=Yt("species"),Je=function(t,e){var i;return Ke(t)&&("function"!=typeof(i=t.constructor)||i!==Array&&!Ke(i.prototype)?b(i)&&null===(i=i[Qe])&&(i=void 0):i=void 0),new(void 0===i?Array:i)(0===e?0:e)},ti=le("navigator","userAgent")||"",ei=s.process,ii=ei&&ei.versions,ni=ii&&ii.v8;ni?Ue=(Ve=ni.split("."))[0]+Ve[1]:ti&&(!(Ve=ti.match(/Edge\/(\d+)/))||Ve[1]>=74)&&(Ve=ti.match(/Chrome\/(\d+)/))&&(Ue=Ve[1]);var oi=Ue&&+Ue,ri=Yt("species"),si=function(t){return oi>=51||!a((function(){var e=[];return(e.constructor={})[ri]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},ai=Yt("isConcatSpreadable"),hi=oi>=51||!a((function(){var t=[];return t[ai]=!1,t.concat()[0]!==t})),li=si("concat"),di=function(t){if(!b(t))return!1;var e=t[ai];return void 0!==e?!!e:Ke(t)};U({target:"Array",proto:!0,forced:!hi||!li},{concat:function(t){var e,i,n,o,r,s=It(this),a=Je(s,0),h=0;for(e=-1,n=arguments.length;e<n;e++)if(r=-1===e?s:arguments[e],di(r)){if(h+(o=Zt(r.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(i=0;i<o;i++,h++)i in r&&Ze(a,h,r[i])}else{if(h>=9007199254740991)throw TypeError("Maximum allowed index exceeded");Ze(a,h++,r)}return a.length=h,a}});var ui=re.concat("length","prototype"),ci={f:Object.getOwnPropertyNames||function(t){return oe(t,ui)}},fi=ci.f,pi={}.toString,vi="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],gi={f:function(t){return vi&&"[object Window]"==pi.call(t)?function(t){try{return fi(t)}catch(t){return vi.slice()}}(t):fi(m(t))}},yi={f:Object.getOwnPropertySymbols},mi={f:Yt},bi=H.f,wi=function(t){var e=j.Symbol||(j.Symbol={});k(e,t)||bi(e,t,{value:mi.f(t)})},_i=[].push,ki=function(t){var e=1==t,i=2==t,n=3==t,o=4==t,r=6==t,s=5==t||r;return function(a,h,l,d){for(var u,c,f=It(a),p=g(f),v=B(h,l,3),y=Zt(p.length),m=0,b=d||Je,w=e?b(a,y):i?b(a,0):void 0;y>m;m++)if((s||m in p)&&(c=v(u=p[m],m,f),t))if(e)w[m]=c;else if(c)switch(t){case 3:return!0;case 5:return u;case 6:return m;case 2:_i.call(w,u)}else if(o)return!1;return r?-1:n||o?o:w}},xi={forEach:ki(0),map:ki(1),filter:ki(2),some:ki(3),every:ki(4),find:ki(5),findIndex:ki(6)},Oi=xi.forEach,Si=_t("hidden"),Ei=Yt("toPrimitive"),Di=Nt.set,Mi=Nt.getterFor("Symbol"),Ci=Object.prototype,Ti=s.Symbol,Pi=le("JSON","stringify"),Ni=M.f,Ii=H.f,Ai=gi.f,Fi=u.f,ji=gt("symbols"),zi=gt("op-symbols"),Bi=gt("string-to-symbol-registry"),Ri=gt("symbol-to-string-registry"),Li=gt("wks"),Hi=s.QObject,Wi=!Hi||!Hi.prototype||!Hi.prototype.findChild,Yi=h&&a((function(){return 7!=ve(Ii({},"a",{get:function(){return Ii(this,"a",{value:7}).a}})).a}))?function(t,e,i){var n=Ni(Ci,e);n&&delete Ci[e],Ii(t,e,i),n&&t!==Ci&&Ii(Ci,e,n)}:Ii,Vi=function(t,e){var i=ji[t]=ve(Ti.prototype);return Di(i,{type:"Symbol",tag:t,description:e}),h||(i.description=e),i},Ui=Rt?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof Ti},Gi=function(t,e,i){t===Ci&&Gi(zi,e,i),R(t);var n=w(e,!0);return R(i),k(ji,n)?(i.enumerable?(k(t,Si)&&t[Si][n]&&(t[Si][n]=!1),i=ve(i,{enumerable:c(0,!1)})):(k(t,Si)||Ii(t,Si,c(1,{})),t[Si][n]=!0),Yi(t,n,i)):Ii(t,n,i)},qi=function(t,e){R(t);var i=m(e),n=se(i).concat(Zi(i));return Oi(n,(function(e){h&&!Xi.call(i,e)||Gi(t,e,i[e])})),t},Xi=function(t){var e=w(t,!0),i=Fi.call(this,e);return!(this===Ci&&k(ji,e)&&!k(zi,e))&&(!(i||!k(this,e)||!k(ji,e)||k(this,Si)&&this[Si][e])||i)},$i=function(t,e){var i=m(t),n=w(e,!0);if(i!==Ci||!k(ji,n)||k(zi,n)){var o=Ni(i,n);return!o||!k(ji,n)||k(i,Si)&&i[Si][n]||(o.enumerable=!0),o}},Ki=function(t){var e=Ai(m(t)),i=[];return Oi(e,(function(t){k(ji,t)||k(kt,t)||i.push(t)})),i},Zi=function(t){var e=t===Ci,i=Ai(e?zi:m(t)),n=[];return Oi(i,(function(t){!k(ji,t)||e&&!k(Ci,t)||n.push(ji[t])})),n};if(Bt||(Me((Ti=function(){if(this instanceof Ti)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=bt(t),i=function(t){this===Ci&&i.call(zi,t),k(this,Si)&&k(this[Si],e)&&(this[Si][e]=!1),Yi(this,e,c(1,t))};return h&&Wi&&Yi(Ci,e,{configurable:!0,set:i}),Vi(e,t)}).prototype,"toString",(function(){return Mi(this).tag})),Me(Ti,"withoutSetter",(function(t){return Vi(bt(t),t)})),u.f=Xi,H.f=Gi,M.f=$i,ci.f=gi.f=Ki,yi.f=Zi,mi.f=function(t){return Vi(Yt(t),t)},h&&Ii(Ti.prototype,"description",{configurable:!0,get:function(){return Mi(this).description}})),U({global:!0,wrap:!0,forced:!Bt,sham:!Bt},{Symbol:Ti}),Oi(se(Li),(function(t){wi(t)})),U({target:"Symbol",stat:!0,forced:!Bt},{for:function(t){var e=String(t);if(k(Bi,e))return Bi[e];var i=Ti(e);return Bi[e]=i,Ri[i]=e,i},keyFor:function(t){if(!Ui(t))throw TypeError(t+" is not a symbol");if(k(Ri,t))return Ri[t]},useSetter:function(){Wi=!0},useSimple:function(){Wi=!1}}),U({target:"Object",stat:!0,forced:!Bt,sham:!h},{create:function(t,e){return void 0===e?ve(t):qi(ve(t),e)},defineProperty:Gi,defineProperties:qi,getOwnPropertyDescriptor:$i}),U({target:"Object",stat:!0,forced:!Bt},{getOwnPropertyNames:Ki,getOwnPropertySymbols:Zi}),U({target:"Object",stat:!0,forced:a((function(){yi.f(1)}))},{getOwnPropertySymbols:function(t){return yi.f(It(t))}}),Pi){var Qi=!Bt||a((function(){var t=Ti();return"[null]"!=Pi([t])||"{}"!=Pi({a:t})||"{}"!=Pi(Object(t))}));U({target:"JSON",stat:!0,forced:Qi},{stringify:function(t,e,i){for(var n,o=[t],r=1;arguments.length>r;)o.push(arguments[r++]);if(n=e,(b(e)||void 0!==t)&&!Ui(t))return Ke(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Ui(e))return e}),o[1]=e,Pi.apply(null,o)}})}Ti.prototype[Ei]||W(Ti.prototype,Ei,Ti.prototype.valueOf),Oe(Ti,"Symbol"),kt[Si]=!0,wi("asyncIterator"),wi("hasInstance"),wi("isConcatSpreadable"),wi("iterator"),wi("match"),wi("matchAll"),wi("replace"),wi("search"),wi("species"),wi("split"),wi("toPrimitive"),wi("toStringTag"),wi("unscopables"),Oe(Math,"Math",!0),Oe(s.JSON,"JSON",!0);var Ji=j.Symbol,tn=Ji,en=function(t,e,i,n){try{return n?e(R(i)[0],i[1]):e(i)}catch(e){var o=t.return;throw void 0!==o&&R(o.call(t)),e}},nn=Yt("iterator"),on=Array.prototype,rn=function(t){return void 0!==t&&(at.Array===t||on[nn]===t)},sn=Yt("iterator"),an=!1;try{var hn=0,ln={next:function(){return{done:!!hn++}},return:function(){an=!0}};ln[sn]=function(){return this},Array.from(ln,(function(){throw 2}))}catch(t){}var dn=!function(t,e){if(!e&&!an)return!1;var i=!1;try{var n={};n[sn]=function(){return{next:function(){return{done:i=!0}}}},t(n)}catch(t){}return i}((function(t){Array.from(t)}));U({target:"Array",stat:!0,forced:dn},{from:function(t){var e,i,n,o,r,s,a=It(t),h="function"==typeof this?this:Array,l=arguments.length,d=l>1?arguments[1]:void 0,u=void 0!==d,c=qe(a),f=0;if(u&&(d=B(d,l>2?arguments[2]:void 0,2)),null==c||h==Array&&rn(c))for(i=new h(e=Zt(a.length));e>f;f++)s=u?d(a[f],f):a[f],Ze(i,f,s);else for(r=(o=c.call(a)).next,i=new h;!(n=r.call(o)).done;f++)s=u?en(o,d,[n.value,f],!0):n.value,Ze(i,f,s);return i.length=f,i}});var un=j.Array.from,cn=un;U({target:"Object",stat:!0,forced:!h,sham:!h},{defineProperty:H.f});var fn=o((function(t){var e=j.Object,i=t.exports=function(t,i,n){return e.defineProperty(t,i,n)};e.defineProperty.sham&&(i.sham=!0)})),pn=fn;U({target:"Object",stat:!0,forced:!h,sham:!h},{defineProperties:ae});var vn=o((function(t){var e=j.Object,i=t.exports=function(t,i){return e.defineProperties(t,i)};e.defineProperties.sham&&(i.sham=!0)})),gn=le("Reflect","ownKeys")||function(t){var e=ci.f(R(t)),i=yi.f;return i?e.concat(i(t)):e};U({target:"Object",stat:!0,sham:!h},{getOwnPropertyDescriptors:function(t){for(var e,i,n=m(t),o=M.f,r=gn(n),s={},a=0;r.length>a;)void 0!==(i=o(n,e=r[a++]))&&Ze(s,e,i);return s}});var yn=j.Object.getOwnPropertyDescriptors,mn=M.f,bn=a((function(){mn(1)}));U({target:"Object",stat:!0,forced:!h||bn,sham:!h},{getOwnPropertyDescriptor:function(t,e){return mn(m(t),e)}});var wn=o((function(t){var e=j.Object,i=t.exports=function(t,i){return e.getOwnPropertyDescriptor(t,i)};e.getOwnPropertyDescriptor.sham&&(i.sham=!0)})),_n=wn,kn=j.Object.getOwnPropertySymbols;U({target:"Object",stat:!0,sham:!h},{create:ve});var xn=j.Object,On=function(t,e){return xn.create(t,e)},Sn=On,En=fn;var Dn=function(t,e,i){return e in t?En(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t},Mn=a((function(){se(1)}));U({target:"Object",stat:!0,forced:Mn},{keys:function(t){return se(It(t))}});var Cn,Tn=j.Object.keys,Pn="\t\n\v\f\r                　\u2028\u2029\ufeff",Nn="["+Pn+"]",In=RegExp("^"+Nn+Nn+"*"),An=RegExp(Nn+Nn+"*$"),Fn=function(t){return function(e){var i=String(y(e));return 1&t&&(i=i.replace(In,"")),2&t&&(i=i.replace(An,"")),i}},jn={start:Fn(1),end:Fn(2),trim:Fn(3)},zn=jn.trim;U({target:"String",proto:!0,forced:(Cn="trim",a((function(){return!!Pn[Cn]()||"​᠎"!="​᠎"[Cn]()||Pn[Cn].name!==Cn})))},{trim:function(){return zn(this)}});var Bn=K("String").trim,Rn=String.prototype,Ln=function(t){var e=t.trim;return"string"==typeof t||t===Rn||t instanceof String&&e===Rn.trim?Bn:e},Hn=function(t,e){var i=[][t];return!!i&&a((function(){i.call(null,e||function(){throw 1},1)}))},Wn=Object.defineProperty,Yn={},Vn=function(t){throw t},Un=function(t,e){if(k(Yn,t))return Yn[t];e||(e={});var i=[][t],n=!!k(e,"ACCESSORS")&&e.ACCESSORS,o=k(e,0)?e[0]:Vn,r=k(e,1)?e[1]:void 0;return Yn[t]=!!i&&!a((function(){if(n&&!h)return!0;var t={length:-1};n?Wn(t,1,{enumerable:!0,get:Vn}):t[1]=1,i.call(t,o,r)}))},Gn=xi.forEach,qn=Hn("forEach"),Xn=Un("forEach"),$n=qn&&Xn?[].forEach:function(t){return Gn(this,t,arguments.length>1?arguments[1]:void 0)};U({target:"Array",proto:!0,forced:[].forEach!=$n},{forEach:$n});var Kn=K("Array").forEach,Zn=Array.prototype,Qn={DOMTokenList:!0,NodeList:!0},Jn=function(t){var e=t.forEach;return t===Zn||t instanceof Array&&e===Zn.forEach||Qn.hasOwnProperty(we(t))?Kn:e},to=xi.map,eo=si("map"),io=Un("map");U({target:"Array",proto:!0,forced:!eo||!io},{map:function(t){return to(this,t,arguments.length>1?arguments[1]:void 0)}});var no=K("Array").map,oo=Array.prototype,ro=function(t){var e=t.map;return t===oo||t instanceof Array&&e===oo.map?no:e},so=jn.trim,ao=s.parseInt,ho=/^[+-]?0[Xx]/,lo=8!==ao(Pn+"08")||22!==ao(Pn+"0x16")?function(t,e){var i=so(String(t));return ao(i,e>>>0||(ho.test(i)?16:10))}:ao;U({global:!0,forced:parseInt!=lo},{parseInt:lo});var uo=j.parseInt,co=u.f,fo=function(t){return function(e){for(var i,n=m(e),o=se(n),r=o.length,s=0,a=[];r>s;)i=o[s++],h&&!co.call(n,i)||a.push(t?[i,n[i]]:n[i]);return a}},po={entries:fo(!0),values:fo(!1)}.values;U({target:"Object",stat:!0},{values:function(t){return po(t)}});var vo=j.Object.values,go=xi.filter,yo=si("filter"),mo=Un("filter");U({target:"Array",proto:!0,forced:!yo||!mo},{filter:function(t){return go(this,t,arguments.length>1?arguments[1]:void 0)}});var bo=K("Array").filter,wo=Array.prototype,_o=function(t){var e=t.filter;return t===wo||t instanceof Array&&e===wo.filter?bo:e},ko=K("Array").concat,xo=Array.prototype,Oo=function(t){var e=t.concat;return t===xo||t instanceof Array&&e===xo.concat?ko:e};U({target:"Array",stat:!0},{isArray:Ke});var So=j.Array.isArray,Eo=So;var Do=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n};var Mo=function(t){if(Eo(t))return Do(t)},Co=un,To=Yt("iterator"),Po=function(t){var e=Object(t);return void 0!==e[To]||"@@iterator"in e||at.hasOwnProperty(we(e))};wi("asyncDispose"),wi("dispose"),wi("observable"),wi("patternMatch"),wi("replaceAll");var No=Ji;var Io=function(t){if(void 0!==No&&Po(Object(t)))return Co(t)},Ao=si("slice"),Fo=Un("slice",{ACCESSORS:!0,0:0,1:2}),jo=Yt("species"),zo=[].slice,Bo=Math.max;U({target:"Array",proto:!0,forced:!Ao||!Fo},{slice:function(t,e){var i,n,o,r=m(this),s=Zt(r.length),a=te(t,s),h=te(void 0===e?s:e,s);if(Ke(r)&&("function"!=typeof(i=r.constructor)||i!==Array&&!Ke(i.prototype)?b(i)&&null===(i=i[jo])&&(i=void 0):i=void 0,i===Array||void 0===i))return zo.call(r,a,h);for(n=new(void 0===i?Array:i)(Bo(h-a,0)),o=0;a<h;a++,o++)a in r&&Ze(n,o,r[a]);return n.length=o,n}});var Ro=K("Array").slice,Lo=Array.prototype,Ho=function(t){var e=t.slice;return t===Lo||t instanceof Array&&e===Lo.slice?Ro:e},Wo=Ho;var Yo=function(t,e){var i;if(t){if("string"==typeof t)return Do(t,e);var n=Wo(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Co(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?Do(t,e):void 0}};var Vo=function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var Uo=function(t){return Mo(t)||Io(t)||Yo(t)||Vo()},Go=Ho,qo=a((function(){zt(1)}));U({target:"Object",stat:!0,forced:qo,sham:!At},{getPrototypeOf:function(t){return zt(It(t))}});var Xo=j.Object.getPrototypeOf,$o=Xo,Ko=ie.indexOf,Zo=[].indexOf,Qo=!!Zo&&1/[1].indexOf(1,-0)<0,Jo=Hn("indexOf"),tr=Un("indexOf",{ACCESSORS:!0,1:0});U({target:"Array",proto:!0,forced:Qo||!Jo||!tr},{indexOf:function(t){return Qo?Zo.apply(this,arguments)||0:Ko(this,t,arguments.length>1?arguments[1]:void 0)}});var er=K("Array").indexOf,ir=Array.prototype,nr=function(t){var e=t.indexOf;return t===ir||t instanceof Array&&e===ir.indexOf?er:e},or=So,rr=Object.assign,sr=Object.defineProperty,ar=!rr||a((function(){if(h&&1!==rr({b:1},rr(sr({},"a",{enumerable:!0,get:function(){sr(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol();return t[i]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=rr({},t)[i]||"abcdefghijklmnopqrst"!=se(rr({},e)).join("")}))?function(t,e){for(var i=It(t),n=arguments.length,o=1,r=yi.f,s=u.f;n>o;)for(var a,l=g(arguments[o++]),d=r?se(l).concat(r(l)):se(l),c=d.length,f=0;c>f;)a=d[f++],h&&!s.call(l,a)||(i[a]=l[a]);return i}:rr;U({target:"Object",stat:!0,forced:Object.assign!==ar},{assign:ar});var hr=j.Object.assign,lr=mi.f("iterator"),dr=lr,ur=o((function(t){function e(i){return t.exports=e="function"==typeof No&&"symbol"==typeof dr?function(t){return typeof t}:function(t){return t&&"function"==typeof No&&t.constructor===No&&t!==No.prototype?"symbol":typeof t},e(i)}t.exports=e}));var cr=function(t){if(Eo(t))return t};var fr=function(t,e){if(void 0!==No&&Po(Object(t))){var i=[],n=!0,o=!1,r=void 0;try{for(var s,a=Xe(t);!(n=(s=a.next()).done)&&(i.push(s.value),!e||i.length!==e);n=!0);}catch(t){o=!0,r=t}finally{try{n||null==a.return||a.return()}finally{if(o)throw r}}return i}};var pr=function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")};var vr=function(t,e){return cr(t)||fr(t,e)||Yo(t,e)||pr()};U({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});var gr=j.Date.now;function yr(t){if(void 0===tn||null==$e(t)){if(or(t)||(t=function(t,e){var i;if(!t)return;if("string"==typeof t)return mr(t,e);var n=Go(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return cn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return mr(t,e)}(t))){var e=0,i=function(){};return{s:i,n:function(){return e>=t.length?{done:!0}:{done:!1,value:t[e++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var n,o,r=!0,s=!1;return{s:function(){n=Xe(t)},n:function(){var t=n.next();return r=t.done,t},e:function(t){s=!0,o=t},f:function(){try{r||null==n.return||n.return()}finally{if(s)throw o}}}}function mr(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function br(t,e){var i=Tn(t);if(kn){var n=kn(t);e&&(n=_o(n).call(n,(function(e){return _n(t,e).enumerable}))),i.push.apply(i,n)}return i}function wr(t){for(var e=1;e<arguments.length;e++){var i,n=null!=arguments[e]?arguments[e]:{};if(e%2)Jn(i=br(Object(n),!0)).call(i,(function(e){Dn(t,e,n[e])}));else if(yn)vn(t,yn(n));else{var o;Jn(o=br(Object(n))).call(o,(function(e){pn(t,e,_n(n,e))}))}}return t}
/**
	 * vis-util
	 * https://github.com/visjs/vis-util
	 *
	 * utilitie collection for visjs
	 *
	 * @version 4.0.2
	 * @date    2020-05-17T17:33:03.726Z
	 *
	 * @copyright (c) 2011-2017 Almende B.V, http://almende.com
	 * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
	 *
	 * @license
	 * vis.js is dual licensed under both
	 *
	 *   1. The Apache 2.0 License
	 *      http://www.apache.org/licenses/LICENSE-2.0
	 *
	 *   and
	 *
	 *   2. The MIT License
	 *      http://opensource.org/licenses/MIT
	 *
	 * vis.js may be distributed under either license.
	 */function _r(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];return kr(e.length?e:[gr()])}function kr(t){var e=function(){for(var t=xr(),e=t(" "),i=t(" "),n=t(" "),o=0;o<arguments.length;o++)(e-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(e+=1),(i-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(i+=1),(n-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(n+=1);return[e,i,n]}(t),i=vr(e,3),n=i[0],o=i[1],r=i[2],s=1,a=function(){var t=2091639*n+2.3283064365386963e-10*s;return n=o,o=r,r=t-(s=0|t)};return a.uint32=function(){return 4294967296*a()},a.fract53=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.algorithm="Alea",a.seed=t,a.version="0.9",a}function xr(){var t=4022871197;return function(e){for(var i=e.toString(),n=0;n<i.length;n++){var o=.02519603282416938*(t+=i.charCodeAt(n));o-=t=o>>>0,t=(o*=t)>>>0,t+=4294967296*(o-=t)}return 2.3283064365386963e-10*(t>>>0)}}var Or=/^\/?Date\((-?\d+)/i,Sr=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,Er=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,Dr=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,Mr=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function Cr(t){return t instanceof Number||"number"==typeof t}function Tr(t){if(t)for(;!0===t.hasChildNodes();){var e=t.firstChild;e&&(Tr(e),t.removeChild(e))}}function Pr(t){return t instanceof String||"string"==typeof t}function Nr(t){return"object"===ur(t)&&null!==t}function Ir(t,e,i,n){var o=!1;!0===n&&(o=null===e[i]&&void 0!==t[i]),o?delete t[i]:t[i]=e[i]}function Ar(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var n in t)if(void 0!==e[n])if(null===e[n]||"object"!==ur(e[n]))Ir(t,e,n,i);else{var o=t[n],r=e[n];Nr(o)&&Nr(r)&&Ar(o,r,i)}}var Fr=hr;function jr(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(or(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o=0;o<t.length;o++){var r=t[o];if(Object.prototype.hasOwnProperty.call(i,r))if(i[r]&&i[r].constructor===Object)void 0===e[r]&&(e[r]={}),e[r].constructor===Object?Br(e[r],i[r],!1,n):Ir(e,i,r,n);else{if(or(i[r]))throw new TypeError("Arrays are not supported by deepExtend");Ir(e,i,r,n)}}return e}function zr(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(or(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o in i)if(Object.prototype.hasOwnProperty.call(i,o)&&-1===nr(t).call(t,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?Br(e[o],i[o]):Ir(e,i,o,n);else if(or(i[o])){e[o]=[];for(var r=0;r<i[o].length;r++)e[o].push(i[o][r])}else Ir(e,i,o,n);return e}function Br(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var o in e)if(Object.prototype.hasOwnProperty.call(e,o)||!0===i)if("object"===ur(e[o])&&null!==e[o]&&$o(e[o])===Object.prototype)void 0===t[o]?t[o]=Br({},e[o],i):"object"===ur(t[o])&&null!==t[o]&&$o(t[o])===Object.prototype?Br(t[o],e[o],i):Ir(t,e,o,n);else if(or(e[o])){var r;t[o]=Go(r=e[o]).call(r)}else Ir(t,e,o,n);return t}function Rr(t){var e=ur(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":or(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e}function Lr(t,e){var i;return Oo(i=[]).call(i,Uo(t),[e])}function Hr(t){return Go(t).call(t)}function Wr(t){return t.getBoundingClientRect().left}function Yr(t){return t.getBoundingClientRect().top}function Vr(t,e){if(or(t))for(var i=t.length,n=0;n<i;n++)e(t[n],n,t);else for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&e(t[o],o,t)}var Ur=vo;function Gr(t,e,i,n){var o;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&nr(o=navigator.userAgent).call(o,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,i,n)):t.attachEvent("on"+e,i)}function qr(t,e,i,n){var o;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&nr(o=navigator.userAgent).call(o,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,i,n)):t.detachEvent("on"+e,i)}var Xr={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),Pr(t)?t:Cr(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function $r(t){var e;switch(t.length){case 3:case 4:return(e=Er.exec(t))?{r:uo(e[1]+e[1],16),g:uo(e[2]+e[2],16),b:uo(e[3]+e[3],16)}:null;case 6:case 7:return(e=Sr.exec(t))?{r:uo(e[1],16),g:uo(e[2],16),b:uo(e[3],16)}:null;default:return null}}function Kr(t,e){if(-1!==nr(t).call(t,"rgba"))return t;if(-1!==nr(t).call(t,"rgb")){var i=t.substr(nr(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+e+")"}var n=$r(t);return null==n?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"}function Zr(t,e,i){var n;return"#"+Go(n=((1<<24)+(t<<16)+(e<<8)+i).toString(16)).call(n,1)}function Qr(t,e){if(Pr(t)){var i=t;if(ss(i)){var n,o=ro(n=i.substr(4).substr(0,i.length-5).split(",")).call(n,(function(t){return uo(t)}));i=Zr(o[0],o[1],o[2])}if(!0===rs(i)){var r=os(i),s={h:r.h,s:.8*r.s,v:Math.min(1,1.02*r.v)},a={h:r.h,s:Math.min(1,1.25*r.s),v:.8*r.v},h=ns(a.h,a.s,a.v),l=ns(s.h,s.s,s.v);return{background:i,border:h,highlight:{background:l,border:h},hover:{background:l,border:h}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:Pr(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:Pr(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:Pr(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:Pr(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}}function Jr(t,e,i){t/=255,e/=255,i/=255;var n=Math.min(t,Math.min(e,i)),o=Math.max(t,Math.max(e,i));return n===o?{h:0,s:0,v:n}:{h:60*((t===n?3:i===n?1:5)-(t===n?e-i:i===n?t-e:i-t)/(o-n))/360,s:(o-n)/o,v:o}}var ts=function(t){var e,i={};return Jn(e=t.split(";")).call(e,(function(t){if(""!=Ln(t).call(t)){var e,n,o=t.split(":"),r=Ln(e=o[0]).call(e),s=Ln(n=o[1]).call(n);i[r]=s}})),i},es=function(t){var e;return ro(e=Tn(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")};function is(t,e,i){var n,o,r,s=Math.floor(6*t),a=6*t-s,h=i*(1-e),l=i*(1-a*e),d=i*(1-(1-a)*e);switch(s%6){case 0:n=i,o=d,r=h;break;case 1:n=l,o=i,r=h;break;case 2:n=h,o=i,r=d;break;case 3:n=h,o=l,r=i;break;case 4:n=d,o=h,r=i;break;case 5:n=i,o=h,r=l}return{r:Math.floor(255*n),g:Math.floor(255*o),b:Math.floor(255*r)}}function ns(t,e,i){var n=is(t,e,i);return Zr(n.r,n.g,n.b)}function os(t){var e=$r(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return Jr(e.r,e.g,e.b)}function rs(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function ss(t){return Dr.test(t)}function as(t){return Mr.test(t)}function hs(t){if(null===t||"object"!==ur(t))return null;if(t instanceof Element)return t;var e=Sn(t);for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&"object"==ur(t[i])&&(e[i]=hs(t[i]));return e}function ls(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=function(t){return null!=t},r=function(t){return null!==t&&"object"===ur(t)},s=function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0};if(!r(t))throw new Error("Parameter mergeTarget must be an object");if(!r(e))throw new Error("Parameter options must be an object");if(!o(i))throw new Error("Parameter option must have a value");if(!r(n))throw new Error("Parameter globalOptions must be an object");var a=function(t,e,i){r(t[i])||(t[i]={});var n=e[i],o=t[i];for(var s in n)Object.prototype.hasOwnProperty.call(n,s)&&(o[s]=n[s])},h=e[i],l=r(n)&&!s(n),d=l?n[i]:void 0,u=d?d.enabled:void 0;if(void 0!==h){if("boolean"==typeof h)return r(t[i])||(t[i]={}),void(t[i].enabled=h);if(null===h&&!r(t[i])){if(!o(d))return;t[i]=Sn(d)}if(r(h)){var c=!0;void 0!==h.enabled?c=h.enabled:void 0!==u&&(c=d.enabled),a(t,e,i),t[i].enabled=c}}}var ds={linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}};function us(t,e){var i;or(e)||(e=[e]);var n,o=yr(t);try{for(o.s();!(n=o.n()).done;){var r=n.value;if(r){i=r[e[0]];for(var s=1;s<e.length;s++)i&&(i=i[e[s]]);if(void 0!==i)break}}}catch(t){o.e(t)}finally{o.f()}return i}var cs=Object.freeze({__proto__:null,Alea:_r,HSVToHex:ns,HSVToRGB:is,RGBToHSV:Jr,RGBToHex:Zr,addClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=Oo(i).call(i,_o(n).call(n,(function(t){return nr(i).call(i,t)<0}))),t.className=i.join(" ")},addCssText:function(t,e){var i=ts(t.style.cssText),n=ts(e),o=wr(wr({},i),n);t.style.cssText=es(o)},addEventListener:Gr,binarySearchCustom:function(t,e,i,n){for(var o=0,r=0,s=t.length-1;r<=s&&o<1e4;){var a=Math.floor((r+s)/2),h=t[a],l=e(void 0===n?h[i]:h[i][n]);if(0==l)return a;-1==l?r=a+1:s=a-1,o++}return-1},binarySearchValue:function(t,e,i,n,o){var r,s,a,h,l=0,d=0,u=t.length-1;for(o=null!=o?o:function(t,e){return t==e?0:t<e?-1:1};d<=u&&l<1e4;){if(h=Math.floor(.5*(u+d)),r=t[Math.max(0,h-1)][i],s=t[h][i],a=t[Math.min(t.length-1,h+1)][i],0==o(s,e))return h;if(o(r,e)<0&&o(s,e)>0)return"before"==n?Math.max(0,h-1):h;if(o(s,e)<0&&o(a,e)>0)return"before"==n?h:Math.min(t.length-1,h+1);o(s,e)<0?d=h+1:u=h-1,l++}return-1},bridgeObject:hs,copyAndExtendArray:Lr,copyArray:Hr,deepExtend:Br,easingFunctions:ds,equalArray:function(t,e){if(t.length!==e.length)return!1;for(var i=0,n=t.length;i<n;i++)if(t[i]!=e[i])return!1;return!0},extend:Fr,fillIfDefined:Ar,forEach:Vr,getAbsoluteLeft:Wr,getAbsoluteRight:function(t){return t.getBoundingClientRect().right},getAbsoluteTop:Yr,getScrollBarWidth:function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var i=t.offsetWidth;e.style.overflow="scroll";var n=t.offsetWidth;return i==n&&(n=e.clientWidth),document.body.removeChild(e),i-n},getTarget:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},getType:Rr,hasParent:function(t,e){for(var i=t;i;){if(i===e)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1},hexToHSV:os,hexToRGB:$r,insertSort:function(t,e){for(var i=0;i<t.length;i++){var n=t[i],o=void 0;for(o=i;o>0&&e(n,t[o-1])<0;o--)t[o]=t[o-1];t[o]=n}return t},isDate:function(t){if(t instanceof Date)return!0;if(Pr(t)){if(Or.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},isNumber:Cr,isObject:Nr,isString:Pr,isValidHex:rs,isValidRGB:ss,isValidRGBA:as,mergeOptions:ls,option:Xr,overrideOpacity:Kr,parseColor:Qr,preventDefault:function(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)},recursiveDOMDelete:Tr,removeClassName:function(t,e){var i=t.className.split(" "),n=e.split(" ");i=_o(i).call(i,(function(t){return nr(n).call(n,t)<0})),t.className=i.join(" ")},removeCssText:function(t,e){var i=ts(t.style.cssText),n=ts(e);for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&delete i[o];t.style.cssText=es(i)},removeEventListener:qr,selectiveBridgeObject:function(t,e){if(null!==e&&"object"===ur(e)){for(var i=Sn(e),n=0;n<t.length;n++)Object.prototype.hasOwnProperty.call(e,t[n])&&"object"==ur(e[t[n]])&&(i[t[n]]=hs(e[t[n]]));return i}return null},selectiveDeepExtend:jr,selectiveExtend:function(t,e){if(!or(t))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,n=new Array(i>2?i-2:0),o=2;o<i;o++)n[o-2]=arguments[o];for(var r=0,s=n;r<s.length;r++)for(var a=s[r],h=0;h<t.length;h++){var l=t[h];a&&Object.prototype.hasOwnProperty.call(a,l)&&(e[l]=a[l])}return e},selectiveNotDeepExtend:zr,throttle:function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},toArray:Ur,topMost:us,updateProperty:function(t,e,i){return t[e]!==i&&(t[e]=i,!0)}}),fs=si("splice"),ps=Un("splice",{ACCESSORS:!0,0:0,1:2}),vs=Math.max,gs=Math.min;U({target:"Array",proto:!0,forced:!fs||!ps},{splice:function(t,e){var i,n,o,r,s,a,h=It(this),l=Zt(h.length),d=te(t,l),u=arguments.length;if(0===u?i=n=0:1===u?(i=0,n=l-d):(i=u-2,n=gs(vs($t(e),0),l-d)),l+i-n>9007199254740991)throw TypeError("Maximum allowed length exceeded");for(o=Je(h,n),r=0;r<n;r++)(s=d+r)in h&&Ze(o,r,h[s]);if(o.length=n,i<n){for(r=d;r<l-n;r++)a=r+i,(s=r+n)in h?h[a]=h[s]:delete h[a];for(r=l;r>l-n+i;r--)delete h[r-1]}else if(i>n)for(r=l-n;r>d;r--)a=r+i-1,(s=r+n-1)in h?h[a]=h[s]:delete h[a];for(r=0;r<i;r++)h[r+d]=arguments[r+2];return h.length=l-n+i,o}});var ys=K("Array").splice,ms=Array.prototype,bs=function(t){var e=t.splice;return t===ms||t instanceof Array&&e===ms.splice?ys:e},ws=ie.includes,_s=Un("indexOf",{ACCESSORS:!0,1:0});U({target:"Array",proto:!0,forced:!_s},{includes:function(t){return ws(this,t,arguments.length>1?arguments[1]:void 0)}});var ks=K("Array").includes,xs=Yt("match"),Os=function(t){if(function(t){var e;return b(t)&&(void 0!==(e=t[xs])?!!e:"RegExp"==p(t))}(t))throw TypeError("The method doesn't accept regular expressions");return t},Ss=Yt("match");U({target:"String",proto:!0,forced:!function(t){var e=/./;try{"/./"[t](e)}catch(i){try{return e[Ss]=!1,"/./"[t](e)}catch(t){}}return!1}("includes")},{includes:function(t){return!!~String(y(this)).indexOf(Os(t),arguments.length>1?arguments[1]:void 0)}});var Es=K("String").includes,Ds=Array.prototype,Ms=String.prototype,Cs=function(t){var e=t.includes;return t===Ds||t instanceof Array&&e===Ds.includes?ks:"string"==typeof t||t===Ms||t instanceof String&&e===Ms.includes?Es:e};function Ts(t){return Bs=t,function(){var t={};Rs=0,void(Ls=Bs.charAt(0)),Qs(),"strict"===Hs&&(t.strict=!0,Qs());"graph"!==Hs&&"digraph"!==Hs||(t.type=Hs,Qs());Ws===Fs&&(t.id=Hs,Qs());if("{"!=Hs)throw oa("Angle bracket { expected");if(Qs(),Js(t),"}"!=Hs)throw oa("Angle bracket } expected");if(Qs(),""!==Hs)throw oa("End of file expected");return Qs(),delete t.node,delete t.edge,delete t.graph,t}()}var Ps={fontsize:"font.size",fontcolor:"font.color",labelfontcolor:"font.color",fontname:"font.face",color:["color.border","color.background"],fillcolor:"color.background",tooltip:"title",labeltooltip:"title"},Ns=Sn(Ps);Ns.color="color.color",Ns.style="dashes";var Is=0,As=1,Fs=2,js=3,zs={"{":!0,"}":!0,"[":!0,"]":!0,";":!0,"=":!0,",":!0,"->":!0,"--":!0},Bs="",Rs=0,Ls="",Hs="",Ws=Is;function Ys(){Rs++,Ls=Bs.charAt(Rs)}function Vs(){return Bs.charAt(Rs+1)}var Us=/[a-zA-Z_0-9.:#]/;function Gs(t){return Us.test(t)}function qs(t,e){if(t||(t={}),e)for(var i in e)e.hasOwnProperty(i)&&(t[i]=e[i]);return t}function Xs(t,e,i){for(var n=e.split("."),o=t;n.length;){var r=n.shift();n.length?(o[r]||(o[r]={}),o=o[r]):o[r]=i}}function $s(t,e){for(var i,n,o=null,r=[t],s=t;s.parent;)r.push(s.parent),s=s.parent;if(s.nodes)for(i=0,n=s.nodes.length;i<n;i++)if(e.id===s.nodes[i].id){o=s.nodes[i];break}for(o||(o={id:e.id},t.node&&(o.attr=qs(o.attr,t.node))),i=r.length-1;i>=0;i--){var a,h=r[i];h.nodes||(h.nodes=[]),-1===nr(a=h.nodes).call(a,o)&&h.nodes.push(o)}e.attr&&(o.attr=qs(o.attr,e.attr))}function Ks(t,e){if(t.edges||(t.edges=[]),t.edges.push(e),t.edge){var i=qs({},t.edge);e.attr=qs(i,e.attr)}}function Zs(t,e,i,n,o){var r={from:e,to:i,type:n};return t.edge&&(r.attr=qs({},t.edge)),r.attr=qs(r.attr||{},o),null!=o&&o.hasOwnProperty("arrows")&&null!=o.arrows&&(r.arrows={to:{enabled:!0,type:o.arrows.type}},o.arrows=null),r}function Qs(){for(Ws=Is,Hs="";" "===Ls||"\t"===Ls||"\n"===Ls||"\r"===Ls;)Ys();do{var t=!1;if("#"===Ls){for(var e=Rs-1;" "===Bs.charAt(e)||"\t"===Bs.charAt(e);)e--;if("\n"===Bs.charAt(e)||""===Bs.charAt(e)){for(;""!=Ls&&"\n"!=Ls;)Ys();t=!0}}if("/"===Ls&&"/"===Vs()){for(;""!=Ls&&"\n"!=Ls;)Ys();t=!0}if("/"===Ls&&"*"===Vs()){for(;""!=Ls;){if("*"===Ls&&"/"===Vs()){Ys(),Ys();break}Ys()}t=!0}for(;" "===Ls||"\t"===Ls||"\n"===Ls||"\r"===Ls;)Ys()}while(t);if(""!==Ls){var i=Ls+Vs();if(zs[i])return Ws=As,Hs=i,Ys(),void Ys();if(zs[Ls])return Ws=As,Hs=Ls,void Ys();if(Gs(Ls)||"-"===Ls){for(Hs+=Ls,Ys();Gs(Ls);)Hs+=Ls,Ys();return"false"===Hs?Hs=!1:"true"===Hs?Hs=!0:isNaN(Number(Hs))||(Hs=Number(Hs)),void(Ws=Fs)}if('"'===Ls){for(Ys();""!=Ls&&('"'!=Ls||'"'===Ls&&'"'===Vs());)'"'===Ls?(Hs+=Ls,Ys()):"\\"===Ls&&"n"===Vs()?(Hs+="\n",Ys()):Hs+=Ls,Ys();if('"'!=Ls)throw oa('End of string " expected');return Ys(),void(Ws=Fs)}for(Ws=js;""!=Ls;)Hs+=Ls,Ys();throw new SyntaxError('Syntax error in part "'+ra(Hs,30)+'"')}Ws=As}function Js(t){for(;""!==Hs&&"}"!=Hs;)ta(t),";"===Hs&&Qs()}function ta(t){var e=ea(t);if(e)ia(t,e);else if(!function(t){if("node"===Hs)return Qs(),t.node=na(),"node";if("edge"===Hs)return Qs(),t.edge=na(),"edge";if("graph"===Hs)return Qs(),t.graph=na(),"graph";return null}(t)){if(Ws!=Fs)throw oa("Identifier expected");var i=Hs;if(Qs(),"="===Hs){if(Qs(),Ws!=Fs)throw oa("Identifier expected");t[i]=Hs,Qs()}else!function(t,e){var i={id:e},n=na();n&&(i.attr=n);$s(t,i),ia(t,e)}(t,i)}}function ea(t){var e=null;if("subgraph"===Hs&&((e={}).type="subgraph",Qs(),Ws===Fs&&(e.id=Hs,Qs())),"{"===Hs){if(Qs(),e||(e={}),e.parent=t,e.node=t.node,e.edge=t.edge,e.graph=t.graph,Js(e),"}"!=Hs)throw oa("Angle bracket } expected");Qs(),delete e.node,delete e.edge,delete e.graph,delete e.parent,t.subgraphs||(t.subgraphs=[]),t.subgraphs.push(e)}return e}function ia(t,e){for(;"->"===Hs||"--"===Hs;){var i,n=Hs;Qs();var o=ea(t);if(o)i=o;else{if(Ws!=Fs)throw oa("Identifier or subgraph expected");$s(t,{id:i=Hs}),Qs()}Ks(t,Zs(t,e,i,n,na())),e=i}}function na(){for(var t,e,i=null,n={dashed:!0,solid:!1,dotted:[1,5]},o={dot:"circle",box:"box",crow:"crow",curve:"curve",icurve:"inv_curve",normal:"triangle",inv:"inv_triangle",diamond:"diamond",tee:"bar",vee:"vee"},r=new Array,s=new Array;"["===Hs;){for(Qs(),i={};""!==Hs&&"]"!=Hs;){if(Ws!=Fs)throw oa("Attribute name expected");var a=Hs;if(Qs(),"="!=Hs)throw oa("Equal sign = expected");if(Qs(),Ws!=Fs)throw oa("Attribute value expected");var h=Hs;"style"===a&&(h=n[h]),"arrowhead"===a&&(a="arrows",h={to:{enabled:!0,type:o[h]}}),"arrowtail"===a&&(a="arrows",h={from:{enabled:!0,type:o[h]}}),r.push({attr:i,name:a,value:h}),s.push(a),Qs(),","==Hs&&Qs()}if("]"!=Hs)throw oa("Bracket ] expected");Qs()}if(Cs(s).call(s,"dir")){var l={arrows:{}};for(t=0;t<r.length;t++)if("arrows"===r[t].name)if(null!=r[t].value.to)l.arrows.to=t;else{if(null==r[t].value.from)throw oa("Invalid value of arrows");l.arrows.from=t}else"dir"===r[t].name&&(l.dir=t);var d,u,c=r[l.dir].value;if(!Cs(s).call(s,"arrows"))if("both"===c)r.push({attr:r[l.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),l.arrows.to=r.length-1,r.push({attr:r[l.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),l.arrows.from=r.length-1;else if("forward"===c)r.push({attr:r[l.dir].attr,name:"arrows",value:{to:{enabled:!0}}}),l.arrows.to=r.length-1;else if("back"===c)r.push({attr:r[l.dir].attr,name:"arrows",value:{from:{enabled:!0}}}),l.arrows.from=r.length-1;else{if("none"!==c)throw oa('Invalid dir type "'+c+'"');r.push({attr:r[l.dir].attr,name:"arrows",value:""}),l.arrows.to=r.length-1}if("both"===c)l.arrows.to&&l.arrows.from?(u=r[l.arrows.to].value.to.type,d=r[l.arrows.from].value.from.type,r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:d}}},bs(r).call(r,l.arrows.from,1)):l.arrows.to?(u=r[l.arrows.to].value.to.type,d="arrow",r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:d}}}):l.arrows.from&&(u="arrow",d=r[l.arrows.from].value.from.type,r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:d}}});else if("back"===c)l.arrows.to&&l.arrows.from?(u="",d=r[l.arrows.from].value.from.type,r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:d}}}):l.arrows.to?(u="",d="arrow",l.arrows.from=l.arrows.to,r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:d}}}):l.arrows.from&&(u="",d=r[l.arrows.from].value.from.type,r[l.arrows.to]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:d}}}),r[l.arrows.from]={attr:r[l.arrows.from].attr,name:r[l.arrows.from].name,value:{from:{enabled:!0,type:r[l.arrows.from].value.from.type}}};else if("none"===c){var f;r[f=l.arrows.to?l.arrows.to:l.arrows.from]={attr:r[f].attr,name:r[f].name,value:""}}else{if("forward"!==c)throw oa('Invalid dir type "'+c+'"');l.arrows.to&&l.arrows.from||l.arrows.to?(u=r[l.arrows.to].value.to.type,d="",r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:d}}}):l.arrows.from&&(u="arrow",d="",l.arrows.to=l.arrows.from,r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:u},from:{enabled:!0,type:d}}}),r[l.arrows.to]={attr:r[l.arrows.to].attr,name:r[l.arrows.to].name,value:{to:{enabled:!0,type:r[l.arrows.to].value.to.type}}}}bs(r).call(r,l.dir,1)}if(Cs(s).call(s,"penwidth")){var p=[];for(e=r.length,t=0;t<e;t++)"width"!==r[t].name&&("penwidth"===r[t].name&&(r[t].name="width"),p.push(r[t]));r=p}for(e=r.length,t=0;t<e;t++)Xs(r[t].attr,r[t].name,r[t].value);return i}function oa(t){return new SyntaxError(t+', got "'+ra(Hs,30)+'" (char '+Rs+")")}function ra(t,e){return t.length<=e?t:t.substr(0,27)+"..."}function sa(t,e,i){for(var n=e.split("."),o=n.pop(),r=t,s=0;s<n.length;s++){var a=n[s];a in r||(r[a]={}),r=r[a]}return r[o]=i,t}function aa(t,e){var i={};for(var n in t)if(t.hasOwnProperty(n)){var o=e[n];or(o)?Jn(o).call(o,(function(e){sa(i,e,t[n])})):sa(i,"string"==typeof o?o:n,t[n])}return i}var ha=Ts,la=function(t){var e,i=Ts(t),n={nodes:[],edges:[],options:{}};if(i.nodes&&Jn(e=i.nodes).call(e,(function(t){var e={id:t.id,label:String(t.label||t.id)};qs(e,aa(t.attr,Ps)),e.image&&(e.shape="image"),n.nodes.push(e)})),i.edges){var o,r=function(t){var e={from:t.from,to:t.to};return qs(e,aa(t.attr,Ns)),null==e.arrows&&"->"===t.type&&(e.arrows="to"),e};Jn(o=i.edges).call(o,(function(t){var e,i,o,s,a,h,l;(e=t.from instanceof Object?t.from.nodes:{id:t.from},i=t.to instanceof Object?t.to.nodes:{id:t.to},t.from instanceof Object&&t.from.edges)&&Jn(o=t.from.edges).call(o,(function(t){var e=r(t);n.edges.push(e)}));(a=i,h=function(e,i){var o=Zs(n,e.id,i.id,t.type,t.attr),s=r(o);n.edges.push(s)},or(s=e)?Jn(s).call(s,(function(t){or(a)?Jn(a).call(a,(function(e){h(t,e)})):h(t,a)})):or(a)?Jn(a).call(a,(function(t){h(s,t)})):h(s,a),t.to instanceof Object&&t.to.edges)&&Jn(l=t.to.edges).call(l,(function(t){var e=r(t);n.edges.push(e)}))}))}return i.attr&&(n.options=i.attr),n},da={parseDOT:ha,DOTToGraph:la},ua=Object.freeze({__proto__:null,default:da,__moduleExports:da,parseDOT:ha,DOTToGraph:la});function ca(t,e){var i,n={edges:{inheritColor:!1},nodes:{fixed:!1,parseColor:!1}};null!=e&&(null!=e.fixed&&(n.nodes.fixed=e.fixed),null!=e.parseColor&&(n.nodes.parseColor=e.parseColor),null!=e.inheritColor&&(n.edges.inheritColor=e.inheritColor));var o=t.edges,r=ro(o).call(o,(function(t){var e={from:t.source,id:t.id,to:t.target};return null!=t.attributes&&(e.attributes=t.attributes),null!=t.label&&(e.label=t.label),null!=t.attributes&&null!=t.attributes.title&&(e.title=t.attributes.title),"Directed"===t.type&&(e.arrows="to"),t.color&&!1===n.edges.inheritColor&&(e.color=t.color),e}));return{nodes:ro(i=t.nodes).call(i,(function(t){var e={id:t.id,fixed:n.nodes.fixed&&null!=t.x&&null!=t.y};return null!=t.attributes&&(e.attributes=t.attributes),null!=t.label&&(e.label=t.label),null!=t.size&&(e.size=t.size),null!=t.attributes&&null!=t.attributes.title&&(e.title=t.attributes.title),null!=t.title&&(e.title=t.title),null!=t.x&&(e.x=t.x),null!=t.y&&(e.y=t.y),null!=t.color&&(!0===n.nodes.parseColor?e.color=t.color:e.color={background:t.color,border:t.color,highlight:{background:t.color,border:t.color},hover:{background:t.color,border:t.color}}),e})),edges:r}}var fa=Object.freeze({__proto__:null,parseGephi:ca}),pa=Object.freeze({__proto__:null,default:void 0}),va=o((function(t,e){t.exports=function(t){var e,i=t&&t.preventDefault||!1,n=t&&t.container||window,o={},r={keydown:{},keyup:{}},s={};for(e=97;e<=122;e++)s[String.fromCharCode(e)]={code:e-97+65,shift:!1};for(e=65;e<=90;e++)s[String.fromCharCode(e)]={code:e,shift:!0};for(e=0;e<=9;e++)s[""+e]={code:48+e,shift:!1};for(e=1;e<=12;e++)s["F"+e]={code:111+e,shift:!1};for(e=0;e<=9;e++)s["num"+e]={code:96+e,shift:!1};s["num*"]={code:106,shift:!1},s["num+"]={code:107,shift:!1},s["num-"]={code:109,shift:!1},s["num/"]={code:111,shift:!1},s["num."]={code:110,shift:!1},s.left={code:37,shift:!1},s.up={code:38,shift:!1},s.right={code:39,shift:!1},s.down={code:40,shift:!1},s.space={code:32,shift:!1},s.enter={code:13,shift:!1},s.shift={code:16,shift:void 0},s.esc={code:27,shift:!1},s.backspace={code:8,shift:!1},s.tab={code:9,shift:!1},s.ctrl={code:17,shift:!1},s.alt={code:18,shift:!1},s.delete={code:46,shift:!1},s.pageup={code:33,shift:!1},s.pagedown={code:34,shift:!1},s["="]={code:187,shift:!1},s["-"]={code:189,shift:!1},s["]"]={code:221,shift:!1},s["["]={code:219,shift:!1};var a=function(t){l(t,"keydown")},h=function(t){l(t,"keyup")},l=function(t,e){if(void 0!==r[e][t.keyCode]){for(var n=r[e][t.keyCode],o=0;o<n.length;o++)(void 0===n[o].shift||1==n[o].shift&&1==t.shiftKey||0==n[o].shift&&0==t.shiftKey)&&n[o].fn(t);1==i&&t.preventDefault()}};return o.bind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);void 0===r[i][s[t].code]&&(r[i][s[t].code]=[]),r[i][s[t].code].push({fn:e,shift:s[t].shift})},o.bindAll=function(t,e){for(var i in void 0===e&&(e="keydown"),s)s.hasOwnProperty(i)&&o.bind(i,t,e)},o.getKey=function(t){for(var e in s)if(s.hasOwnProperty(e)){if(1==t.shiftKey&&1==s[e].shift&&t.keyCode==s[e].code)return e;if(0==t.shiftKey&&0==s[e].shift&&t.keyCode==s[e].code)return e;if(t.keyCode==s[e].code&&"shift"==e)return e}return"unknown key, currently not supported"},o.unbind=function(t,e,i){if(void 0===i&&(i="keydown"),void 0===s[t])throw new Error("unsupported key: "+t);if(void 0!==e){var n=[],o=r[i][s[t].code];if(void 0!==o)for(var a=0;a<o.length;a++)o[a].fn==e&&o[a].shift==s[t].shift||n.push(r[i][s[t].code][a]);r[i][s[t].code]=n}else r[i][s[t].code]=[]},o.reset=function(){r={keydown:{},keyup:{}}},o.destroy=function(){r={keydown:{},keyup:{}},n.removeEventListener("keydown",a,!0),n.removeEventListener("keyup",h,!0)},n.addEventListener("keydown",a,!0),n.addEventListener("keyup",h,!0),o}})),ga=Object.freeze({__proto__:null,default:va,__moduleExports:va});function ya(){return(ya=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(t[n]=i[n])}return t}).apply(this,arguments)}function ma(t,e){t.prototype=Object.create(e.prototype),t.prototype.constructor=t,t.__proto__=e}function ba(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t}var wa,_a="function"!=typeof Object.assign?function(t){if(null==t)throw new TypeError("Cannot convert undefined or null to object");for(var e=Object(t),i=1;i<arguments.length;i++){var n=arguments[i];if(null!=n)for(var o in n)n.hasOwnProperty(o)&&(e[o]=n[o])}return e}:Object.assign,ka=["","webkit","Moz","MS","ms","o"],xa="undefined"==typeof document?{style:{}}:document.createElement("div"),Oa=Math.round,Sa=Math.abs,Ea=Date.now;function Da(t,e){for(var i,n,o=e[0].toUpperCase()+e.slice(1),r=0;r<ka.length;){if((n=(i=ka[r])?i+o:e)in t)return n;r++}}wa="undefined"==typeof window?{}:window;var Ma=Da(xa.style,"touchAction"),Ca=void 0!==Ma;var Ta=function(){if(!Ca)return!1;var t={},e=wa.CSS&&wa.CSS.supports;return["auto","manipulation","pan-y","pan-x","pan-x pan-y","none"].forEach((function(i){return t[i]=!e||wa.CSS.supports("touch-action",i)})),t}(),Pa="ontouchstart"in wa,Na=void 0!==Da(wa,"PointerEvent"),Ia=Pa&&/mobile|tablet|ip(ad|hone|od)|android/i.test(navigator.userAgent),Aa=["x","y"],Fa=["clientX","clientY"];function ja(t,e,i){var n;if(t)if(t.forEach)t.forEach(e,i);else if(void 0!==t.length)for(n=0;n<t.length;)e.call(i,t[n],n,t),n++;else for(n in t)t.hasOwnProperty(n)&&e.call(i,t[n],n,t)}function za(t,e){return"function"==typeof t?t.apply(e&&e[0]||void 0,e):t}function Ba(t,e){return t.indexOf(e)>-1}var Ra=function(){function t(t,e){this.manager=t,this.set(e)}var e=t.prototype;return e.set=function(t){"compute"===t&&(t=this.compute()),Ca&&this.manager.element.style&&Ta[t]&&(this.manager.element.style[Ma]=t),this.actions=t.toLowerCase().trim()},e.update=function(){this.set(this.manager.options.touchAction)},e.compute=function(){var t=[];return ja(this.manager.recognizers,(function(e){za(e.options.enable,[e])&&(t=t.concat(e.getTouchAction()))})),function(t){if(Ba(t,"none"))return"none";var e=Ba(t,"pan-x"),i=Ba(t,"pan-y");return e&&i?"none":e||i?e?"pan-x":"pan-y":Ba(t,"manipulation")?"manipulation":"auto"}(t.join(" "))},e.preventDefaults=function(t){var e=t.srcEvent,i=t.offsetDirection;if(this.manager.session.prevented)e.preventDefault();else{var n=this.actions,o=Ba(n,"none")&&!Ta.none,r=Ba(n,"pan-y")&&!Ta["pan-y"],s=Ba(n,"pan-x")&&!Ta["pan-x"];if(o){var a=1===t.pointers.length,h=t.distance<2,l=t.deltaTime<250;if(a&&h&&l)return}if(!s||!r)return o||r&&6&i||s&&24&i?this.preventSrc(e):void 0}},e.preventSrc=function(t){this.manager.session.prevented=!0,t.preventDefault()},t}();function La(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1}function Ha(t){var e=t.length;if(1===e)return{x:Oa(t[0].clientX),y:Oa(t[0].clientY)};for(var i=0,n=0,o=0;o<e;)i+=t[o].clientX,n+=t[o].clientY,o++;return{x:Oa(i/e),y:Oa(n/e)}}function Wa(t){for(var e=[],i=0;i<t.pointers.length;)e[i]={clientX:Oa(t.pointers[i].clientX),clientY:Oa(t.pointers[i].clientY)},i++;return{timeStamp:Ea(),pointers:e,center:Ha(e),deltaX:t.deltaX,deltaY:t.deltaY}}function Ya(t,e,i){i||(i=Aa);var n=e[i[0]]-t[i[0]],o=e[i[1]]-t[i[1]];return Math.sqrt(n*n+o*o)}function Va(t,e,i){i||(i=Aa);var n=e[i[0]]-t[i[0]],o=e[i[1]]-t[i[1]];return 180*Math.atan2(o,n)/Math.PI}function Ua(t,e){return t===e?1:Sa(t)>=Sa(e)?t<0?2:4:e<0?8:16}function Ga(t,e,i){return{x:e/t||0,y:i/t||0}}function qa(t,e){var i=t.session,n=e.pointers,o=n.length;i.firstInput||(i.firstInput=Wa(e)),o>1&&!i.firstMultiple?i.firstMultiple=Wa(e):1===o&&(i.firstMultiple=!1);var r=i.firstInput,s=i.firstMultiple,a=s?s.center:r.center,h=e.center=Ha(n);e.timeStamp=Ea(),e.deltaTime=e.timeStamp-r.timeStamp,e.angle=Va(a,h),e.distance=Ya(a,h),function(t,e){var i=e.center,n=t.offsetDelta||{},o=t.prevDelta||{},r=t.prevInput||{};1!==e.eventType&&4!==r.eventType||(o=t.prevDelta={x:r.deltaX||0,y:r.deltaY||0},n=t.offsetDelta={x:i.x,y:i.y}),e.deltaX=o.x+(i.x-n.x),e.deltaY=o.y+(i.y-n.y)}(i,e),e.offsetDirection=Ua(e.deltaX,e.deltaY);var l,d,u=Ga(e.deltaTime,e.deltaX,e.deltaY);e.overallVelocityX=u.x,e.overallVelocityY=u.y,e.overallVelocity=Sa(u.x)>Sa(u.y)?u.x:u.y,e.scale=s?(l=s.pointers,Ya((d=n)[0],d[1],Fa)/Ya(l[0],l[1],Fa)):1,e.rotation=s?function(t,e){return Va(e[1],e[0],Fa)+Va(t[1],t[0],Fa)}(s.pointers,n):0,e.maxPointers=i.prevInput?e.pointers.length>i.prevInput.maxPointers?e.pointers.length:i.prevInput.maxPointers:e.pointers.length,function(t,e){var i,n,o,r,s=t.lastInterval||e,a=e.timeStamp-s.timeStamp;if(8!==e.eventType&&(a>25||void 0===s.velocity)){var h=e.deltaX-s.deltaX,l=e.deltaY-s.deltaY,d=Ga(a,h,l);n=d.x,o=d.y,i=Sa(d.x)>Sa(d.y)?d.x:d.y,r=Ua(h,l),t.lastInterval=e}else i=s.velocity,n=s.velocityX,o=s.velocityY,r=s.direction;e.velocity=i,e.velocityX=n,e.velocityY=o,e.direction=r}(i,e);var c,f=t.element,p=e.srcEvent;La(c=p.composedPath?p.composedPath()[0]:p.path?p.path[0]:p.target,f)&&(f=c),e.target=f}function Xa(t,e,i){var n=i.pointers.length,o=i.changedPointers.length,r=1&e&&n-o==0,s=12&e&&n-o==0;i.isFirst=!!r,i.isFinal=!!s,r&&(t.session={}),i.eventType=e,qa(t,i),t.emit("hammer.input",i),t.recognize(i),t.session.prevInput=i}function $a(t){return t.trim().split(/\s+/g)}function Ka(t,e,i){ja($a(e),(function(e){t.addEventListener(e,i,!1)}))}function Za(t,e,i){ja($a(e),(function(e){t.removeEventListener(e,i,!1)}))}function Qa(t){var e=t.ownerDocument||t;return e.defaultView||e.parentWindow||window}var Ja=function(){function t(t,e){var i=this;this.manager=t,this.callback=e,this.element=t.element,this.target=t.options.inputTarget,this.domHandler=function(e){za(t.options.enable,[t])&&i.handler(e)},this.init()}var e=t.prototype;return e.handler=function(){},e.init=function(){this.evEl&&Ka(this.element,this.evEl,this.domHandler),this.evTarget&&Ka(this.target,this.evTarget,this.domHandler),this.evWin&&Ka(Qa(this.element),this.evWin,this.domHandler)},e.destroy=function(){this.evEl&&Za(this.element,this.evEl,this.domHandler),this.evTarget&&Za(this.target,this.evTarget,this.domHandler),this.evWin&&Za(Qa(this.element),this.evWin,this.domHandler)},t}();function th(t,e,i){if(t.indexOf&&!i)return t.indexOf(e);for(var n=0;n<t.length;){if(i&&t[n][i]==e||!i&&t[n]===e)return n;n++}return-1}var eh={pointerdown:1,pointermove:2,pointerup:4,pointercancel:8,pointerout:8},ih={2:"touch",3:"pen",4:"mouse",5:"kinect"},nh="pointerdown",oh="pointermove pointerup pointercancel";wa.MSPointerEvent&&!wa.PointerEvent&&(nh="MSPointerDown",oh="MSPointerMove MSPointerUp MSPointerCancel");var rh=function(t){function e(){var i,n=e.prototype;return n.evEl=nh,n.evWin=oh,(i=t.apply(this,arguments)||this).store=i.manager.session.pointerEvents=[],i}return ma(e,t),e.prototype.handler=function(t){var e=this.store,i=!1,n=t.type.toLowerCase().replace("ms",""),o=eh[n],r=ih[t.pointerType]||t.pointerType,s="touch"===r,a=th(e,t.pointerId,"pointerId");1&o&&(0===t.button||s)?a<0&&(e.push(t),a=e.length-1):12&o&&(i=!0),a<0||(e[a]=t,this.callback(this.manager,o,{pointers:e,changedPointers:[t],pointerType:r,srcEvent:t}),i&&e.splice(a,1))},e}(Ja);function sh(t){return Array.prototype.slice.call(t,0)}function ah(t,e,i){for(var n=[],o=[],r=0;r<t.length;){var s=e?t[r][e]:t[r];th(o,s)<0&&n.push(t[r]),o[r]=s,r++}return i&&(n=e?n.sort((function(t,i){return t[e]>i[e]})):n.sort()),n}var hh={touchstart:1,touchmove:2,touchend:4,touchcancel:8},lh=function(t){function e(){var i;return e.prototype.evTarget="touchstart touchmove touchend touchcancel",(i=t.apply(this,arguments)||this).targetIds={},i}return ma(e,t),e.prototype.handler=function(t){var e=hh[t.type],i=dh.call(this,t,e);i&&this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:"touch",srcEvent:t})},e}(Ja);function dh(t,e){var i,n,o=sh(t.touches),r=this.targetIds;if(3&e&&1===o.length)return r[o[0].identifier]=!0,[o,o];var s=sh(t.changedTouches),a=[],h=this.target;if(n=o.filter((function(t){return La(t.target,h)})),1===e)for(i=0;i<n.length;)r[n[i].identifier]=!0,i++;for(i=0;i<s.length;)r[s[i].identifier]&&a.push(s[i]),12&e&&delete r[s[i].identifier],i++;return a.length?[ah(n.concat(a),"identifier",!0),a]:void 0}var uh={mousedown:1,mousemove:2,mouseup:4},ch=function(t){function e(){var i,n=e.prototype;return n.evEl="mousedown",n.evWin="mousemove mouseup",(i=t.apply(this,arguments)||this).pressed=!1,i}return ma(e,t),e.prototype.handler=function(t){var e=uh[t.type];1&e&&0===t.button&&(this.pressed=!0),2&e&&1!==t.which&&(e=4),this.pressed&&(4&e&&(this.pressed=!1),this.callback(this.manager,e,{pointers:[t],changedPointers:[t],pointerType:"mouse",srcEvent:t}))},e}(Ja);function fh(t){var e=t.changedPointers[0];if(e.identifier===this.primaryTouch){var i={x:e.clientX,y:e.clientY},n=this.lastTouches;this.lastTouches.push(i);setTimeout((function(){var t=n.indexOf(i);t>-1&&n.splice(t,1)}),2500)}}function ph(t,e){1&t?(this.primaryTouch=e.changedPointers[0].identifier,fh.call(this,e)):12&t&&fh.call(this,e)}function vh(t){for(var e=t.srcEvent.clientX,i=t.srcEvent.clientY,n=0;n<this.lastTouches.length;n++){var o=this.lastTouches[n],r=Math.abs(e-o.x),s=Math.abs(i-o.y);if(r<=25&&s<=25)return!0}return!1}var gh=function(){return function(t){function e(e,i){var n;return(n=t.call(this,e,i)||this).handler=function(t,e,i){var o="touch"===i.pointerType,r="mouse"===i.pointerType;if(!(r&&i.sourceCapabilities&&i.sourceCapabilities.firesTouchEvents)){if(o)ph.call(ba(ba(n)),e,i);else if(r&&vh.call(ba(ba(n)),i))return;n.callback(t,e,i)}},n.touch=new lh(n.manager,n.handler),n.mouse=new ch(n.manager,n.handler),n.primaryTouch=null,n.lastTouches=[],n}return ma(e,t),e.prototype.destroy=function(){this.touch.destroy(),this.mouse.destroy()},e}(Ja)}();function yh(t,e,i){return!!Array.isArray(t)&&(ja(t,i[e],i),!0)}var mh=1;function bh(t,e){var i=e.manager;return i?i.get(t):t}function wh(t){return 16&t?"cancel":8&t?"end":4&t?"move":2&t?"start":""}var _h=function(){function t(t){void 0===t&&(t={}),this.options=ya({enable:!0},t),this.id=mh++,this.manager=null,this.state=1,this.simultaneous={},this.requireFail=[]}var e=t.prototype;return e.set=function(t){return _a(this.options,t),this.manager&&this.manager.touchAction.update(),this},e.recognizeWith=function(t){if(yh(t,"recognizeWith",this))return this;var e=this.simultaneous;return e[(t=bh(t,this)).id]||(e[t.id]=t,t.recognizeWith(this)),this},e.dropRecognizeWith=function(t){return yh(t,"dropRecognizeWith",this)||(t=bh(t,this),delete this.simultaneous[t.id]),this},e.requireFailure=function(t){if(yh(t,"requireFailure",this))return this;var e=this.requireFail;return-1===th(e,t=bh(t,this))&&(e.push(t),t.requireFailure(this)),this},e.dropRequireFailure=function(t){if(yh(t,"dropRequireFailure",this))return this;t=bh(t,this);var e=th(this.requireFail,t);return e>-1&&this.requireFail.splice(e,1),this},e.hasRequireFailures=function(){return this.requireFail.length>0},e.canRecognizeWith=function(t){return!!this.simultaneous[t.id]},e.emit=function(t){var e=this,i=this.state;function n(i){e.manager.emit(i,t)}i<8&&n(e.options.event+wh(i)),n(e.options.event),t.additionalEvent&&n(t.additionalEvent),i>=8&&n(e.options.event+wh(i))},e.tryEmit=function(t){if(this.canEmit())return this.emit(t);this.state=32},e.canEmit=function(){for(var t=0;t<this.requireFail.length;){if(!(33&this.requireFail[t].state))return!1;t++}return!0},e.recognize=function(t){var e=_a({},t);if(!za(this.options.enable,[this,e]))return this.reset(),void(this.state=32);56&this.state&&(this.state=1),this.state=this.process(e),30&this.state&&this.tryEmit(e)},e.process=function(t){},e.getTouchAction=function(){},e.reset=function(){},t}(),kh=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,ya({event:"tap",pointers:1,taps:1,interval:300,time:250,threshold:9,posThreshold:10},e))||this).pTime=!1,i.pCenter=!1,i._timer=null,i._input=null,i.count=0,i}ma(e,t);var i=e.prototype;return i.getTouchAction=function(){return["manipulation"]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,o=t.distance<i.threshold,r=t.deltaTime<i.time;if(this.reset(),1&t.eventType&&0===this.count)return this.failTimeout();if(o&&r&&n){if(4!==t.eventType)return this.failTimeout();var s=!this.pTime||t.timeStamp-this.pTime<i.interval,a=!this.pCenter||Ya(this.pCenter,t.center)<i.posThreshold;if(this.pTime=t.timeStamp,this.pCenter=t.center,a&&s?this.count+=1:this.count=1,this._input=t,0===this.count%i.taps)return this.hasRequireFailures()?(this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),i.interval),2):8}return 32},i.failTimeout=function(){var t=this;return this._timer=setTimeout((function(){t.state=32}),this.options.interval),32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(){8===this.state&&(this._input.tapCount=this.count,this.manager.emit(this.options.event,this._input))},e}(_h),xh=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ya({pointers:1},e))||this}ma(e,t);var i=e.prototype;return i.attrTest=function(t){var e=this.options.pointers;return 0===e||t.pointers.length===e},i.process=function(t){var e=this.state,i=t.eventType,n=6&e,o=this.attrTest(t);return n&&(8&i||!o)?16|e:n||o?4&i?8|e:2&e?4|e:2:32},e}(_h);function Oh(t){return 16===t?"down":8===t?"up":2===t?"left":4===t?"right":""}var Sh=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,ya({event:"pan",threshold:10,pointers:1,direction:30},e))||this).pX=null,i.pY=null,i}ma(e,t);var i=e.prototype;return i.getTouchAction=function(){var t=this.options.direction,e=[];return 6&t&&e.push("pan-y"),24&t&&e.push("pan-x"),e},i.directionTest=function(t){var e=this.options,i=!0,n=t.distance,o=t.direction,r=t.deltaX,s=t.deltaY;return o&e.direction||(6&e.direction?(o=0===r?1:r<0?2:4,i=r!==this.pX,n=Math.abs(t.deltaX)):(o=0===s?1:s<0?8:16,i=s!==this.pY,n=Math.abs(t.deltaY))),t.direction=o,i&&n>e.threshold&&o&e.direction},i.attrTest=function(t){return xh.prototype.attrTest.call(this,t)&&(2&this.state||!(2&this.state)&&this.directionTest(t))},i.emit=function(e){this.pX=e.deltaX,this.pY=e.deltaY;var i=Oh(e.direction);i&&(e.additionalEvent=this.options.event+i),t.prototype.emit.call(this,e)},e}(xh),Eh=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ya({event:"swipe",threshold:10,velocity:.3,direction:30,pointers:1},e))||this}ma(e,t);var i=e.prototype;return i.getTouchAction=function(){return Sh.prototype.getTouchAction.call(this)},i.attrTest=function(e){var i,n=this.options.direction;return 30&n?i=e.overallVelocity:6&n?i=e.overallVelocityX:24&n&&(i=e.overallVelocityY),t.prototype.attrTest.call(this,e)&&n&e.offsetDirection&&e.distance>this.options.threshold&&e.maxPointers===this.options.pointers&&Sa(i)>this.options.velocity&&4&e.eventType},i.emit=function(t){var e=Oh(t.offsetDirection);e&&this.manager.emit(this.options.event+e,t),this.manager.emit(this.options.event,t)},e}(xh),Dh=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ya({event:"pinch",threshold:0,pointers:2},e))||this}ma(e,t);var i=e.prototype;return i.getTouchAction=function(){return["none"]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.scale-1)>this.options.threshold||2&this.state)},i.emit=function(e){if(1!==e.scale){var i=e.scale<1?"in":"out";e.additionalEvent=this.options.event+i}t.prototype.emit.call(this,e)},e}(xh),Mh=function(t){function e(e){return void 0===e&&(e={}),t.call(this,ya({event:"rotate",threshold:0,pointers:2},e))||this}ma(e,t);var i=e.prototype;return i.getTouchAction=function(){return["none"]},i.attrTest=function(e){return t.prototype.attrTest.call(this,e)&&(Math.abs(e.rotation)>this.options.threshold||2&this.state)},e}(xh),Ch=function(t){function e(e){var i;return void 0===e&&(e={}),(i=t.call(this,ya({event:"press",pointers:1,time:251,threshold:9},e))||this)._timer=null,i._input=null,i}ma(e,t);var i=e.prototype;return i.getTouchAction=function(){return["auto"]},i.process=function(t){var e=this,i=this.options,n=t.pointers.length===i.pointers,o=t.distance<i.threshold,r=t.deltaTime>i.time;if(this._input=t,!o||!n||12&t.eventType&&!r)this.reset();else if(1&t.eventType)this.reset(),this._timer=setTimeout((function(){e.state=8,e.tryEmit()}),i.time);else if(4&t.eventType)return 8;return 32},i.reset=function(){clearTimeout(this._timer)},i.emit=function(t){8===this.state&&(t&&4&t.eventType?this.manager.emit(this.options.event+"up",t):(this._input.timeStamp=Ea(),this.manager.emit(this.options.event,this._input)))},e}(_h),Th={domEvents:!1,touchAction:"compute",enable:!0,inputTarget:null,inputClass:null,cssProps:{userSelect:"none",touchSelect:"none",touchCallout:"none",contentZooming:"none",userDrag:"none",tapHighlightColor:"rgba(0,0,0,0)"}},Ph=[[Mh,{enable:!1}],[Dh,{enable:!1},["rotate"]],[Eh,{direction:6}],[Sh,{direction:6},["swipe"]],[kh],[kh,{event:"doubletap",taps:2},["tap"]],[Ch]];function Nh(t,e){var i,n=t.element;n.style&&(ja(t.options.cssProps,(function(o,r){i=Da(n.style,r),e?(t.oldCssProps[i]=n.style[i],n.style[i]=o):n.style[i]=t.oldCssProps[i]||""})),e||(t.oldCssProps={}))}var Ih=function(){function t(t,e){var i,n=this;this.options=_a({},Th,e||{}),this.options.inputTarget=this.options.inputTarget||t,this.handlers={},this.session={},this.recognizers=[],this.oldCssProps={},this.element=t,this.input=new((i=this).options.inputClass||(Na?rh:Ia?lh:Pa?gh:ch))(i,Xa),this.touchAction=new Ra(this,this.options.touchAction),Nh(this,!0),ja(this.options.recognizers,(function(t){var e=n.add(new t[0](t[1]));t[2]&&e.recognizeWith(t[2]),t[3]&&e.requireFailure(t[3])}),this)}var e=t.prototype;return e.set=function(t){return _a(this.options,t),t.touchAction&&this.touchAction.update(),t.inputTarget&&(this.input.destroy(),this.input.target=t.inputTarget,this.input.init()),this},e.stop=function(t){this.session.stopped=t?2:1},e.recognize=function(t){var e=this.session;if(!e.stopped){var i;this.touchAction.preventDefaults(t);var n=this.recognizers,o=e.curRecognizer;(!o||o&&8&o.state)&&(e.curRecognizer=null,o=null);for(var r=0;r<n.length;)i=n[r],2===e.stopped||o&&i!==o&&!i.canRecognizeWith(o)?i.reset():i.recognize(t),!o&&14&i.state&&(e.curRecognizer=i,o=i),r++}},e.get=function(t){if(t instanceof _h)return t;for(var e=this.recognizers,i=0;i<e.length;i++)if(e[i].options.event===t)return e[i];return null},e.add=function(t){if(yh(t,"add",this))return this;var e=this.get(t.options.event);return e&&this.remove(e),this.recognizers.push(t),t.manager=this,this.touchAction.update(),t},e.remove=function(t){if(yh(t,"remove",this))return this;var e=this.get(t);if(t){var i=this.recognizers,n=th(i,e);-1!==n&&(i.splice(n,1),this.touchAction.update())}return this},e.on=function(t,e){if(void 0===t||void 0===e)return this;var i=this.handlers;return ja($a(t),(function(t){i[t]=i[t]||[],i[t].push(e)})),this},e.off=function(t,e){if(void 0===t)return this;var i=this.handlers;return ja($a(t),(function(t){e?i[t]&&i[t].splice(th(i[t],e),1):delete i[t]})),this},e.emit=function(t,e){this.options.domEvents&&function(t,e){var i=document.createEvent("Event");i.initEvent(t,!0,!0),i.gesture=e,e.target.dispatchEvent(i)}(t,e);var i=this.handlers[t]&&this.handlers[t].slice();if(i&&i.length){e.type=t,e.preventDefault=function(){e.srcEvent.preventDefault()};for(var n=0;n<i.length;)i[n](e),n++}},e.destroy=function(){this.element&&Nh(this,!1),this.handlers={},this.session={},this.input.destroy(),this.element=null},t}(),Ah={touchstart:1,touchmove:2,touchend:4,touchcancel:8},Fh=function(t){function e(){var i,n=e.prototype;return n.evTarget="touchstart",n.evWin="touchstart touchmove touchend touchcancel",(i=t.apply(this,arguments)||this).started=!1,i}return ma(e,t),e.prototype.handler=function(t){var e=Ah[t.type];if(1===e&&(this.started=!0),this.started){var i=jh.call(this,t,e);12&e&&i[0].length-i[1].length==0&&(this.started=!1),this.callback(this.manager,e,{pointers:i[0],changedPointers:i[1],pointerType:"touch",srcEvent:t})}},e}(Ja);function jh(t,e){var i=sh(t.touches),n=sh(t.changedTouches);return 12&e&&(i=ah(i.concat(n),"identifier",!0)),[i,n]}function zh(t,e,i){var n="DEPRECATED METHOD: "+e+"\n"+i+" AT \n";return function(){var e=new Error("get-stack-trace"),i=e&&e.stack?e.stack.replace(/^[^\(]+?[\n$]/gm,"").replace(/^\s+at\s+/gm,"").replace(/^Object.<anonymous>\s*\(/gm,"{anonymous}()@"):"Unknown Stack Trace",o=window.console&&(window.console.warn||window.console.log);return o&&o.call(window.console,n,i),t.apply(this,arguments)}}var Bh=zh((function(t,e,i){for(var n=Object.keys(e),o=0;o<n.length;)(!i||i&&void 0===t[n[o]])&&(t[n[o]]=e[n[o]]),o++;return t}),"extend","Use `assign`."),Rh=zh((function(t,e){return Bh(t,e,!0)}),"merge","Use `assign`.");function Lh(t,e,i){var n,o=e.prototype;(n=t.prototype=Object.create(o)).constructor=t,n._super=o,i&&_a(n,i)}function Hh(t,e){return function(){return t.apply(e,arguments)}}var Wh,Yh=function(){var t=function(t,e){return void 0===e&&(e={}),new Ih(t,ya({recognizers:Ph.concat()},e))};return t.VERSION="2.0.17-rc",t.DIRECTION_ALL=30,t.DIRECTION_DOWN=16,t.DIRECTION_LEFT=2,t.DIRECTION_RIGHT=4,t.DIRECTION_UP=8,t.DIRECTION_HORIZONTAL=6,t.DIRECTION_VERTICAL=24,t.DIRECTION_NONE=1,t.DIRECTION_DOWN=16,t.INPUT_START=1,t.INPUT_MOVE=2,t.INPUT_END=4,t.INPUT_CANCEL=8,t.STATE_POSSIBLE=1,t.STATE_BEGAN=2,t.STATE_CHANGED=4,t.STATE_ENDED=8,t.STATE_RECOGNIZED=8,t.STATE_CANCELLED=16,t.STATE_FAILED=32,t.Manager=Ih,t.Input=Ja,t.TouchAction=Ra,t.TouchInput=lh,t.MouseInput=ch,t.PointerEventInput=rh,t.TouchMouseInput=gh,t.SingleTouchInput=Fh,t.Recognizer=_h,t.AttrRecognizer=xh,t.Tap=kh,t.Pan=Sh,t.Swipe=Eh,t.Pinch=Dh,t.Rotate=Mh,t.Press=Ch,t.on=Ka,t.off=Za,t.each=ja,t.merge=Rh,t.extend=Bh,t.bindFn=Hh,t.assign=_a,t.inherit=Lh,t.bindFn=Hh,t.prefixed=Da,t.toArray=sh,t.inArray=th,t.uniqueArray=ah,t.splitStr=$a,t.boolOrFn=za,t.hasParent=La,t.addEventListeners=Ka,t.removeEventListeners=Za,t.defaults=_a({},Th,{preset:Ph}),t}(),Vh=o((function(t){if("undefined"!=typeof window){var e=window.Hammer||Yh;t.exports=e}else t.exports=function(){return{on:t=function(){},off:t,destroy:t,emit:t,get:function(e){return{set:t}}};var t}})),Uh=Object.freeze({__proto__:null,default:Vh,__moduleExports:Vh}),Gh=o((function(t,i){
/**
	   * vis-util
	   * https://github.com/visjs/vis-util
	   *
	   * utilitie collection for visjs
	   *
	   * @version 4.0.2
	   * @date    2020-05-17T17:33:03.726Z
	   *
	   * @copyright (c) 2011-2017 Almende B.V, http://almende.com
	   * @copyright (c) 2017-2019 visjs contributors, https://github.com/visjs
	   *
	   * @license
	   * vis.js is dual licensed under both
	   *
	   *   1. The Apache 2.0 License
	   *      http://www.apache.org/licenses/LICENSE-2.0
	   *
	   *   and
	   *
	   *   2. The MIT License
	   *      http://opensource.org/licenses/MIT
	   *
	   * vis.js may be distributed under either license.
	   */
!function(t){var i="undefined"!=typeof globalThis?globalThis:"undefined"!=typeof window?window:void 0!==e?e:"undefined"!=typeof self?self:{};function n(t,e){return t(e={exports:{}},e.exports),e.exports}function o(t){return t&&t.default||t}var r=function(t){return t&&t.Math==Math&&t},s=r("object"==typeof globalThis&&globalThis)||r("object"==typeof window&&window)||r("object"==typeof self&&self)||r("object"==typeof i&&i)||Function("return this")(),a=function(t){try{return!!t()}catch(t){return!0}},h=!a((function(){return 7!=Object.defineProperty({},1,{get:function(){return 7}})[1]})),l={}.propertyIsEnumerable,d=Object.getOwnPropertyDescriptor,u={f:d&&!l.call({1:2},1)?function(t){var e=d(this,t);return!!e&&e.enumerable}:l},c=function(t,e){return{enumerable:!(1&t),configurable:!(2&t),writable:!(4&t),value:e}},f={}.toString,p=function(t){return f.call(t).slice(8,-1)},v="".split,g=a((function(){return!Object("z").propertyIsEnumerable(0)}))?function(t){return"String"==p(t)?v.call(t,""):Object(t)}:Object,y=function(t){if(null==t)throw TypeError("Can't call method on "+t);return t},m=function(t){return g(y(t))},b=function(t){return"object"==typeof t?null!==t:"function"==typeof t},w=function(t,e){if(!b(t))return t;var i,n;if(e&&"function"==typeof(i=t.toString)&&!b(n=i.call(t)))return n;if("function"==typeof(i=t.valueOf)&&!b(n=i.call(t)))return n;if(!e&&"function"==typeof(i=t.toString)&&!b(n=i.call(t)))return n;throw TypeError("Can't convert object to primitive value")},_={}.hasOwnProperty,k=function(t,e){return _.call(t,e)},x=s.document,O=b(x)&&b(x.createElement),S=function(t){return O?x.createElement(t):{}},E=!h&&!a((function(){return 7!=Object.defineProperty(S("div"),"a",{get:function(){return 7}}).a})),D=Object.getOwnPropertyDescriptor,M={f:h?D:function(t,e){if(t=m(t),e=w(e,!0),E)try{return D(t,e)}catch(t){}if(k(t,e))return c(!u.f.call(t,e),t[e])}},C=/#|\.prototype\./,T=function(t,e){var i=N[P(t)];return i==A||i!=I&&("function"==typeof e?a(e):!!e)},P=T.normalize=function(t){return String(t).replace(C,".").toLowerCase()},N=T.data={},I=T.NATIVE="N",A=T.POLYFILL="P",F=T,j={},z=function(t,e,i){if(function(t){if("function"!=typeof t)throw TypeError(String(t)+" is not a function")}(t),void 0===e)return t;switch(i){case 0:return function(){return t.call(e)};case 1:return function(i){return t.call(e,i)};case 2:return function(i,n){return t.call(e,i,n)};case 3:return function(i,n,o){return t.call(e,i,n,o)}}return function(){return t.apply(e,arguments)}},B=function(t){if(!b(t))throw TypeError(String(t)+" is not an object");return t},R=Object.defineProperty,L={f:h?R:function(t,e,i){if(B(t),e=w(e,!0),B(i),E)try{return R(t,e,i)}catch(t){}if("get"in i||"set"in i)throw TypeError("Accessors not supported");return"value"in i&&(t[e]=i.value),t}},H=h?function(t,e,i){return L.f(t,e,c(1,i))}:function(t,e,i){return t[e]=i,t},W=M.f,Y=function(t){var e=function(e,i,n){if(this instanceof t){switch(arguments.length){case 0:return new t;case 1:return new t(e);case 2:return new t(e,i)}return new t(e,i,n)}return t.apply(this,arguments)};return e.prototype=t.prototype,e},V=function(t,e){var i,n,o,r,a,h,l,d,u=t.target,c=t.global,f=t.stat,p=t.proto,v=c?s:f?s[u]:(s[u]||{}).prototype,g=c?j:j[u]||(j[u]={}),y=g.prototype;for(o in e)i=!F(c?o:u+(f?".":"#")+o,t.forced)&&v&&k(v,o),a=g[o],i&&(h=t.noTargetGet?(d=W(v,o))&&d.value:v[o]),r=i&&h?h:e[o],i&&typeof a==typeof r||(l=t.bind&&i?z(r,s):t.wrap&&i?Y(r):p&&"function"==typeof r?z(Function.call,r):r,(t.sham||r&&r.sham||a&&a.sham)&&H(l,"sham",!0),g[o]=l,p&&(k(j,n=u+"Prototype")||H(j,n,{}),j[n][o]=r,t.real&&y&&!y[o]&&H(y,o,r)))},U=Array.isArray||function(t){return"Array"==p(t)};V({target:"Array",stat:!0},{isArray:U});var G=j.Array.isArray,q=G,X={},$=s["__core-js_shared__"]||function(t,e){try{H(s,t,e)}catch(i){s[t]=e}return e}("__core-js_shared__",{}),K=Function.toString;"function"!=typeof $.inspectSource&&($.inspectSource=function(t){return K.call(t)});var Z,Q,J,tt=$.inspectSource,et=s.WeakMap,it="function"==typeof et&&/native code/.test(tt(et)),nt=n((function(t){(t.exports=function(t,e){return $[t]||($[t]=void 0!==e?e:{})})("versions",[]).push({version:"3.6.4",mode:"pure",copyright:"© 2020 Denis Pushkarev (zloirock.ru)"})})),ot=0,rt=Math.random(),st=function(t){return"Symbol("+String(void 0===t?"":t)+")_"+(++ot+rt).toString(36)},at=nt("keys"),ht=function(t){return at[t]||(at[t]=st(t))},lt={},dt=s.WeakMap;if(it){var ut=new dt,ct=ut.get,ft=ut.has,pt=ut.set;Z=function(t,e){return pt.call(ut,t,e),e},Q=function(t){return ct.call(ut,t)||{}},J=function(t){return ft.call(ut,t)}}else{var vt=ht("state");lt[vt]=!0,Z=function(t,e){return H(t,vt,e),e},Q=function(t){return k(t,vt)?t[vt]:{}},J=function(t){return k(t,vt)}}var gt,yt,mt,bt={set:Z,get:Q,has:J,enforce:function(t){return J(t)?Q(t):Z(t,{})},getterFor:function(t){return function(e){var i;if(!b(e)||(i=Q(e)).type!==t)throw TypeError("Incompatible receiver, "+t+" required");return i}}},wt=function(t){return Object(y(t))},_t=!a((function(){function t(){}return t.prototype.constructor=null,Object.getPrototypeOf(new t)!==t.prototype})),kt=ht("IE_PROTO"),xt=Object.prototype,Ot=_t?Object.getPrototypeOf:function(t){return t=wt(t),k(t,kt)?t[kt]:"function"==typeof t.constructor&&t instanceof t.constructor?t.constructor.prototype:t instanceof Object?xt:null},St=!!Object.getOwnPropertySymbols&&!a((function(){return!String(Symbol())})),Et=St&&!Symbol.sham&&"symbol"==typeof Symbol.iterator,Dt=nt("wks"),Mt=s.Symbol,Ct=Et?Mt:Mt&&Mt.withoutSetter||st,Tt=function(t){return k(Dt,t)||(St&&k(Mt,t)?Dt[t]=Mt[t]:Dt[t]=Ct("Symbol."+t)),Dt[t]},Pt=(Tt("iterator"),!1);[].keys&&("next"in(mt=[].keys())?(yt=Ot(Ot(mt)))!==Object.prototype&&(gt=yt):Pt=!0),null==gt&&(gt={});var Nt,It={IteratorPrototype:gt,BUGGY_SAFARI_ITERATORS:Pt},At=Math.ceil,Ft=Math.floor,jt=function(t){return isNaN(t=+t)?0:(t>0?Ft:At)(t)},zt=Math.min,Bt=function(t){return t>0?zt(jt(t),9007199254740991):0},Rt=Math.max,Lt=Math.min,Ht=function(t,e){var i=jt(t);return i<0?Rt(i+e,0):Lt(i,e)},Wt=function(t){return function(e,i,n){var o,r=m(e),s=Bt(r.length),a=Ht(n,s);if(t&&i!=i){for(;s>a;)if((o=r[a++])!=o)return!0}else for(;s>a;a++)if((t||a in r)&&r[a]===i)return t||a||0;return!t&&-1}},Yt={includes:Wt(!0),indexOf:Wt(!1)},Vt=Yt.indexOf,Ut=function(t,e){var i,n=m(t),o=0,r=[];for(i in n)!k(lt,i)&&k(n,i)&&r.push(i);for(;e.length>o;)k(n,i=e[o++])&&(~Vt(r,i)||r.push(i));return r},Gt=["constructor","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","toLocaleString","toString","valueOf"],qt=Object.keys||function(t){return Ut(t,Gt)},Xt=h?Object.defineProperties:function(t,e){B(t);for(var i,n=qt(e),o=n.length,r=0;o>r;)L.f(t,i=n[r++],e[i]);return t},$t=function(t){return"function"==typeof t?t:void 0},Kt=function(t,e){return arguments.length<2?$t(j[t])||$t(s[t]):j[t]&&j[t][e]||s[t]&&s[t][e]},Zt=Kt("document","documentElement"),Qt=ht("IE_PROTO"),Jt=function(){},te=function(t){return"<script>"+t+"<\/script>"},ee=function(){try{Nt=document.domain&&new ActiveXObject("htmlfile")}catch(t){}var t,e;ee=Nt?function(t){t.write(te("")),t.close();var e=t.parentWindow.Object;return t=null,e}(Nt):((e=S("iframe")).style.display="none",Zt.appendChild(e),e.src=String("javascript:"),(t=e.contentWindow.document).open(),t.write(te("document.F=Object")),t.close(),t.F);for(var i=Gt.length;i--;)delete ee.prototype[Gt[i]];return ee()};lt[Qt]=!0;var ie=Object.create||function(t,e){var i;return null!==t?(Jt.prototype=B(t),i=new Jt,Jt.prototype=null,i[Qt]=t):i=ee(),void 0===e?i:Xt(i,e)},ne={};ne[Tt("toStringTag")]="z";var oe="[object z]"===String(ne),re=Tt("toStringTag"),se="Arguments"==p(function(){return arguments}()),ae=oe?p:function(t){var e,i,n;return void 0===t?"Undefined":null===t?"Null":"string"==typeof(i=function(t,e){try{return t[e]}catch(t){}}(e=Object(t),re))?i:se?p(e):"Object"==(n=p(e))&&"function"==typeof e.callee?"Arguments":n},he=oe?{}.toString:function(){return"[object "+ae(this)+"]"},le=L.f,de=Tt("toStringTag"),ue=function(t,e,i,n){if(t){var o=i?t:t.prototype;k(o,de)||le(o,de,{configurable:!0,value:e}),n&&!oe&&H(o,"toString",he)}},ce=It.IteratorPrototype,fe=function(){return this},pe=(Object.setPrototypeOf||"__proto__"in{}&&function(){var t={};try{Object.getOwnPropertyDescriptor(Object.prototype,"__proto__").set.call(t,[])}catch(t){}}(),function(t,e,i,n){n&&n.enumerable?t[e]=i:H(t,e,i)}),ve=It.IteratorPrototype,ge=It.BUGGY_SAFARI_ITERATORS,ye=Tt("iterator"),me=function(){return this},be=function(t,e,i,n,o,r,s){!function(t,e,i){var n=e+" Iterator";t.prototype=ie(ce,{next:c(1,i)}),ue(t,n,!1,!0),X[n]=fe}(i,e,n);var a,h,l,d=function(t){if(t===o&&g)return g;if(!ge&&t in p)return p[t];switch(t){case"keys":case"values":case"entries":return function(){return new i(this,t)}}return function(){return new i(this)}},u=e+" Iterator",f=!1,p=t.prototype,v=p[ye]||p["@@iterator"]||o&&p[o],g=!ge&&v||d(o),y="Array"==e&&p.entries||v;if(y&&(a=Ot(y.call(new t)),ve!==Object.prototype&&a.next&&(ue(a,u,!0,!0),X[u]=me)),"values"==o&&v&&"values"!==v.name&&(f=!0,g=function(){return v.call(this)}),s&&p[ye]!==g&&H(p,ye,g),X[e]=g,o)if(h={values:d("values"),keys:r?g:d("keys"),entries:d("entries")},s)for(l in h)!ge&&!f&&l in p||pe(p,l,h[l]);else V({target:e,proto:!0,forced:ge||f},h);return h},we=bt.set,_e=bt.getterFor("Array Iterator");be(Array,"Array",(function(t,e){we(this,{type:"Array Iterator",target:m(t),index:0,kind:e})}),(function(){var t=_e(this),e=t.target,i=t.kind,n=t.index++;return!e||n>=e.length?(t.target=void 0,{value:void 0,done:!0}):"keys"==i?{value:n,done:!1}:"values"==i?{value:e[n],done:!1}:{value:[n,e[n]],done:!1}}),"values"),X.Arguments=X.Array;var ke=Tt("toStringTag");for(var xe in{CSSRuleList:0,CSSStyleDeclaration:0,CSSValueList:0,ClientRectList:0,DOMRectList:0,DOMStringList:0,DOMTokenList:1,DataTransferItemList:0,FileList:0,HTMLAllCollection:0,HTMLCollection:0,HTMLFormElement:0,HTMLSelectElement:0,MediaList:0,MimeTypeArray:0,NamedNodeMap:0,NodeList:1,PaintRequestList:0,Plugin:0,PluginArray:0,SVGLengthList:0,SVGNumberList:0,SVGPathSegList:0,SVGPointList:0,SVGStringList:0,SVGTransformList:0,SourceBufferList:0,StyleSheetList:0,TextTrackCueList:0,TextTrackList:0,TouchList:0}){var Oe=s[xe],Se=Oe&&Oe.prototype;Se&&ae(Se)!==ke&&H(Se,ke,xe),X[xe]=X.Array}var Ee=function(t){return function(e,i){var n,o,r=String(y(e)),s=jt(i),a=r.length;return s<0||s>=a?t?"":void 0:(n=r.charCodeAt(s))<55296||n>56319||s+1===a||(o=r.charCodeAt(s+1))<56320||o>57343?t?r.charAt(s):n:t?r.slice(s,s+2):o-56320+(n-55296<<10)+65536}},De=(Ee(!1),Ee(!0)),Me=bt.set,Ce=bt.getterFor("String Iterator");be(String,"String",(function(t){Me(this,{type:"String Iterator",string:String(t),index:0})}),(function(){var t,e=Ce(this),i=e.string,n=e.index;return n>=i.length?{value:void 0,done:!0}:(t=De(i,n),e.index+=t.length,{value:t,done:!1})}));var Te,Pe,Ne=Tt("iterator"),Ie=function(t){if(null!=t)return t[Ne]||t["@@iterator"]||X[ae(t)]},Ae=function(t){var e=Ie(t);if("function"!=typeof e)throw TypeError(String(t)+" is not iterable");return B(e.call(t))},Fe=Tt("iterator"),je=function(t){var e=Object(t);return void 0!==e[Fe]||"@@iterator"in e||X.hasOwnProperty(ae(e))},ze=function(t,e,i){var n=w(e);n in t?L.f(t,n,c(0,i)):t[n]=i},Be=Tt("species"),Re=function(t,e){var i;return U(t)&&("function"!=typeof(i=t.constructor)||i!==Array&&!U(i.prototype)?b(i)&&null===(i=i[Be])&&(i=void 0):i=void 0),new(void 0===i?Array:i)(0===e?0:e)},Le=Kt("navigator","userAgent")||"",He=s.process,We=He&&He.versions,Ye=We&&We.v8;Ye?Pe=(Te=Ye.split("."))[0]+Te[1]:Le&&(!(Te=Le.match(/Edge\/(\d+)/))||Te[1]>=74)&&(Te=Le.match(/Chrome\/(\d+)/))&&(Pe=Te[1]);var Ve=Pe&&+Pe,Ue=Tt("species"),Ge=function(t){return Ve>=51||!a((function(){var e=[];return(e.constructor={})[Ue]=function(){return{foo:1}},1!==e[t](Boolean).foo}))},qe=Tt("isConcatSpreadable"),Xe=Ve>=51||!a((function(){var t=[];return t[qe]=!1,t.concat()[0]!==t})),$e=Ge("concat"),Ke=function(t){if(!b(t))return!1;var e=t[qe];return void 0!==e?!!e:U(t)};V({target:"Array",proto:!0,forced:!Xe||!$e},{concat:function(t){var e,i,n,o,r,s=wt(this),a=Re(s,0),h=0;for(e=-1,n=arguments.length;e<n;e++)if(r=-1===e?s:arguments[e],Ke(r)){if(h+(o=Bt(r.length))>9007199254740991)throw TypeError("Maximum allowed index exceeded");for(i=0;i<o;i++,h++)i in r&&ze(a,h,r[i])}else{if(h>=9007199254740991)throw TypeError("Maximum allowed index exceeded");ze(a,h++,r)}return a.length=h,a}});var Ze=Object.freeze({__proto__:null}),Qe=Gt.concat("length","prototype"),Je={f:Object.getOwnPropertyNames||function(t){return Ut(t,Qe)}},ti=Je.f,ei={}.toString,ii="object"==typeof window&&window&&Object.getOwnPropertyNames?Object.getOwnPropertyNames(window):[],ni={f:function(t){return ii&&"[object Window]"==ei.call(t)?function(t){try{return ti(t)}catch(t){return ii.slice()}}(t):ti(m(t))}},oi={f:Object.getOwnPropertySymbols},ri={f:Tt},si=L.f,ai=function(t){var e=j.Symbol||(j.Symbol={});k(e,t)||si(e,t,{value:ri.f(t)})},hi=[].push,li=function(t){var e=1==t,i=2==t,n=3==t,o=4==t,r=6==t,s=5==t||r;return function(a,h,l,d){for(var u,c,f=wt(a),p=g(f),v=z(h,l,3),y=Bt(p.length),m=0,b=d||Re,w=e?b(a,y):i?b(a,0):void 0;y>m;m++)if((s||m in p)&&(c=v(u=p[m],m,f),t))if(e)w[m]=c;else if(c)switch(t){case 3:return!0;case 5:return u;case 6:return m;case 2:hi.call(w,u)}else if(o)return!1;return r?-1:n||o?o:w}},di={forEach:li(0),map:li(1),filter:li(2),some:li(3),every:li(4),find:li(5),findIndex:li(6)},ui=di.forEach,ci=ht("hidden"),fi=Tt("toPrimitive"),pi=bt.set,vi=bt.getterFor("Symbol"),gi=Object.prototype,yi=s.Symbol,mi=Kt("JSON","stringify"),bi=M.f,wi=L.f,_i=ni.f,ki=u.f,xi=nt("symbols"),Oi=nt("op-symbols"),Si=nt("string-to-symbol-registry"),Ei=nt("symbol-to-string-registry"),Di=nt("wks"),Mi=s.QObject,Ci=!Mi||!Mi.prototype||!Mi.prototype.findChild,Ti=h&&a((function(){return 7!=ie(wi({},"a",{get:function(){return wi(this,"a",{value:7}).a}})).a}))?function(t,e,i){var n=bi(gi,e);n&&delete gi[e],wi(t,e,i),n&&t!==gi&&wi(gi,e,n)}:wi,Pi=function(t,e){var i=xi[t]=ie(yi.prototype);return pi(i,{type:"Symbol",tag:t,description:e}),h||(i.description=e),i},Ni=Et?function(t){return"symbol"==typeof t}:function(t){return Object(t)instanceof yi},Ii=function(t,e,i){t===gi&&Ii(Oi,e,i),B(t);var n=w(e,!0);return B(i),k(xi,n)?(i.enumerable?(k(t,ci)&&t[ci][n]&&(t[ci][n]=!1),i=ie(i,{enumerable:c(0,!1)})):(k(t,ci)||wi(t,ci,c(1,{})),t[ci][n]=!0),Ti(t,n,i)):wi(t,n,i)},Ai=function(t,e){B(t);var i=m(e),n=qt(i).concat(Bi(i));return ui(n,(function(e){h&&!Fi.call(i,e)||Ii(t,e,i[e])})),t},Fi=function(t){var e=w(t,!0),i=ki.call(this,e);return!(this===gi&&k(xi,e)&&!k(Oi,e))&&(!(i||!k(this,e)||!k(xi,e)||k(this,ci)&&this[ci][e])||i)},ji=function(t,e){var i=m(t),n=w(e,!0);if(i!==gi||!k(xi,n)||k(Oi,n)){var o=bi(i,n);return!o||!k(xi,n)||k(i,ci)&&i[ci][n]||(o.enumerable=!0),o}},zi=function(t){var e=_i(m(t)),i=[];return ui(e,(function(t){k(xi,t)||k(lt,t)||i.push(t)})),i},Bi=function(t){var e=t===gi,i=_i(e?Oi:m(t)),n=[];return ui(i,(function(t){!k(xi,t)||e&&!k(gi,t)||n.push(xi[t])})),n};if(St||(pe((yi=function(){if(this instanceof yi)throw TypeError("Symbol is not a constructor");var t=arguments.length&&void 0!==arguments[0]?String(arguments[0]):void 0,e=st(t),i=function(t){this===gi&&i.call(Oi,t),k(this,ci)&&k(this[ci],e)&&(this[ci][e]=!1),Ti(this,e,c(1,t))};return h&&Ci&&Ti(gi,e,{configurable:!0,set:i}),Pi(e,t)}).prototype,"toString",(function(){return vi(this).tag})),pe(yi,"withoutSetter",(function(t){return Pi(st(t),t)})),u.f=Fi,L.f=Ii,M.f=ji,Je.f=ni.f=zi,oi.f=Bi,ri.f=function(t){return Pi(Tt(t),t)},h&&wi(yi.prototype,"description",{configurable:!0,get:function(){return vi(this).description}})),V({global:!0,wrap:!0,forced:!St,sham:!St},{Symbol:yi}),ui(qt(Di),(function(t){ai(t)})),V({target:"Symbol",stat:!0,forced:!St},{for:function(t){var e=String(t);if(k(Si,e))return Si[e];var i=yi(e);return Si[e]=i,Ei[i]=e,i},keyFor:function(t){if(!Ni(t))throw TypeError(t+" is not a symbol");if(k(Ei,t))return Ei[t]},useSetter:function(){Ci=!0},useSimple:function(){Ci=!1}}),V({target:"Object",stat:!0,forced:!St,sham:!h},{create:function(t,e){return void 0===e?ie(t):Ai(ie(t),e)},defineProperty:Ii,defineProperties:Ai,getOwnPropertyDescriptor:ji}),V({target:"Object",stat:!0,forced:!St},{getOwnPropertyNames:zi,getOwnPropertySymbols:Bi}),V({target:"Object",stat:!0,forced:a((function(){oi.f(1)}))},{getOwnPropertySymbols:function(t){return oi.f(wt(t))}}),mi){var Ri=!St||a((function(){var t=yi();return"[null]"!=mi([t])||"{}"!=mi({a:t})||"{}"!=mi(Object(t))}));V({target:"JSON",stat:!0,forced:Ri},{stringify:function(t,e,i){for(var n,o=[t],r=1;arguments.length>r;)o.push(arguments[r++]);if(n=e,(b(e)||void 0!==t)&&!Ni(t))return U(e)||(e=function(t,e){if("function"==typeof n&&(e=n.call(this,t,e)),!Ni(e))return e}),o[1]=e,mi.apply(null,o)}})}yi.prototype[fi]||H(yi.prototype,fi,yi.prototype.valueOf),ue(yi,"Symbol"),lt[ci]=!0,ai("asyncIterator");var Li=Object.freeze({__proto__:null});ai("hasInstance"),ai("isConcatSpreadable"),ai("iterator"),ai("match"),ai("matchAll"),ai("replace"),ai("search"),ai("species"),ai("split"),ai("toPrimitive"),ai("toStringTag"),ai("unscopables"),ue(Math,"Math",!0),ue(s.JSON,"JSON",!0),o(Ze),o(Li);var Hi=j.Symbol;ai("asyncDispose"),ai("dispose"),ai("observable"),ai("patternMatch"),ai("replaceAll");var Wi=Hi,Yi=function(t,e,i,n){try{return n?e(B(i)[0],i[1]):e(i)}catch(e){var o=t.return;throw void 0!==o&&B(o.call(t)),e}},Vi=Tt("iterator"),Ui=Array.prototype,Gi=function(t){return void 0!==t&&(X.Array===t||Ui[Vi]===t)},qi=Tt("iterator"),Xi=!1;try{var $i=0,Ki={next:function(){return{done:!!$i++}},return:function(){Xi=!0}};Ki[qi]=function(){return this},Array.from(Ki,(function(){throw 2}))}catch(t){}var Zi=!function(t,e){if(!Xi)return!1;var i=!1;try{var n={};n[qi]=function(){return{next:function(){return{done:i=!0}}}},function(t){Array.from(t)}(n)}catch(t){}return i}();V({target:"Array",stat:!0,forced:Zi},{from:function(t){var e,i,n,o,r,s,a=wt(t),h="function"==typeof this?this:Array,l=arguments.length,d=l>1?arguments[1]:void 0,u=void 0!==d,c=Ie(a),f=0;if(u&&(d=z(d,l>2?arguments[2]:void 0,2)),null==c||h==Array&&Gi(c))for(i=new h(e=Bt(a.length));e>f;f++)s=u?d(a[f],f):a[f],ze(i,f,s);else for(r=(o=c.call(a)).next,i=new h;!(n=r.call(o)).done;f++)s=u?Yi(o,d,[n.value,f],!0):n.value,ze(i,f,s);return i.length=f,i}});var Qi=j.Array.from,Ji=Qi,tn=Object.defineProperty,en={},nn=function(t){throw t},on=function(t,e){if(k(en,t))return en[t];e||(e={});var i=[][t],n=!!k(e,"ACCESSORS")&&e.ACCESSORS,o=k(e,0)?e[0]:nn,r=k(e,1)?e[1]:void 0;return en[t]=!!i&&!a((function(){if(n&&!h)return!0;var t={length:-1};n?tn(t,1,{enumerable:!0,get:nn}):t[1]=1,i.call(t,o,r)}))},rn=Ge("slice"),sn=on("slice",{ACCESSORS:!0,0:0,1:2}),an=Tt("species"),hn=[].slice,ln=Math.max;V({target:"Array",proto:!0,forced:!rn||!sn},{slice:function(t,e){var i,n,o,r=m(this),s=Bt(r.length),a=Ht(t,s),h=Ht(void 0===e?s:e,s);if(U(r)&&("function"!=typeof(i=r.constructor)||i!==Array&&!U(i.prototype)?b(i)&&null===(i=i[an])&&(i=void 0):i=void 0,i===Array||void 0===i))return hn.call(r,a,h);for(n=new(void 0===i?Array:i)(ln(h-a,0)),o=0;a<h;a++,o++)a in r&&ze(n,o,r[a]);return n.length=o,n}});var dn=function(t){return j[t+"Prototype"]},un=dn("Array").slice,cn=Array.prototype,fn=function(t){var e=t.slice;return t===cn||t instanceof Array&&e===cn.slice?un:e},pn=fn,vn=function(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n},gn=function(t,e){var i;if(t){if("string"==typeof t)return vn(t,e);var n=pn(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?Ji(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?vn(t,e):void 0}},yn=function(t,e){return function(t){if(q(t))return t}(t)||function(t,e){if(void 0!==Wi&&je(Object(t))){var i=[],n=!0,o=!1,r=void 0;try{for(var s,a=Ae(t);!(n=(s=a.next()).done)&&(i.push(s.value),!e||i.length!==e);n=!0);}catch(t){o=!0,r=t}finally{try{n||null==a.return||a.return()}finally{if(o)throw r}}return i}}(t,e)||gn(t,e)||function(){throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()};V({target:"Date",stat:!0},{now:function(){return(new Date).getTime()}});var mn=j.Date.now;function bn(t){var e=function(){for(var t=wn(),e=t(" "),i=t(" "),n=t(" "),o=0;o<arguments.length;o++)(e-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(e+=1),(i-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(i+=1),(n-=t(o<0||arguments.length<=o?void 0:arguments[o]))<0&&(n+=1);return[e,i,n]}(t),i=yn(e,3),n=i[0],o=i[1],r=i[2],s=1,a=function(){var t=2091639*n+2.3283064365386963e-10*s;return n=o,o=r,r=t-(s=0|t)};return a.uint32=function(){return 4294967296*a()},a.fract53=function(){return a()+11102230246251565e-32*(2097152*a()|0)},a.algorithm="Alea",a.seed=t,a.version="0.9",a}function wn(){var t=4022871197;return function(e){for(var i=e.toString(),n=0;n<i.length;n++){var o=.02519603282416938*(t+=i.charCodeAt(n));o-=t=o>>>0,t=(o*=t)>>>0,t+=4294967296*(o-=t)}return 2.3283064365386963e-10*(t>>>0)}}var _n=Ie,kn=Hi,xn=Qi;V({target:"Object",stat:!0,forced:!h,sham:!h},{defineProperty:L.f});var On=n((function(t){var e=j.Object,i=t.exports=function(t,i,n){return e.defineProperty(t,i,n)};e.defineProperty.sham&&(i.sham=!0)})),Sn=On;V({target:"Object",stat:!0,forced:!h,sham:!h},{defineProperties:Xt});var En=n((function(t){var e=j.Object,i=t.exports=function(t,i){return e.defineProperties(t,i)};e.defineProperties.sham&&(i.sham=!0)})),Dn=Kt("Reflect","ownKeys")||function(t){var e=Je.f(B(t)),i=oi.f;return i?e.concat(i(t)):e};V({target:"Object",stat:!0,sham:!h},{getOwnPropertyDescriptors:function(t){for(var e,i,n=m(t),o=M.f,r=Dn(n),s={},a=0;r.length>a;)void 0!==(i=o(n,e=r[a++]))&&ze(s,e,i);return s}});var Mn=j.Object.getOwnPropertyDescriptors,Cn=M.f,Tn=a((function(){Cn(1)}));V({target:"Object",stat:!0,forced:!h||Tn,sham:!h},{getOwnPropertyDescriptor:function(t,e){return Cn(m(t),e)}});var Pn=n((function(t){var e=j.Object,i=t.exports=function(t,i){return e.getOwnPropertyDescriptor(t,i)};e.getOwnPropertyDescriptor.sham&&(i.sham=!0)})),Nn=j.Object.getOwnPropertySymbols;V({target:"Object",stat:!0,sham:!h},{create:ie});var In=j.Object,An=function(t,e){return In.create(t,e)},Fn=On,jn=function(t,e,i){return e in t?Fn(t,e,{value:i,enumerable:!0,configurable:!0,writable:!0}):t[e]=i,t},zn=a((function(){qt(1)}));V({target:"Object",stat:!0,forced:zn},{keys:function(t){return qt(wt(t))}});var Bn,Rn=j.Object.keys,Ln="\t\n\v\f\r                　\u2028\u2029\ufeff",Hn="["+Ln+"]",Wn=RegExp("^"+Hn+Hn+"*"),Yn=RegExp(Hn+Hn+"*$"),Vn=function(t){return function(e){var i=String(y(e));return 1&t&&(i=i.replace(Wn,"")),2&t&&(i=i.replace(Yn,"")),i}},Un={start:Vn(1),end:Vn(2),trim:Vn(3)},Gn=Un.trim;V({target:"String",proto:!0,forced:(Bn="trim",a((function(){return!!Ln[Bn]()||"​᠎"!="​᠎"[Bn]()||Ln[Bn].name!==Bn})))},{trim:function(){return Gn(this)}});var qn=dn("String").trim,Xn=String.prototype,$n=function(t){var e=t.trim;return"string"==typeof t||t===Xn||t instanceof String&&e===Xn.trim?qn:e},Kn=function(t,e){var i=[][t];return!!i&&a((function(){i.call(null,e||function(){throw 1},1)}))},Zn=di.forEach,Qn=Kn("forEach"),Jn=on("forEach"),to=Qn&&Jn?[].forEach:function(t){return Zn(this,t,arguments.length>1?arguments[1]:void 0)};V({target:"Array",proto:!0,forced:[].forEach!=to},{forEach:to});var eo=dn("Array").forEach,io=Array.prototype,no={DOMTokenList:!0,NodeList:!0},oo=function(t){var e=t.forEach;return t===io||t instanceof Array&&e===io.forEach||no.hasOwnProperty(ae(t))?eo:e},ro=di.map,so=Ge("map"),ao=on("map");V({target:"Array",proto:!0,forced:!so||!ao},{map:function(t){return ro(this,t,arguments.length>1?arguments[1]:void 0)}});var ho=dn("Array").map,lo=Array.prototype,uo=function(t){var e=t.map;return t===lo||t instanceof Array&&e===lo.map?ho:e},co=Un.trim,fo=s.parseInt,po=/^[+-]?0[Xx]/,vo=8!==fo(Ln+"08")||22!==fo(Ln+"0x16")?function(t,e){var i=co(String(t));return fo(i,e>>>0||(po.test(i)?16:10))}:fo;V({global:!0,forced:parseInt!=vo},{parseInt:vo});var go=j.parseInt,yo=u.f,mo=function(t){return function(e){for(var i,n=m(e),o=qt(n),r=o.length,s=0,a=[];r>s;)i=o[s++],h&&!yo.call(n,i)||a.push(t?[i,n[i]]:n[i]);return a}},bo=(mo(!0),mo(!1));V({target:"Object",stat:!0},{values:function(t){return bo(t)}});var wo=j.Object.values,_o=di.filter,ko=Ge("filter"),xo=on("filter");V({target:"Array",proto:!0,forced:!ko||!xo},{filter:function(t){return _o(this,t,arguments.length>1?arguments[1]:void 0)}});var Oo=dn("Array").filter,So=Array.prototype,Eo=function(t){var e=t.filter;return t===So||t instanceof Array&&e===So.filter?Oo:e},Do=dn("Array").concat,Mo=Array.prototype,Co=function(t){var e=t.concat;return t===Mo||t instanceof Array&&e===Mo.concat?Do:e},To=function(t){return function(t){if(q(t))return vn(t)}(t)||function(t){if(void 0!==Wi&&je(Object(t)))return Ji(t)}(t)||gn(t)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}()},Po=fn,No=a((function(){Ot(1)}));V({target:"Object",stat:!0,forced:No,sham:!_t},{getPrototypeOf:function(t){return Ot(wt(t))}});var Io=j.Object.getPrototypeOf,Ao=Yt.indexOf,Fo=[].indexOf,jo=!!Fo&&1/[1].indexOf(1,-0)<0,zo=Kn("indexOf"),Bo=on("indexOf",{ACCESSORS:!0,1:0});V({target:"Array",proto:!0,forced:jo||!zo||!Bo},{indexOf:function(t){return jo?Fo.apply(this,arguments)||0:Ao(this,t,arguments.length>1?arguments[1]:void 0)}});var Ro=dn("Array").indexOf,Lo=Array.prototype,Ho=function(t){var e=t.indexOf;return t===Lo||t instanceof Array&&e===Lo.indexOf?Ro:e},Wo=G,Yo=Object.assign,Vo=Object.defineProperty,Uo=!Yo||a((function(){if(h&&1!==Yo({b:1},Yo(Vo({},"a",{enumerable:!0,get:function(){Vo(this,"b",{value:3,enumerable:!1})}}),{b:2})).b)return!0;var t={},e={},i=Symbol();return t[i]=7,"abcdefghijklmnopqrst".split("").forEach((function(t){e[t]=t})),7!=Yo({},t)[i]||"abcdefghijklmnopqrst"!=qt(Yo({},e)).join("")}))?function(t,e){for(var i=wt(t),n=arguments.length,o=1,r=oi.f,s=u.f;n>o;)for(var a,l=g(arguments[o++]),d=r?qt(l).concat(r(l)):qt(l),c=d.length,f=0;c>f;)a=d[f++],h&&!s.call(l,a)||(i[a]=l[a]);return i}:Yo;V({target:"Object",stat:!0,forced:Object.assign!==Uo},{assign:Uo});var Go=j.Object.assign,qo=ri.f("iterator"),Xo=n((function(t){function e(i){return t.exports=e="function"==typeof Wi&&"symbol"==typeof qo?function(t){return typeof t}:function(t){return t&&"function"==typeof Wi&&t.constructor===Wi&&t!==Wi.prototype?"symbol":typeof t},e(i)}t.exports=e}));function $o(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function Ko(t,e){var i=Rn(t);if(Nn){var n=Nn(t);e&&(n=Eo(n).call(n,(function(e){return Pn(t,e).enumerable}))),i.push.apply(i,n)}return i}function Zo(t){for(var e=1;e<arguments.length;e++){var i,n=null!=arguments[e]?arguments[e]:{};if(e%2)oo(i=Ko(Object(n),!0)).call(i,(function(e){jn(t,e,n[e])}));else if(Mn)En(t,Mn(n));else{var o;oo(o=Ko(Object(n))).call(o,(function(e){Sn(t,e,Pn(n,e))}))}}return t}var Qo=/^\/?Date\((-?\d+)/i,Jo=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i,tr=/^#?([a-f\d])([a-f\d])([a-f\d])$/i,er=/^rgb\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *\)$/i,ir=/^rgba\( *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *(1?\d{1,2}|2[0-4]\d|25[0-5]) *, *([01]|0?\.\d+) *\)$/i;function nr(t){return t instanceof Number||"number"==typeof t}function or(t){return t instanceof String||"string"==typeof t}function rr(t){return"object"===Xo(t)&&null!==t}function sr(t,e,i,n){var o=!1;!0===n&&(o=null===e[i]&&void 0!==t[i]),o?delete t[i]:t[i]=e[i]}var ar=Go;function hr(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];for(var o in e)if(Object.prototype.hasOwnProperty.call(e,o)||!0===i)if("object"===Xo(e[o])&&null!==e[o]&&Io(e[o])===Object.prototype)void 0===t[o]?t[o]=hr({},e[o],i):"object"===Xo(t[o])&&null!==t[o]&&Io(t[o])===Object.prototype?hr(t[o],e[o],i):sr(t,e,o,n);else if(Wo(e[o])){var r;t[o]=Po(r=e[o]).call(r)}else sr(t,e,o,n);return t}var lr=wo,dr={asBoolean:function(t,e){return"function"==typeof t&&(t=t()),null!=t?0!=t:e||null},asNumber:function(t,e){return"function"==typeof t&&(t=t()),null!=t?Number(t)||e||null:e||null},asString:function(t,e){return"function"==typeof t&&(t=t()),null!=t?String(t):e||null},asSize:function(t,e){return"function"==typeof t&&(t=t()),or(t)?t:nr(t)?t+"px":e||null},asElement:function(t,e){return"function"==typeof t&&(t=t()),t||e||null}};function ur(t){var e;switch(t.length){case 3:case 4:return(e=tr.exec(t))?{r:go(e[1]+e[1],16),g:go(e[2]+e[2],16),b:go(e[3]+e[3],16)}:null;case 6:case 7:return(e=Jo.exec(t))?{r:go(e[1],16),g:go(e[2],16),b:go(e[3],16)}:null;default:return null}}function cr(t,e,i){var n;return"#"+Po(n=((1<<24)+(t<<16)+(e<<8)+i).toString(16)).call(n,1)}function fr(t,e,i){t/=255,e/=255,i/=255;var n=Math.min(t,Math.min(e,i)),o=Math.max(t,Math.max(e,i));return n===o?{h:0,s:0,v:n}:{h:60*((t===n?3:i===n?1:5)-(t===n?e-i:i===n?t-e:i-t)/(o-n))/360,s:(o-n)/o,v:o}}var pr=function(t){var e,i={};return oo(e=t.split(";")).call(e,(function(t){if(""!=$n(t).call(t)){var e,n,o=t.split(":"),r=$n(e=o[0]).call(e),s=$n(n=o[1]).call(n);i[r]=s}})),i},vr=function(t){var e;return uo(e=Rn(t)).call(e,(function(e){return e+": "+t[e]})).join("; ")};function gr(t,e,i){var n,o,r,s=Math.floor(6*t),a=6*t-s,h=i*(1-e),l=i*(1-a*e),d=i*(1-(1-a)*e);switch(s%6){case 0:n=i,o=d,r=h;break;case 1:n=l,o=i,r=h;break;case 2:n=h,o=i,r=d;break;case 3:n=h,o=l,r=i;break;case 4:n=d,o=h,r=i;break;case 5:n=i,o=h,r=l}return{r:Math.floor(255*n),g:Math.floor(255*o),b:Math.floor(255*r)}}function yr(t,e,i){var n=gr(t,e,i);return cr(n.r,n.g,n.b)}function mr(t){var e=ur(t);if(!e)throw new TypeError("'".concat(t,"' is not a valid color."));return fr(e.r,e.g,e.b)}function br(t){return/(^#[0-9A-F]{6}$)|(^#[0-9A-F]{3}$)/i.test(t)}function wr(t){return er.test(t)}function _r(t){if(null===t||"object"!==Xo(t))return null;if(t instanceof Element)return t;var e=An(t);for(var i in t)Object.prototype.hasOwnProperty.call(t,i)&&"object"==Xo(t[i])&&(e[i]=_r(t[i]));return e}t.Alea=function(){for(var t=arguments.length,e=new Array(t),i=0;i<t;i++)e[i]=arguments[i];return bn(e.length?e:[mn()])},t.HSVToHex=yr,t.HSVToRGB=gr,t.RGBToHSV=fr,t.RGBToHex=cr,t.addClassName=function(t,e){var i=t.className.split(" "),n=e.split(" ");i=Co(i).call(i,Eo(n).call(n,(function(t){return Ho(i).call(i,t)<0}))),t.className=i.join(" ")},t.addCssText=function(t,e){var i=pr(t.style.cssText),n=pr(e),o=Zo(Zo({},i),n);t.style.cssText=vr(o)},t.addEventListener=function(t,e,i,n){var o;t.addEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Ho(o=navigator.userAgent).call(o,"Firefox")>=0&&(e="DOMMouseScroll"),t.addEventListener(e,i,n)):t.attachEvent("on"+e,i)},t.binarySearchCustom=function(t,e,i,n){for(var o=0,r=0,s=t.length-1;r<=s&&o<1e4;){var a=Math.floor((r+s)/2),h=t[a],l=e(void 0===n?h[i]:h[i][n]);if(0==l)return a;-1==l?r=a+1:s=a-1,o++}return-1},t.binarySearchValue=function(t,e,i,n,o){var r,s,a,h,l=0,d=0,u=t.length-1;for(o=null!=o?o:function(t,e){return t==e?0:t<e?-1:1};d<=u&&l<1e4;){if(h=Math.floor(.5*(u+d)),r=t[Math.max(0,h-1)][i],s=t[h][i],a=t[Math.min(t.length-1,h+1)][i],0==o(s,e))return h;if(o(r,e)<0&&o(s,e)>0)return"before"==n?Math.max(0,h-1):h;if(o(s,e)<0&&o(a,e)>0)return"before"==n?h:Math.min(t.length-1,h+1);o(s,e)<0?d=h+1:u=h-1,l++}return-1},t.bridgeObject=_r,t.copyAndExtendArray=function(t,e){var i;return Co(i=[]).call(i,To(t),[e])},t.copyArray=function(t){return Po(t).call(t)},t.deepExtend=hr,t.easingFunctions={linear:function(t){return t},easeInQuad:function(t){return t*t},easeOutQuad:function(t){return t*(2-t)},easeInOutQuad:function(t){return t<.5?2*t*t:(4-2*t)*t-1},easeInCubic:function(t){return t*t*t},easeOutCubic:function(t){return--t*t*t+1},easeInOutCubic:function(t){return t<.5?4*t*t*t:(t-1)*(2*t-2)*(2*t-2)+1},easeInQuart:function(t){return t*t*t*t},easeOutQuart:function(t){return 1- --t*t*t*t},easeInOutQuart:function(t){return t<.5?8*t*t*t*t:1-8*--t*t*t*t},easeInQuint:function(t){return t*t*t*t*t},easeOutQuint:function(t){return 1+--t*t*t*t*t},easeInOutQuint:function(t){return t<.5?16*t*t*t*t*t:1+16*--t*t*t*t*t}},t.equalArray=function(t,e){if(t.length!==e.length)return!1;for(var i=0,n=t.length;i<n;i++)if(t[i]!=e[i])return!1;return!0},t.extend=ar,t.fillIfDefined=function t(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];for(var o in e)if(void 0!==i[o])if(null===i[o]||"object"!==Xo(i[o]))sr(e,i,o,n);else{var r=e[o],s=i[o];rr(r)&&rr(s)&&t(r,s,n)}},t.forEach=function(t,e){if(Wo(t))for(var i=t.length,n=0;n<i;n++)e(t[n],n,t);else for(var o in t)Object.prototype.hasOwnProperty.call(t,o)&&e(t[o],o,t)},t.getAbsoluteLeft=function(t){return t.getBoundingClientRect().left},t.getAbsoluteRight=function(t){return t.getBoundingClientRect().right},t.getAbsoluteTop=function(t){return t.getBoundingClientRect().top},t.getScrollBarWidth=function(){var t=document.createElement("p");t.style.width="100%",t.style.height="200px";var e=document.createElement("div");e.style.position="absolute",e.style.top="0px",e.style.left="0px",e.style.visibility="hidden",e.style.width="200px",e.style.height="150px",e.style.overflow="hidden",e.appendChild(t),document.body.appendChild(e);var i=t.offsetWidth;e.style.overflow="scroll";var n=t.offsetWidth;return i==n&&(n=e.clientWidth),document.body.removeChild(e),i-n},t.getTarget=function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window.event,e=null;return t&&(t.target?e=t.target:t.srcElement&&(e=t.srcElement)),e instanceof Element&&(null==e.nodeType||3!=e.nodeType||(e=e.parentNode)instanceof Element)?e:null},t.getType=function(t){var e=Xo(t);return"object"===e?null===t?"null":t instanceof Boolean?"Boolean":t instanceof Number?"Number":t instanceof String?"String":Wo(t)?"Array":t instanceof Date?"Date":"Object":"number"===e?"Number":"boolean"===e?"Boolean":"string"===e?"String":void 0===e?"undefined":e},t.hasParent=function(t,e){for(var i=t;i;){if(i===e)return!0;if(!i.parentNode)return!1;i=i.parentNode}return!1},t.hexToHSV=mr,t.hexToRGB=ur,t.insertSort=function(t,e){for(var i=0;i<t.length;i++){var n=t[i],o=void 0;for(o=i;o>0&&e(n,t[o-1])<0;o--)t[o]=t[o-1];t[o]=n}return t},t.isDate=function(t){if(t instanceof Date)return!0;if(or(t)){if(Qo.exec(t))return!0;if(!isNaN(Date.parse(t)))return!0}return!1},t.isNumber=nr,t.isObject=rr,t.isString=or,t.isValidHex=br,t.isValidRGB=wr,t.isValidRGBA=function(t){return ir.test(t)},t.mergeOptions=function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=function(t){return null!=t},r=function(t){return null!==t&&"object"===Xo(t)},s=function(t){for(var e in t)if(Object.prototype.hasOwnProperty.call(t,e))return!1;return!0};if(!r(t))throw new Error("Parameter mergeTarget must be an object");if(!r(e))throw new Error("Parameter options must be an object");if(!o(i))throw new Error("Parameter option must have a value");if(!r(n))throw new Error("Parameter globalOptions must be an object");var a=function(t,e,i){r(t[i])||(t[i]={});var n=e[i],o=t[i];for(var s in n)Object.prototype.hasOwnProperty.call(n,s)&&(o[s]=n[s])},h=e[i],l=r(n)&&!s(n),d=l?n[i]:void 0,u=d?d.enabled:void 0;if(void 0!==h){if("boolean"==typeof h)return r(t[i])||(t[i]={}),void(t[i].enabled=h);if(null===h&&!r(t[i])){if(!o(d))return;t[i]=An(d)}if(r(h)){var c=!0;void 0!==h.enabled?c=h.enabled:void 0!==u&&(c=d.enabled),a(t,e,i),t[i].enabled=c}}},t.option=dr,t.overrideOpacity=function(t,e){if(-1!==Ho(t).call(t,"rgba"))return t;if(-1!==Ho(t).call(t,"rgb")){var i=t.substr(Ho(t).call(t,"(")+1).replace(")","").split(",");return"rgba("+i[0]+","+i[1]+","+i[2]+","+e+")"}var n=ur(t);return null==n?t:"rgba("+n.r+","+n.g+","+n.b+","+e+")"},t.parseColor=function(t,e){if(or(t)){var i=t;if(wr(i)){var n,o=uo(n=i.substr(4).substr(0,i.length-5).split(",")).call(n,(function(t){return go(t)}));i=cr(o[0],o[1],o[2])}if(!0===br(i)){var r=mr(i),s={h:r.h,s:.8*r.s,v:Math.min(1,1.02*r.v)},a={h:r.h,s:Math.min(1,1.25*r.s),v:.8*r.v},h=yr(a.h,a.s,a.v),l=yr(s.h,s.s,s.v);return{background:i,border:h,highlight:{background:l,border:h},hover:{background:l,border:h}}}return{background:i,border:i,highlight:{background:i,border:i},hover:{background:i,border:i}}}return e?{background:t.background||e.background,border:t.border||e.border,highlight:or(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||e.highlight.background,border:t.highlight&&t.highlight.border||e.highlight.border},hover:or(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||e.hover.border,background:t.hover&&t.hover.background||e.hover.background}}:{background:t.background||void 0,border:t.border||void 0,highlight:or(t.highlight)?{border:t.highlight,background:t.highlight}:{background:t.highlight&&t.highlight.background||void 0,border:t.highlight&&t.highlight.border||void 0},hover:or(t.hover)?{border:t.hover,background:t.hover}:{border:t.hover&&t.hover.border||void 0,background:t.hover&&t.hover.background||void 0}}},t.preventDefault=function(t){t||(t=window.event),t&&(t.preventDefault?t.preventDefault():t.returnValue=!1)},t.recursiveDOMDelete=function t(e){if(e)for(;!0===e.hasChildNodes();){var i=e.firstChild;i&&(t(i),e.removeChild(i))}},t.removeClassName=function(t,e){var i=t.className.split(" "),n=e.split(" ");i=Eo(i).call(i,(function(t){return Ho(n).call(n,t)<0})),t.className=i.join(" ")},t.removeCssText=function(t,e){var i=pr(t.style.cssText),n=pr(e);for(var o in n)Object.prototype.hasOwnProperty.call(n,o)&&delete i[o];t.style.cssText=vr(i)},t.removeEventListener=function(t,e,i,n){var o;t.removeEventListener?(void 0===n&&(n=!1),"mousewheel"===e&&Ho(o=navigator.userAgent).call(o,"Firefox")>=0&&(e="DOMMouseScroll"),t.removeEventListener(e,i,n)):t.detachEvent("on"+e,i)},t.selectiveBridgeObject=function(t,e){if(null!==e&&"object"===Xo(e)){for(var i=An(e),n=0;n<t.length;n++)Object.prototype.hasOwnProperty.call(e,t[n])&&"object"==Xo(e[t[n]])&&(i[t[n]]=_r(e[t[n]]));return i}return null},t.selectiveDeepExtend=function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Wo(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o=0;o<t.length;o++){var r=t[o];if(Object.prototype.hasOwnProperty.call(i,r))if(i[r]&&i[r].constructor===Object)void 0===e[r]&&(e[r]={}),e[r].constructor===Object?hr(e[r],i[r],!1,n):sr(e,i,r,n);else{if(Wo(i[r]))throw new TypeError("Arrays are not supported by deepExtend");sr(e,i,r,n)}}return e},t.selectiveExtend=function(t,e){if(!Wo(t))throw new Error("Array with property names expected as first argument");for(var i=arguments.length,n=new Array(i>2?i-2:0),o=2;o<i;o++)n[o-2]=arguments[o];for(var r=0,s=n;r<s.length;r++)for(var a=s[r],h=0;h<t.length;h++){var l=t[h];a&&Object.prototype.hasOwnProperty.call(a,l)&&(e[l]=a[l])}return e},t.selectiveNotDeepExtend=function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]&&arguments[3];if(Wo(i))throw new TypeError("Arrays are not supported by deepExtend");for(var o in i)if(Object.prototype.hasOwnProperty.call(i,o)&&-1===Ho(t).call(t,o))if(i[o]&&i[o].constructor===Object)void 0===e[o]&&(e[o]={}),e[o].constructor===Object?hr(e[o],i[o]):sr(e,i,o,n);else if(Wo(i[o])){e[o]=[];for(var r=0;r<i[o].length;r++)e[o].push(i[o][r])}else sr(e,i,o,n);return e},t.throttle=function(t){var e=!1;return function(){e||(e=!0,requestAnimationFrame((function(){e=!1,t()})))}},t.toArray=lr,t.topMost=function(t,e){var i;Wo(e)||(e=[e]);var n,o=function(t){if(void 0===kn||null==_n(t)){if(Wo(t)||(t=function(t,e){var i;if(t){if("string"==typeof t)return $o(t,e);var n=Po(i=Object.prototype.toString.call(t)).call(i,8,-1);return"Object"===n&&t.constructor&&(n=t.constructor.name),"Map"===n||"Set"===n?xn(t):"Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)?$o(t,e):void 0}}(t))){var e=0,i=function(){};return{s:i,n:function(){return e>=t.length?{done:!0}:{done:!1,value:t[e++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var n,o,r=!0,s=!1;return{s:function(){n=Ae(t)},n:function(){var t=n.next();return r=t.done,t},e:function(t){s=!0,o=t},f:function(){try{r||null==n.return||n.return()}finally{if(s)throw o}}}}(t);try{for(o.s();!(n=o.n()).done;){var r=n.value;if(r){i=r[e[0]];for(var s=1;s<e.length;s++)i&&(i=i[e[s]]);if(void 0!==i)break}}}catch(t){o.e(t)}finally{o.f()}return i},t.updateProperty=function(t,e,i){return t[e]!==i&&(t[e]=i,!0)},Object.defineProperty(t,"__esModule",{value:!0})}(i)}));function qh(t){var e,i,n=this;this.active=!1,this.dom={container:t},this.dom.overlay=document.createElement("div"),this.dom.overlay.className="vis-overlay",this.dom.container.appendChild(this.dom.overlay),this.hammer=Vh(this.dom.overlay),this.hammer.on("tap",J(e=this._onTapOverlay).call(e,this));var o=["tap","doubletap","press","pinch","pan","panstart","panmove","panend"];Jn(o).call(o,(function(t){n.hammer.on(t,(function(t){t.srcEvent.stopPropagation()}))})),document&&document.body&&(this.onClick=function(e){(function(t,e){for(;t;){if(t===e)return!0;t=t.parentNode}return!1})(e.target,t)||n.deactivate()},document.body.addEventListener("click",this.onClick)),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=va(),this.escListener=J(i=this.deactivate).call(i,this)}n(Gh),(Wh=pa)&&Wh.default,st(qh.prototype),qh.current=null,qh.prototype.destroy=function(){this.deactivate(),this.dom.overlay.parentNode.removeChild(this.dom.overlay),this.onClick&&document.body.removeEventListener("click",this.onClick),void 0!==this.keycharm&&this.keycharm.destroy(),this.keycharm=null,this.hammer.destroy(),this.hammer=null},qh.prototype.activate=function(){var t;qh.current&&qh.current.deactivate(),qh.current=this,this.active=!0,this.dom.overlay.style.display="none",Gh.addClassName(this.dom.container,"vis-active"),this.emit("change"),this.emit("activate"),J(t=this.keycharm).call(t,"esc",this.escListener)},qh.prototype.deactivate=function(){this.active=!1,this.dom.overlay.style.display="block",Gh.removeClassName(this.dom.container,"vis-active"),this.keycharm.unbind("esc",this.escListener),this.emit("change"),this.emit("deactivate")},qh.prototype._onTapOverlay=function(t){this.activate(),t.srcEvent.stopPropagation()};var Xh=qh,$h=Object.freeze({__proto__:null,en:{addDescription:"Click in an empty space to place a new node.",addEdge:"Add Edge",addNode:"Add Node",back:"Back",createEdgeError:"Cannot link edges to a cluster.",del:"Delete selected",deleteClusterError:"Clusters cannot be deleted.",edgeDescription:"Click on a node and drag the edge to another node to connect them.",edit:"Edit",editClusterError:"Clusters cannot be edited.",editEdge:"Edit Edge",editEdgeDescription:"Click on the control points and drag them to a node to connect to it.",editNode:"Edit Node"},de:{addDescription:"Klicke auf eine freie Stelle, um einen neuen Knoten zu plazieren.",addEdge:"Kante hinzufügen",addNode:"Knoten hinzufügen",back:"Zurück",createEdgeError:"Es ist nicht möglich, Kanten mit Clustern zu verbinden.",del:"Lösche Auswahl",deleteClusterError:"Cluster können nicht gelöscht werden.",edgeDescription:"Klicke auf einen Knoten und ziehe die Kante zu einem anderen Knoten, um diese zu verbinden.",edit:"Editieren",editClusterError:"Cluster können nicht editiert werden.",editEdge:"Kante editieren",editEdgeDescription:"Klicke auf die Verbindungspunkte und ziehe diese auf einen Knoten, um sie zu verbinden.",editNode:"Knoten editieren"},es:{addDescription:"Haga clic en un lugar vacío para colocar un nuevo nodo.",addEdge:"Añadir arista",addNode:"Añadir nodo",back:"Atrás",createEdgeError:"No se puede conectar una arista a un grupo.",del:"Eliminar selección",deleteClusterError:"No es posible eliminar grupos.",edgeDescription:"Haga clic en un nodo y arrastre la arista hacia otro nodo para conectarlos.",edit:"Editar",editClusterError:"No es posible editar grupos.",editEdge:"Editar arista",editEdgeDescription:"Haga clic en un punto de control y arrastrelo a un nodo para conectarlo.",editNode:"Editar nodo"},it:{addDescription:"Clicca per aggiungere un nuovo nodo",addEdge:"Aggiungi un vertice",addNode:"Aggiungi un nodo",back:"Indietro",createEdgeError:"Non si possono collegare vertici ad un cluster",del:"Cancella la selezione",deleteClusterError:"I cluster non possono essere cancellati",edgeDescription:"Clicca su un nodo e trascinalo ad un altro nodo per connetterli.",edit:"Modifica",editClusterError:"I clusters non possono essere modificati.",editEdge:"Modifica il vertice",editEdgeDescription:"Clicca sui Punti di controllo e trascinali ad un nodo per connetterli.",editNode:"Modifica il nodo"},nl:{addDescription:"Klik op een leeg gebied om een nieuwe node te maken.",addEdge:"Link toevoegen",addNode:"Node toevoegen",back:"Terug",createEdgeError:"Kan geen link maken naar een cluster.",del:"Selectie verwijderen",deleteClusterError:"Clusters kunnen niet worden verwijderd.",edgeDescription:"Klik op een node en sleep de link naar een andere node om ze te verbinden.",edit:"Wijzigen",editClusterError:"Clusters kunnen niet worden aangepast.",editEdge:"Link wijzigen",editEdgeDescription:"Klik op de verbindingspunten en sleep ze naar een node om daarmee te verbinden.",editNode:"Node wijzigen"},pt:{addDescription:"Clique em um espaço em branco para adicionar um novo nó",addEdge:"Adicionar aresta",addNode:"Adicionar nó",back:"Voltar",createEdgeError:"Não foi possível linkar arestas a um cluster.",del:"Remover selecionado",deleteClusterError:"Clusters não puderam ser removidos.",edgeDescription:"Clique em um nó e arraste a aresta até outro nó para conectá-los",edit:"Editar",editClusterError:"Clusters não puderam ser editados.",editEdge:"Editar aresta",editEdgeDescription:"Clique nos pontos de controle e os arraste para um nó para conectá-los",editNode:"Editar nó"},ru:{addDescription:"Кликните в свободное место, чтобы добавить новый узел.",addEdge:"Добавить ребро",addNode:"Добавить узел",back:"Назад",createEdgeError:"Невозможно соединить ребра в кластер.",del:"Удалить выбранное",deleteClusterError:"Кластеры не могут быть удалены",edgeDescription:"Кликните на узел и протяните ребро к другому узлу, чтобы соединить их.",edit:"Редактировать",editClusterError:"Кластеры недоступны для редактирования.",editEdge:"Редактировать ребро",editEdgeDescription:"Кликните на контрольные точки и перетащите их в узел, чтобы подключиться к нему.",editNode:"Редактировать узел"},cn:{addDescription:"单击空白处放置新节点。",addEdge:"添加连接线",addNode:"添加节点",back:"返回",createEdgeError:"无法将连接线连接到群集。",del:"删除选定",deleteClusterError:"无法删除群集。",edgeDescription:"单击某个节点并将该连接线拖动到另一个节点以连接它们。",edit:"编辑",editClusterError:"无法编辑群集。",editEdge:"编辑连接线",editEdgeDescription:"单击控制节点并将它们拖到节点上连接。",editNode:"编辑节点"},uk:{addDescription:"Kлікніть на вільне місце, щоб додати новий вузол.",addEdge:"Додати край",addNode:"Додати вузол",back:"Назад",createEdgeError:"Не можливо об'єднати краї в групу.",del:"Видалити обране",deleteClusterError:"Групи не можуть бути видалені.",edgeDescription:"Клікніть на вузол і перетягніть край до іншого вузла, щоб їх з'єднати.",edit:"Редагувати",editClusterError:"Групи недоступні для редагування.",editEdge:"Редагувати край",editEdgeDescription:"Клікніть на контрольні точки і перетягніть їх у вузол, щоб підключитися до нього.",editNode:"Редагувати вузол"},fr:{addDescription:"Cliquez dans un endroit vide pour placer un nœud.",addEdge:"Ajouter un lien",addNode:"Ajouter un nœud",back:"Retour",createEdgeError:"Impossible de créer un lien vers un cluster.",del:"Effacer la sélection",deleteClusterError:"Les clusters ne peuvent pas être effacés.",edgeDescription:"Cliquez sur un nœud et glissez le lien vers un autre nœud pour les connecter.",edit:"Éditer",editClusterError:"Les clusters ne peuvent pas être édités.",editEdge:"Éditer le lien",editEdgeDescription:"Cliquez sur les points de contrôle et glissez-les pour connecter un nœud.",editNode:"Éditer le nœud"},cs:{addDescription:"Kluknutím do prázdného prostoru můžete přidat nový vrchol.",addEdge:"Přidat hranu",addNode:"Přidat vrchol",back:"Zpět",createEdgeError:"Nelze připojit hranu ke shluku.",del:"Smazat výběr",deleteClusterError:"Nelze mazat shluky.",edgeDescription:"Přetažením z jednoho vrcholu do druhého můžete spojit tyto vrcholy novou hranou.",edit:"Upravit",editClusterError:"Nelze upravovat shluky.",editEdge:"Upravit hranu",editEdgeDescription:"Přetažením kontrolního vrcholu hrany ji můžete připojit k jinému vrcholu.",editNode:"Upravit vrchol"}});var Kh=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")};function Zh(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),En(t,n.key,n)}}var Qh=function(t,e,i){return e&&Zh(t.prototype,e),i&&Zh(t,i),t},Jh=function(){function t(){Kh(this,t),this.NUM_ITERATIONS=4,this.image=new Image,this.canvas=document.createElement("canvas")}return Qh(t,[{key:"init",value:function(){if(!this.initialized()){this.src=this.image.src;var t=this.image.width,e=this.image.height;this.width=t,this.height=e;var i=Math.floor(e/2),n=Math.floor(e/4),o=Math.floor(e/8),r=Math.floor(e/16),s=Math.floor(t/2),a=Math.floor(t/4),h=Math.floor(t/8),l=Math.floor(t/16);this.canvas.width=3*a,this.canvas.height=i,this.coordinates=[[0,0,s,i],[s,0,a,n],[s,n,h,o],[5*h,n,l,r]],this._fillMipMap()}}},{key:"initialized",value:function(){return void 0!==this.coordinates}},{key:"_fillMipMap",value:function(){var t=this.canvas.getContext("2d"),e=this.coordinates[0];t.drawImage(this.image,e[0],e[1],e[2],e[3]);for(var i=1;i<this.NUM_ITERATIONS;i++){var n=this.coordinates[i-1],o=this.coordinates[i];t.drawImage(this.canvas,n[0],n[1],n[2],n[3],o[0],o[1],o[2],o[3])}}},{key:"drawImageAtPosition",value:function(t,e,i,n,o,r){if(this.initialized())if(e>2){e*=.5;for(var s=0;e>2&&s<this.NUM_ITERATIONS;)e*=.5,s+=1;s>=this.NUM_ITERATIONS&&(s=this.NUM_ITERATIONS-1);var a=this.coordinates[s];t.drawImage(this.canvas,a[0],a[1],a[2],a[3],i,n,o,r)}else t.drawImage(this.image,i,n,o,r)}}]),t}(),tl=function(){function t(e){Kh(this,t),this.images={},this.imageBroken={},this.callback=e}return Qh(t,[{key:"_tryloadBrokenUrl",value:function(t,e,i){void 0!==t&&void 0!==i&&(void 0!==e?(i.image.onerror=function(){console.error("Could not load brokenImage:",e)},i.image.src=e):console.warn("No broken url image defined"))}},{key:"_redrawWithImage",value:function(t){this.callback&&this.callback(t)}},{key:"load",value:function(t,e){var i=this,n=this.images[t];if(n)return n;var o=new Jh;return this.images[t]=o,o.image.onload=function(){i._fixImageCoordinates(o.image),o.init(),i._redrawWithImage(o)},o.image.onerror=function(){console.error("Could not load image:",t),i._tryloadBrokenUrl(t,e,o)},o.image.src=t,o}},{key:"_fixImageCoordinates",value:function(t){0===t.width&&(document.body.appendChild(t),t.width=t.offsetWidth,t.height=t.offsetHeight,document.body.removeChild(t))}}]),t}(),el=function(){function t(){Kh(this,t),this.clear(),this.defaultIndex=0,this.groupsArray=[],this.groupIndex=0,this.defaultGroups=[{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},{border:"#FFA500",background:"#FFFF00",highlight:{border:"#FFA500",background:"#FFFFA3"},hover:{border:"#FFA500",background:"#FFFFA3"}},{border:"#FA0A10",background:"#FB7E81",highlight:{border:"#FA0A10",background:"#FFAFB1"},hover:{border:"#FA0A10",background:"#FFAFB1"}},{border:"#41A906",background:"#7BE141",highlight:{border:"#41A906",background:"#A1EC76"},hover:{border:"#41A906",background:"#A1EC76"}},{border:"#E129F0",background:"#EB7DF4",highlight:{border:"#E129F0",background:"#F0B3F5"},hover:{border:"#E129F0",background:"#F0B3F5"}},{border:"#7C29F0",background:"#AD85E4",highlight:{border:"#7C29F0",background:"#D3BDF0"},hover:{border:"#7C29F0",background:"#D3BDF0"}},{border:"#C37F00",background:"#FFA807",highlight:{border:"#C37F00",background:"#FFCA66"},hover:{border:"#C37F00",background:"#FFCA66"}},{border:"#4220FB",background:"#6E6EFD",highlight:{border:"#4220FB",background:"#9B9BFD"},hover:{border:"#4220FB",background:"#9B9BFD"}},{border:"#FD5A77",background:"#FFC0CB",highlight:{border:"#FD5A77",background:"#FFD1D9"},hover:{border:"#FD5A77",background:"#FFD1D9"}},{border:"#4AD63A",background:"#C2FABC",highlight:{border:"#4AD63A",background:"#E6FFE3"},hover:{border:"#4AD63A",background:"#E6FFE3"}},{border:"#990000",background:"#EE0000",highlight:{border:"#BB0000",background:"#FF3333"},hover:{border:"#BB0000",background:"#FF3333"}},{border:"#FF6000",background:"#FF6000",highlight:{border:"#FF6000",background:"#FF6000"},hover:{border:"#FF6000",background:"#FF6000"}},{border:"#97C2FC",background:"#2B7CE9",highlight:{border:"#D2E5FF",background:"#2B7CE9"},hover:{border:"#D2E5FF",background:"#2B7CE9"}},{border:"#399605",background:"#255C03",highlight:{border:"#399605",background:"#255C03"},hover:{border:"#399605",background:"#255C03"}},{border:"#B70054",background:"#FF007E",highlight:{border:"#B70054",background:"#FF007E"},hover:{border:"#B70054",background:"#FF007E"}},{border:"#AD85E4",background:"#7C29F0",highlight:{border:"#D3BDF0",background:"#7C29F0"},hover:{border:"#D3BDF0",background:"#7C29F0"}},{border:"#4557FA",background:"#000EA1",highlight:{border:"#6E6EFD",background:"#000EA1"},hover:{border:"#6E6EFD",background:"#000EA1"}},{border:"#FFC0CB",background:"#FD5A77",highlight:{border:"#FFD1D9",background:"#FD5A77"},hover:{border:"#FFD1D9",background:"#FD5A77"}},{border:"#C2FABC",background:"#74D66A",highlight:{border:"#E6FFE3",background:"#74D66A"},hover:{border:"#E6FFE3",background:"#74D66A"}},{border:"#EE0000",background:"#990000",highlight:{border:"#FF3333",background:"#BB0000"},hover:{border:"#FF3333",background:"#BB0000"}}],this.options={},this.defaultOptions={useDefaultGroups:!0},Fr(this.options,this.defaultOptions)}return Qh(t,[{key:"setOptions",value:function(t){var e=["useDefaultGroups"];if(void 0!==t)for(var i in t)if(t.hasOwnProperty(i)&&-1===nr(e).call(e,i)){var n=t[i];this.add(i,n)}}},{key:"clear",value:function(){this.groups={},this.groupsArray=[]}},{key:"get",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.groups[t];if(void 0===i&&e)if(!1===this.options.useDefaultGroups&&this.groupsArray.length>0){var n=this.groupIndex%this.groupsArray.length;this.groupIndex++,(i={}).color=this.groups[this.groupsArray[n]],this.groups[t]=i}else{var o=this.defaultIndex%this.defaultGroups.length;this.defaultIndex++,(i={}).color=this.defaultGroups[o],this.groups[t]=i}return i}},{key:"add",value:function(t,e){return this.groups[t]=e,this.groupsArray.push(t),e}}]),t}(),il=[].slice,nl=/MSIE .\./.test(ti),ol=function(t){return function(e,i){var n=arguments.length>2,o=n?il.call(arguments,2):void 0;return t(n?function(){("function"==typeof e?e:Function(e)).apply(this,o)}:e,i)}};U({global:!0,bind:!0,forced:nl},{setTimeout:ol(s.setTimeout),setInterval:ol(s.setInterval)});var rl=j.setTimeout,sl=xi.some,al=Hn("some"),hl=Un("some");U({target:"Array",proto:!0,forced:!al||!hl},{some:function(t){return sl(this,t,arguments.length>1?arguments[1]:void 0)}});var ll=K("Array").some,dl=Array.prototype,ul=function(t){var e=t.some;return t===dl||t instanceof Array&&e===dl.some?ll:e},cl=s.isFinite,fl=Number.isFinite||function(t){return"number"==typeof t&&cl(t)};U({target:"Number",stat:!0},{isFinite:fl});var pl=j.Number.isFinite;U({target:"Number",stat:!0},{isNaN:function(t){return t!=t}});var vl=j.Number.isNaN;var gl=function(t){if(void 0===t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return t},yl=le("Reflect","construct"),ml=a((function(){function t(){}return!(yl((function(){}),[],t)instanceof t)})),bl=!a((function(){yl((function(){}))})),wl=ml||bl;U({target:"Reflect",stat:!0,forced:wl,sham:wl},{construct:function(t,e){z(t),R(e);var i=arguments.length<3?t:z(arguments[2]);if(bl&&!ml)return yl(t,e,i);if(t==i){switch(e.length){case 0:return new t;case 1:return new t(e[0]);case 2:return new t(e[0],e[1]);case 3:return new t(e[0],e[1],e[2]);case 4:return new t(e[0],e[1],e[2],e[3])}var n=[null];return n.push.apply(n,e),new($.apply(t,n))}var o=i.prototype,r=ve(b(o)?o:Object.prototype),s=Function.apply.call(t,r,e);return b(s)?s:r}});var _l=j.Reflect.construct,kl=K("Array").entries,xl=Array.prototype,Ol={DOMTokenList:!0,NodeList:!0},Sl=function(t){var e=t.entries;return t===xl||t instanceof Array&&e===xl.entries||Ol.hasOwnProperty(we(t))?kl:e},El=le("JSON","stringify"),Dl=/[\uD800-\uDFFF]/g,Ml=/^[\uD800-\uDBFF]$/,Cl=/^[\uDC00-\uDFFF]$/,Tl=function(t,e,i){var n=i.charAt(e-1),o=i.charAt(e+1);return Ml.test(t)&&!Cl.test(o)||Cl.test(t)&&!Ml.test(n)?"\\u"+t.charCodeAt(0).toString(16):t},Pl=a((function(){return'"\\udf06\\ud834"'!==El("\udf06\ud834")||'"\\udead"'!==El("\udead")}));El&&U({target:"JSON",stat:!0,forced:Pl},{stringify:function(t,e,i){var n=El.apply(null,arguments);return"string"==typeof n?n.replace(Dl,Tl):n}}),j.JSON||(j.JSON={stringify:JSON.stringify});var Nl=function(t,e,i){return j.JSON.stringify.apply(null,arguments)},Il=K("Array").values,Al=Array.prototype,Fl={DOMTokenList:!0,NodeList:!0},jl=function(t){var e=t.values;return t===Al||t instanceof Array&&e===Al.values||Fl.hasOwnProperty(we(t))?Il:e},zl=K("Array").keys,Bl=Array.prototype,Rl={DOMTokenList:!0,NodeList:!0},Ll=function(t){var e=t.keys;return t===Bl||t instanceof Array&&e===Bl.keys||Rl.hasOwnProperty(we(t))?zl:e},Hl=On;U({target:"Object",stat:!0},{setPrototypeOf:De});var Wl=j.Object.setPrototypeOf,Yl=o((function(t){function e(i,n){return t.exports=e=Wl||function(t,e){return t.__proto__=e,t},e(i,n)}t.exports=e}));var Vl=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function");t.prototype=Hl(e&&e.prototype,{constructor:{value:t,writable:!0,configurable:!0}}),e&&Yl(t,e)};var Ul=function(t,e){return!e||"object"!==ur(e)&&"function"!=typeof e?gl(t):e},Gl=Xo,ql=o((function(t){function e(i){return t.exports=e=Wl?Gl:function(t){return t.__proto__||Gl(t)},e(i)}t.exports=e})),Xl=[],$l=Xl.sort,Kl=a((function(){Xl.sort(void 0)})),Zl=a((function(){Xl.sort(null)})),Ql=Hn("sort");U({target:"Array",proto:!0,forced:Kl||!Zl||!Ql},{sort:function(t){return void 0===t?$l.call(It(this)):$l.call(It(this),z(t))}});var Jl=K("Array").sort,td=Array.prototype,ed=function(t){var e=t.sort;return t===td||t instanceof Array&&e===td.sort?Jl:e},id=!a((function(){return Object.isExtensible(Object.preventExtensions({}))})),nd=o((function(t){var e=H.f,i=bt("meta"),n=0,o=Object.isExtensible||function(){return!0},r=function(t){e(t,i,{value:{objectID:"O"+ ++n,weakData:{}}})},s=t.exports={REQUIRED:!1,fastKey:function(t,e){if(!b(t))return"symbol"==typeof t?t:("string"==typeof t?"S":"P")+t;if(!k(t,i)){if(!o(t))return"F";if(!e)return"E";r(t)}return t[i].objectID},getWeakData:function(t,e){if(!k(t,i)){if(!o(t))return!0;if(!e)return!1;r(t)}return t[i].weakData},onFreeze:function(t){return id&&s.REQUIRED&&o(t)&&!k(t,i)&&r(t),t}};kt[i]=!0})),od=(nd.REQUIRED,nd.fastKey,nd.getWeakData,nd.onFreeze,o((function(t){var e=function(t,e){this.stopped=t,this.result=e};(t.exports=function(t,i,n,o,r){var s,a,h,l,d,u,c,f=B(i,n,o?2:1);if(r)s=t;else{if("function"!=typeof(a=qe(t)))throw TypeError("Target is not iterable");if(rn(a)){for(h=0,l=Zt(t.length);l>h;h++)if((d=o?f(R(c=t[h])[0],c[1]):f(t[h]))&&d instanceof e)return d;return new e(!1)}s=a.call(t)}for(u=s.next;!(c=u.call(s)).done;)if("object"==typeof(d=en(s,f,c.value,o))&&d&&d instanceof e)return d;return new e(!1)}).stop=function(t){return new e(!0,t)}}))),rd=function(t,e,i){if(!(t instanceof e))throw TypeError("Incorrect "+(i?i+" ":"")+"invocation");return t},sd=H.f,ad=xi.forEach,hd=Nt.set,ld=Nt.getterFor,dd=function(t,e,i){var n,o=-1!==t.indexOf("Map"),r=-1!==t.indexOf("Weak"),l=o?"set":"add",d=s[t],u=d&&d.prototype,c={};if(h&&"function"==typeof d&&(r||u.forEach&&!a((function(){(new d).entries().next()})))){n=e((function(e,i){hd(rd(e,n,t),{type:t,collection:new d}),null!=i&&od(i,e[l],e,o)}));var f=ld(t);ad(["add","clear","delete","forEach","get","has","set","keys","values","entries"],(function(t){var e="add"==t||"set"==t;t in u&&(!r||"clear"!=t)&&W(n.prototype,t,(function(i,n){var o=f(this).collection;if(!e&&r&&!b(i))return"get"==t&&void 0;var s=o[t](0===i?0:i,n);return e?this:s}))})),r||sd(n.prototype,"size",{configurable:!0,get:function(){return f(this).collection.size}})}else n=i.getConstructor(e,t,o,l),nd.REQUIRED=!0;return Oe(n,t,!1,!0),c[t]=n,U({global:!0,forced:!0},c),r||i.setStrong(n,t,o),n},ud=function(t,e,i){for(var n in e)i&&i.unsafe&&t[n]?t[n]=e[n]:Me(t,n,e[n],i);return t},cd=Yt("species"),fd=H.f,pd=nd.fastKey,vd=Nt.set,gd=Nt.getterFor,yd={getConstructor:function(t,e,i,n){var o=t((function(t,r){rd(t,o,e),vd(t,{type:e,index:ve(null),first:void 0,last:void 0,size:0}),h||(t.size=0),null!=r&&od(r,t[n],t,i)})),r=gd(e),s=function(t,e,i){var n,o,s=r(t),l=a(t,e);return l?l.value=i:(s.last=l={index:o=pd(e,!0),key:e,value:i,previous:n=s.last,next:void 0,removed:!1},s.first||(s.first=l),n&&(n.next=l),h?s.size++:t.size++,"F"!==o&&(s.index[o]=l)),t},a=function(t,e){var i,n=r(t),o=pd(e);if("F"!==o)return n.index[o];for(i=n.first;i;i=i.next)if(i.key==e)return i};return ud(o.prototype,{clear:function(){for(var t=r(this),e=t.index,i=t.first;i;)i.removed=!0,i.previous&&(i.previous=i.previous.next=void 0),delete e[i.index],i=i.next;t.first=t.last=void 0,h?t.size=0:this.size=0},delete:function(t){var e=r(this),i=a(this,t);if(i){var n=i.next,o=i.previous;delete e.index[i.index],i.removed=!0,o&&(o.next=n),n&&(n.previous=o),e.first==i&&(e.first=n),e.last==i&&(e.last=o),h?e.size--:this.size--}return!!i},forEach:function(t){for(var e,i=r(this),n=B(t,arguments.length>1?arguments[1]:void 0,3);e=e?e.next:i.first;)for(n(e.value,e.key,this);e&&e.removed;)e=e.previous},has:function(t){return!!a(this,t)}}),ud(o.prototype,i?{get:function(t){var e=a(this,t);return e&&e.value},set:function(t,e){return s(this,0===t?0:t,e)}}:{add:function(t){return s(this,t=0===t?0:t,t)}}),h&&fd(o.prototype,"size",{get:function(){return r(this).size}}),o},setStrong:function(t,e,i){var n=e+" Iterator",o=gd(e),r=gd(n);Ie(t,e,(function(t,e){vd(this,{type:n,target:t,state:o(t),kind:e,last:void 0})}),(function(){for(var t=r(this),e=t.kind,i=t.last;i&&i.removed;)i=i.previous;return t.target&&(t.last=i=i?i.next:t.state.first)?"keys"==e?{value:i.key,done:!1}:"values"==e?{value:i.value,done:!1}:{value:[i.key,i.value],done:!1}:(t.target=void 0,{value:void 0,done:!0})}),i?"entries":"values",!i,!0),function(t){var e=le(t),i=H.f;h&&e&&!e[cd]&&i(e,cd,{configurable:!0,get:function(){return this}})}(e)}},md=(dd("Set",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),yd),j.Set),bd=(dd("Map",(function(t){return function(){return t(this,arguments.length?arguments[0]:void 0)}}),yd),j.Map),wd=o((function(t){var e=function(t){var e=Object.prototype,i=e.hasOwnProperty,n="function"==typeof Symbol?Symbol:{},o=n.iterator||"@@iterator",r=n.asyncIterator||"@@asyncIterator",s=n.toStringTag||"@@toStringTag";function a(t,e,i,n){var o=e&&e.prototype instanceof d?e:d,r=Object.create(o.prototype),s=new k(n||[]);return r._invoke=function(t,e,i){var n="suspendedStart";return function(o,r){if("executing"===n)throw new Error("Generator is already running");if("completed"===n){if("throw"===o)throw r;return O()}for(i.method=o,i.arg=r;;){var s=i.delegate;if(s){var a=b(s,i);if(a){if(a===l)continue;return a}}if("next"===i.method)i.sent=i._sent=i.arg;else if("throw"===i.method){if("suspendedStart"===n)throw n="completed",i.arg;i.dispatchException(i.arg)}else"return"===i.method&&i.abrupt("return",i.arg);n="executing";var d=h(t,e,i);if("normal"===d.type){if(n=i.done?"completed":"suspendedYield",d.arg===l)continue;return{value:d.arg,done:i.done}}"throw"===d.type&&(n="completed",i.method="throw",i.arg=d.arg)}}}(t,i,s),r}function h(t,e,i){try{return{type:"normal",arg:t.call(e,i)}}catch(t){return{type:"throw",arg:t}}}t.wrap=a;var l={};function d(){}function u(){}function c(){}var f={};f[o]=function(){return this};var p=Object.getPrototypeOf,v=p&&p(p(x([])));v&&v!==e&&i.call(v,o)&&(f=v);var g=c.prototype=d.prototype=Object.create(f);function y(t){["next","throw","return"].forEach((function(e){t[e]=function(t){return this._invoke(e,t)}}))}function m(t,e){var n;this._invoke=function(o,r){function s(){return new e((function(n,s){!function n(o,r,s,a){var l=h(t[o],t,r);if("throw"!==l.type){var d=l.arg,u=d.value;return u&&"object"==typeof u&&i.call(u,"__await")?e.resolve(u.__await).then((function(t){n("next",t,s,a)}),(function(t){n("throw",t,s,a)})):e.resolve(u).then((function(t){d.value=t,s(d)}),(function(t){return n("throw",t,s,a)}))}a(l.arg)}(o,r,n,s)}))}return n=n?n.then(s,s):s()}}function b(t,e){var i=t.iterator[e.method];if(void 0===i){if(e.delegate=null,"throw"===e.method){if(t.iterator.return&&(e.method="return",e.arg=void 0,b(t,e),"throw"===e.method))return l;e.method="throw",e.arg=new TypeError("The iterator does not provide a 'throw' method")}return l}var n=h(i,t.iterator,e.arg);if("throw"===n.type)return e.method="throw",e.arg=n.arg,e.delegate=null,l;var o=n.arg;return o?o.done?(e[t.resultName]=o.value,e.next=t.nextLoc,"return"!==e.method&&(e.method="next",e.arg=void 0),e.delegate=null,l):o:(e.method="throw",e.arg=new TypeError("iterator result is not an object"),e.delegate=null,l)}function w(t){var e={tryLoc:t[0]};1 in t&&(e.catchLoc=t[1]),2 in t&&(e.finallyLoc=t[2],e.afterLoc=t[3]),this.tryEntries.push(e)}function _(t){var e=t.completion||{};e.type="normal",delete e.arg,t.completion=e}function k(t){this.tryEntries=[{tryLoc:"root"}],t.forEach(w,this),this.reset(!0)}function x(t){if(t){var e=t[o];if(e)return e.call(t);if("function"==typeof t.next)return t;if(!isNaN(t.length)){var n=-1,r=function e(){for(;++n<t.length;)if(i.call(t,n))return e.value=t[n],e.done=!1,e;return e.value=void 0,e.done=!0,e};return r.next=r}}return{next:O}}function O(){return{value:void 0,done:!0}}return u.prototype=g.constructor=c,c.constructor=u,c[s]=u.displayName="GeneratorFunction",t.isGeneratorFunction=function(t){var e="function"==typeof t&&t.constructor;return!!e&&(e===u||"GeneratorFunction"===(e.displayName||e.name))},t.mark=function(t){return Object.setPrototypeOf?Object.setPrototypeOf(t,c):(t.__proto__=c,s in t||(t[s]="GeneratorFunction")),t.prototype=Object.create(g),t},t.awrap=function(t){return{__await:t}},y(m.prototype),m.prototype[r]=function(){return this},t.AsyncIterator=m,t.async=function(e,i,n,o,r){void 0===r&&(r=Promise);var s=new m(a(e,i,n,o),r);return t.isGeneratorFunction(i)?s:s.next().then((function(t){return t.done?t.value:s.next()}))},y(g),g[s]="Generator",g[o]=function(){return this},g.toString=function(){return"[object Generator]"},t.keys=function(t){var e=[];for(var i in t)e.push(i);return e.reverse(),function i(){for(;e.length;){var n=e.pop();if(n in t)return i.value=n,i.done=!1,i}return i.done=!0,i}},t.values=x,k.prototype={constructor:k,reset:function(t){if(this.prev=0,this.next=0,this.sent=this._sent=void 0,this.done=!1,this.delegate=null,this.method="next",this.arg=void 0,this.tryEntries.forEach(_),!t)for(var e in this)"t"===e.charAt(0)&&i.call(this,e)&&!isNaN(+e.slice(1))&&(this[e]=void 0)},stop:function(){this.done=!0;var t=this.tryEntries[0].completion;if("throw"===t.type)throw t.arg;return this.rval},dispatchException:function(t){if(this.done)throw t;var e=this;function n(i,n){return s.type="throw",s.arg=t,e.next=i,n&&(e.method="next",e.arg=void 0),!!n}for(var o=this.tryEntries.length-1;o>=0;--o){var r=this.tryEntries[o],s=r.completion;if("root"===r.tryLoc)return n("end");if(r.tryLoc<=this.prev){var a=i.call(r,"catchLoc"),h=i.call(r,"finallyLoc");if(a&&h){if(this.prev<r.catchLoc)return n(r.catchLoc,!0);if(this.prev<r.finallyLoc)return n(r.finallyLoc)}else if(a){if(this.prev<r.catchLoc)return n(r.catchLoc,!0)}else{if(!h)throw new Error("try statement without catch or finally");if(this.prev<r.finallyLoc)return n(r.finallyLoc)}}}},abrupt:function(t,e){for(var n=this.tryEntries.length-1;n>=0;--n){var o=this.tryEntries[n];if(o.tryLoc<=this.prev&&i.call(o,"finallyLoc")&&this.prev<o.finallyLoc){var r=o;break}}r&&("break"===t||"continue"===t)&&r.tryLoc<=e&&e<=r.finallyLoc&&(r=null);var s=r?r.completion:{};return s.type=t,s.arg=e,r?(this.method="next",this.next=r.finallyLoc,l):this.complete(s)},complete:function(t,e){if("throw"===t.type)throw t.arg;return"break"===t.type||"continue"===t.type?this.next=t.arg:"return"===t.type?(this.rval=this.arg=t.arg,this.method="return",this.next="end"):"normal"===t.type&&e&&(this.next=e),l},finish:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.finallyLoc===t)return this.complete(i.completion,i.afterLoc),_(i),l}},catch:function(t){for(var e=this.tryEntries.length-1;e>=0;--e){var i=this.tryEntries[e];if(i.tryLoc===t){var n=i.completion;if("throw"===n.type){var o=n.arg;_(i)}return o}}throw new Error("illegal catch attempt")},delegateYield:function(t,e,i){return this.delegate={iterator:x(t),resultName:e,nextLoc:i},"next"===this.method&&(this.arg=void 0),l}},t}(t.exports);try{regeneratorRuntime=e}catch(t){Function("r","regeneratorRuntime = r")(e)}})),_d=lr,kd=function(t,e,i,n,o,r,s,a){for(var h,l=o,d=0,u=!!s&&B(s,a,3);d<n;){if(d in i){if(h=u?u(i[d],d,e):i[d],r>0&&Ke(h))l=kd(t,e,h,Zt(h.length),l,r-1)-1;else{if(l>=9007199254740991)throw TypeError("Exceed the acceptable array length");t[l]=h}l++}d++}return l},xd=kd;U({target:"Array",proto:!0},{flatMap:function(t){var e,i=It(this),n=Zt(i.length);return z(t),(e=Je(i,0)).length=xd(e,i,i,n,0,1,t,arguments.length>1?arguments[1]:void 0),e}});var Od=K("Array").flatMap,Sd=Array.prototype,Ed=function(t){var e=t.flatMap;return t===Sd||t instanceof Array&&e===Sd.flatMap?Od:e},Dd=function(t){return function(e,i,n,o){z(i);var r=It(e),s=g(r),a=Zt(r.length),h=t?a-1:0,l=t?-1:1;if(n<2)for(;;){if(h in s){o=s[h],h+=l;break}if(h+=l,t?h<0:a<=h)throw TypeError("Reduce of empty array with no initial value")}for(;t?h>=0:a>h;h+=l)h in s&&(o=i(o,s[h],h,r));return o}},Md={left:Dd(!1),right:Dd(!0)}.left,Cd=Hn("reduce"),Td=Un("reduce",{1:0});U({target:"Array",proto:!0,forced:!Cd||!Td},{reduce:function(t){return Md(this,t,arguments.length,arguments.length>1?arguments[1]:void 0)}});var Pd=K("Array").reduce,Nd=Array.prototype,Id=function(t){var e=t.reduce;return t===Nd||t instanceof Array&&e===Nd.reduce?Pd:e},Ad="undefined"!=typeof crypto&&crypto.getRandomValues&&crypto.getRandomValues.bind(crypto)||"undefined"!=typeof msCrypto&&"function"==typeof msCrypto.getRandomValues&&msCrypto.getRandomValues.bind(msCrypto),Fd=new Uint8Array(16);function jd(){if(!Ad)throw new Error("crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported");return Ad(Fd)}for(var zd=[],Bd=0;Bd<256;++Bd)zd[Bd]=(Bd+256).toString(16).substr(1);function Rd(t,e,i){var n=e&&i||0;"string"==typeof t&&(e="binary"===t?new Array(16):null,t=null);var o=(t=t||{}).random||(t.rng||jd)();if(o[6]=15&o[6]|64,o[8]=63&o[8]|128,e)for(var r=0;r<16;++r)e[n+r]=o[r];return e||function(t,e){var i=e||0,n=zd;return[n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],"-",n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]],n[t[i++]]].join("")}(o)}var Ld=o((function(t,e){t.exports=function(){var e,n;function o(){return e.apply(null,arguments)}function r(t){return t instanceof Array||"[object Array]"===Object.prototype.toString.call(t)}function s(t){return null!=t&&"[object Object]"===Object.prototype.toString.call(t)}function a(t,e){return Object.prototype.hasOwnProperty.call(t,e)}function h(t){if(Object.getOwnPropertyNames)return 0===Object.getOwnPropertyNames(t).length;var e;for(e in t)if(a(t,e))return!1;return!0}function l(t){return void 0===t}function d(t){return"number"==typeof t||"[object Number]"===Object.prototype.toString.call(t)}function u(t){return t instanceof Date||"[object Date]"===Object.prototype.toString.call(t)}function c(t,e){var i,n=[];for(i=0;i<t.length;++i)n.push(e(t[i],i));return n}function f(t,e){for(var i in e)a(e,i)&&(t[i]=e[i]);return a(e,"toString")&&(t.toString=e.toString),a(e,"valueOf")&&(t.valueOf=e.valueOf),t}function p(t,e,i,n){return Se(t,e,i,n,!0).utc()}function v(t){return null==t._pf&&(t._pf={empty:!1,unusedTokens:[],unusedInput:[],overflow:-2,charsLeftOver:0,nullInput:!1,invalidEra:null,invalidMonth:null,invalidFormat:!1,userInvalidated:!1,iso:!1,parsedDateParts:[],era:null,meridiem:null,rfc2822:!1,weekdayMismatch:!1}),t._pf}function g(t){if(null==t._isValid){var e=v(t),i=n.call(e.parsedDateParts,(function(t){return null!=t})),o=!isNaN(t._d.getTime())&&e.overflow<0&&!e.empty&&!e.invalidEra&&!e.invalidMonth&&!e.invalidWeekday&&!e.weekdayMismatch&&!e.nullInput&&!e.invalidFormat&&!e.userInvalidated&&(!e.meridiem||e.meridiem&&i);if(t._strict&&(o=o&&0===e.charsLeftOver&&0===e.unusedTokens.length&&void 0===e.bigHour),null!=Object.isFrozen&&Object.isFrozen(t))return o;t._isValid=o}return t._isValid}function y(t){var e=p(NaN);return null!=t?f(v(e),t):v(e).userInvalidated=!0,e}n=Array.prototype.some?Array.prototype.some:function(t){var e,i=Object(this),n=i.length>>>0;for(e=0;e<n;e++)if(e in i&&t.call(this,i[e],e,i))return!0;return!1};var m=o.momentProperties=[],b=!1;function w(t,e){var i,n,o;if(l(e._isAMomentObject)||(t._isAMomentObject=e._isAMomentObject),l(e._i)||(t._i=e._i),l(e._f)||(t._f=e._f),l(e._l)||(t._l=e._l),l(e._strict)||(t._strict=e._strict),l(e._tzm)||(t._tzm=e._tzm),l(e._isUTC)||(t._isUTC=e._isUTC),l(e._offset)||(t._offset=e._offset),l(e._pf)||(t._pf=v(e)),l(e._locale)||(t._locale=e._locale),m.length>0)for(i=0;i<m.length;i++)l(o=e[n=m[i]])||(t[n]=o);return t}function _(t){w(this,t),this._d=new Date(null!=t._d?t._d.getTime():NaN),this.isValid()||(this._d=new Date(NaN)),!1===b&&(b=!0,o.updateOffset(this),b=!1)}function k(t){return t instanceof _||null!=t&&null!=t._isAMomentObject}function x(t){!1===o.suppressDeprecationWarnings&&"undefined"!=typeof console&&console.warn&&console.warn("Deprecation warning: "+t)}function O(t,e){var i=!0;return f((function(){if(null!=o.deprecationHandler&&o.deprecationHandler(null,t),i){var n,r,s,h=[];for(r=0;r<arguments.length;r++){if(n="","object"==typeof arguments[r]){for(s in n+="\n["+r+"] ",arguments[0])a(arguments[0],s)&&(n+=s+": "+arguments[0][s]+", ");n=n.slice(0,-2)}else n=arguments[r];h.push(n)}x(t+"\nArguments: "+Array.prototype.slice.call(h).join("")+"\n"+(new Error).stack),i=!1}return e.apply(this,arguments)}),e)}var S,E={};function D(t,e){null!=o.deprecationHandler&&o.deprecationHandler(t,e),E[t]||(x(e),E[t]=!0)}function M(t){return"undefined"!=typeof Function&&t instanceof Function||"[object Function]"===Object.prototype.toString.call(t)}function C(t,e){var i,n=f({},t);for(i in e)a(e,i)&&(s(t[i])&&s(e[i])?(n[i]={},f(n[i],t[i]),f(n[i],e[i])):null!=e[i]?n[i]=e[i]:delete n[i]);for(i in t)a(t,i)&&!a(e,i)&&s(t[i])&&(n[i]=f({},n[i]));return n}function T(t){null!=t&&this.set(t)}function P(t,e,i){var n=""+Math.abs(t),o=e-n.length;return(t>=0?i?"+":"":"-")+Math.pow(10,Math.max(0,o)).toString().substr(1)+n}o.suppressDeprecationWarnings=!1,o.deprecationHandler=null,S=Object.keys?Object.keys:function(t){var e,i=[];for(e in t)a(t,e)&&i.push(e);return i};var N=/(\[[^\[]*\])|(\\)?([Hh]mm(ss)?|Mo|MM?M?M?|Do|DDDo|DD?D?D?|ddd?d?|do?|w[o|w]?|W[o|W]?|Qo?|N{1,5}|YYYYYY|YYYYY|YYYY|YY|y{2,4}|yo?|gg(ggg?)?|GG(GGG?)?|e|E|a|A|hh?|HH?|kk?|mm?|ss?|S{1,9}|x|X|zz?|ZZ?|.)/g,I=/(\[[^\[]*\])|(\\)?(LTS|LT|LL?L?L?|l{1,4})/g,A={},F={};function j(t,e,i,n){var o=n;"string"==typeof n&&(o=function(){return this[n]()}),t&&(F[t]=o),e&&(F[e[0]]=function(){return P(o.apply(this,arguments),e[1],e[2])}),i&&(F[i]=function(){return this.localeData().ordinal(o.apply(this,arguments),t)})}function z(t,e){return t.isValid()?(e=B(e,t.localeData()),A[e]=A[e]||function(t){var e,i,n,o=t.match(N);for(e=0,i=o.length;e<i;e++)F[o[e]]?o[e]=F[o[e]]:o[e]=(n=o[e]).match(/\[[\s\S]/)?n.replace(/^\[|\]$/g,""):n.replace(/\\/g,"");return function(e){var n,r="";for(n=0;n<i;n++)r+=M(o[n])?o[n].call(e,t):o[n];return r}}(e),A[e](t)):t.localeData().invalidDate()}function B(t,e){var i=5;function n(t){return e.longDateFormat(t)||t}for(I.lastIndex=0;i>=0&&I.test(t);)t=t.replace(I,n),I.lastIndex=0,i-=1;return t}var R={};function L(t,e){var i=t.toLowerCase();R[i]=R[i+"s"]=R[e]=t}function H(t){return"string"==typeof t?R[t]||R[t.toLowerCase()]:void 0}function W(t){var e,i,n={};for(i in t)a(t,i)&&(e=H(i))&&(n[e]=t[i]);return n}var Y={};function V(t,e){Y[t]=e}function U(t){return t%4==0&&t%100!=0||t%400==0}function G(t){return t<0?Math.ceil(t)||0:Math.floor(t)}function q(t){var e=+t,i=0;return 0!==e&&isFinite(e)&&(i=G(e)),i}function X(t,e){return function(i){return null!=i?(K(this,t,i),o.updateOffset(this,e),this):$(this,t)}}function $(t,e){return t.isValid()?t._d["get"+(t._isUTC?"UTC":"")+e]():NaN}function K(t,e,i){t.isValid()&&!isNaN(i)&&("FullYear"===e&&U(t.year())&&1===t.month()&&29===t.date()?(i=q(i),t._d["set"+(t._isUTC?"UTC":"")+e](i,t.month(),kt(i,t.month()))):t._d["set"+(t._isUTC?"UTC":"")+e](i))}var Z,Q=/\d/,J=/\d\d/,tt=/\d{3}/,et=/\d{4}/,it=/[+-]?\d{6}/,nt=/\d\d?/,ot=/\d\d\d\d?/,rt=/\d\d\d\d\d\d?/,st=/\d{1,3}/,at=/\d{1,4}/,ht=/[+-]?\d{1,6}/,lt=/\d+/,dt=/[+-]?\d+/,ut=/Z|[+-]\d\d:?\d\d/gi,ct=/Z|[+-]\d\d(?::?\d\d)?/gi,ft=/[0-9]{0,256}['a-z\u00A0-\u05FF\u0700-\uD7FF\uF900-\uFDCF\uFDF0-\uFF07\uFF10-\uFFEF]{1,256}|[\u0600-\u06FF\/]{1,256}(\s*?[\u0600-\u06FF]{1,256}){1,2}/i;function pt(t,e,i){Z[t]=M(e)?e:function(t,n){return t&&i?i:e}}function vt(t,e){return a(Z,t)?Z[t](e._strict,e._locale):new RegExp(gt(t.replace("\\","").replace(/\\(\[)|\\(\])|\[([^\]\[]*)\]|\\(.)/g,(function(t,e,i,n,o){return e||i||n||o}))))}function gt(t){return t.replace(/[-\/\\^$*+?.()|[\]{}]/g,"\\$&")}Z={};var yt,mt={};function bt(t,e){var i,n=e;for("string"==typeof t&&(t=[t]),d(e)&&(n=function(t,i){i[e]=q(t)}),i=0;i<t.length;i++)mt[t[i]]=n}function wt(t,e){bt(t,(function(t,i,n,o){n._w=n._w||{},e(t,n._w,n,o)}))}function _t(t,e,i){null!=e&&a(mt,t)&&mt[t](e,i._a,i,t)}function kt(t,e){if(isNaN(t)||isNaN(e))return NaN;var i=function(t,e){return(t%e+e)%e}(e,12);return t+=(e-i)/12,1===i?U(t)?29:28:31-i%7%2}yt=Array.prototype.indexOf?Array.prototype.indexOf:function(t){var e;for(e=0;e<this.length;++e)if(this[e]===t)return e;return-1},j("M",["MM",2],"Mo",(function(){return this.month()+1})),j("MMM",0,0,(function(t){return this.localeData().monthsShort(this,t)})),j("MMMM",0,0,(function(t){return this.localeData().months(this,t)})),L("month","M"),V("month",8),pt("M",nt),pt("MM",nt,J),pt("MMM",(function(t,e){return e.monthsShortRegex(t)})),pt("MMMM",(function(t,e){return e.monthsRegex(t)})),bt(["M","MM"],(function(t,e){e[1]=q(t)-1})),bt(["MMM","MMMM"],(function(t,e,i,n){var o=i._locale.monthsParse(t,n,i._strict);null!=o?e[1]=o:v(i).invalidMonth=t}));var xt="January_February_March_April_May_June_July_August_September_October_November_December".split("_"),Ot="Jan_Feb_Mar_Apr_May_Jun_Jul_Aug_Sep_Oct_Nov_Dec".split("_"),St=/D[oD]?(\[[^\[\]]*\]|\s)+MMMM?/,Et=ft,Dt=ft;function Mt(t,e,i){var n,o,r,s=t.toLocaleLowerCase();if(!this._monthsParse)for(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[],n=0;n<12;++n)r=p([2e3,n]),this._shortMonthsParse[n]=this.monthsShort(r,"").toLocaleLowerCase(),this._longMonthsParse[n]=this.months(r,"").toLocaleLowerCase();return i?"MMM"===e?-1!==(o=yt.call(this._shortMonthsParse,s))?o:null:-1!==(o=yt.call(this._longMonthsParse,s))?o:null:"MMM"===e?-1!==(o=yt.call(this._shortMonthsParse,s))||-1!==(o=yt.call(this._longMonthsParse,s))?o:null:-1!==(o=yt.call(this._longMonthsParse,s))||-1!==(o=yt.call(this._shortMonthsParse,s))?o:null}function Ct(t,e){var i;if(!t.isValid())return t;if("string"==typeof e)if(/^\d+$/.test(e))e=q(e);else if(!d(e=t.localeData().monthsParse(e)))return t;return i=Math.min(t.date(),kt(t.year(),e)),t._d["set"+(t._isUTC?"UTC":"")+"Month"](e,i),t}function Tt(t){return null!=t?(Ct(this,t),o.updateOffset(this,!0),this):$(this,"Month")}function Pt(){function t(t,e){return e.length-t.length}var e,i,n=[],o=[],r=[];for(e=0;e<12;e++)i=p([2e3,e]),n.push(this.monthsShort(i,"")),o.push(this.months(i,"")),r.push(this.months(i,"")),r.push(this.monthsShort(i,""));for(n.sort(t),o.sort(t),r.sort(t),e=0;e<12;e++)n[e]=gt(n[e]),o[e]=gt(o[e]);for(e=0;e<24;e++)r[e]=gt(r[e]);this._monthsRegex=new RegExp("^("+r.join("|")+")","i"),this._monthsShortRegex=this._monthsRegex,this._monthsStrictRegex=new RegExp("^("+o.join("|")+")","i"),this._monthsShortStrictRegex=new RegExp("^("+n.join("|")+")","i")}function Nt(t){return U(t)?366:365}j("Y",0,0,(function(){var t=this.year();return t<=9999?P(t,4):"+"+t})),j(0,["YY",2],0,(function(){return this.year()%100})),j(0,["YYYY",4],0,"year"),j(0,["YYYYY",5],0,"year"),j(0,["YYYYYY",6,!0],0,"year"),L("year","y"),V("year",1),pt("Y",dt),pt("YY",nt,J),pt("YYYY",at,et),pt("YYYYY",ht,it),pt("YYYYYY",ht,it),bt(["YYYYY","YYYYYY"],0),bt("YYYY",(function(t,e){e[0]=2===t.length?o.parseTwoDigitYear(t):q(t)})),bt("YY",(function(t,e){e[0]=o.parseTwoDigitYear(t)})),bt("Y",(function(t,e){e[0]=parseInt(t,10)})),o.parseTwoDigitYear=function(t){return q(t)+(q(t)>68?1900:2e3)};var It=X("FullYear",!0);function At(t,e,i,n,o,r,s){var a;return t<100&&t>=0?(a=new Date(t+400,e,i,n,o,r,s),isFinite(a.getFullYear())&&a.setFullYear(t)):a=new Date(t,e,i,n,o,r,s),a}function Ft(t){var e,i;return t<100&&t>=0?((i=Array.prototype.slice.call(arguments))[0]=t+400,e=new Date(Date.UTC.apply(null,i)),isFinite(e.getUTCFullYear())&&e.setUTCFullYear(t)):e=new Date(Date.UTC.apply(null,arguments)),e}function jt(t,e,i){var n=7+e-i;return-(7+Ft(t,0,n).getUTCDay()-e)%7+n-1}function zt(t,e,i,n,o){var r,s,a=1+7*(e-1)+(7+i-n)%7+jt(t,n,o);return a<=0?s=Nt(r=t-1)+a:a>Nt(t)?(r=t+1,s=a-Nt(t)):(r=t,s=a),{year:r,dayOfYear:s}}function Bt(t,e,i){var n,o,r=jt(t.year(),e,i),s=Math.floor((t.dayOfYear()-r-1)/7)+1;return s<1?n=s+Rt(o=t.year()-1,e,i):s>Rt(t.year(),e,i)?(n=s-Rt(t.year(),e,i),o=t.year()+1):(o=t.year(),n=s),{week:n,year:o}}function Rt(t,e,i){var n=jt(t,e,i),o=jt(t+1,e,i);return(Nt(t)-n+o)/7}function Lt(t,e){return t.slice(e,7).concat(t.slice(0,e))}j("w",["ww",2],"wo","week"),j("W",["WW",2],"Wo","isoWeek"),L("week","w"),L("isoWeek","W"),V("week",5),V("isoWeek",5),pt("w",nt),pt("ww",nt,J),pt("W",nt),pt("WW",nt,J),wt(["w","ww","W","WW"],(function(t,e,i,n){e[n.substr(0,1)]=q(t)})),j("d",0,"do","day"),j("dd",0,0,(function(t){return this.localeData().weekdaysMin(this,t)})),j("ddd",0,0,(function(t){return this.localeData().weekdaysShort(this,t)})),j("dddd",0,0,(function(t){return this.localeData().weekdays(this,t)})),j("e",0,0,"weekday"),j("E",0,0,"isoWeekday"),L("day","d"),L("weekday","e"),L("isoWeekday","E"),V("day",11),V("weekday",11),V("isoWeekday",11),pt("d",nt),pt("e",nt),pt("E",nt),pt("dd",(function(t,e){return e.weekdaysMinRegex(t)})),pt("ddd",(function(t,e){return e.weekdaysShortRegex(t)})),pt("dddd",(function(t,e){return e.weekdaysRegex(t)})),wt(["dd","ddd","dddd"],(function(t,e,i,n){var o=i._locale.weekdaysParse(t,n,i._strict);null!=o?e.d=o:v(i).invalidWeekday=t})),wt(["d","e","E"],(function(t,e,i,n){e[n]=q(t)}));var Ht="Sunday_Monday_Tuesday_Wednesday_Thursday_Friday_Saturday".split("_"),Wt="Sun_Mon_Tue_Wed_Thu_Fri_Sat".split("_"),Yt="Su_Mo_Tu_We_Th_Fr_Sa".split("_"),Vt=ft,Ut=ft,Gt=ft;function qt(t,e,i){var n,o,r,s=t.toLocaleLowerCase();if(!this._weekdaysParse)for(this._weekdaysParse=[],this._shortWeekdaysParse=[],this._minWeekdaysParse=[],n=0;n<7;++n)r=p([2e3,1]).day(n),this._minWeekdaysParse[n]=this.weekdaysMin(r,"").toLocaleLowerCase(),this._shortWeekdaysParse[n]=this.weekdaysShort(r,"").toLocaleLowerCase(),this._weekdaysParse[n]=this.weekdays(r,"").toLocaleLowerCase();return i?"dddd"===e?-1!==(o=yt.call(this._weekdaysParse,s))?o:null:"ddd"===e?-1!==(o=yt.call(this._shortWeekdaysParse,s))?o:null:-1!==(o=yt.call(this._minWeekdaysParse,s))?o:null:"dddd"===e?-1!==(o=yt.call(this._weekdaysParse,s))||-1!==(o=yt.call(this._shortWeekdaysParse,s))||-1!==(o=yt.call(this._minWeekdaysParse,s))?o:null:"ddd"===e?-1!==(o=yt.call(this._shortWeekdaysParse,s))||-1!==(o=yt.call(this._weekdaysParse,s))||-1!==(o=yt.call(this._minWeekdaysParse,s))?o:null:-1!==(o=yt.call(this._minWeekdaysParse,s))||-1!==(o=yt.call(this._weekdaysParse,s))||-1!==(o=yt.call(this._shortWeekdaysParse,s))?o:null}function Xt(){function t(t,e){return e.length-t.length}var e,i,n,o,r,s=[],a=[],h=[],l=[];for(e=0;e<7;e++)i=p([2e3,1]).day(e),n=gt(this.weekdaysMin(i,"")),o=gt(this.weekdaysShort(i,"")),r=gt(this.weekdays(i,"")),s.push(n),a.push(o),h.push(r),l.push(n),l.push(o),l.push(r);s.sort(t),a.sort(t),h.sort(t),l.sort(t),this._weekdaysRegex=new RegExp("^("+l.join("|")+")","i"),this._weekdaysShortRegex=this._weekdaysRegex,this._weekdaysMinRegex=this._weekdaysRegex,this._weekdaysStrictRegex=new RegExp("^("+h.join("|")+")","i"),this._weekdaysShortStrictRegex=new RegExp("^("+a.join("|")+")","i"),this._weekdaysMinStrictRegex=new RegExp("^("+s.join("|")+")","i")}function $t(){return this.hours()%12||12}function Kt(t,e){j(t,0,0,(function(){return this.localeData().meridiem(this.hours(),this.minutes(),e)}))}function Zt(t,e){return e._meridiemParse}j("H",["HH",2],0,"hour"),j("h",["hh",2],0,$t),j("k",["kk",2],0,(function(){return this.hours()||24})),j("hmm",0,0,(function(){return""+$t.apply(this)+P(this.minutes(),2)})),j("hmmss",0,0,(function(){return""+$t.apply(this)+P(this.minutes(),2)+P(this.seconds(),2)})),j("Hmm",0,0,(function(){return""+this.hours()+P(this.minutes(),2)})),j("Hmmss",0,0,(function(){return""+this.hours()+P(this.minutes(),2)+P(this.seconds(),2)})),Kt("a",!0),Kt("A",!1),L("hour","h"),V("hour",13),pt("a",Zt),pt("A",Zt),pt("H",nt),pt("h",nt),pt("k",nt),pt("HH",nt,J),pt("hh",nt,J),pt("kk",nt,J),pt("hmm",ot),pt("hmmss",rt),pt("Hmm",ot),pt("Hmmss",rt),bt(["H","HH"],3),bt(["k","kk"],(function(t,e,i){var n=q(t);e[3]=24===n?0:n})),bt(["a","A"],(function(t,e,i){i._isPm=i._locale.isPM(t),i._meridiem=t})),bt(["h","hh"],(function(t,e,i){e[3]=q(t),v(i).bigHour=!0})),bt("hmm",(function(t,e,i){var n=t.length-2;e[3]=q(t.substr(0,n)),e[4]=q(t.substr(n)),v(i).bigHour=!0})),bt("hmmss",(function(t,e,i){var n=t.length-4,o=t.length-2;e[3]=q(t.substr(0,n)),e[4]=q(t.substr(n,2)),e[5]=q(t.substr(o)),v(i).bigHour=!0})),bt("Hmm",(function(t,e,i){var n=t.length-2;e[3]=q(t.substr(0,n)),e[4]=q(t.substr(n))})),bt("Hmmss",(function(t,e,i){var n=t.length-4,o=t.length-2;e[3]=q(t.substr(0,n)),e[4]=q(t.substr(n,2)),e[5]=q(t.substr(o))}));var Qt,Jt=X("Hours",!0),te={calendar:{sameDay:"[Today at] LT",nextDay:"[Tomorrow at] LT",nextWeek:"dddd [at] LT",lastDay:"[Yesterday at] LT",lastWeek:"[Last] dddd [at] LT",sameElse:"L"},longDateFormat:{LTS:"h:mm:ss A",LT:"h:mm A",L:"MM/DD/YYYY",LL:"MMMM D, YYYY",LLL:"MMMM D, YYYY h:mm A",LLLL:"dddd, MMMM D, YYYY h:mm A"},invalidDate:"Invalid date",ordinal:"%d",dayOfMonthOrdinalParse:/\d{1,2}/,relativeTime:{future:"in %s",past:"%s ago",s:"a few seconds",ss:"%d seconds",m:"a minute",mm:"%d minutes",h:"an hour",hh:"%d hours",d:"a day",dd:"%d days",w:"a week",ww:"%d weeks",M:"a month",MM:"%d months",y:"a year",yy:"%d years"},months:xt,monthsShort:Ot,week:{dow:0,doy:6},weekdays:Ht,weekdaysMin:Yt,weekdaysShort:Wt,meridiemParse:/[ap]\.?m?\.?/i},ee={},ie={};function ne(t,e){var i,n=Math.min(t.length,e.length);for(i=0;i<n;i+=1)if(t[i]!==e[i])return i;return n}function oe(t){return t?t.toLowerCase().replace("_","-"):t}function re(e){var n=null;if(void 0===ee[e]&&t&&t.exports)try{n=Qt._abbr,i(),se(n)}catch(t){ee[e]=null}return ee[e]}function se(t,e){var i;return t&&((i=l(e)?he(t):ae(t,e))?Qt=i:"undefined"!=typeof console&&console.warn&&console.warn("Locale "+t+" not found. Did you forget to load it?")),Qt._abbr}function ae(t,e){if(null!==e){var i,n=te;if(e.abbr=t,null!=ee[t])D("defineLocaleOverride","use moment.updateLocale(localeName, config) to change an existing locale. moment.defineLocale(localeName, config) should only be used for creating a new locale See http://momentjs.com/guides/#/warnings/define-locale/ for more info."),n=ee[t]._config;else if(null!=e.parentLocale)if(null!=ee[e.parentLocale])n=ee[e.parentLocale]._config;else{if(null==(i=re(e.parentLocale)))return ie[e.parentLocale]||(ie[e.parentLocale]=[]),ie[e.parentLocale].push({name:t,config:e}),null;n=i._config}return ee[t]=new T(C(n,e)),ie[t]&&ie[t].forEach((function(t){ae(t.name,t.config)})),se(t),ee[t]}return delete ee[t],null}function he(t){var e;if(t&&t._locale&&t._locale._abbr&&(t=t._locale._abbr),!t)return Qt;if(!r(t)){if(e=re(t))return e;t=[t]}return function(t){for(var e,i,n,o,r=0;r<t.length;){for(e=(o=oe(t[r]).split("-")).length,i=(i=oe(t[r+1]))?i.split("-"):null;e>0;){if(n=re(o.slice(0,e).join("-")))return n;if(i&&i.length>=e&&ne(o,i)>=e-1)break;e--}r++}return Qt}(t)}function le(t){var e,i=t._a;return i&&-2===v(t).overflow&&(e=i[1]<0||i[1]>11?1:i[2]<1||i[2]>kt(i[0],i[1])?2:i[3]<0||i[3]>24||24===i[3]&&(0!==i[4]||0!==i[5]||0!==i[6])?3:i[4]<0||i[4]>59?4:i[5]<0||i[5]>59?5:i[6]<0||i[6]>999?6:-1,v(t)._overflowDayOfYear&&(e<0||e>2)&&(e=2),v(t)._overflowWeeks&&-1===e&&(e=7),v(t)._overflowWeekday&&-1===e&&(e=8),v(t).overflow=e),t}var de=/^\s*((?:[+-]\d{6}|\d{4})-(?:\d\d-\d\d|W\d\d-\d|W\d\d|\d\d\d|\d\d))(?:(T| )(\d\d(?::\d\d(?::\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,ue=/^\s*((?:[+-]\d{6}|\d{4})(?:\d\d\d\d|W\d\d\d|W\d\d|\d\d\d|\d\d|))(?:(T| )(\d\d(?:\d\d(?:\d\d(?:[.,]\d+)?)?)?)([+-]\d\d(?::?\d\d)?|\s*Z)?)?$/,ce=/Z|[+-]\d\d(?::?\d\d)?/,fe=[["YYYYYY-MM-DD",/[+-]\d{6}-\d\d-\d\d/],["YYYY-MM-DD",/\d{4}-\d\d-\d\d/],["GGGG-[W]WW-E",/\d{4}-W\d\d-\d/],["GGGG-[W]WW",/\d{4}-W\d\d/,!1],["YYYY-DDD",/\d{4}-\d{3}/],["YYYY-MM",/\d{4}-\d\d/,!1],["YYYYYYMMDD",/[+-]\d{10}/],["YYYYMMDD",/\d{8}/],["GGGG[W]WWE",/\d{4}W\d{3}/],["GGGG[W]WW",/\d{4}W\d{2}/,!1],["YYYYDDD",/\d{7}/],["YYYYMM",/\d{6}/,!1],["YYYY",/\d{4}/,!1]],pe=[["HH:mm:ss.SSSS",/\d\d:\d\d:\d\d\.\d+/],["HH:mm:ss,SSSS",/\d\d:\d\d:\d\d,\d+/],["HH:mm:ss",/\d\d:\d\d:\d\d/],["HH:mm",/\d\d:\d\d/],["HHmmss.SSSS",/\d\d\d\d\d\d\.\d+/],["HHmmss,SSSS",/\d\d\d\d\d\d,\d+/],["HHmmss",/\d\d\d\d\d\d/],["HHmm",/\d\d\d\d/],["HH",/\d\d/]],ve=/^\/?Date\((-?\d+)/i,ge=/^(?:(Mon|Tue|Wed|Thu|Fri|Sat|Sun),?\s)?(\d{1,2})\s(Jan|Feb|Mar|Apr|May|Jun|Jul|Aug|Sep|Oct|Nov|Dec)\s(\d{2,4})\s(\d\d):(\d\d)(?::(\d\d))?\s(?:(UT|GMT|[ECMP][SD]T)|([Zz])|([+-]\d{4}))$/,ye={UT:0,GMT:0,EDT:-240,EST:-300,CDT:-300,CST:-360,MDT:-360,MST:-420,PDT:-420,PST:-480};function me(t){var e,i,n,o,r,s,a=t._i,h=de.exec(a)||ue.exec(a);if(h){for(v(t).iso=!0,e=0,i=fe.length;e<i;e++)if(fe[e][1].exec(h[1])){o=fe[e][0],n=!1!==fe[e][2];break}if(null==o)return void(t._isValid=!1);if(h[3]){for(e=0,i=pe.length;e<i;e++)if(pe[e][1].exec(h[3])){r=(h[2]||" ")+pe[e][0];break}if(null==r)return void(t._isValid=!1)}if(!n&&null!=r)return void(t._isValid=!1);if(h[4]){if(!ce.exec(h[4]))return void(t._isValid=!1);s="Z"}t._f=o+(r||"")+(s||""),xe(t)}else t._isValid=!1}function be(t){var e=parseInt(t,10);return e<=49?2e3+e:e<=999?1900+e:e}function we(t){var e,i,n,o,r,s,a,h,l=ge.exec(t._i.replace(/\([^)]*\)|[\n\t]/g," ").replace(/(\s\s+)/g," ").replace(/^\s\s*/,"").replace(/\s\s*$/,""));if(l){if(i=l[4],n=l[3],o=l[2],r=l[5],s=l[6],a=l[7],h=[be(i),Ot.indexOf(n),parseInt(o,10),parseInt(r,10),parseInt(s,10)],a&&h.push(parseInt(a,10)),e=h,!function(t,e,i){return!t||Wt.indexOf(t)===new Date(e[0],e[1],e[2]).getDay()||(v(i).weekdayMismatch=!0,i._isValid=!1,!1)}(l[1],e,t))return;t._a=e,t._tzm=function(t,e,i){if(t)return ye[t];if(e)return 0;var n=parseInt(i,10),o=n%100;return(n-o)/100*60+o}(l[8],l[9],l[10]),t._d=Ft.apply(null,t._a),t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),v(t).rfc2822=!0}else t._isValid=!1}function _e(t,e,i){return null!=t?t:null!=e?e:i}function ke(t){var e,i,n,r,s,a=[];if(!t._d){for(n=function(t){var e=new Date(o.now());return t._useUTC?[e.getUTCFullYear(),e.getUTCMonth(),e.getUTCDate()]:[e.getFullYear(),e.getMonth(),e.getDate()]}(t),t._w&&null==t._a[2]&&null==t._a[1]&&function(t){var e,i,n,o,r,s,a,h,l;null!=(e=t._w).GG||null!=e.W||null!=e.E?(r=1,s=4,i=_e(e.GG,t._a[0],Bt(Ee(),1,4).year),n=_e(e.W,1),((o=_e(e.E,1))<1||o>7)&&(h=!0)):(r=t._locale._week.dow,s=t._locale._week.doy,l=Bt(Ee(),r,s),i=_e(e.gg,t._a[0],l.year),n=_e(e.w,l.week),null!=e.d?((o=e.d)<0||o>6)&&(h=!0):null!=e.e?(o=e.e+r,(e.e<0||e.e>6)&&(h=!0)):o=r),n<1||n>Rt(i,r,s)?v(t)._overflowWeeks=!0:null!=h?v(t)._overflowWeekday=!0:(a=zt(i,n,o,r,s),t._a[0]=a.year,t._dayOfYear=a.dayOfYear)}(t),null!=t._dayOfYear&&(s=_e(t._a[0],n[0]),(t._dayOfYear>Nt(s)||0===t._dayOfYear)&&(v(t)._overflowDayOfYear=!0),i=Ft(s,0,t._dayOfYear),t._a[1]=i.getUTCMonth(),t._a[2]=i.getUTCDate()),e=0;e<3&&null==t._a[e];++e)t._a[e]=a[e]=n[e];for(;e<7;e++)t._a[e]=a[e]=null==t._a[e]?2===e?1:0:t._a[e];24===t._a[3]&&0===t._a[4]&&0===t._a[5]&&0===t._a[6]&&(t._nextDay=!0,t._a[3]=0),t._d=(t._useUTC?Ft:At).apply(null,a),r=t._useUTC?t._d.getUTCDay():t._d.getDay(),null!=t._tzm&&t._d.setUTCMinutes(t._d.getUTCMinutes()-t._tzm),t._nextDay&&(t._a[3]=24),t._w&&void 0!==t._w.d&&t._w.d!==r&&(v(t).weekdayMismatch=!0)}}function xe(t){if(t._f!==o.ISO_8601)if(t._f!==o.RFC_2822){t._a=[],v(t).empty=!0;var e,i,n,r,s,a,h=""+t._i,l=h.length,d=0;for(n=B(t._f,t._locale).match(N)||[],e=0;e<n.length;e++)r=n[e],(i=(h.match(vt(r,t))||[])[0])&&((s=h.substr(0,h.indexOf(i))).length>0&&v(t).unusedInput.push(s),h=h.slice(h.indexOf(i)+i.length),d+=i.length),F[r]?(i?v(t).empty=!1:v(t).unusedTokens.push(r),_t(r,i,t)):t._strict&&!i&&v(t).unusedTokens.push(r);v(t).charsLeftOver=l-d,h.length>0&&v(t).unusedInput.push(h),t._a[3]<=12&&!0===v(t).bigHour&&t._a[3]>0&&(v(t).bigHour=void 0),v(t).parsedDateParts=t._a.slice(0),v(t).meridiem=t._meridiem,t._a[3]=function(t,e,i){var n;return null==i?e:null!=t.meridiemHour?t.meridiemHour(e,i):null!=t.isPM?((n=t.isPM(i))&&e<12&&(e+=12),n||12!==e||(e=0),e):e}(t._locale,t._a[3],t._meridiem),null!==(a=v(t).era)&&(t._a[0]=t._locale.erasConvertYear(a,t._a[0])),ke(t),le(t)}else we(t);else me(t)}function Oe(t){var e=t._i,i=t._f;return t._locale=t._locale||he(t._l),null===e||void 0===i&&""===e?y({nullInput:!0}):("string"==typeof e&&(t._i=e=t._locale.preparse(e)),k(e)?new _(le(e)):(u(e)?t._d=e:r(i)?function(t){var e,i,n,o,r,s,a=!1;if(0===t._f.length)return v(t).invalidFormat=!0,void(t._d=new Date(NaN));for(o=0;o<t._f.length;o++)r=0,s=!1,e=w({},t),null!=t._useUTC&&(e._useUTC=t._useUTC),e._f=t._f[o],xe(e),g(e)&&(s=!0),r+=v(e).charsLeftOver,r+=10*v(e).unusedTokens.length,v(e).score=r,a?r<n&&(n=r,i=e):(null==n||r<n||s)&&(n=r,i=e,s&&(a=!0));f(t,i||e)}(t):i?xe(t):function(t){var e=t._i;l(e)?t._d=new Date(o.now()):u(e)?t._d=new Date(e.valueOf()):"string"==typeof e?function(t){var e=ve.exec(t._i);null===e?(me(t),!1===t._isValid&&(delete t._isValid,we(t),!1===t._isValid&&(delete t._isValid,t._strict?t._isValid=!1:o.createFromInputFallback(t)))):t._d=new Date(+e[1])}(t):r(e)?(t._a=c(e.slice(0),(function(t){return parseInt(t,10)})),ke(t)):s(e)?function(t){if(!t._d){var e=W(t._i),i=void 0===e.day?e.date:e.day;t._a=c([e.year,e.month,i,e.hour,e.minute,e.second,e.millisecond],(function(t){return t&&parseInt(t,10)})),ke(t)}}(t):d(e)?t._d=new Date(e):o.createFromInputFallback(t)}(t),g(t)||(t._d=null),t))}function Se(t,e,i,n,o){var a,l={};return!0!==e&&!1!==e||(n=e,e=void 0),!0!==i&&!1!==i||(n=i,i=void 0),(s(t)&&h(t)||r(t)&&0===t.length)&&(t=void 0),l._isAMomentObject=!0,l._useUTC=l._isUTC=o,l._l=i,l._i=t,l._f=e,l._strict=n,(a=new _(le(Oe(l))))._nextDay&&(a.add(1,"d"),a._nextDay=void 0),a}function Ee(t,e,i,n){return Se(t,e,i,n,!1)}o.createFromInputFallback=O("value provided is not in a recognized RFC2822 or ISO format. moment construction falls back to js Date(), which is not reliable across all browsers and versions. Non RFC2822/ISO date formats are discouraged and will be removed in an upcoming major release. Please refer to http://momentjs.com/guides/#/warnings/js-date/ for more info.",(function(t){t._d=new Date(t._i+(t._useUTC?" UTC":""))})),o.ISO_8601=function(){},o.RFC_2822=function(){};var De=O("moment().min is deprecated, use moment.max instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ee.apply(null,arguments);return this.isValid()&&t.isValid()?t<this?this:t:y()})),Me=O("moment().max is deprecated, use moment.min instead. http://momentjs.com/guides/#/warnings/min-max/",(function(){var t=Ee.apply(null,arguments);return this.isValid()&&t.isValid()?t>this?this:t:y()}));function Ce(t,e){var i,n;if(1===e.length&&r(e[0])&&(e=e[0]),!e.length)return Ee();for(i=e[0],n=1;n<e.length;++n)e[n].isValid()&&!e[n][t](i)||(i=e[n]);return i}var Te=["year","quarter","month","week","day","hour","minute","second","millisecond"];function Pe(t){var e=W(t),i=e.year||0,n=e.quarter||0,o=e.month||0,r=e.week||e.isoWeek||0,s=e.day||0,h=e.hour||0,l=e.minute||0,d=e.second||0,u=e.millisecond||0;this._isValid=function(t){var e,i,n=!1;for(e in t)if(a(t,e)&&(-1===yt.call(Te,e)||null!=t[e]&&isNaN(t[e])))return!1;for(i=0;i<Te.length;++i)if(t[Te[i]]){if(n)return!1;parseFloat(t[Te[i]])!==q(t[Te[i]])&&(n=!0)}return!0}(e),this._milliseconds=+u+1e3*d+6e4*l+1e3*h*60*60,this._days=+s+7*r,this._months=+o+3*n+12*i,this._data={},this._locale=he(),this._bubble()}function Ne(t){return t instanceof Pe}function Ie(t){return t<0?-1*Math.round(-1*t):Math.round(t)}function Ae(t,e){j(t,0,0,(function(){var t=this.utcOffset(),i="+";return t<0&&(t=-t,i="-"),i+P(~~(t/60),2)+e+P(~~t%60,2)}))}Ae("Z",":"),Ae("ZZ",""),pt("Z",ct),pt("ZZ",ct),bt(["Z","ZZ"],(function(t,e,i){i._useUTC=!0,i._tzm=je(ct,t)}));var Fe=/([\+\-]|\d\d)/gi;function je(t,e){var i,n,o=(e||"").match(t);return null===o?null:0===(n=60*(i=((o[o.length-1]||[])+"").match(Fe)||["-",0,0])[1]+q(i[2]))?0:"+"===i[0]?n:-n}function ze(t,e){var i,n;return e._isUTC?(i=e.clone(),n=(k(t)||u(t)?t.valueOf():Ee(t).valueOf())-i.valueOf(),i._d.setTime(i._d.valueOf()+n),o.updateOffset(i,!1),i):Ee(t).local()}function Be(t){return-Math.round(t._d.getTimezoneOffset())}function Re(){return!!this.isValid()&&this._isUTC&&0===this._offset}o.updateOffset=function(){};var Le=/^(-|\+)?(?:(\d*)[. ])?(\d+):(\d+)(?::(\d+)(\.\d*)?)?$/,He=/^(-|\+)?P(?:([-+]?[0-9,.]*)Y)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)W)?(?:([-+]?[0-9,.]*)D)?(?:T(?:([-+]?[0-9,.]*)H)?(?:([-+]?[0-9,.]*)M)?(?:([-+]?[0-9,.]*)S)?)?$/;function We(t,e){var i,n,o,r,s,h,l=t,u=null;return Ne(t)?l={ms:t._milliseconds,d:t._days,M:t._months}:d(t)||!isNaN(+t)?(l={},e?l[e]=+t:l.milliseconds=+t):(u=Le.exec(t))?(i="-"===u[1]?-1:1,l={y:0,d:q(u[2])*i,h:q(u[3])*i,m:q(u[4])*i,s:q(u[5])*i,ms:q(Ie(1e3*u[6]))*i}):(u=He.exec(t))?(i="-"===u[1]?-1:1,l={y:Ye(u[2],i),M:Ye(u[3],i),w:Ye(u[4],i),d:Ye(u[5],i),h:Ye(u[6],i),m:Ye(u[7],i),s:Ye(u[8],i)}):null==l?l={}:"object"==typeof l&&("from"in l||"to"in l)&&(r=Ee(l.from),s=Ee(l.to),o=r.isValid()&&s.isValid()?(s=ze(s,r),r.isBefore(s)?h=Ve(r,s):((h=Ve(s,r)).milliseconds=-h.milliseconds,h.months=-h.months),h):{milliseconds:0,months:0},(l={}).ms=o.milliseconds,l.M=o.months),n=new Pe(l),Ne(t)&&a(t,"_locale")&&(n._locale=t._locale),Ne(t)&&a(t,"_isValid")&&(n._isValid=t._isValid),n}function Ye(t,e){var i=t&&parseFloat(t.replace(",","."));return(isNaN(i)?0:i)*e}function Ve(t,e){var i={};return i.months=e.month()-t.month()+12*(e.year()-t.year()),t.clone().add(i.months,"M").isAfter(e)&&--i.months,i.milliseconds=+e-+t.clone().add(i.months,"M"),i}function Ue(t,e){return function(i,n){var o;return null===n||isNaN(+n)||(D(e,"moment()."+e+"(period, number) is deprecated. Please use moment()."+e+"(number, period). See http://momentjs.com/guides/#/warnings/add-inverted-param/ for more info."),o=i,i=n,n=o),Ge(this,We(i,n),t),this}}function Ge(t,e,i,n){var r=e._milliseconds,s=Ie(e._days),a=Ie(e._months);t.isValid()&&(n=null==n||n,a&&Ct(t,$(t,"Month")+a*i),s&&K(t,"Date",$(t,"Date")+s*i),r&&t._d.setTime(t._d.valueOf()+r*i),n&&o.updateOffset(t,s||a))}We.fn=Pe.prototype,We.invalid=function(){return We(NaN)};var qe=Ue(1,"add"),Xe=Ue(-1,"subtract");function $e(t){return"string"==typeof t||t instanceof String}function Ke(t){return k(t)||u(t)||$e(t)||d(t)||function(t){var e=r(t),i=!1;return e&&(i=0===t.filter((function(e){return!d(e)&&$e(t)})).length),e&&i}(t)||function(t){var e,i,n=s(t)&&!h(t),o=!1,r=["years","year","y","months","month","M","days","day","d","dates","date","D","hours","hour","h","minutes","minute","m","seconds","second","s","milliseconds","millisecond","ms"];for(e=0;e<r.length;e+=1)i=r[e],o=o||a(t,i);return n&&o}(t)||null==t}function Ze(t){var e,i=s(t)&&!h(t),n=!1,o=["sameDay","nextDay","lastDay","nextWeek","lastWeek","sameElse"];for(e=0;e<o.length;e+=1)n=n||a(t,o[e]);return i&&n}function Qe(t,e){if(t.date()<e.date())return-Qe(e,t);var i=12*(e.year()-t.year())+(e.month()-t.month()),n=t.clone().add(i,"months");return-(i+(e-n<0?(e-n)/(n-t.clone().add(i-1,"months")):(e-n)/(t.clone().add(i+1,"months")-n)))||0}function Je(t){var e;return void 0===t?this._locale._abbr:(null!=(e=he(t))&&(this._locale=e),this)}o.defaultFormat="YYYY-MM-DDTHH:mm:ssZ",o.defaultFormatUtc="YYYY-MM-DDTHH:mm:ss[Z]";var ti=O("moment().lang() is deprecated. Instead, use moment().localeData() to get the language configuration. Use moment().locale() to change languages.",(function(t){return void 0===t?this.localeData():this.locale(t)}));function ei(){return this._locale}function ii(t,e){return(t%e+e)%e}function ni(t,e,i){return t<100&&t>=0?new Date(t+400,e,i)-126227808e5:new Date(t,e,i).valueOf()}function oi(t,e,i){return t<100&&t>=0?Date.UTC(t+400,e,i)-126227808e5:Date.UTC(t,e,i)}function ri(t,e){return e.erasAbbrRegex(t)}function si(){var t,e,i=[],n=[],o=[],r=[],s=this.eras();for(t=0,e=s.length;t<e;++t)n.push(gt(s[t].name)),i.push(gt(s[t].abbr)),o.push(gt(s[t].narrow)),r.push(gt(s[t].name)),r.push(gt(s[t].abbr)),r.push(gt(s[t].narrow));this._erasRegex=new RegExp("^("+r.join("|")+")","i"),this._erasNameRegex=new RegExp("^("+n.join("|")+")","i"),this._erasAbbrRegex=new RegExp("^("+i.join("|")+")","i"),this._erasNarrowRegex=new RegExp("^("+o.join("|")+")","i")}function ai(t,e){j(0,[t,t.length],0,e)}function hi(t,e,i,n,o){var r;return null==t?Bt(this,n,o).year:(e>(r=Rt(t,n,o))&&(e=r),li.call(this,t,e,i,n,o))}function li(t,e,i,n,o){var r=zt(t,e,i,n,o),s=Ft(r.year,0,r.dayOfYear);return this.year(s.getUTCFullYear()),this.month(s.getUTCMonth()),this.date(s.getUTCDate()),this}j("N",0,0,"eraAbbr"),j("NN",0,0,"eraAbbr"),j("NNN",0,0,"eraAbbr"),j("NNNN",0,0,"eraName"),j("NNNNN",0,0,"eraNarrow"),j("y",["y",1],"yo","eraYear"),j("y",["yy",2],0,"eraYear"),j("y",["yyy",3],0,"eraYear"),j("y",["yyyy",4],0,"eraYear"),pt("N",ri),pt("NN",ri),pt("NNN",ri),pt("NNNN",(function(t,e){return e.erasNameRegex(t)})),pt("NNNNN",(function(t,e){return e.erasNarrowRegex(t)})),bt(["N","NN","NNN","NNNN","NNNNN"],(function(t,e,i,n){var o=i._locale.erasParse(t,n,i._strict);o?v(i).era=o:v(i).invalidEra=t})),pt("y",lt),pt("yy",lt),pt("yyy",lt),pt("yyyy",lt),pt("yo",(function(t,e){return e._eraYearOrdinalRegex||lt})),bt(["y","yy","yyy","yyyy"],0),bt(["yo"],(function(t,e,i,n){var o;i._locale._eraYearOrdinalRegex&&(o=t.match(i._locale._eraYearOrdinalRegex)),i._locale.eraYearOrdinalParse?e[0]=i._locale.eraYearOrdinalParse(t,o):e[0]=parseInt(t,10)})),j(0,["gg",2],0,(function(){return this.weekYear()%100})),j(0,["GG",2],0,(function(){return this.isoWeekYear()%100})),ai("gggg","weekYear"),ai("ggggg","weekYear"),ai("GGGG","isoWeekYear"),ai("GGGGG","isoWeekYear"),L("weekYear","gg"),L("isoWeekYear","GG"),V("weekYear",1),V("isoWeekYear",1),pt("G",dt),pt("g",dt),pt("GG",nt,J),pt("gg",nt,J),pt("GGGG",at,et),pt("gggg",at,et),pt("GGGGG",ht,it),pt("ggggg",ht,it),wt(["gggg","ggggg","GGGG","GGGGG"],(function(t,e,i,n){e[n.substr(0,2)]=q(t)})),wt(["gg","GG"],(function(t,e,i,n){e[n]=o.parseTwoDigitYear(t)})),j("Q",0,"Qo","quarter"),L("quarter","Q"),V("quarter",7),pt("Q",Q),bt("Q",(function(t,e){e[1]=3*(q(t)-1)})),j("D",["DD",2],"Do","date"),L("date","D"),V("date",9),pt("D",nt),pt("DD",nt,J),pt("Do",(function(t,e){return t?e._dayOfMonthOrdinalParse||e._ordinalParse:e._dayOfMonthOrdinalParseLenient})),bt(["D","DD"],2),bt("Do",(function(t,e){e[2]=q(t.match(nt)[0])}));var di=X("Date",!0);j("DDD",["DDDD",3],"DDDo","dayOfYear"),L("dayOfYear","DDD"),V("dayOfYear",4),pt("DDD",st),pt("DDDD",tt),bt(["DDD","DDDD"],(function(t,e,i){i._dayOfYear=q(t)})),j("m",["mm",2],0,"minute"),L("minute","m"),V("minute",14),pt("m",nt),pt("mm",nt,J),bt(["m","mm"],4);var ui=X("Minutes",!1);j("s",["ss",2],0,"second"),L("second","s"),V("second",15),pt("s",nt),pt("ss",nt,J),bt(["s","ss"],5);var ci,fi,pi=X("Seconds",!1);for(j("S",0,0,(function(){return~~(this.millisecond()/100)})),j(0,["SS",2],0,(function(){return~~(this.millisecond()/10)})),j(0,["SSS",3],0,"millisecond"),j(0,["SSSS",4],0,(function(){return 10*this.millisecond()})),j(0,["SSSSS",5],0,(function(){return 100*this.millisecond()})),j(0,["SSSSSS",6],0,(function(){return 1e3*this.millisecond()})),j(0,["SSSSSSS",7],0,(function(){return 1e4*this.millisecond()})),j(0,["SSSSSSSS",8],0,(function(){return 1e5*this.millisecond()})),j(0,["SSSSSSSSS",9],0,(function(){return 1e6*this.millisecond()})),L("millisecond","ms"),V("millisecond",16),pt("S",st,Q),pt("SS",st,J),pt("SSS",st,tt),ci="SSSS";ci.length<=9;ci+="S")pt(ci,lt);function vi(t,e){e[6]=q(1e3*("0."+t))}for(ci="S";ci.length<=9;ci+="S")bt(ci,vi);fi=X("Milliseconds",!1),j("z",0,0,"zoneAbbr"),j("zz",0,0,"zoneName");var gi=_.prototype;function yi(t){return t}gi.add=qe,gi.calendar=function(t,e){1===arguments.length&&(Ke(arguments[0])?(t=arguments[0],e=void 0):Ze(arguments[0])&&(e=arguments[0],t=void 0));var i=t||Ee(),n=ze(i,this).startOf("day"),r=o.calendarFormat(this,n)||"sameElse",s=e&&(M(e[r])?e[r].call(this,i):e[r]);return this.format(s||this.localeData().calendar(r,this,Ee(i)))},gi.clone=function(){return new _(this)},gi.diff=function(t,e,i){var n,o,r;if(!this.isValid())return NaN;if(!(n=ze(t,this)).isValid())return NaN;switch(o=6e4*(n.utcOffset()-this.utcOffset()),e=H(e)){case"year":r=Qe(this,n)/12;break;case"month":r=Qe(this,n);break;case"quarter":r=Qe(this,n)/3;break;case"second":r=(this-n)/1e3;break;case"minute":r=(this-n)/6e4;break;case"hour":r=(this-n)/36e5;break;case"day":r=(this-n-o)/864e5;break;case"week":r=(this-n-o)/6048e5;break;default:r=this-n}return i?r:G(r)},gi.endOf=function(t){var e,i;if(void 0===(t=H(t))||"millisecond"===t||!this.isValid())return this;switch(i=this._isUTC?oi:ni,t){case"year":e=i(this.year()+1,0,1)-1;break;case"quarter":e=i(this.year(),this.month()-this.month()%3+3,1)-1;break;case"month":e=i(this.year(),this.month()+1,1)-1;break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday()+7)-1;break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1)+7)-1;break;case"day":case"date":e=i(this.year(),this.month(),this.date()+1)-1;break;case"hour":e=this._d.valueOf(),e+=36e5-ii(e+(this._isUTC?0:6e4*this.utcOffset()),36e5)-1;break;case"minute":e=this._d.valueOf(),e+=6e4-ii(e,6e4)-1;break;case"second":e=this._d.valueOf(),e+=1e3-ii(e,1e3)-1}return this._d.setTime(e),o.updateOffset(this,!0),this},gi.format=function(t){t||(t=this.isUtc()?o.defaultFormatUtc:o.defaultFormat);var e=z(this,t);return this.localeData().postformat(e)},gi.from=function(t,e){return this.isValid()&&(k(t)&&t.isValid()||Ee(t).isValid())?We({to:this,from:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},gi.fromNow=function(t){return this.from(Ee(),t)},gi.to=function(t,e){return this.isValid()&&(k(t)&&t.isValid()||Ee(t).isValid())?We({from:this,to:t}).locale(this.locale()).humanize(!e):this.localeData().invalidDate()},gi.toNow=function(t){return this.to(Ee(),t)},gi.get=function(t){return M(this[t=H(t)])?this[t]():this},gi.invalidAt=function(){return v(this).overflow},gi.isAfter=function(t,e){var i=k(t)?t:Ee(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=H(e)||"millisecond")?this.valueOf()>i.valueOf():i.valueOf()<this.clone().startOf(e).valueOf())},gi.isBefore=function(t,e){var i=k(t)?t:Ee(t);return!(!this.isValid()||!i.isValid())&&("millisecond"===(e=H(e)||"millisecond")?this.valueOf()<i.valueOf():this.clone().endOf(e).valueOf()<i.valueOf())},gi.isBetween=function(t,e,i,n){var o=k(t)?t:Ee(t),r=k(e)?e:Ee(e);return!!(this.isValid()&&o.isValid()&&r.isValid())&&(("("===(n=n||"()")[0]?this.isAfter(o,i):!this.isBefore(o,i))&&(")"===n[1]?this.isBefore(r,i):!this.isAfter(r,i)))},gi.isSame=function(t,e){var i,n=k(t)?t:Ee(t);return!(!this.isValid()||!n.isValid())&&("millisecond"===(e=H(e)||"millisecond")?this.valueOf()===n.valueOf():(i=n.valueOf(),this.clone().startOf(e).valueOf()<=i&&i<=this.clone().endOf(e).valueOf()))},gi.isSameOrAfter=function(t,e){return this.isSame(t,e)||this.isAfter(t,e)},gi.isSameOrBefore=function(t,e){return this.isSame(t,e)||this.isBefore(t,e)},gi.isValid=function(){return g(this)},gi.lang=ti,gi.locale=Je,gi.localeData=ei,gi.max=Me,gi.min=De,gi.parsingFlags=function(){return f({},v(this))},gi.set=function(t,e){if("object"==typeof t){var i,n=function(t){var e,i=[];for(e in t)a(t,e)&&i.push({unit:e,priority:Y[e]});return i.sort((function(t,e){return t.priority-e.priority})),i}(t=W(t));for(i=0;i<n.length;i++)this[n[i].unit](t[n[i].unit])}else if(M(this[t=H(t)]))return this[t](e);return this},gi.startOf=function(t){var e,i;if(void 0===(t=H(t))||"millisecond"===t||!this.isValid())return this;switch(i=this._isUTC?oi:ni,t){case"year":e=i(this.year(),0,1);break;case"quarter":e=i(this.year(),this.month()-this.month()%3,1);break;case"month":e=i(this.year(),this.month(),1);break;case"week":e=i(this.year(),this.month(),this.date()-this.weekday());break;case"isoWeek":e=i(this.year(),this.month(),this.date()-(this.isoWeekday()-1));break;case"day":case"date":e=i(this.year(),this.month(),this.date());break;case"hour":e=this._d.valueOf(),e-=ii(e+(this._isUTC?0:6e4*this.utcOffset()),36e5);break;case"minute":e=this._d.valueOf(),e-=ii(e,6e4);break;case"second":e=this._d.valueOf(),e-=ii(e,1e3)}return this._d.setTime(e),o.updateOffset(this,!0),this},gi.subtract=Xe,gi.toArray=function(){var t=this;return[t.year(),t.month(),t.date(),t.hour(),t.minute(),t.second(),t.millisecond()]},gi.toObject=function(){var t=this;return{years:t.year(),months:t.month(),date:t.date(),hours:t.hours(),minutes:t.minutes(),seconds:t.seconds(),milliseconds:t.milliseconds()}},gi.toDate=function(){return new Date(this.valueOf())},gi.toISOString=function(t){if(!this.isValid())return null;var e=!0!==t,i=e?this.clone().utc():this;return i.year()<0||i.year()>9999?z(i,e?"YYYYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYYYY-MM-DD[T]HH:mm:ss.SSSZ"):M(Date.prototype.toISOString)?e?this.toDate().toISOString():new Date(this.valueOf()+60*this.utcOffset()*1e3).toISOString().replace("Z",z(i,"Z")):z(i,e?"YYYY-MM-DD[T]HH:mm:ss.SSS[Z]":"YYYY-MM-DD[T]HH:mm:ss.SSSZ")},gi.inspect=function(){if(!this.isValid())return"moment.invalid(/* "+this._i+" */)";var t,e,i,n="moment",o="";return this.isLocal()||(n=0===this.utcOffset()?"moment.utc":"moment.parseZone",o="Z"),t="["+n+'("]',e=0<=this.year()&&this.year()<=9999?"YYYY":"YYYYYY",i=o+'[")]',this.format(t+e+"-MM-DD[T]HH:mm:ss.SSS"+i)},"undefined"!=typeof Symbol&&null!=Symbol.for&&(gi[Symbol.for("nodejs.util.inspect.custom")]=function(){return"Moment<"+this.format()+">"}),gi.toJSON=function(){return this.isValid()?this.toISOString():null},gi.toString=function(){return this.clone().locale("en").format("ddd MMM DD YYYY HH:mm:ss [GMT]ZZ")},gi.unix=function(){return Math.floor(this.valueOf()/1e3)},gi.valueOf=function(){return this._d.valueOf()-6e4*(this._offset||0)},gi.creationData=function(){return{input:this._i,format:this._f,locale:this._locale,isUTC:this._isUTC,strict:this._strict}},gi.eraName=function(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].name;if(n[t].until<=i&&i<=n[t].since)return n[t].name}return""},gi.eraNarrow=function(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].narrow;if(n[t].until<=i&&i<=n[t].since)return n[t].narrow}return""},gi.eraAbbr=function(){var t,e,i,n=this.localeData().eras();for(t=0,e=n.length;t<e;++t){if(i=this.startOf("day").valueOf(),n[t].since<=i&&i<=n[t].until)return n[t].abbr;if(n[t].until<=i&&i<=n[t].since)return n[t].abbr}return""},gi.eraYear=function(){var t,e,i,n,r=this.localeData().eras();for(t=0,e=r.length;t<e;++t)if(i=r[t].since<=r[t].until?1:-1,n=this.startOf("day").valueOf(),r[t].since<=n&&n<=r[t].until||r[t].until<=n&&n<=r[t].since)return(this.year()-o(r[t].since).year())*i+r[t].offset;return this.year()},gi.year=It,gi.isLeapYear=function(){return U(this.year())},gi.weekYear=function(t){return hi.call(this,t,this.week(),this.weekday(),this.localeData()._week.dow,this.localeData()._week.doy)},gi.isoWeekYear=function(t){return hi.call(this,t,this.isoWeek(),this.isoWeekday(),1,4)},gi.quarter=gi.quarters=function(t){return null==t?Math.ceil((this.month()+1)/3):this.month(3*(t-1)+this.month()%3)},gi.month=Tt,gi.daysInMonth=function(){return kt(this.year(),this.month())},gi.week=gi.weeks=function(t){var e=this.localeData().week(this);return null==t?e:this.add(7*(t-e),"d")},gi.isoWeek=gi.isoWeeks=function(t){var e=Bt(this,1,4).week;return null==t?e:this.add(7*(t-e),"d")},gi.weeksInYear=function(){var t=this.localeData()._week;return Rt(this.year(),t.dow,t.doy)},gi.weeksInWeekYear=function(){var t=this.localeData()._week;return Rt(this.weekYear(),t.dow,t.doy)},gi.isoWeeksInYear=function(){return Rt(this.year(),1,4)},gi.isoWeeksInISOWeekYear=function(){return Rt(this.isoWeekYear(),1,4)},gi.date=di,gi.day=gi.days=function(t){if(!this.isValid())return null!=t?this:NaN;var e=this._isUTC?this._d.getUTCDay():this._d.getDay();return null!=t?(t=function(t,e){return"string"!=typeof t?t:isNaN(t)?"number"==typeof(t=e.weekdaysParse(t))?t:null:parseInt(t,10)}(t,this.localeData()),this.add(t-e,"d")):e},gi.weekday=function(t){if(!this.isValid())return null!=t?this:NaN;var e=(this.day()+7-this.localeData()._week.dow)%7;return null==t?e:this.add(t-e,"d")},gi.isoWeekday=function(t){if(!this.isValid())return null!=t?this:NaN;if(null!=t){var e=function(t,e){return"string"==typeof t?e.weekdaysParse(t)%7||7:isNaN(t)?null:t}(t,this.localeData());return this.day(this.day()%7?e:e-7)}return this.day()||7},gi.dayOfYear=function(t){var e=Math.round((this.clone().startOf("day")-this.clone().startOf("year"))/864e5)+1;return null==t?e:this.add(t-e,"d")},gi.hour=gi.hours=Jt,gi.minute=gi.minutes=ui,gi.second=gi.seconds=pi,gi.millisecond=gi.milliseconds=fi,gi.utcOffset=function(t,e,i){var n,r=this._offset||0;if(!this.isValid())return null!=t?this:NaN;if(null!=t){if("string"==typeof t){if(null===(t=je(ct,t)))return this}else Math.abs(t)<16&&!i&&(t*=60);return!this._isUTC&&e&&(n=Be(this)),this._offset=t,this._isUTC=!0,null!=n&&this.add(n,"m"),r!==t&&(!e||this._changeInProgress?Ge(this,We(t-r,"m"),1,!1):this._changeInProgress||(this._changeInProgress=!0,o.updateOffset(this,!0),this._changeInProgress=null)),this}return this._isUTC?r:Be(this)},gi.utc=function(t){return this.utcOffset(0,t)},gi.local=function(t){return this._isUTC&&(this.utcOffset(0,t),this._isUTC=!1,t&&this.subtract(Be(this),"m")),this},gi.parseZone=function(){if(null!=this._tzm)this.utcOffset(this._tzm,!1,!0);else if("string"==typeof this._i){var t=je(ut,this._i);null!=t?this.utcOffset(t):this.utcOffset(0,!0)}return this},gi.hasAlignedHourOffset=function(t){return!!this.isValid()&&(t=t?Ee(t).utcOffset():0,(this.utcOffset()-t)%60==0)},gi.isDST=function(){return this.utcOffset()>this.clone().month(0).utcOffset()||this.utcOffset()>this.clone().month(5).utcOffset()},gi.isLocal=function(){return!!this.isValid()&&!this._isUTC},gi.isUtcOffset=function(){return!!this.isValid()&&this._isUTC},gi.isUtc=Re,gi.isUTC=Re,gi.zoneAbbr=function(){return this._isUTC?"UTC":""},gi.zoneName=function(){return this._isUTC?"Coordinated Universal Time":""},gi.dates=O("dates accessor is deprecated. Use date instead.",di),gi.months=O("months accessor is deprecated. Use month instead",Tt),gi.years=O("years accessor is deprecated. Use year instead",It),gi.zone=O("moment().zone is deprecated, use moment().utcOffset instead. http://momentjs.com/guides/#/warnings/zone/",(function(t,e){return null!=t?("string"!=typeof t&&(t=-t),this.utcOffset(t,e),this):-this.utcOffset()})),gi.isDSTShifted=O("isDSTShifted is deprecated. See http://momentjs.com/guides/#/warnings/dst-shifted/ for more information",(function(){if(!l(this._isDSTShifted))return this._isDSTShifted;var t,e={};return w(e,this),(e=Oe(e))._a?(t=e._isUTC?p(e._a):Ee(e._a),this._isDSTShifted=this.isValid()&&function(t,e,i){var n,o=Math.min(t.length,e.length),r=Math.abs(t.length-e.length),s=0;for(n=0;n<o;n++)(i&&t[n]!==e[n]||!i&&q(t[n])!==q(e[n]))&&s++;return s+r}(e._a,t.toArray())>0):this._isDSTShifted=!1,this._isDSTShifted}));var mi=T.prototype;function bi(t,e,i,n){var o=he(),r=p().set(n,e);return o[i](r,t)}function wi(t,e,i){if(d(t)&&(e=t,t=void 0),t=t||"",null!=e)return bi(t,e,i,"month");var n,o=[];for(n=0;n<12;n++)o[n]=bi(t,n,i,"month");return o}function _i(t,e,i,n){"boolean"==typeof t?(d(e)&&(i=e,e=void 0),e=e||""):(i=e=t,t=!1,d(e)&&(i=e,e=void 0),e=e||"");var o,r=he(),s=t?r._week.dow:0,a=[];if(null!=i)return bi(e,(i+s)%7,n,"day");for(o=0;o<7;o++)a[o]=bi(e,(o+s)%7,n,"day");return a}mi.calendar=function(t,e,i){var n=this._calendar[t]||this._calendar.sameElse;return M(n)?n.call(e,i):n},mi.longDateFormat=function(t){var e=this._longDateFormat[t],i=this._longDateFormat[t.toUpperCase()];return e||!i?e:(this._longDateFormat[t]=i.match(N).map((function(t){return"MMMM"===t||"MM"===t||"DD"===t||"dddd"===t?t.slice(1):t})).join(""),this._longDateFormat[t])},mi.invalidDate=function(){return this._invalidDate},mi.ordinal=function(t){return this._ordinal.replace("%d",t)},mi.preparse=yi,mi.postformat=yi,mi.relativeTime=function(t,e,i,n){var o=this._relativeTime[i];return M(o)?o(t,e,i,n):o.replace(/%d/i,t)},mi.pastFuture=function(t,e){var i=this._relativeTime[t>0?"future":"past"];return M(i)?i(e):i.replace(/%s/i,e)},mi.set=function(t){var e,i;for(i in t)a(t,i)&&(M(e=t[i])?this[i]=e:this["_"+i]=e);this._config=t,this._dayOfMonthOrdinalParseLenient=new RegExp((this._dayOfMonthOrdinalParse.source||this._ordinalParse.source)+"|"+/\d{1,2}/.source)},mi.eras=function(t,e){var i,n,r,s=this._eras||he("en")._eras;for(i=0,n=s.length;i<n;++i){switch(typeof s[i].since){case"string":r=o(s[i].since).startOf("day"),s[i].since=r.valueOf()}switch(typeof s[i].until){case"undefined":s[i].until=1/0;break;case"string":r=o(s[i].until).startOf("day").valueOf(),s[i].until=r.valueOf()}}return s},mi.erasParse=function(t,e,i){var n,o,r,s,a,h=this.eras();for(t=t.toUpperCase(),n=0,o=h.length;n<o;++n)if(r=h[n].name.toUpperCase(),s=h[n].abbr.toUpperCase(),a=h[n].narrow.toUpperCase(),i)switch(e){case"N":case"NN":case"NNN":if(s===t)return h[n];break;case"NNNN":if(r===t)return h[n];break;case"NNNNN":if(a===t)return h[n]}else if([r,s,a].indexOf(t)>=0)return h[n]},mi.erasConvertYear=function(t,e){var i=t.since<=t.until?1:-1;return void 0===e?o(t.since).year():o(t.since).year()+(e-t.offset)*i},mi.erasAbbrRegex=function(t){return a(this,"_erasAbbrRegex")||si.call(this),t?this._erasAbbrRegex:this._erasRegex},mi.erasNameRegex=function(t){return a(this,"_erasNameRegex")||si.call(this),t?this._erasNameRegex:this._erasRegex},mi.erasNarrowRegex=function(t){return a(this,"_erasNarrowRegex")||si.call(this),t?this._erasNarrowRegex:this._erasRegex},mi.months=function(t,e){return t?r(this._months)?this._months[t.month()]:this._months[(this._months.isFormat||St).test(e)?"format":"standalone"][t.month()]:r(this._months)?this._months:this._months.standalone},mi.monthsShort=function(t,e){return t?r(this._monthsShort)?this._monthsShort[t.month()]:this._monthsShort[St.test(e)?"format":"standalone"][t.month()]:r(this._monthsShort)?this._monthsShort:this._monthsShort.standalone},mi.monthsParse=function(t,e,i){var n,o,r;if(this._monthsParseExact)return Mt.call(this,t,e,i);for(this._monthsParse||(this._monthsParse=[],this._longMonthsParse=[],this._shortMonthsParse=[]),n=0;n<12;n++){if(o=p([2e3,n]),i&&!this._longMonthsParse[n]&&(this._longMonthsParse[n]=new RegExp("^"+this.months(o,"").replace(".","")+"$","i"),this._shortMonthsParse[n]=new RegExp("^"+this.monthsShort(o,"").replace(".","")+"$","i")),i||this._monthsParse[n]||(r="^"+this.months(o,"")+"|^"+this.monthsShort(o,""),this._monthsParse[n]=new RegExp(r.replace(".",""),"i")),i&&"MMMM"===e&&this._longMonthsParse[n].test(t))return n;if(i&&"MMM"===e&&this._shortMonthsParse[n].test(t))return n;if(!i&&this._monthsParse[n].test(t))return n}},mi.monthsRegex=function(t){return this._monthsParseExact?(a(this,"_monthsRegex")||Pt.call(this),t?this._monthsStrictRegex:this._monthsRegex):(a(this,"_monthsRegex")||(this._monthsRegex=Dt),this._monthsStrictRegex&&t?this._monthsStrictRegex:this._monthsRegex)},mi.monthsShortRegex=function(t){return this._monthsParseExact?(a(this,"_monthsRegex")||Pt.call(this),t?this._monthsShortStrictRegex:this._monthsShortRegex):(a(this,"_monthsShortRegex")||(this._monthsShortRegex=Et),this._monthsShortStrictRegex&&t?this._monthsShortStrictRegex:this._monthsShortRegex)},mi.week=function(t){return Bt(t,this._week.dow,this._week.doy).week},mi.firstDayOfYear=function(){return this._week.doy},mi.firstDayOfWeek=function(){return this._week.dow},mi.weekdays=function(t,e){var i=r(this._weekdays)?this._weekdays:this._weekdays[t&&!0!==t&&this._weekdays.isFormat.test(e)?"format":"standalone"];return!0===t?Lt(i,this._week.dow):t?i[t.day()]:i},mi.weekdaysMin=function(t){return!0===t?Lt(this._weekdaysMin,this._week.dow):t?this._weekdaysMin[t.day()]:this._weekdaysMin},mi.weekdaysShort=function(t){return!0===t?Lt(this._weekdaysShort,this._week.dow):t?this._weekdaysShort[t.day()]:this._weekdaysShort},mi.weekdaysParse=function(t,e,i){var n,o,r;if(this._weekdaysParseExact)return qt.call(this,t,e,i);for(this._weekdaysParse||(this._weekdaysParse=[],this._minWeekdaysParse=[],this._shortWeekdaysParse=[],this._fullWeekdaysParse=[]),n=0;n<7;n++){if(o=p([2e3,1]).day(n),i&&!this._fullWeekdaysParse[n]&&(this._fullWeekdaysParse[n]=new RegExp("^"+this.weekdays(o,"").replace(".","\\.?")+"$","i"),this._shortWeekdaysParse[n]=new RegExp("^"+this.weekdaysShort(o,"").replace(".","\\.?")+"$","i"),this._minWeekdaysParse[n]=new RegExp("^"+this.weekdaysMin(o,"").replace(".","\\.?")+"$","i")),this._weekdaysParse[n]||(r="^"+this.weekdays(o,"")+"|^"+this.weekdaysShort(o,"")+"|^"+this.weekdaysMin(o,""),this._weekdaysParse[n]=new RegExp(r.replace(".",""),"i")),i&&"dddd"===e&&this._fullWeekdaysParse[n].test(t))return n;if(i&&"ddd"===e&&this._shortWeekdaysParse[n].test(t))return n;if(i&&"dd"===e&&this._minWeekdaysParse[n].test(t))return n;if(!i&&this._weekdaysParse[n].test(t))return n}},mi.weekdaysRegex=function(t){return this._weekdaysParseExact?(a(this,"_weekdaysRegex")||Xt.call(this),t?this._weekdaysStrictRegex:this._weekdaysRegex):(a(this,"_weekdaysRegex")||(this._weekdaysRegex=Vt),this._weekdaysStrictRegex&&t?this._weekdaysStrictRegex:this._weekdaysRegex)},mi.weekdaysShortRegex=function(t){return this._weekdaysParseExact?(a(this,"_weekdaysRegex")||Xt.call(this),t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex):(a(this,"_weekdaysShortRegex")||(this._weekdaysShortRegex=Ut),this._weekdaysShortStrictRegex&&t?this._weekdaysShortStrictRegex:this._weekdaysShortRegex)},mi.weekdaysMinRegex=function(t){return this._weekdaysParseExact?(a(this,"_weekdaysRegex")||Xt.call(this),t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex):(a(this,"_weekdaysMinRegex")||(this._weekdaysMinRegex=Gt),this._weekdaysMinStrictRegex&&t?this._weekdaysMinStrictRegex:this._weekdaysMinRegex)},mi.isPM=function(t){return"p"===(t+"").toLowerCase().charAt(0)},mi.meridiem=function(t,e,i){return t>11?i?"pm":"PM":i?"am":"AM"},se("en",{eras:[{since:"0001-01-01",until:1/0,offset:1,name:"Anno Domini",narrow:"AD",abbr:"AD"},{since:"0000-12-31",until:-1/0,offset:1,name:"Before Christ",narrow:"BC",abbr:"BC"}],dayOfMonthOrdinalParse:/\d{1,2}(th|st|nd|rd)/,ordinal:function(t){var e=t%10;return t+(1===q(t%100/10)?"th":1===e?"st":2===e?"nd":3===e?"rd":"th")}}),o.lang=O("moment.lang is deprecated. Use moment.locale instead.",se),o.langData=O("moment.langData is deprecated. Use moment.localeData instead.",he);var ki=Math.abs;function xi(t,e,i,n){var o=We(e,i);return t._milliseconds+=n*o._milliseconds,t._days+=n*o._days,t._months+=n*o._months,t._bubble()}function Oi(t){return t<0?Math.floor(t):Math.ceil(t)}function Si(t){return 4800*t/146097}function Ei(t){return 146097*t/4800}function Di(t){return function(){return this.as(t)}}var Mi=Di("ms"),Ci=Di("s"),Ti=Di("m"),Pi=Di("h"),Ni=Di("d"),Ii=Di("w"),Ai=Di("M"),Fi=Di("Q"),ji=Di("y");function zi(t){return function(){return this.isValid()?this._data[t]:NaN}}var Bi=zi("milliseconds"),Ri=zi("seconds"),Li=zi("minutes"),Hi=zi("hours"),Wi=zi("days"),Yi=zi("months"),Vi=zi("years"),Ui=Math.round,Gi={ss:44,s:45,m:45,h:22,d:26,w:null,M:11};function qi(t,e,i,n,o){return o.relativeTime(e||1,!!i,t,n)}function Xi(t,e,i,n){var o=We(t).abs(),r=Ui(o.as("s")),s=Ui(o.as("m")),a=Ui(o.as("h")),h=Ui(o.as("d")),l=Ui(o.as("M")),d=Ui(o.as("w")),u=Ui(o.as("y")),c=r<=i.ss&&["s",r]||r<i.s&&["ss",r]||s<=1&&["m"]||s<i.m&&["mm",s]||a<=1&&["h"]||a<i.h&&["hh",a]||h<=1&&["d"]||h<i.d&&["dd",h];return null!=i.w&&(c=c||d<=1&&["w"]||d<i.w&&["ww",d]),(c=c||l<=1&&["M"]||l<i.M&&["MM",l]||u<=1&&["y"]||["yy",u])[2]=e,c[3]=+t>0,c[4]=n,qi.apply(null,c)}var $i=Math.abs;function Ki(t){return(t>0)-(t<0)||+t}function Zi(){if(!this.isValid())return this.localeData().invalidDate();var t,e,i,n,o,r,s,a,h=$i(this._milliseconds)/1e3,l=$i(this._days),d=$i(this._months),u=this.asSeconds();return u?(t=G(h/60),e=G(t/60),h%=60,t%=60,i=G(d/12),d%=12,n=h?h.toFixed(3).replace(/\.?0+$/,""):"",o=u<0?"-":"",r=Ki(this._months)!==Ki(u)?"-":"",s=Ki(this._days)!==Ki(u)?"-":"",a=Ki(this._milliseconds)!==Ki(u)?"-":"",o+"P"+(i?r+i+"Y":"")+(d?r+d+"M":"")+(l?s+l+"D":"")+(e||t||h?"T":"")+(e?a+e+"H":"")+(t?a+t+"M":"")+(h?a+n+"S":"")):"P0D"}var Qi=Pe.prototype;return Qi.isValid=function(){return this._isValid},Qi.abs=function(){var t=this._data;return this._milliseconds=ki(this._milliseconds),this._days=ki(this._days),this._months=ki(this._months),t.milliseconds=ki(t.milliseconds),t.seconds=ki(t.seconds),t.minutes=ki(t.minutes),t.hours=ki(t.hours),t.months=ki(t.months),t.years=ki(t.years),this},Qi.add=function(t,e){return xi(this,t,e,1)},Qi.subtract=function(t,e){return xi(this,t,e,-1)},Qi.as=function(t){if(!this.isValid())return NaN;var e,i,n=this._milliseconds;if("month"===(t=H(t))||"quarter"===t||"year"===t)switch(e=this._days+n/864e5,i=this._months+Si(e),t){case"month":return i;case"quarter":return i/3;case"year":return i/12}else switch(e=this._days+Math.round(Ei(this._months)),t){case"week":return e/7+n/6048e5;case"day":return e+n/864e5;case"hour":return 24*e+n/36e5;case"minute":return 1440*e+n/6e4;case"second":return 86400*e+n/1e3;case"millisecond":return Math.floor(864e5*e)+n;default:throw new Error("Unknown unit "+t)}},Qi.asMilliseconds=Mi,Qi.asSeconds=Ci,Qi.asMinutes=Ti,Qi.asHours=Pi,Qi.asDays=Ni,Qi.asWeeks=Ii,Qi.asMonths=Ai,Qi.asQuarters=Fi,Qi.asYears=ji,Qi.valueOf=function(){return this.isValid()?this._milliseconds+864e5*this._days+this._months%12*2592e6+31536e6*q(this._months/12):NaN},Qi._bubble=function(){var t,e,i,n,o,r=this._milliseconds,s=this._days,a=this._months,h=this._data;return r>=0&&s>=0&&a>=0||r<=0&&s<=0&&a<=0||(r+=864e5*Oi(Ei(a)+s),s=0,a=0),h.milliseconds=r%1e3,t=G(r/1e3),h.seconds=t%60,e=G(t/60),h.minutes=e%60,i=G(e/60),h.hours=i%24,s+=G(i/24),o=G(Si(s)),a+=o,s-=Oi(Ei(o)),n=G(a/12),a%=12,h.days=s,h.months=a,h.years=n,this},Qi.clone=function(){return We(this)},Qi.get=function(t){return t=H(t),this.isValid()?this[t+"s"]():NaN},Qi.milliseconds=Bi,Qi.seconds=Ri,Qi.minutes=Li,Qi.hours=Hi,Qi.days=Wi,Qi.weeks=function(){return G(this.days()/7)},Qi.months=Yi,Qi.years=Vi,Qi.humanize=function(t,e){if(!this.isValid())return this.localeData().invalidDate();var i,n,o=!1,r=Gi;return"object"==typeof t&&(e=t,t=!1),"boolean"==typeof t&&(o=t),"object"==typeof e&&(r=Object.assign({},Gi,e),null!=e.s&&null==e.ss&&(r.ss=e.s-1)),i=this.localeData(),n=Xi(this,!o,r,i),o&&(n=i.pastFuture(+this,n)),i.postformat(n)},Qi.toISOString=Zi,Qi.toString=Zi,Qi.toJSON=Zi,Qi.locale=Je,Qi.localeData=ei,Qi.toIsoString=O("toIsoString() is deprecated. Please use toISOString() instead (notice the capitals)",Zi),Qi.lang=ti,j("X",0,0,"unix"),j("x",0,0,"valueOf"),pt("x",dt),pt("X",/[+-]?\d+(\.\d{1,3})?/),bt("X",(function(t,e,i){i._d=new Date(1e3*parseFloat(t))})),bt("x",(function(t,e,i){i._d=new Date(q(t))})),o.version="2.25.3",e=Ee,o.fn=gi,o.min=function(){var t=[].slice.call(arguments,0);return Ce("isBefore",t)},o.max=function(){var t=[].slice.call(arguments,0);return Ce("isAfter",t)},o.now=function(){return Date.now?Date.now():+new Date},o.utc=p,o.unix=function(t){return Ee(1e3*t)},o.months=function(t,e){return wi(t,e,"months")},o.isDate=u,o.locale=se,o.invalid=y,o.duration=We,o.isMoment=k,o.weekdays=function(t,e,i){return _i(t,e,i,"weekdays")},o.parseZone=function(){return Ee.apply(null,arguments).parseZone()},o.localeData=he,o.isDuration=Ne,o.monthsShort=function(t,e){return wi(t,e,"monthsShort")},o.weekdaysMin=function(t,e,i){return _i(t,e,i,"weekdaysMin")},o.defineLocale=ae,o.updateLocale=function(t,e){if(null!=e){var i,n,o=te;null!=ee[t]&&null!=ee[t].parentLocale?ee[t].set(C(ee[t]._config,e)):(null!=(n=re(t))&&(o=n._config),e=C(o,e),null==n&&(e.abbr=t),(i=new T(e)).parentLocale=ee[t],ee[t]=i),se(t)}else null!=ee[t]&&(null!=ee[t].parentLocale?(ee[t]=ee[t].parentLocale,t===se()&&se(t)):null!=ee[t]&&delete ee[t]);return ee[t]},o.locales=function(){return S(ee)},o.weekdaysShort=function(t,e,i){return _i(t,e,i,"weekdaysShort")},o.normalizeUnits=H,o.relativeTimeRounding=function(t){return void 0===t?Ui:"function"==typeof t&&(Ui=t,!0)},o.relativeTimeThreshold=function(t,e){return void 0!==Gi[t]&&(void 0===e?Gi[t]:(Gi[t]=e,"s"===t&&(Gi.ss=e-1),!0))},o.calendarFormat=function(t,e){var i=t.diff(e,"days",!0);return i<-6?"sameElse":i<-1?"lastWeek":i<0?"lastDay":i<1?"sameDay":i<2?"nextDay":i<7?"nextWeek":"sameElse"},o.prototype=gi,o.HTML5_FMT={DATETIME_LOCAL:"YYYY-MM-DDTHH:mm",DATETIME_LOCAL_SECONDS:"YYYY-MM-DDTHH:mm:ss",DATETIME_LOCAL_MS:"YYYY-MM-DDTHH:mm:ss.SSS",DATE:"YYYY-MM-DD",TIME:"HH:mm",TIME_SECONDS:"HH:mm:ss",TIME_MS:"HH:mm:ss.SSS",WEEK:"GGGG-[W]WW",MONTH:"YYYY-MM"},o}()}));function Hd(t,e){var i=Tn(t);if(kn){var n=kn(t);e&&(n=_o(n).call(n,(function(e){return _n(t,e).enumerable}))),i.push.apply(i,n)}return i}function Wd(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}function Yd(t){if(void 0===tn||null==$e(t)){if(or(t)||(t=function(t,e){var i;if(!t)return;if("string"==typeof t)return Vd(t,e);var n=Go(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return cn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Vd(t,e)}(t))){var e=0,i=function(){};return{s:i,n:function(){return e>=t.length?{done:!0}:{done:!1,value:t[e++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var n,o,r=!0,s=!1;return{s:function(){n=Xe(t)},n:function(){var t=n.next();return r=t.done,t},e:function(t){s=!0,o=t},f:function(){try{r||null==n.return||n.return()}finally{if(s)throw o}}}}function Vd(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var Ud=function(){function t(e,i,n){var o,r,s;Kh(this,t),this._source=e,this._transformers=i,this._target=n,this._listeners={add:J(o=this._add).call(o,this),remove:J(r=this._remove).call(r,this),update:J(s=this._update).call(s,this)}}return Qh(t,[{key:"all",value:function(){return this._target.update(this._transformItems(this._source.get())),this}},{key:"start",value:function(){return this._source.on("add",this._listeners.add),this._source.on("remove",this._listeners.remove),this._source.on("update",this._listeners.update),this}},{key:"stop",value:function(){return this._source.off("add",this._listeners.add),this._source.off("remove",this._listeners.remove),this._source.off("update",this._listeners.update),this}},{key:"_transformItems",value:function(t){var e;return Id(e=this._transformers).call(e,(function(t,e){return e(t)}),t)}},{key:"_add",value:function(t,e){null!=e&&this._target.add(this._transformItems(this._source.get(e.items)))}},{key:"_update",value:function(t,e){null!=e&&this._target.update(this._transformItems(this._source.get(e.items)))}},{key:"_remove",value:function(t,e){null!=e&&this._target.remove(this._transformItems(e.oldData))}}]),t}(),Gd=function(){function t(e){Kh(this,t),this._source=e,this._transformers=[]}return Qh(t,[{key:"filter",value:function(t){return this._transformers.push((function(e){return _o(e).call(e,t)})),this}},{key:"map",value:function(t){return this._transformers.push((function(e){return ro(e).call(e,t)})),this}},{key:"flatMap",value:function(t){return this._transformers.push((function(e){return Ed(e).call(e,t)})),this}},{key:"to",value:function(t){return new Ud(this._source,this._transformers,t)}}]),t}(),qd=/^\/?Date\((-?\d+)/i;function Xd(t){return Ld.isMoment(t)}function $d(t,e){var i;if(void 0!==t){if(null===t)return null;if(!e)return t;if("string"!=typeof e&&!(e instanceof String))throw new Error("Type must be a string");switch(e){case"boolean":case"Boolean":return Boolean(t);case"number":case"Number":return Pr(t)&&!isNaN(Date.parse(t))?Ld(t).valueOf():Number(t.valueOf());case"string":case"String":return String(t);case"Date":if(Cr(t))return new Date(t);if(t instanceof Date)return new Date(t.valueOf());if(Xd(t))return new Date(t.valueOf());if(Pr(t))return(i=qd.exec(t))?new Date(Number(i[1])):Ld(new Date(t)).toDate();throw new Error("Cannot convert object of type "+Rr(t)+" to type Date");case"Moment":if(Cr(t))return Ld(t);if(t instanceof Date)return Ld(t.valueOf());if(Xd(t))return Ld(t);if(Pr(t))return i=qd.exec(t),Ld(i?Number(i[1]):t);throw new Error("Cannot convert object of type "+Rr(t)+" to type Date");case"ISODate":if(Cr(t))return new Date(t);if(t instanceof Date)return t.toISOString();if(Xd(t))return t.toDate().toISOString();if(Pr(t))return(i=qd.exec(t))?new Date(Number(i[1])).toISOString():Ld(t).format();throw new Error("Cannot convert object of type "+Rr(t)+" to type ISODate");case"ASPDate":if(Cr(t))return"/Date("+t+")/";if(t instanceof Date||Xd(t))return"/Date("+t.valueOf()+")/";if(Pr(t))return"/Date("+((i=qd.exec(t))?new Date(Number(i[1])).valueOf():new Date(t).valueOf())+")/";throw new Error("Cannot convert object of type "+Rr(t)+" to type ASPDate");default:throw new Error("Unknown type ".concat(e))}}}function Kd(t){return"string"==typeof t||"number"==typeof t}var Zd=function(){function t(e){Kh(this,t),this._queue=[],this._timeout=null,this._extended=null,this.delay=null,this.max=1/0,this.setOptions(e)}return Qh(t,[{key:"setOptions",value:function(t){t&&void 0!==t.delay&&(this.delay=t.delay),t&&void 0!==t.max&&(this.max=t.max),this._flushIfNeeded()}},{key:"destroy",value:function(){if(this.flush(),this._extended){for(var t=this._extended.object,e=this._extended.methods,i=0;i<e.length;i++){var n=e[i];n.original?t[n.name]=n.original:delete t[n.name]}this._extended=null}}},{key:"replace",value:function(t,e){var i=this,n=t[e];if(!n)throw new Error("Method "+e+" undefined");t[e]=function(){for(var t=arguments.length,e=new Array(t),o=0;o<t;o++)e[o]=arguments[o];i.queue({args:e,fn:n,context:this})}}},{key:"queue",value:function(t){"function"==typeof t?this._queue.push({fn:t}):this._queue.push(t),this._flushIfNeeded()}},{key:"_flushIfNeeded",value:function(){var t=this;this._queue.length>this.max&&this.flush(),null!=this._timeout&&(clearTimeout(this._timeout),this._timeout=null),this.queue.length>0&&"number"==typeof this.delay&&(this._timeout=rl((function(){t.flush()}),this.delay))}},{key:"flush",value:function(){var t,e;Jn(t=bs(e=this._queue).call(e,0)).call(t,(function(t){t.fn.apply(t.context||t.fn,t.args||[])}))}}],[{key:"extend",value:function(e,i){var n=new t(i);if(void 0!==e.flush)throw new Error("Target object already has a property flush");e.flush=function(){n.flush()};var o=[{name:"flush",original:void 0}];if(i&&i.replace)for(var r=0;r<i.replace.length;r++){var s=i.replace[r];o.push({name:s,original:e[s]}),n.replace(e,s)}return n._extended={object:e,methods:o},n}}]),t}(),Qd=function(){function t(){Kh(this,t),this._subscribers={"*":[],add:[],remove:[],update:[]},this.subscribe=t.prototype.on,this.unsubscribe=t.prototype.off}return Qh(t,[{key:"_trigger",value:function(t,e,i){var n,o;if("*"===t)throw new Error("Cannot trigger event *");Jn(n=Oo(o=[]).call(o,Uo(this._subscribers[t]),Uo(this._subscribers["*"]))).call(n,(function(n){n(t,e,null!=i?i:null)}))}},{key:"on",value:function(t,e){"function"==typeof e&&this._subscribers[t].push(e)}},{key:"off",value:function(t,e){var i;this._subscribers[t]=_o(i=this._subscribers[t]).call(i,(function(t){return t!==e}))}}]),t}(),Jd=function(){function t(e){Kh(this,t),this._pairs=e}return Qh(t,[{key:_d,value:wd.mark((function t(){var e,i,n,o,r;return wd.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Yd(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=vr(i.value,2),o=n[0],r=n[1],t.next=7,[o,r];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"entries",value:wd.mark((function t(){var e,i,n,o,r;return wd.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Yd(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=vr(i.value,2),o=n[0],r=n[1],t.next=7,[o,r];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"keys",value:wd.mark((function t(){var e,i,n,o;return wd.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Yd(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=vr(i.value,1),o=n[0],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"values",value:wd.mark((function t(){var e,i,n,o;return wd.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:e=Yd(this._pairs),t.prev=1,e.s();case 3:if((i=e.n()).done){t.next=9;break}return n=vr(i.value,2),o=n[1],t.next=7,o;case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),e.e(t.t0);case 14:return t.prev=14,e.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,this,[[1,11,14,17]])}))},{key:"toIdArray",value:function(){var t;return ro(t=Uo(this._pairs)).call(t,(function(t){return t[0]}))}},{key:"toItemArray",value:function(){var t;return ro(t=Uo(this._pairs)).call(t,(function(t){return t[1]}))}},{key:"toEntryArray",value:function(){return Uo(this._pairs)}},{key:"toObjectMap",value:function(){var t,e=Sn(null),i=Yd(this._pairs);try{for(i.s();!(t=i.n()).done;){var n=vr(t.value,2),o=n[0],r=n[1];e[o]=r}}catch(t){i.e(t)}finally{i.f()}return e}},{key:"toMap",value:function(){return new bd(this._pairs)}},{key:"toIdSet",value:function(){return new md(this.toIdArray())}},{key:"toItemSet",value:function(){return new md(this.toItemArray())}},{key:"cache",value:function(){return new t(Uo(this._pairs))}},{key:"distinct",value:function(t){var e,i=new md,n=Yd(this._pairs);try{for(n.s();!(e=n.n()).done;){var o=vr(e.value,2),r=o[0],s=o[1];i.add(t(s,r))}}catch(t){n.e(t)}finally{n.f()}return i}},{key:"filter",value:function(e){var i=this._pairs;return new t(Dn({},_d,wd.mark((function t(){var n,o,r,s,a;return wd.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=Yd(i),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=10;break}if(r=vr(o.value,2),s=r[0],a=r[1],!e(a,s)){t.next=8;break}return t.next=8,[s,a];case 8:t.next=3;break;case 10:t.next=15;break;case 12:t.prev=12,t.t0=t.catch(1),n.e(t.t0);case 15:return t.prev=15,n.f(),t.finish(15);case 18:case"end":return t.stop()}}),t,null,[[1,12,15,18]])}))))}},{key:"forEach",value:function(t){var e,i=Yd(this._pairs);try{for(i.s();!(e=i.n()).done;){var n=vr(e.value,2),o=n[0];t(n[1],o)}}catch(t){i.e(t)}finally{i.f()}}},{key:"map",value:function(e){var i=this._pairs;return new t(Dn({},_d,wd.mark((function t(){var n,o,r,s,a;return wd.wrap((function(t){for(;;)switch(t.prev=t.next){case 0:n=Yd(i),t.prev=1,n.s();case 3:if((o=n.n()).done){t.next=9;break}return r=vr(o.value,2),s=r[0],a=r[1],t.next=7,[s,e(a,s)];case 7:t.next=3;break;case 9:t.next=14;break;case 11:t.prev=11,t.t0=t.catch(1),n.e(t.t0);case 14:return t.prev=14,n.f(),t.finish(14);case 17:case"end":return t.stop()}}),t,null,[[1,11,14,17]])}))))}},{key:"max",value:function(t){var e=Xe(this._pairs),i=e.next();if(i.done)return null;for(var n=i.value[1],o=t(i.value[1],i.value[0]);!(i=e.next()).done;){var r=vr(i.value,2),s=r[0],a=r[1],h=t(a,s);h>o&&(o=h,n=a)}return n}},{key:"min",value:function(t){var e=Xe(this._pairs),i=e.next();if(i.done)return null;for(var n=i.value[1],o=t(i.value[1],i.value[0]);!(i=e.next()).done;){var r=vr(i.value,2),s=r[0],a=r[1],h=t(a,s);h<o&&(o=h,n=a)}return n}},{key:"reduce",value:function(t,e){var i,n=Yd(this._pairs);try{for(n.s();!(i=n.n()).done;){var o=vr(i.value,2),r=o[0];e=t(e,o[1],r)}}catch(t){n.e(t)}finally{n.f()}return e}},{key:"sort",value:function(e){var i=this;return new t(Dn({},_d,(function(){var t;return Xe(ed(t=Uo(i._pairs)).call(t,(function(t,i){var n=vr(t,2),o=n[0],r=n[1],s=vr(i,2),a=s[0],h=s[1];return e(r,h,o,a)})))})))}}]),t}(),tu=function(){console.warn("Type coercion has been deprecated. Please, use data pipes instead. See https://visjs.github.io/vis-data/data/datapipe.html#TypeCoercion for more details with working migration example.")},eu=function(t){Vl(i,t);var e=Wd(i);function i(t,n){var o;if(Kh(this,i),o=e.call(this),t&&!or(t)&&(n=t,t=[]),o._options=n||{},o._data=new bd,o.length=0,o._idProp=o._options.fieldId||"id",o._type={},o._options.type){tu();for(var r=Tn(o._options.type),s=0,a=r.length;s<a;s++){var h=r[s],l=o._options.type[h];o._type[h]="Date"==l||"ISODate"==l||"ASPDate"==l?"Date":l}}return t&&t.length&&o.add(t),o.setOptions(n),o}return Qh(i,[{key:"setOptions",value:function(t){t&&void 0!==t.queue&&(!1===t.queue?this._queue&&(this._queue.destroy(),delete this._queue):(this._queue||(this._queue=Zd.extend(this,{replace:["add","update","remove"]})),t.queue&&"object"===ur(t.queue)&&this._queue.setOptions(t.queue)))}},{key:"add",value:function(t,e){var i,n=this,o=[];if(or(t)){var r=ro(t).call(t,(function(t){return t[n._idProp]}));if(ul(r).call(r,(function(t){return n._data.has(t)})))throw new Error("A duplicate id was found in the parameter array.");for(var s=0,a=t.length;s<a;s++)i=this._addItem(t[s]),o.push(i)}else{if(!t||"object"!==ur(t))throw new Error("Unknown dataType");i=this._addItem(t),o.push(i)}return o.length&&this._trigger("add",{items:o},e),o}},{key:"update",value:function(t,e){var i=this,n=[],o=[],r=[],s=[],a=this._idProp,h=function(t){var e=t[a];if(null!=e&&i._data.has(e)){var h=t,l=hr({},i._data.get(e)),d=i._updateItem(h);o.push(d),s.push(h),r.push(l)}else{var u=i._addItem(t);n.push(u)}};if(or(t))for(var l=0,d=t.length;l<d;l++)t[l]&&"object"===ur(t[l])?h(t[l]):console.warn("Ignoring input item, which is not an object at index "+l);else{if(!t||"object"!==ur(t))throw new Error("Unknown dataType");h(t)}if(n.length&&this._trigger("add",{items:n},e),o.length){var u={items:o,oldData:r,data:s};this._trigger("update",u,e)}return Oo(n).call(n,o)}},{key:"updateOnly",value:function(t,e){var i,n=this;or(t)||(t=[t]);var o=ro(i=ro(t).call(t,(function(t){var e=n._data.get(t[n._idProp]);if(null==e)throw new Error("Updating non-existent items is not allowed.");return{oldData:e,update:t}}))).call(i,(function(t){var e=t.oldData,i=t.update,o=e[n._idProp],r=Br(Br({},e),i);return n._data.set(o,r),{id:o,oldData:e,updatedData:r}}));if(o.length){var r={items:ro(o).call(o,(function(t){return t.id})),oldData:ro(o).call(o,(function(t){return t.oldData})),data:ro(o).call(o,(function(t){return t.updatedData}))};return this._trigger("update",r,e),r.items}return[]}},{key:"get",value:function(t,e){var i=void 0,n=void 0,o=void 0;Kd(t)?(i=t,o=e):or(t)?(n=t,o=e):o=t;var r=o&&"Object"===o.returnType?"Object":"Array",s=o&&o.type||this._options.type,a=o&&_o(o),h=[],l=null,d=null,u=null;if(null!=i)(l=this._getItem(i,s))&&a&&!a(l)&&(l=null);else if(null!=n)for(var c=0,f=n.length;c<f;c++)null==(l=this._getItem(n[c],s))||a&&!a(l)||h.push(l);else for(var p,v=0,g=(d=Uo(Ll(p=this._data).call(p))).length;v<g;v++)u=d[v],null==(l=this._getItem(u,s))||a&&!a(l)||h.push(l);if(o&&o.order&&null==i&&this._sort(h,o.order),o&&o.fields){var y=o.fields;if(null!=i&&null!=l)l=this._filterFields(l,y);else for(var m=0,b=h.length;m<b;m++)h[m]=this._filterFields(h[m],y)}if("Object"==r){for(var w={},_=0,k=h.length;_<k;_++){var x=h[_];w[x[this._idProp]]=x}return w}return null!=i?l:h}},{key:"getIds",value:function(t){var e,i,n=this._data,o=t&&_o(t),r=t&&t.order,s=t&&t.type||this._options.type,a=Uo(Ll(n).call(n)),h=[];if(o)if(r){i=[];for(var l=0,d=a.length;l<d;l++){var u=a[l];o(e=this._getItem(u,s))&&i.push(e)}this._sort(i,r);for(var c=0,f=i.length;c<f;c++)h.push(i[c][this._idProp])}else for(var p=0,v=a.length;p<v;p++){var g=a[p];o(e=this._getItem(g,s))&&h.push(e[this._idProp])}else if(r){i=[];for(var y=0,m=a.length;y<m;y++){var b=a[y];i.push(n.get(b))}this._sort(i,r);for(var w=0,_=i.length;w<_;w++)h.push(i[w][this._idProp])}else for(var k=0,x=a.length;k<x;k++){var O=a[k];e=n.get(O),h.push(e[this._idProp])}return h}},{key:"getDataSet",value:function(){return this}},{key:"forEach",value:function(t,e){var i=e&&_o(e),n=e&&e.type||this._options.type,o=this._data,r=Uo(Ll(o).call(o));if(e&&e.order)for(var s=this.get(e),a=0,h=s.length;a<h;a++){var l=s[a];t(l,l[this._idProp])}else for(var d=0,u=r.length;d<u;d++){var c=r[d],f=this._getItem(c,n);i&&!i(f)||t(f,c)}}},{key:"map",value:function(t,e){for(var i=e&&_o(e),n=e&&e.type||this._options.type,o=[],r=this._data,s=Uo(Ll(r).call(r)),a=0,h=s.length;a<h;a++){var l=s[a],d=this._getItem(l,n);i&&!i(d)||o.push(t(d,l))}return e&&e.order&&this._sort(o,e.order),o}},{key:"_filterFields",value:function(t,e){var i;return t?Id(i=or(e)?e:Tn(e)).call(i,(function(e,i){return e[i]=t[i],e}),{}):t}},{key:"_sort",value:function(t,e){if("string"==typeof e){var i=e;ed(t).call(t,(function(t,e){var n=t[i],o=e[i];return n>o?1:n<o?-1:0}))}else{if("function"!=typeof e)throw new TypeError("Order must be a function or a string");ed(t).call(t,e)}}},{key:"remove",value:function(t,e){for(var i=[],n=[],o=or(t)?t:[t],r=0,s=o.length;r<s;r++){var a=this._remove(o[r]);if(a){var h=a[this._idProp];null!=h&&(i.push(h),n.push(a))}}return i.length&&this._trigger("remove",{items:i,oldData:n},e),i}},{key:"_remove",value:function(t){var e;if(Kd(t)?e=t:t&&"object"===ur(t)&&(e=t[this._idProp]),null!=e&&this._data.has(e)){var i=this._data.get(e)||null;return this._data.delete(e),--this.length,i}return null}},{key:"clear",value:function(t){for(var e,i=Uo(Ll(e=this._data).call(e)),n=[],o=0,r=i.length;o<r;o++)n.push(this._data.get(i[o]));return this._data.clear(),this.length=0,this._trigger("remove",{items:i,oldData:n},t),i}},{key:"max",value:function(t){var e,i,n=null,o=null,r=Yd(jl(e=this._data).call(e));try{for(r.s();!(i=r.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==o||a>o)&&(n=s,o=a)}}catch(t){r.e(t)}finally{r.f()}return n||null}},{key:"min",value:function(t){var e,i,n=null,o=null,r=Yd(jl(e=this._data).call(e));try{for(r.s();!(i=r.n()).done;){var s=i.value,a=s[t];"number"==typeof a&&(null==o||a<o)&&(n=s,o=a)}}catch(t){r.e(t)}finally{r.f()}return n||null}},{key:"distinct",value:function(t){for(var e=this._data,i=Uo(Ll(e).call(e)),n=[],o=this._options.type&&this._options.type[t]||null,r=0,s=0,a=i.length;s<a;s++){for(var h=i[s],l=e.get(h)[t],d=!1,u=0;u<r;u++)if(n[u]==l){d=!0;break}d||void 0===l||(n[r]=l,r++)}if(o)for(var c=0,f=n.length;c<f;c++)n[c]=$d(n[c],o);return n}},{key:"_addItem",value:function(t){var e=t[this._idProp];if(null!=e){if(this._data.has(e))throw new Error("Cannot add item: item with id "+e+" already exists")}else e=Rd(),t[this._idProp]=e;for(var i={},n=Tn(t),o=0,r=n.length;o<r;o++){var s=n[o],a=this._type[s];i[s]=$d(t[s],a)}return this._data.set(e,i),++this.length,e}},{key:"_getItem",value:function(t,e){var i,n=this._data.get(t);if(!n)return null;var o=Tn(n);if(e){tu(),i={};for(var r=0,s=o.length;r<s;r++){var a=o[r],h=n[a];i[a]=$d(h,e[a])}}else i=function(t){for(var e=1;e<arguments.length;e++){var i,n=null!=arguments[e]?arguments[e]:{};if(e%2)Jn(i=Hd(Object(n),!0)).call(i,(function(e){Dn(t,e,n[e])}));else if(yn)vn(t,yn(n));else{var o;Jn(o=Hd(Object(n))).call(o,(function(e){pn(t,e,_n(n,e))}))}}return t}({},n);return null==i[this._idProp]&&(i[this._idProp]=n.id),i}},{key:"_updateItem",value:function(t){var e=t[this._idProp];if(null==e)throw new Error("Cannot update item: item has no id (item: "+Nl(t)+")");var i=this._data.get(e);if(!i)throw new Error("Cannot update item: no item with id "+e+" found");for(var n=Tn(t),o=0,r=n.length;o<r;o++){var s=n[o],a=this._type[s];i[s]=$d(t[s],a)}return e}},{key:"stream",value:function(t){if(t){var e=this._data;return new Jd(Dn({},_d,wd.mark((function i(){var n,o,r,s;return wd.wrap((function(i){for(;;)switch(i.prev=i.next){case 0:n=Yd(t),i.prev=1,n.s();case 3:if((o=n.n()).done){i.next=11;break}if(r=o.value,null==(s=e.get(r))){i.next=9;break}return i.next=9,[r,s];case 9:i.next=3;break;case 11:i.next=16;break;case 13:i.prev=13,i.t0=i.catch(1),n.e(i.t0);case 16:return i.prev=16,n.f(),i.finish(16);case 19:case"end":return i.stop()}}),i,null,[[1,13,16,19]])}))))}var i;return new Jd(Dn({},_d,J(i=Sl(this._data)).call(i,this._data)))}}]),i}(Qd),iu=function(t){Vl(i,t);var e=Wd(i);function i(t,n){var o,r;return Kh(this,i),(r=e.call(this)).length=0,r._ids=new md,r._options=n||{},r._listener=J(o=r._onEvent).call(o,gl(r)),r.setData(t),r}return Qh(i,[{key:"setData",value:function(t){if(this._data){this._data.off&&this._data.off("*",this._listener);var e=this._data.getIds({filter:_o(this._options)}),i=this._data.get(e);this._ids.clear(),this.length=0,this._trigger("remove",{items:e,oldData:i})}if(null!=t){this._data=t;for(var n=this._data.getIds({filter:_o(this._options)}),o=0,r=n.length;o<r;o++){var s=n[o];this._ids.add(s)}this.length=n.length,this._trigger("add",{items:n})}else this._data=new eu;this._data.on&&this._data.on("*",this._listener)}},{key:"refresh",value:function(){for(var t=this._data.getIds({filter:_o(this._options)}),e=Uo(this._ids),i={},n=[],o=[],r=[],s=0,a=t.length;s<a;s++){var h=t[s];i[h]=!0,this._ids.has(h)||(n.push(h),this._ids.add(h))}for(var l=0,d=e.length;l<d;l++){var u=e[l],c=this._data.get(u);null==c?console.error("If you see this, report it please."):i[u]||(o.push(u),r.push(c),this._ids.delete(u))}this.length+=n.length-o.length,n.length&&this._trigger("add",{items:n}),o.length&&this._trigger("remove",{items:o,oldData:r})}},{key:"get",value:function(t,e){if(null==this._data)return null;var i,n=null;Kd(t)||or(t)?(n=t,i=e):i=t;var o=hr({},this._options,i),r=_o(this._options),s=i&&_o(i);return r&&s&&(o.filter=function(t){return r(t)&&s(t)}),null==n?this._data.get(o):this._data.get(n,o)}},{key:"getIds",value:function(t){if(this._data.length){var e,i=_o(this._options),n=null!=t?_o(t):null;return e=n?i?function(t){return i(t)&&n(t)}:n:i,this._data.getIds({filter:e,order:t&&t.order})}return[]}},{key:"forEach",value:function(t,e){if(this._data){var i,n,o=_o(this._options),r=e&&_o(e);n=r?o?function(t){return o(t)&&r(t)}:r:o,Jn(i=this._data).call(i,t,{filter:n,order:e&&e.order})}}},{key:"map",value:function(t,e){if(this._data){var i,n,o=_o(this._options),r=e&&_o(e);return n=r?o?function(t){return o(t)&&r(t)}:r:o,ro(i=this._data).call(i,t,{filter:n,order:e&&e.order})}return[]}},{key:"getDataSet",value:function(){return this._data.getDataSet()}},{key:"stream",value:function(t){var e;return this._data.stream(t||Dn({},_d,J(e=Ll(this._ids)).call(e,this._ids)))}},{key:"dispose",value:function(){var t;(null===(t=this._data)||void 0===t?void 0:t.off)&&this._data.off("*",this._listener);var e="This data view has already been disposed of.";pn(this,"_data",{get:function(){throw new Error(e)},set:function(){throw new Error(e)},configurable:!1})}},{key:"_onEvent",value:function(t,e,i){if(e&&e.items&&this._data){var n=e.items,o=[],r=[],s=[],a=[],h=[],l=[];switch(t){case"add":for(var d=0,u=n.length;d<u;d++){var c=n[d];this.get(c)&&(this._ids.add(c),o.push(c))}break;case"update":for(var f=0,p=n.length;f<p;f++){var v=n[f];this.get(v)?this._ids.has(v)?(r.push(v),h.push(e.data[f]),a.push(e.oldData[f])):(this._ids.add(v),o.push(v)):this._ids.has(v)&&(this._ids.delete(v),s.push(v),l.push(e.oldData[f]))}break;case"remove":for(var g=0,y=n.length;g<y;g++){var m=n[g];this._ids.has(m)&&(this._ids.delete(m),s.push(m),l.push(e.oldData[g]))}}this.length+=o.length-s.length,o.length&&this._trigger("add",{items:o},i),r.length&&this._trigger("update",{items:r,oldData:a,data:h},i),s.length&&this._trigger("remove",{items:s,oldData:l},i)}}}]),i}(Qd),nu=Object.freeze({__proto__:null,DataSet:eu,DataStream:Jd,DataView:iu,Queue:Zd,createNewDataPipeFrom:function(t){return new Gd(t)}}),ou=gi.f,ru=a((function(){return!Object.getOwnPropertyNames(1)}));U({target:"Object",stat:!0,forced:ru},{getOwnPropertyNames:ou});var su=j.Object,au=function(t){return su.getOwnPropertyNames(t)},hu=jn.trim,lu=s.parseFloat,du=1/lu(Pn+"-0")!=-1/0?function(t){var e=hu(String(t)),i=lu(e);return 0===i&&"-"==e.charAt(0)?-0:i}:lu;U({global:!0,forced:parseFloat!=du},{parseFloat:du});var uu=j.parseFloat,cu=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"choosify",value:function(t,e){var i=["node","edge","label"],n=!0,o=us(e,"chosen");if("boolean"==typeof o)n=o;else if("object"===ur(o)){if(-1===nr(i).call(i,t))throw new Error("choosify: subOption '"+t+"' should be one of '"+i.join("', '")+"'");var r=us(e,["chosen",t]);"boolean"!=typeof r&&"function"!=typeof r||(n=r)}return n}},{key:"pointInRect",value:function(t,e,i){if(t.width<=0||t.height<=0)return!1;if(void 0!==i){var n={x:e.x-i.x,y:e.y-i.y};if(0!==i.angle){var o=-i.angle;e={x:Math.cos(o)*n.x-Math.sin(o)*n.y,y:Math.sin(o)*n.x+Math.cos(o)*n.y}}else e=n}var r=t.x+t.width,s=t.y+t.width;return t.left<e.x&&r>e.x&&t.top<e.y&&s>e.y}},{key:"isValidLabel",value:function(t){return"string"==typeof t&&""!==t}},{key:"getSelfRefCoordinates",value:function(t,e,i,n){var o=n.x,r=n.y;if("function"==typeof n.distanceToBorder){var s=n.distanceToBorder(t,e),a=Math.sin(e)*s,h=Math.cos(e)*s;h===s?(o+=s,r=n.y):a===s?(o=n.x,r-=s):(o+=h,r-=a)}else n.shape.width>n.shape.height?(o=n.x+.5*n.shape.width,r=n.y-i):(o=n.x+i,r=n.y-.5*n.shape.height);return{x:o,y:r}}}]),t}(),fu=function(){function t(e){Kh(this,t),this.measureText=e,this.current=0,this.width=0,this.height=0,this.lines=[]}return Qh(t,[{key:"_add",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"normal";void 0===this.lines[t]&&(this.lines[t]={width:0,height:0,blocks:[]});var n=e;void 0!==e&&""!==e||(n=" ");var o=this.measureText(n,i),r=hr({},jl(o));r.text=e,r.width=o.width,r.mod=i,void 0!==e&&""!==e||(r.width=0),this.lines[t].blocks.push(r),this.lines[t].width+=r.width}},{key:"curWidth",value:function(){var t=this.lines[this.current];return void 0===t?0:t.width}},{key:"append",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,t,e)}},{key:"newLine",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal";this._add(this.current,t,e),this.current++}},{key:"determineLineHeights",value:function(){for(var t=0;t<this.lines.length;t++){var e=this.lines[t],i=0;if(void 0!==e.blocks)for(var n=0;n<e.blocks.length;n++){var o=e.blocks[n];i<o.height&&(i=o.height)}e.height=i}}},{key:"determineLabelSize",value:function(){for(var t=0,e=0,i=0;i<this.lines.length;i++){var n=this.lines[i];n.width>t&&(t=n.width),e+=n.height}this.width=t,this.height=e}},{key:"removeEmptyBlocks",value:function(){for(var t=[],e=0;e<this.lines.length;e++){var i=this.lines[e];if(0!==i.blocks.length&&(e!==this.lines.length-1||0!==i.width)){var n={};hr(n,i),n.blocks=[];for(var o=void 0,r=[],s=0;s<i.blocks.length;s++){var a=i.blocks[s];0!==a.width?r.push(a):void 0===o&&(o=a)}0===r.length&&void 0!==o&&r.push(o),n.blocks=r,t.push(n)}}return t}},{key:"finalize",value:function(){this.determineLineHeights(),this.determineLabelSize();var t=this.removeEmptyBlocks();return{width:this.width,height:this.height,lines:t}}}]),t}(),pu={"<b>":/<b>/,"<i>":/<i>/,"<code>":/<code>/,"</b>":/<\/b>/,"</i>":/<\/i>/,"</code>":/<\/code>/,"*":/\*/,_:/\_/,"`":/`/,afterBold:/[^\*]/,afterItal:/[^_]/,afterMono:/[^`]/},vu=function(){function t(e){Kh(this,t),this.text=e,this.bold=!1,this.ital=!1,this.mono=!1,this.spacing=!1,this.position=0,this.buffer="",this.modStack=[],this.blocks=[]}return Qh(t,[{key:"mod",value:function(){return 0===this.modStack.length?"normal":this.modStack[0]}},{key:"modName",value:function(){return 0===this.modStack.length?"normal":"mono"===this.modStack[0]?"mono":this.bold&&this.ital?"boldital":this.bold?"bold":this.ital?"ital":void 0}},{key:"emitBlock",value:function(){this.spacing&&(this.add(" "),this.spacing=!1),this.buffer.length>0&&(this.blocks.push({text:this.buffer,mod:this.modName()}),this.buffer="")}},{key:"add",value:function(t){" "===t&&(this.spacing=!0),this.spacing&&(this.buffer+=" ",this.spacing=!1)," "!=t&&(this.buffer+=t)}},{key:"parseWS",value:function(t){return!!/[ \t]/.test(t)&&(this.mono?this.add(t):this.spacing=!0,!0)}},{key:"setTag",value:function(t){this.emitBlock(),this[t]=!0,this.modStack.unshift(t)}},{key:"unsetTag",value:function(t){this.emitBlock(),this[t]=!1,this.modStack.shift()}},{key:"parseStartTag",value:function(t,e){return!(this.mono||this[t]||!this.match(e))&&(this.setTag(t),!0)}},{key:"match",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.prepareRegExp(t),n=vr(i,2),o=n[0],r=n[1],s=o.test(this.text.substr(this.position,r));return s&&e&&(this.position+=r-1),s}},{key:"parseEndTag",value:function(t,e,i){var n=this.mod()===t;return!(!(n="mono"===t?n&&this.mono:n&&!this.mono)||!this.match(e))&&(void 0!==i?(this.position===this.text.length-1||this.match(i,!1))&&this.unsetTag(t):this.unsetTag(t),!0)}},{key:"replace",value:function(t,e){return!!this.match(t)&&(this.add(e),this.position+=length-1,!0)}},{key:"prepareRegExp",value:function(t){var e,i;if(t instanceof RegExp)i=t,e=1;else{var n=pu[t];i=void 0!==n?n:new RegExp(t),e=t.length}return[i,e]}}]),t}(),gu=function(){function t(e,i,n,o){var r=this;Kh(this,t),this.ctx=e,this.parent=i,this.selected=n,this.hover=o;this.lines=new fu((function(t,i){if(void 0===t)return 0;var s=r.parent.getFormattingValues(e,n,o,i),a=0;""!==t&&(a=r.ctx.measureText(t).width);return{width:a,values:s}}))}return Qh(t,[{key:"process",value:function(t){if(!cu.isValidLabel(t))return this.lines.finalize();var e=this.parent.fontOptions;t=(t=t.replace(/\r\n/g,"\n")).replace(/\r/g,"\n");var i=String(t).split("\n"),n=i.length;if(e.multi)for(var o=0;o<n;o++){var r=this.splitBlocks(i[o],e.multi);if(void 0!==r)if(0!==r.length){if(e.maxWdt>0)for(var s=0;s<r.length;s++){var a=r[s].mod,h=r[s].text;this.splitStringIntoLines(h,a,!0)}else for(var l=0;l<r.length;l++){var d=r[l].mod,u=r[l].text;this.lines.append(u,d)}this.lines.newLine()}else this.lines.newLine("")}else if(e.maxWdt>0)for(var c=0;c<n;c++)this.splitStringIntoLines(i[c]);else for(var f=0;f<n;f++)this.lines.newLine(i[f]);return this.lines.finalize()}},{key:"decodeMarkupSystem",value:function(t){var e="none";return"markdown"===t||"md"===t?e="markdown":!0!==t&&"html"!==t||(e="html"),e}},{key:"splitHtmlBlocks",value:function(t){for(var e=new vu(t),i=function(t){return!!/&/.test(t)&&(e.replace(e.text,"&lt;","<")||e.replace(e.text,"&amp;","&")||e.add("&"),!0)};e.position<e.text.length;){var n=e.text.charAt(e.position);e.parseWS(n)||/</.test(n)&&(e.parseStartTag("bold","<b>")||e.parseStartTag("ital","<i>")||e.parseStartTag("mono","<code>")||e.parseEndTag("bold","</b>")||e.parseEndTag("ital","</i>")||e.parseEndTag("mono","</code>"))||i(n)||e.add(n),e.position++}return e.emitBlock(),e.blocks}},{key:"splitMarkdownBlocks",value:function(t){for(var e=this,i=new vu(t),n=!0,o=function(t){return!!/\\/.test(t)&&(i.position<e.text.length+1&&(i.position++,t=e.text.charAt(i.position),/ \t/.test(t)?i.spacing=!0:(i.add(t),n=!1)),!0)};i.position<i.text.length;){var r=i.text.charAt(i.position);i.parseWS(r)||o(r)||(n||i.spacing)&&(i.parseStartTag("bold","*")||i.parseStartTag("ital","_")||i.parseStartTag("mono","`"))||i.parseEndTag("bold","*","afterBold")||i.parseEndTag("ital","_","afterItal")||i.parseEndTag("mono","`","afterMono")||(i.add(r),n=!1),i.position++}return i.emitBlock(),i.blocks}},{key:"splitBlocks",value:function(t,e){var i=this.decodeMarkupSystem(e);return"none"===i?[{text:t,mod:"normal"}]:"markdown"===i?this.splitMarkdownBlocks(t):"html"===i?this.splitHtmlBlocks(t):void 0}},{key:"overMaxWidth",value:function(t){var e=this.ctx.measureText(t).width;return this.lines.curWidth()+e>this.parent.fontOptions.maxWdt}},{key:"getLongestFit",value:function(t){for(var e="",i=0;i<t.length;){var n=e+(""===e?"":" ")+t[i];if(this.overMaxWidth(n))break;e=n,i++}return i}},{key:"getLongestFitWord",value:function(t){for(var e=0;e<t.length&&!this.overMaxWidth(Go(t).call(t,0,e));)e++;return e}},{key:"splitStringIntoLines",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:"normal",i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];this.parent.getFormattingValues(this.ctx,this.selected,this.hover,e);for(var n=(t=(t=t.replace(/^( +)/g,"$1\r")).replace(/([^\r][^ ]*)( +)/g,"$1\r$2\r")).split("\r");n.length>0;){var o=this.getLongestFit(n);if(0===o){var r=n[0],s=this.getLongestFitWord(r);this.lines.newLine(Go(r).call(r,0,s),e),n[0]=Go(r).call(r,s)}else{var a=o;" "===n[o-1]?o--:" "===n[a]&&a++;var h=Go(n).call(n,0,o).join("");o==n.length&&i?this.lines.append(h,e):this.lines.newLine(h,e),n=Go(n).call(n,a)}}}}]),t}(),yu=["bold","ital","boldital","mono"],mu=function(){function t(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2];Kh(this,t),this.body=e,this.pointToSelf=!1,this.baseSize=void 0,this.fontOptions={},this.setOptions(i),this.size={top:0,left:0,width:0,height:0,yLine:0},this.isEdgeLabel=n}return Qh(t,[{key:"setOptions",value:function(t){if(this.elementOptions=t,this.initFontOptions(t.font),cu.isValidLabel(t.label)?this.labelDirty=!0:t.label=void 0,void 0!==t.font&&null!==t.font)if("string"==typeof t.font)this.baseSize=this.fontOptions.size;else if("object"===ur(t.font)){var e=t.font.size;void 0!==e&&(this.baseSize=e)}}},{key:"initFontOptions",value:function(e){var i=this;Vr(yu,(function(t){i.fontOptions[t]={}})),t.parseFontString(this.fontOptions,e)?this.fontOptions.vadjust=0:Vr(e,(function(t,e){null!=t&&"object"!==ur(t)&&(i.fontOptions[e]=t)}))}},{key:"constrain",value:function(t){var e={constrainWidth:!1,maxWdt:-1,minWdt:-1,constrainHeight:!1,minHgt:-1,valign:"middle"},i=us(t,"widthConstraint");if("number"==typeof i)e.maxWdt=Number(i),e.minWdt=Number(i);else if("object"===ur(i)){var n=us(t,["widthConstraint","maximum"]);"number"==typeof n&&(e.maxWdt=Number(n));var o=us(t,["widthConstraint","minimum"]);"number"==typeof o&&(e.minWdt=Number(o))}var r=us(t,"heightConstraint");if("number"==typeof r)e.minHgt=Number(r);else if("object"===ur(r)){var s=us(t,["heightConstraint","minimum"]);"number"==typeof s&&(e.minHgt=Number(s));var a=us(t,["heightConstraint","valign"]);"string"==typeof a&&("top"!==a&&"bottom"!==a||(e.valign=a))}return e}},{key:"update",value:function(t,e){this.setOptions(t,!0),this.propagateFonts(e),Br(this.fontOptions,this.constrain(e)),this.fontOptions.chooser=cu.choosify("label",e)}},{key:"adjustSizes",value:function(t){var e=t?t.right+t.left:0;this.fontOptions.constrainWidth&&(this.fontOptions.maxWdt-=e,this.fontOptions.minWdt-=e);var i=t?t.top+t.bottom:0;this.fontOptions.constrainHeight&&(this.fontOptions.minHgt-=i)}},{key:"addFontOptionsToPile",value:function(t,e){for(var i=0;i<e.length;++i)this.addFontToPile(t,e[i])}},{key:"addFontToPile",value:function(t,e){if(void 0!==e&&void 0!==e.font&&null!==e.font){var i=e.font;t.push(i)}}},{key:"getBasicOptions",value:function(e){for(var i={},n=0;n<e.length;++n){var o=e[n],r={};t.parseFontString(r,o)&&(o=r),Vr(o,(function(t,e){void 0!==t&&(i.hasOwnProperty(e)||(-1!==nr(yu).call(yu,e)?i[e]={}:i[e]=t))}))}return i}},{key:"getFontOption",value:function(e,i,n){for(var o,r=0;r<e.length;++r){var s=e[r];if(s.hasOwnProperty(i)){if(null==(o=s[i]))continue;var a={};if(t.parseFontString(a,o)&&(o=a),o.hasOwnProperty(n))return o[n]}}if(this.fontOptions.hasOwnProperty(n))return this.fontOptions[n];throw new Error("Did not find value for multi-font for property: '"+n+"'")}},{key:"getFontOptions",value:function(t,e){for(var i={},n=["color","size","face","mod","vadjust"],o=0;o<n.length;++o){var r=n[o];i[r]=this.getFontOption(t,e,r)}return i}},{key:"propagateFonts",value:function(t){var e=this,i=[];this.addFontOptionsToPile(i,t),this.fontOptions=this.getBasicOptions(i);for(var n=function(t){var n=yu[t],o=e.fontOptions[n];Vr(e.getFontOptions(i,n),(function(t,e){o[e]=t})),o.size=Number(o.size),o.vadjust=Number(o.vadjust)},o=0;o<yu.length;++o)n(o)}},{key:"draw",value:function(t,e,i,n,o){var r=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";if(void 0!==this.elementOptions.label){var s=this.fontOptions.size*this.body.view.scale;this.elementOptions.label&&s<this.elementOptions.scaling.label.drawThreshold-1||(s>=this.elementOptions.scaling.label.maxVisible&&(s=Number(this.elementOptions.scaling.label.maxVisible)/this.body.view.scale),this.calculateLabelSize(t,n,o,e,i,r),this._drawBackground(t),this._drawText(t,e,this.size.yLine,r,s))}}},{key:"_drawBackground",value:function(t){if(void 0!==this.fontOptions.background&&"none"!==this.fontOptions.background){t.fillStyle=this.fontOptions.background;var e=this.getSize();t.fillRect(e.left,e.top,e.width,e.height)}}},{key:"_drawText",value:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"middle",o=arguments.length>4?arguments[4]:void 0,r=this._setAlignment(t,e,i,n),s=vr(r,2);e=s[0],i=s[1],t.textAlign="left",e-=this.size.width/2,this.fontOptions.valign&&this.size.height>this.size.labelHeight&&("top"===this.fontOptions.valign&&(i-=(this.size.height-this.size.labelHeight)/2),"bottom"===this.fontOptions.valign&&(i+=(this.size.height-this.size.labelHeight)/2));for(var a=0;a<this.lineCount;a++){var h=this.lines[a];if(h&&h.blocks){var l=0;this.isEdgeLabel||"center"===this.fontOptions.align?l+=(this.size.width-h.width)/2:"right"===this.fontOptions.align&&(l+=this.size.width-h.width);for(var d=0;d<h.blocks.length;d++){var u=h.blocks[d];t.font=u.font;var c=this._getColor(u.color,o,u.strokeColor),f=vr(c,2),p=f[0],v=f[1];u.strokeWidth>0&&(t.lineWidth=u.strokeWidth,t.strokeStyle=v,t.lineJoin="round"),t.fillStyle=p,u.strokeWidth>0&&t.strokeText(u.text,e+l,i+u.vadjust),t.fillText(u.text,e+l,i+u.vadjust),l+=u.width}i+=h.height}}}},{key:"_setAlignment",value:function(t,e,i,n){if(this.isEdgeLabel&&"horizontal"!==this.fontOptions.align&&!1===this.pointToSelf){e=0,i=0;"top"===this.fontOptions.align?(t.textBaseline="alphabetic",i-=4):"bottom"===this.fontOptions.align?(t.textBaseline="hanging",i+=4):t.textBaseline="middle"}else t.textBaseline=n;return[e,i]}},{key:"_getColor",value:function(t,e,i){var n=t||"#000000",o=i||"#ffffff";if(e<=this.elementOptions.scaling.label.drawThreshold){var r=Math.max(0,Math.min(1,1-(this.elementOptions.scaling.label.drawThreshold-e)));n=Kr(n,r),o=Kr(o,r)}return[n,o]}},{key:"getTextSize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2];return this._processLabel(t,e,i),{width:this.size.width,height:this.size.height,lineCount:this.lineCount}}},{key:"getSize",value:function(){var t=this.size.left,e=this.size.top-1;if(this.isEdgeLabel){var i=.5*-this.size.width;switch(this.fontOptions.align){case"middle":t=i,e=.5*-this.size.height;break;case"top":t=i,e=-(this.size.height+2);break;case"bottom":t=i,e=2}}return{left:t,top:e,width:this.size.width,height:this.size.height}}},{key:"calculateLabelSize",value:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:0,o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:0,r=arguments.length>5&&void 0!==arguments[5]?arguments[5]:"middle";this._processLabel(t,e,i),this.size.left=n-.5*this.size.width,this.size.top=o-.5*this.size.height,this.size.yLine=o+.5*(1-this.lineCount)*this.fontOptions.size,"hanging"===r&&(this.size.top+=.5*this.fontOptions.size,this.size.top+=4,this.size.yLine+=4)}},{key:"getFormattingValues",value:function(t,e,i,n){var o=function(t,e,i){return"normal"===e?"mod"===i?"":t[i]:void 0!==t[e][i]?t[e][i]:t[i]},r={color:o(this.fontOptions,n,"color"),size:o(this.fontOptions,n,"size"),face:o(this.fontOptions,n,"face"),mod:o(this.fontOptions,n,"mod"),vadjust:o(this.fontOptions,n,"vadjust"),strokeWidth:this.fontOptions.strokeWidth,strokeColor:this.fontOptions.strokeColor};(e||i)&&("normal"===n&&!0===this.fontOptions.chooser&&this.elementOptions.labelHighlightBold?r.mod="bold":"function"==typeof this.fontOptions.chooser&&this.fontOptions.chooser(r,this.elementOptions.id,e,i));var s="";return void 0!==r.mod&&""!==r.mod&&(s+=r.mod+" "),s+=r.size+"px "+r.face,t.font=s.replace(/"/g,""),r.font=t.font,r.height=r.size,r}},{key:"differentState",value:function(t,e){return t!==this.selectedState||e!==this.hoverState}},{key:"_processLabelText",value:function(t,e,i,n){return new gu(t,this,e,i).process(n)}},{key:"_processLabel",value:function(t,e,i){if(!1!==this.labelDirty||this.differentState(e,i)){var n=this._processLabelText(t,e,i,this.elementOptions.label);this.fontOptions.minWdt>0&&n.width<this.fontOptions.minWdt&&(n.width=this.fontOptions.minWdt),this.size.labelHeight=n.height,this.fontOptions.minHgt>0&&n.height<this.fontOptions.minHgt&&(n.height=this.fontOptions.minHgt),this.lines=n.lines,this.lineCount=n.lines.length,this.size.width=n.width,this.size.height=n.height,this.selectedState=e,this.hoverState=i,this.labelDirty=!1}}},{key:"visible",value:function(){return 0!==this.size.width&&0!==this.size.height&&void 0!==this.elementOptions.label&&!(this.fontOptions.size*this.body.view.scale<this.elementOptions.scaling.label.drawThreshold-1)}}],[{key:"parseFontString",value:function(t,e){if(!e||"string"!=typeof e)return!1;var i=e.split(" ");return t.size=+i[0].replace("px",""),t.face=i[1],t.color=i[2],!0}}]),t}();U({target:"Array",proto:!0},{fill:function(t){for(var e=It(this),i=Zt(e.length),n=arguments.length,o=te(n>1?arguments[1]:void 0,i),r=n>2?arguments[2]:void 0,s=void 0===r?i:te(r,i);s>o;)e[o++]=t;return e}});var bu=K("Array").fill,wu=Array.prototype,_u=function(t){var e=t.fill;return t===wu||t instanceof Array&&e===wu.fill?bu:e},ku=function(){function t(e,i,n){Kh(this,t),this.body=i,this.labelModule=n,this.setOptions(e),this.top=void 0,this.left=void 0,this.height=void 0,this.width=void 0,this.radius=void 0,this.margin=void 0,this.refreshNeeded=!0,this.boundingBox={top:0,left:0,right:0,bottom:0}}return Qh(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"_setMargins",value:function(t){this.margin={},this.options.margin&&("object"==ur(this.options.margin)?(this.margin.top=this.options.margin.top,this.margin.right=this.options.margin.right,this.margin.bottom=this.options.margin.bottom,this.margin.left=this.options.margin.left):(this.margin.top=this.options.margin,this.margin.right=this.options.margin,this.margin.bottom=this.options.margin,this.margin.left=this.options.margin)),t.adjustSizes(this.margin)}},{key:"_distanceToBorder",value:function(t,e){var i=this.options.borderWidth;return t&&this.resize(t),Math.min(Math.abs(this.width/2/Math.cos(e)),Math.abs(this.height/2/Math.sin(e)))+i}},{key:"enableShadow",value:function(t,e){e.shadow&&(t.shadowColor=e.shadowColor,t.shadowBlur=e.shadowSize,t.shadowOffsetX=e.shadowX,t.shadowOffsetY=e.shadowY)}},{key:"disableShadow",value:function(t,e){e.shadow&&(t.shadowColor="rgba(0,0,0,0)",t.shadowBlur=0,t.shadowOffsetX=0,t.shadowOffsetY=0)}},{key:"enableBorderDashes",value:function(t,e){if(!1!==e.borderDashes)if(void 0!==t.setLineDash){var i=e.borderDashes;!0===i&&(i=[5,15]),t.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,e.borderDashes=!1}},{key:"disableBorderDashes",value:function(t,e){!1!==e.borderDashes&&(void 0!==t.setLineDash?t.setLineDash([0]):(console.warn("setLineDash is not supported in this browser. The dashed borders cannot be used."),this.options.shapeProperties.borderDashes=!1,e.borderDashes=!1))}},{key:"needsRefresh",value:function(t,e){return!0===this.refreshNeeded?(this.refreshNeeded=!1,!0):void 0===this.width||this.labelModule.differentState(t,e)}},{key:"initContextForDraw",value:function(t,e){var i=e.borderWidth/this.body.view.scale;t.lineWidth=Math.min(this.width,i),t.strokeStyle=e.borderColor,t.fillStyle=e.color}},{key:"performStroke",value:function(t,e){var i=e.borderWidth/this.body.view.scale;t.save(),i>0&&(this.enableBorderDashes(t,e),t.stroke(),this.disableBorderDashes(t,e)),t.restore()}},{key:"performFill",value:function(t,e){t.save(),t.fillStyle=e.color,this.enableShadow(t,e),_u(t).call(t),this.disableShadow(t,e),t.restore(),this.performStroke(t,e)}},{key:"_addBoundingBoxMargin",value:function(t){this.boundingBox.left-=t,this.boundingBox.top-=t,this.boundingBox.bottom+=t,this.boundingBox.right+=t}},{key:"_updateBoundingBox",value:function(t,e,i,n,o){void 0!==i&&this.resize(i,n,o),this.left=t-this.width/2,this.top=e-this.height/2,this.boundingBox.left=this.left,this.boundingBox.top=this.top,this.boundingBox.bottom=this.top+this.height,this.boundingBox.right=this.left+this.width}},{key:"updateBoundingBox",value:function(t,e,i,n,o){this._updateBoundingBox(t,e,i,n,o)}},{key:"getDimensionsFromLabel",value:function(t,e,i){this.textSize=this.labelModule.getTextSize(t,e,i);var n=this.textSize.width,o=this.textSize.height;return 0===n&&(n=14,o=14),{width:n,height:o}}}]),t}();function xu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Ou=function(t){Vl(i,t);var e=xu(i);function i(t,n,o){var r;return Kh(this,i),(r=e.call(this,t,n,o))._setMargins(o),r}return Qh(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var n=this.getDimensionsFromLabel(t,e,i);this.width=n.width+this.margin.right+this.margin.left,this.height=n.height+this.margin.top+this.margin.bottom,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o),this.left=e-this.width/2,this.top=i-this.height/2,this.initContextForDraw(t,r),et(t,this.left,this.top,this.width,this.height,r.borderRadius),this.performFill(t,r),this.updateBoundingBox(e,i,t,n,o),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,n,o)}},{key:"updateBoundingBox",value:function(t,e,i,n,o){this._updateBoundingBox(t,e,i,n,o);var r=this.options.shapeProperties.borderRadius;this._addBoundingBoxMargin(r)}},{key:"distanceToBorder",value:function(t,e){t&&this.resize(t);var i=this.options.borderWidth;return Math.min(Math.abs(this.width/2/Math.cos(e)),Math.abs(this.height/2/Math.sin(e)))+i}}]),i}(ku);function Su(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Eu=function(t){Vl(i,t);var e=Su(i);function i(t,n,o){var r;return Kh(this,i),(r=e.call(this,t,n,o)).labelOffset=0,r.selected=!1,r}return Qh(i,[{key:"setOptions",value:function(t,e,i){this.options=t,void 0===e&&void 0===i||this.setImages(e,i)}},{key:"setImages",value:function(t,e){e&&this.selected?(this.imageObj=e,this.imageObjAlt=t):(this.imageObj=t,this.imageObjAlt=e)}},{key:"switchImages",value:function(t){var e=t&&!this.selected||!t&&this.selected;if(this.selected=t,void 0!==this.imageObjAlt&&e){var i=this.imageObj;this.imageObj=this.imageObjAlt,this.imageObjAlt=i}}},{key:"_getImagePadding",value:function(){var t={top:0,right:0,bottom:0,left:0};if(this.options.imagePadding){var e=this.options.imagePadding;"object"==ur(e)?(t.top=e.top,t.right=e.right,t.bottom=e.bottom,t.left=e.left):(t.top=e,t.right=e,t.bottom=e,t.left=e)}return t}},{key:"_resizeImage",value:function(){var t,e;if(!1===this.options.shapeProperties.useImageSize){var i=1,n=1;this.imageObj.width&&this.imageObj.height&&(this.imageObj.width>this.imageObj.height?i=this.imageObj.width/this.imageObj.height:n=this.imageObj.height/this.imageObj.width),t=2*this.options.size*i,e=2*this.options.size*n}else{var o=this._getImagePadding();t=this.imageObj.width+o.left+o.right,e=this.imageObj.height+o.top+o.bottom}this.width=t,this.height=e,this.radius=.5*this.width}},{key:"_drawRawCircle",value:function(t,e,i,n){this.initContextForDraw(t,n),tt(t,e,i,n.size),this.performFill(t,n)}},{key:"_drawImageAtPosition",value:function(t,e){if(0!=this.imageObj.width){t.globalAlpha=void 0!==e.opacity?e.opacity:1,this.enableShadow(t,e);var i=1;!0===this.options.shapeProperties.interpolation&&(i=this.imageObj.width/this.width/this.body.view.scale);var n=this._getImagePadding(),o=this.left+n.left,r=this.top+n.top,s=this.width-n.left-n.right,a=this.height-n.top-n.bottom;this.imageObj.drawImageAtPosition(t,i,o,r,s,a),this.disableShadow(t,e)}}},{key:"_drawImageLabel",value:function(t,e,i,n,o){var r,s=0;if(void 0!==this.height){s=.5*this.height;var a=this.labelModule.getTextSize(t,n,o);a.lineCount>=1&&(s+=a.height/2)}r=i+s,this.options.label&&(this.labelOffset=s),this.labelModule.draw(t,e,r,n,o,"hanging")}}]),i}(ku);function Du(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Mu=function(t){Vl(i,t);var e=Du(i);function i(t,n,o){var r;return Kh(this,i),(r=e.call(this,t,n,o))._setMargins(o),r}return Qh(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var n=this.getDimensionsFromLabel(t,e,i),o=Math.max(n.width+this.margin.right+this.margin.left,n.height+this.margin.top+this.margin.bottom);this.options.size=o/2,this.width=o,this.height=o,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o),this.left=e-this.width/2,this.top=i-this.height/2,this._drawRawCircle(t,e,i,r),this.updateBoundingBox(e,i),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,i,n,o)}},{key:"updateBoundingBox",value:function(t,e){this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size}},{key:"distanceToBorder",value:function(t,e){return t&&this.resize(t),.5*this.width}}]),i}(Eu);function Cu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Tu=function(t){Vl(i,t);var e=Cu(i);function i(t,n,o,r,s){var a;return Kh(this,i),(a=e.call(this,t,n,o)).setImages(r,s),a}return Qh(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,n=void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height;if(n){var o=2*this.options.size;return this.width=o,this.height=o,void(this.radius=.5*this.width)}this.needsRefresh(e,i)&&this._resizeImage()}},{key:"draw",value:function(t,e,i,n,o,r){this.switchImages(n),this.resize(),this.left=e-this.width/2,this.top=i-this.height/2,this._drawRawCircle(t,e,i,r),t.save(),t.clip(),this._drawImageAtPosition(t,r),t.restore(),this._drawImageLabel(t,e,i,n,o),this.updateBoundingBox(e,i)}},{key:"updateBoundingBox",value:function(t,e){this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size,this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset)}},{key:"distanceToBorder",value:function(t,e){return t&&this.resize(t),.5*this.width}}]),i}(Eu);function Pu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Nu=function(t){Vl(i,t);var e=Pu(i);function i(t,n,o){var r;return Kh(this,i),(r=e.call(this,t,n,o))._setMargins(o),r}return Qh(i,[{key:"resize",value:function(t,e,i){if(this.needsRefresh(e,i)){var n=this.getDimensionsFromLabel(t,e,i).width+this.margin.right+this.margin.left;this.width=n,this.height=n,this.radius=this.width/2}}},{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o),this.left=e-this.width/2,this.top=i-this.height/2,this.initContextForDraw(t,r),nt(t,e-this.width/2,i-this.height/2,this.width,this.height),this.performFill(t,r),this.updateBoundingBox(e,i,t,n,o),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,n,o)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(ku);function Iu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Au=function(t){Vl(i,t);var e=Iu(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{size:this.options.size};if(this.needsRefresh(e,i)){this.labelModule.getTextSize(t,e,i);var o=2*n.size;this.width=o,this.height=o,this.radius=.5*this.width}}},{key:"_drawShape",value:function(t,e,i,n,o,r,s,a){var h;if(this.resize(t,r,s,a),this.left=n-this.width/2,this.top=o-this.height/2,this.initContextForDraw(t,a),(h=e,Object.prototype.hasOwnProperty.call(rt,h)?rt[h]:function(t){for(var e=arguments.length,i=new Array(e>1?e-1:0),n=1;n<e;n++)i[n-1]=arguments[n];CanvasRenderingContext2D.prototype[h].call(t,i)})(t,n,o,a.size),this.performFill(t,a),void 0!==this.options.icon&&void 0!==this.options.icon.code&&(t.font=(r?"bold ":"")+this.height/2+"px "+(this.options.icon.face||"FontAwesome"),t.fillStyle=this.options.icon.color||"black",t.textAlign="center",t.textBaseline="middle",t.fillText(this.options.icon.code,n,o)),void 0!==this.options.label){this.labelModule.calculateLabelSize(t,r,s,n,o,"hanging");var l=o+.5*this.height+.5*this.labelModule.size.height;this.labelModule.draw(t,n,l,r,s,"hanging")}this.updateBoundingBox(n,o)}},{key:"updateBoundingBox",value:function(t,e){this.boundingBox.top=e-this.options.size,this.boundingBox.left=t-this.options.size,this.boundingBox.right=t+this.options.size,this.boundingBox.bottom=e+this.options.size,void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height))}}]),i}(ku);function Fu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var ju=function(t){Vl(i,t);var e=Fu(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"draw",value:function(t,e,i,n,o,r){this._drawShape(t,"diamond",4,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(Au);function zu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Bu=function(t){Vl(i,t);var e=zu(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"draw",value:function(t,e,i,n,o,r){this._drawShape(t,"circle",2,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return t&&this.resize(t),this.options.size}}]),i}(Au);function Ru(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Lu=function(t){Vl(i,t);var e=Ru(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover;if(this.needsRefresh(e,i)){var n=this.getDimensionsFromLabel(t,e,i);this.height=2*n.height,this.width=n.width+n.height,this.radius=.5*this.width}}},{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o),this.left=e-.5*this.width,this.top=i-.5*this.height,this.initContextForDraw(t,r),it(t,this.left,this.top,this.width,this.height),this.performFill(t,r),this.updateBoundingBox(e,i,t,n,o),this.labelModule.draw(t,e,i,n,o)}},{key:"distanceToBorder",value:function(t,e){t&&this.resize(t);var i=.5*this.width,n=.5*this.height,o=Math.sin(e)*i,r=Math.cos(e)*n;return i*n/Math.sqrt(o*o+r*r)}}]),i}(ku);function Hu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Wu=function(t){Vl(i,t);var e=Hu(i);function i(t,n,o){var r;return Kh(this,i),(r=e.call(this,t,n,o))._setMargins(o),r}return Qh(i,[{key:"resize",value:function(t,e,i){this.needsRefresh(e,i)&&(this.iconSize={width:Number(this.options.icon.size),height:Number(this.options.icon.size)},this.width=this.iconSize.width+this.margin.right+this.margin.left,this.height=this.iconSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(t,e,i,n,o,r){if(this.resize(t,n,o),this.options.icon.size=this.options.icon.size||50,this.left=e-this.width/2,this.top=i-this.height/2,this._icon(t,e,i,n,o,r),void 0!==this.options.label){this.labelModule.draw(t,this.left+this.iconSize.width/2+this.margin.left,i+this.height/2+5,n)}this.updateBoundingBox(e,i)}},{key:"updateBoundingBox",value:function(t,e){if(this.boundingBox.top=e-.5*this.options.icon.size,this.boundingBox.left=t-.5*this.options.icon.size,this.boundingBox.right=t+.5*this.options.icon.size,this.boundingBox.bottom=e+.5*this.options.icon.size,void 0!==this.options.label&&this.labelModule.size.width>0){this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelModule.size.height+5)}}},{key:"_icon",value:function(t,e,i,n,o,r){var s=Number(this.options.icon.size);void 0!==this.options.icon.code?(t.font=[null!=this.options.icon.weight?this.options.icon.weight:n?"bold":"",(null!=this.options.icon.weight&&n?5:0)+s+"px",this.options.icon.face].join(" "),t.fillStyle=this.options.icon.color||"black",t.textAlign="center",t.textBaseline="middle",this.enableShadow(t,r),t.fillText(this.options.icon.code,e,i),this.disableShadow(t,r)):console.error("When using the icon shape, you need to define the code in the icon options object. This can be done per node or globally.")}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(ku);function Yu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Vu=function(t){Vl(i,t);var e=Yu(i);function i(t,n,o,r,s){var a;return Kh(this,i),(a=e.call(this,t,n,o)).setImages(r,s),a}return Qh(i,[{key:"resize",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.selected,i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this.hover,n=void 0===this.imageObj.src||void 0===this.imageObj.width||void 0===this.imageObj.height;if(n){var o=2*this.options.size;return this.width=o,void(this.height=o)}this.needsRefresh(e,i)&&this._resizeImage()}},{key:"draw",value:function(t,e,i,n,o,r){if(t.save(),this.switchImages(n),this.resize(),this.left=e-this.width/2,this.top=i-this.height/2,!0===this.options.shapeProperties.useBorderWithImage){var s=this.options.borderWidth,a=this.options.borderWidthSelected||2*this.options.borderWidth,h=(n?a:s)/this.body.view.scale;t.lineWidth=Math.min(this.width,h),t.beginPath();var l=n?this.options.color.highlight.border:o?this.options.color.hover.border:this.options.color.border,d=n?this.options.color.highlight.background:o?this.options.color.hover.background:this.options.color.background;void 0!==r.opacity&&(l=Kr(l,r.opacity),d=Kr(d,r.opacity)),t.strokeStyle=l,t.fillStyle=d,t.rect(this.left-.5*t.lineWidth,this.top-.5*t.lineWidth,this.width+t.lineWidth,this.height+t.lineWidth),_u(t).call(t),this.performStroke(t,r),t.closePath()}this._drawImageAtPosition(t,r),this._drawImageLabel(t,e,i,n,o),this.updateBoundingBox(e,i),t.restore()}},{key:"updateBoundingBox",value:function(t,e){this.resize(),this._updateBoundingBox(t,e),void 0!==this.options.label&&this.labelModule.size.width>0&&(this.boundingBox.left=Math.min(this.boundingBox.left,this.labelModule.size.left),this.boundingBox.right=Math.max(this.boundingBox.right,this.labelModule.size.left+this.labelModule.size.width),this.boundingBox.bottom=Math.max(this.boundingBox.bottom,this.boundingBox.bottom+this.labelOffset))}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(Eu);function Uu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Gu=function(t){Vl(i,t);var e=Uu(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"draw",value:function(t,e,i,n,o,r){this._drawShape(t,"square",2,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(Au);function qu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Xu=function(t){Vl(i,t);var e=qu(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"draw",value:function(t,e,i,n,o,r){this._drawShape(t,"hexagon",4,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(Au);function $u(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Ku=function(t){Vl(i,t);var e=$u(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"draw",value:function(t,e,i,n,o,r){this._drawShape(t,"star",4,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(Au);function Zu(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Qu=function(t){Vl(i,t);var e=Zu(i);function i(t,n,o){var r;return Kh(this,i),(r=e.call(this,t,n,o))._setMargins(o),r}return Qh(i,[{key:"resize",value:function(t,e,i){this.needsRefresh(e,i)&&(this.textSize=this.labelModule.getTextSize(t,e,i),this.width=this.textSize.width+this.margin.right+this.margin.left,this.height=this.textSize.height+this.margin.top+this.margin.bottom,this.radius=.5*this.width)}},{key:"draw",value:function(t,e,i,n,o,r){this.resize(t,n,o),this.left=e-this.width/2,this.top=i-this.height/2,this.enableShadow(t,r),this.labelModule.draw(t,this.left+this.textSize.width/2+this.margin.left,this.top+this.textSize.height/2+this.margin.top,n,o),this.disableShadow(t,r),this.updateBoundingBox(e,i,t,n,o)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(ku);function Ju(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var tc=function(t){Vl(i,t);var e=Ju(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"draw",value:function(t,e,i,n,o,r){this._drawShape(t,"triangle",3,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(Au);function ec(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var ic,nc=function(t){Vl(i,t);var e=ec(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"draw",value:function(t,e,i,n,o,r){this._drawShape(t,"triangleDown",3,e,i,n,o,r)}},{key:"distanceToBorder",value:function(t,e){return this._distanceToBorder(t,e)}}]),i}(Au),oc=!1,rc="background: #FFeeee; color: #dd0000",sc=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"validate",value:function(e,i,n){oc=!1,ic=i;var o=i;return void 0!==n&&(o=i[n]),t.parse(e,o,[]),oc}},{key:"parse",value:function(e,i,n){for(var o in e)e.hasOwnProperty(o)&&t.check(o,e,i,n)}},{key:"check",value:function(e,i,n,o){if(void 0!==n[e]||void 0!==n.__any__){var r=e,s=!0;void 0===n[e]&&void 0!==n.__any__&&(r="__any__",s="object"===t.getType(i[e]));var a=n[r];s&&void 0!==a.__type__&&(a=a.__type__),t.checkFields(e,i,n,r,a,o)}else t.getSuggestion(e,n,o)}},{key:"checkFields",value:function(e,i,n,o,r,s){var a=function(i){console.log("%c"+i+t.printLocation(s,e),rc)},h=t.getType(i[e]),l=r[h];void 0!==l?"array"===t.getType(l)&&-1===nr(l).call(l,i[e])?(a('Invalid option detected in "'+e+'". Allowed values are:'+t.print(l)+' not "'+i[e]+'". '),oc=!0):"object"===h&&"__any__"!==o&&(s=Lr(s,e),t.parse(i[e],n[o],s)):void 0===r.any&&(a('Invalid type received for "'+e+'". Expected: '+t.print(Tn(r))+". Received ["+h+'] "'+i[e]+'"'),oc=!0)}},{key:"getType",value:function(t){var e=ur(t);return"object"===e?null===t?"null":t instanceof Boolean?"boolean":t instanceof Number?"number":t instanceof String?"string":or(t)?"array":t instanceof Date?"date":void 0!==t.nodeType?"dom":!0===t._isAMomentObject?"moment":"object":"number"===e?"number":"boolean"===e?"boolean":"string"===e?"string":void 0===e?"undefined":e}},{key:"getSuggestion",value:function(e,i,n){var o,r=t.findInOptions(e,i,n,!1),s=t.findInOptions(e,ic,[],!0);o=void 0!==r.indexMatch?" in "+t.printLocation(r.path,e,"")+'Perhaps it was incomplete? Did you mean: "'+r.indexMatch+'"?\n\n':s.distance<=4&&r.distance>s.distance?" in "+t.printLocation(r.path,e,"")+"Perhaps it was misplaced? Matching option found at: "+t.printLocation(s.path,s.closestMatch,""):r.distance<=8?'. Did you mean "'+r.closestMatch+'"?'+t.printLocation(r.path,e):". Did you mean one of these: "+t.print(Tn(i))+t.printLocation(n,e),console.log('%cUnknown option detected: "'+e+'"'+o,rc),oc=!0}},{key:"findInOptions",value:function(e,i,n){var o=arguments.length>3&&void 0!==arguments[3]&&arguments[3],r=1e9,s="",a=[],h=e.toLowerCase(),l=void 0;for(var d in i){var u=void 0;if(void 0!==i[d].__type__&&!0===o){var c=t.findInOptions(e,i[d],Lr(n,d));r>c.distance&&(s=c.closestMatch,a=c.path,r=c.distance,l=c.indexMatch)}else{var f;-1!==nr(f=d.toLowerCase()).call(f,h)&&(l=d),r>(u=t.levenshteinDistance(e,d))&&(s=d,a=Hr(n),r=u)}}return{closestMatch:s,path:a,distance:r,indexMatch:l}}},{key:"printLocation",value:function(t,e){for(var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:"Problem value found at: \n",n="\n\n"+i+"options = {\n",o=0;o<t.length;o++){for(var r=0;r<o+1;r++)n+="  ";n+=t[o]+": {\n"}for(var s=0;s<t.length+1;s++)n+="  ";n+=e+"\n";for(var a=0;a<t.length+1;a++){for(var h=0;h<t.length-a;h++)n+="  ";n+="}\n"}return n+"\n\n"}},{key:"print",value:function(t){return Nl(t).replace(/(\")|(\[)|(\])|(,"__type__")/g,"").replace(/(\,)/g,", ")}},{key:"levenshteinDistance",value:function(t,e){if(0===t.length)return e.length;if(0===e.length)return t.length;var i,n,o=[];for(i=0;i<=e.length;i++)o[i]=[i];for(n=0;n<=t.length;n++)o[0][n]=n;for(i=1;i<=e.length;i++)for(n=1;n<=t.length;n++)e.charAt(i-1)==t.charAt(n-1)?o[i][n]=o[i-1][n-1]:o[i][n]=Math.min(o[i-1][n-1]+1,Math.min(o[i][n-1]+1,o[i-1][n]+1));return o[e.length][t.length]}}]),t}();function ac(t,e){var i=Tn(t);if(kn){var n=kn(t);e&&(n=_o(n).call(n,(function(e){return _n(t,e).enumerable}))),i.push.apply(i,n)}return i}function hc(t){for(var e=1;e<arguments.length;e++){var i,n=null!=arguments[e]?arguments[e]:{};if(e%2)Jn(i=ac(Object(n),!0)).call(i,(function(e){Dn(t,e,n[e])}));else if(yn)vn(t,yn(n));else{var o;Jn(o=ac(Object(n))).call(o,(function(e){pn(t,e,_n(n,e))}))}}return t}var lc=function(){function t(e,i,n,o,r,s){Kh(this,t),this.options=hs(r),this.globalOptions=r,this.defaultOptions=s,this.body=i,this.edges=[],this.id=void 0,this.imagelist=n,this.grouplist=o,this.x=void 0,this.y=void 0,this.baseSize=this.options.size,this.baseFontSize=this.options.font.size,this.predefinedPosition=!1,this.selected=!1,this.hover=!1,this.labelModule=new mu(this.body,this.options,!1),this.setOptions(e)}return Qh(t,[{key:"attachEdge",value:function(t){var e;-1===nr(e=this.edges).call(e,t)&&this.edges.push(t)}},{key:"detachEdge",value:function(t){var e,i,n=nr(e=this.edges).call(e,t);-1!=n&&bs(i=this.edges).call(i,n,1)}},{key:"setOptions",value:function(e){var i=this.options.shape;if(e){if(void 0!==e.color&&(this._localColor=e.color),void 0!==e.id&&(this.id=e.id),void 0===this.id)throw new Error("Node must have an id");t.checkMass(e,this.id),void 0!==e.x&&(null===e.x?(this.x=void 0,this.predefinedPosition=!1):(this.x=uo(e.x),this.predefinedPosition=!0)),void 0!==e.y&&(null===e.y?(this.y=void 0,this.predefinedPosition=!1):(this.y=uo(e.y),this.predefinedPosition=!0)),void 0!==e.size&&(this.baseSize=e.size),void 0!==e.value&&(e.value=uu(e.value)),t.parseOptions(this.options,e,!0,this.globalOptions,this.grouplist);var n=[e,this.options,this.defaultOptions];return this.chooser=cu.choosify("node",n),this._load_images(),this.updateLabelModule(e),void 0!==e.opacity&&t.checkOpacity(e.opacity)&&(this.options.opacity=e.opacity),this.updateShape(i),void 0!==e.hidden||void 0!==e.physics}}},{key:"_load_images",value:function(){if(("circularImage"===this.options.shape||"image"===this.options.shape)&&void 0===this.options.image)throw new Error("Option image must be defined for node type '"+this.options.shape+"'");if(void 0!==this.options.image){if(void 0===this.imagelist)throw new Error("Internal Error: No images provided");if("string"==typeof this.options.image)this.imageObj=this.imagelist.load(this.options.image,this.options.brokenImage,this.id);else{if(void 0===this.options.image.unselected)throw new Error("No unselected image provided");this.imageObj=this.imagelist.load(this.options.image.unselected,this.options.brokenImage,this.id),void 0!==this.options.image.selected?this.imageObjAlt=this.imagelist.load(this.options.image.selected,this.options.brokenImage,this.id):this.imageObjAlt=void 0}}}},{key:"getFormattingValues",value:function(){var t={color:this.options.color.background,opacity:this.options.opacity,borderWidth:this.options.borderWidth,borderColor:this.options.color.border,size:this.options.size,borderDashes:this.options.shapeProperties.borderDashes,borderRadius:this.options.shapeProperties.borderRadius,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y};if(this.selected||this.hover?!0===this.chooser?this.selected?(t.borderWidth*=2,t.color=this.options.color.highlight.background,t.borderColor=this.options.color.highlight.border,t.shadow=this.options.shadow.enabled):this.hover&&(t.color=this.options.color.hover.background,t.borderColor=this.options.color.hover.border,t.shadow=this.options.shadow.enabled):"function"==typeof this.chooser&&(this.chooser(t,this.options.id,this.selected,this.hover),!1===t.shadow&&(t.shadowColor===this.options.shadow.color&&t.shadowSize===this.options.shadow.size&&t.shadowX===this.options.shadow.x&&t.shadowY===this.options.shadow.y||(t.shadow=!0))):t.shadow=this.options.shadow.enabled,void 0!==this.options.opacity){var e=this.options.opacity;t.borderColor=Kr(t.borderColor,e),t.color=Kr(t.color,e),t.shadowColor=Kr(t.shadowColor,e)}return t}},{key:"updateLabelModule",value:function(e){void 0!==this.options.label&&null!==this.options.label||(this.options.label=""),t.updateGroupOptions(this.options,hc(hc({},e),{},{color:e&&e.color||this._localColor||void 0}),this.grouplist);var i=this.grouplist.get(this.options.group,!1),n=[e,this.options,i,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,n),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateShape",value:function(t){if(t===this.options.shape&&this.shape)this.shape.setOptions(this.options,this.imageObj,this.imageObjAlt);else switch(this.options.shape){case"box":this.shape=new Ou(this.options,this.body,this.labelModule);break;case"circle":this.shape=new Mu(this.options,this.body,this.labelModule);break;case"circularImage":this.shape=new Tu(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"database":this.shape=new Nu(this.options,this.body,this.labelModule);break;case"diamond":this.shape=new ju(this.options,this.body,this.labelModule);break;case"dot":this.shape=new Bu(this.options,this.body,this.labelModule);break;case"ellipse":this.shape=new Lu(this.options,this.body,this.labelModule);break;case"icon":this.shape=new Wu(this.options,this.body,this.labelModule);break;case"image":this.shape=new Vu(this.options,this.body,this.labelModule,this.imageObj,this.imageObjAlt);break;case"square":this.shape=new Gu(this.options,this.body,this.labelModule);break;case"hexagon":this.shape=new Xu(this.options,this.body,this.labelModule);break;case"star":this.shape=new Ku(this.options,this.body,this.labelModule);break;case"text":this.shape=new Qu(this.options,this.body,this.labelModule);break;case"triangle":this.shape=new tc(this.options,this.body,this.labelModule);break;case"triangleDown":this.shape=new nc(this.options,this.body,this.labelModule);break;default:this.shape=new Lu(this.options,this.body,this.labelModule)}this.needsRefresh()}},{key:"select",value:function(){this.selected=!0,this.needsRefresh()}},{key:"unselect",value:function(){this.selected=!1,this.needsRefresh()}},{key:"needsRefresh",value:function(){this.shape.refreshNeeded=!0}},{key:"getTitle",value:function(){return this.options.title}},{key:"distanceToBorder",value:function(t,e){return this.shape.distanceToBorder(t,e)}},{key:"isFixed",value:function(){return this.options.fixed.x&&this.options.fixed.y}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"getLabelSize",value:function(){return this.labelModule.size()}},{key:"setValueRange",value:function(t,e,i){if(void 0!==this.options.value){var n=this.options.scaling.customScalingFunction(t,e,i,this.options.value),o=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var r=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+n*r}this.options.size=this.options.scaling.min+n*o}else this.options.size=this.baseSize,this.options.font.size=this.baseFontSize;this.updateLabelModule()}},{key:"draw",value:function(t){var e=this.getFormattingValues();this.shape.draw(t,this.x,this.y,this.selected,this.hover,e)}},{key:"updateBoundingBox",value:function(t){this.shape.updateBoundingBox(this.x,this.y,t)}},{key:"resize",value:function(t){var e=this.getFormattingValues();this.shape.resize(t,this.selected,this.hover,e)}},{key:"getItemsOnPoint",value:function(t){var e=[];return this.labelModule.visible()&&cu.pointInRect(this.labelModule.getSize(),t)&&e.push({nodeId:this.id,labelId:0}),cu.pointInRect(this.shape.boundingBox,t)&&e.push({nodeId:this.id}),e}},{key:"isOverlappingWith",value:function(t){return this.shape.left<t.right&&this.shape.left+this.shape.width>t.left&&this.shape.top<t.bottom&&this.shape.top+this.shape.height>t.top}},{key:"isBoundingBoxOverlappingWith",value:function(t){return this.shape.boundingBox.left<t.right&&this.shape.boundingBox.right>t.left&&this.shape.boundingBox.top<t.bottom&&this.shape.boundingBox.bottom>t.top}}],[{key:"checkOpacity",value:function(t){return 0<=t&&t<=1}},{key:"updateGroupOptions",value:function(e,i,n){var o;if(void 0!==n){var r=e.group;if(void 0!==i&&void 0!==i.group&&r!==i.group)throw new Error("updateGroupOptions: group values in options don't match.");if("number"==typeof r||"string"==typeof r&&""!=r){var s=n.get(r);void 0!==s.opacity&&void 0===i.opacity&&(t.checkOpacity(s.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+s.opacity),s.opacity=void 0));var a=_o(o=au(i)).call(o,(function(t){return null!=i[t]}));a.push("font"),zr(a,e,s),e.color=Qr(e.color)}}}},{key:"parseOptions",value:function(e,i){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},r=arguments.length>4?arguments[4]:void 0,s=["color","fixed","shadow"];if(zr(s,e,i,n),t.checkMass(i),void 0!==e.opacity&&(t.checkOpacity(e.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+e.opacity),e.opacity=void 0)),void 0!==i.opacity&&(t.checkOpacity(i.opacity)||(console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+i.opacity),i.opacity=void 0)),ls(e,i,"shadow",o),void 0!==i.color&&null!==i.color){var a=Qr(i.color);Ar(e.color,a)}else!0===n&&null===i.color&&(e.color=hs(o.color));void 0!==i.fixed&&null!==i.fixed&&("boolean"==typeof i.fixed?(e.fixed.x=i.fixed,e.fixed.y=i.fixed):(void 0!==i.fixed.x&&"boolean"==typeof i.fixed.x&&(e.fixed.x=i.fixed.x),void 0!==i.fixed.y&&"boolean"==typeof i.fixed.y&&(e.fixed.y=i.fixed.y))),!0===n&&null===i.font&&(e.font=hs(o.font)),t.updateGroupOptions(e,i,r),void 0!==i.scaling&&ls(e.scaling,i.scaling,"label",o.scaling)}},{key:"checkMass",value:function(t,e){if(void 0!==t.mass&&t.mass<=0){var i="";void 0!==e&&(i=" in node id: "+e),console.log("%cNegative or zero mass disallowed"+i+", setting mass to 1.",rc),t.mass=1}}}]),t}();function dc(t){if(void 0===tn||null==$e(t)){if(or(t)||(t=function(t,e){var i;if(!t)return;if("string"==typeof t)return uc(t,e);var n=Go(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return cn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return uc(t,e)}(t))){var e=0,i=function(){};return{s:i,n:function(){return e>=t.length?{done:!0}:{done:!1,value:t[e++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var n,o,r=!0,s=!1;return{s:function(){n=Xe(t)},n:function(){var t=n.next();return r=t.done,t},e:function(t){s=!0,o=t},f:function(){try{r||null==n.return||n.return()}finally{if(s)throw o}}}}function uc(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}var cc=function(){function t(e,i,n,o){var r,s=this;if(Kh(this,t),this.body=e,this.images=i,this.groups=n,this.layoutEngine=o,this.body.functions.createNode=J(r=this.create).call(r,this),this.nodesListeners={add:function(t,e){s.add(e.items)},update:function(t,e){s.update(e.items,e.data,e.oldData)},remove:function(t,e){s.remove(e.items)}},this.defaultOptions={borderWidth:1,borderWidthSelected:2,brokenImage:void 0,color:{border:"#2B7CE9",background:"#97C2FC",highlight:{border:"#2B7CE9",background:"#D2E5FF"},hover:{border:"#2B7CE9",background:"#D2E5FF"}},opacity:void 0,fixed:{x:!1,y:!1},font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:0,strokeColor:"#ffffff",align:"center",vadjust:0,multi:!1,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"monospace",vadjust:2}},group:void 0,hidden:!1,icon:{face:"FontAwesome",code:void 0,size:50,color:"#2B7CE9"},image:void 0,imagePadding:{top:0,right:0,bottom:0,left:0},label:void 0,labelHighlightBold:!0,level:void 0,margin:{top:5,right:5,bottom:5,left:5},mass:1,physics:!0,scaling:{min:10,max:30,label:{enabled:!1,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(t,e,i,n){if(e===t)return.5;var o=1/(e-t);return Math.max(0,(n-t)*o)}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},shape:"ellipse",shapeProperties:{borderDashes:!1,borderRadius:6,interpolation:!0,useImageSize:!1,useBorderWithImage:!1},size:25,title:void 0,value:void 0,x:void 0,y:void 0},this.defaultOptions.mass<=0)throw"Internal error: mass in defaultOptions of NodesHandler may not be zero or negative";this.options=hs(this.defaultOptions),this.bindEventListeners()}return Qh(t,[{key:"bindEventListeners",value:function(){var t,e,i=this;this.body.emitter.on("refreshNodes",J(t=this.refresh).call(t,this)),this.body.emitter.on("refresh",J(e=this.refresh).call(e,this)),this.body.emitter.on("destroy",(function(){Vr(i.nodesListeners,(function(t,e){i.body.data.nodes&&i.body.data.nodes.off(e,t)})),delete i.body.functions.createNode,delete i.nodesListeners.add,delete i.nodesListeners.update,delete i.nodesListeners.remove,delete i.nodesListeners}))}},{key:"setOptions",value:function(t){if(void 0!==t){if(lc.parseOptions(this.options,t),void 0!==t.opacity&&(vl(t.opacity)||!pl(t.opacity)||t.opacity<0||t.opacity>1?console.error("Invalid option for node opacity. Value must be between 0 and 1, found: "+t.opacity):this.options.opacity=t.opacity),void 0!==t.shape)for(var e in this.body.nodes)this.body.nodes.hasOwnProperty(e)&&this.body.nodes[e].updateShape();if(void 0!==t.font||void 0!==t.widthConstraint||void 0!==t.heightConstraint)for(var i=0,n=Tn(this.body.nodes);i<n.length;i++){var o=n[i];this.body.nodes[o].updateLabelModule(),this.body.nodes[o].needsRefresh()}if(void 0!==t.size)for(var r in this.body.nodes)this.body.nodes.hasOwnProperty(r)&&this.body.nodes[r].needsRefresh();void 0===t.hidden&&void 0===t.physics||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.body.data.nodes;if(t instanceof eu||t instanceof iu)this.body.data.nodes=t;else if(or(t))this.body.data.nodes=new eu,this.body.data.nodes.add(t);else{if(t)throw new TypeError("Array or DataSet expected");this.body.data.nodes=new eu}if(i&&Vr(this.nodesListeners,(function(t,e){i.off(e,t)})),this.body.nodes={},this.body.data.nodes){var n=this;Vr(this.nodesListeners,(function(t,e){n.body.data.nodes.on(e,t)}));var o=this.body.data.nodes.getIds();this.add(o,!0)}!1===e&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(t){for(var e,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=[],o=0;o<t.length;o++){e=t[o];var r=this.body.data.nodes.get(e),s=this.create(r);n.push(s),this.body.nodes[e]=s}this.layoutEngine.positionInitially(n),!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(t,e,i){for(var n=this.body.nodes,o=!1,r=0;r<t.length;r++){var s=t[r],a=n[s],h=e[r];void 0!==a?a.setOptions(h)&&(o=!0):(o=!0,a=this.create(h),n[s]=a)}o||void 0===i||(o=ul(e).call(e,(function(t,e){var n=i[e];return n&&n.level!==t.level}))),!0===o?this.body.emitter.emit("_dataChanged"):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(t){for(var e=this.body.nodes,i=0;i<t.length;i++){delete e[t[i]]}this.body.emitter.emit("_dataChanged")}},{key:"create",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:lc;return new e(t,this.body,this.images,this.groups,this.options,this.defaultOptions)}},{key:"refresh",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]&&arguments[0];Vr(this.body.nodes,(function(i,n){var o=t.body.data.nodes.get(n);void 0!==o&&(!0===e&&i.setOptions({x:null,y:null}),i.setOptions({fixed:!1}),i.setOptions(o))}))}},{key:"getPositions",value:function(t){var e={};if(void 0!==t){if(!0===or(t)){for(var i=0;i<t.length;i++)if(void 0!==this.body.nodes[t[i]]){var n=this.body.nodes[t[i]];e[t[i]]={x:Math.round(n.x),y:Math.round(n.y)}}}else if(void 0!==this.body.nodes[t]){var o=this.body.nodes[t];e[t]={x:Math.round(o.x),y:Math.round(o.y)}}}else for(var r=0;r<this.body.nodeIndices.length;r++){var s=this.body.nodes[this.body.nodeIndices[r]];e[this.body.nodeIndices[r]]={x:Math.round(s.x),y:Math.round(s.y)}}return e}},{key:"getPosition",value:function(t){if(null==t)throw new TypeError("No id was specified for getPosition method.");if(null==this.body.nodes[t])throw new ReferenceError("NodeId provided for getPosition does not exist. Provided: ".concat(t));return{x:Math.round(this.body.nodes[t].x),y:Math.round(this.body.nodes[t].y)}}},{key:"storePositions",value:function(){var t,e=[],i=this.body.data.nodes.getDataSet(),n=dc(i.get());try{for(n.s();!(t=n.n()).done;){var o=t.value,r=o.id,s=this.body.nodes[r],a=Math.round(s.x),h=Math.round(s.y);o.x===a&&o.y===h||e.push({id:r,x:a,y:h})}}catch(t){n.e(t)}finally{n.f()}i.update(e)}},{key:"getBoundingBox",value:function(t){if(void 0!==this.body.nodes[t])return this.body.nodes[t].shape.boundingBox}},{key:"getConnectedNodes",value:function(t,e){var i=[];if(void 0!==this.body.nodes[t])for(var n=this.body.nodes[t],o={},r=0;r<n.edges.length;r++){var s=n.edges[r];"to"!==e&&s.toId==n.id?void 0===o[s.fromId]&&(i.push(s.fromId),o[s.fromId]=!0):"from"!==e&&s.fromId==n.id&&void 0===o[s.toId]&&(i.push(s.toId),o[s.toId]=!0)}return i}},{key:"getConnectedEdges",value:function(t){var e=[];if(void 0!==this.body.nodes[t])for(var i=this.body.nodes[t],n=0;n<i.edges.length;n++)e.push(i.edges[n].id);else console.log("NodeId provided for getConnectedEdges does not exist. Provided: ",t);return e}},{key:"moveNode",value:function(t,e,i){var n=this;void 0!==this.body.nodes[t]?(this.body.nodes[t].x=Number(e),this.body.nodes[t].y=Number(i),rl((function(){n.body.emitter.emit("startSimulation")}),0)):console.log("Node id supplied to moveNode does not exist. Provided: ",t)}}]),t}(),fc=wn;U({target:"Reflect",stat:!0},{get:function t(e,i){var n,o,r=arguments.length<3?e:arguments[2];return R(e)===r?e[i]:(n=M.f(e,i))?k(n,"value")?n.value:void 0===n.get?void 0:n.get.call(r):b(o=zt(e))?t(o,i,r):void 0}});var pc=j.Reflect.get;var vc=function(t,e){for(;!Object.prototype.hasOwnProperty.call(t,e)&&null!==(t=ql(t)););return t},gc=o((function(t){function e(i,n,o){return"undefined"!=typeof Reflect&&pc?t.exports=e=pc:t.exports=e=function(t,e,i){var n=vc(t,e);if(n){var o=fc(n,e);return o.get?o.get.call(i):o.value}},e(i,n,o||i)}t.exports=e})),yc=Math.hypot,mc=Math.abs,bc=Math.sqrt,wc=!!yc&&yc(1/0,NaN)!==1/0;U({target:"Math",stat:!0,forced:wc},{hypot:function(t,e){for(var i,n,o=0,r=0,s=arguments.length,a=0;r<s;)a<(i=mc(arguments[r++]))?(o=o*(n=a/i)*n+1,a=i):o+=i>0?(n=i/a)*n:i;return a===1/0?1/0:a*bc(o)}});var _c=j.Math.hypot;function kc(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var xc=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"transform",value:function(t,e){or(t)||(t=[t]);for(var i=e.point.x,n=e.point.y,o=e.angle,r=e.length,s=0;s<t.length;++s){var a=t[s],h=a.x*Math.cos(o)-a.y*Math.sin(o),l=a.x*Math.sin(o)+a.y*Math.cos(o);a.x=i+r*h,a.y=n+r*l}}},{key:"drawPath",value:function(t,e){t.beginPath(),t.moveTo(e[0].x,e[0].y);for(var i=1;i<e.length;++i)t.lineTo(e[i].x,e[i].y);t.closePath()}}]),t}(),Oc=function(t){Vl(i,t);var e=kc(i);function i(){return Kh(this,i),e.apply(this,arguments)}return Qh(i,null,[{key:"draw",value:function(t,e){if(e.image){t.save(),t.translate(e.point.x,e.point.y),t.rotate(Math.PI/2+e.angle);var i=null!=e.imageWidth?e.imageWidth:e.image.width,n=null!=e.imageHeight?e.imageHeight:e.image.height;e.image.drawImageAtPosition(t,1,-i/2,0,i,n),t.restore()}return!1}}]),i}(xc),Sc=function(t){Vl(i,t);var e=kc(i);function i(){return Kh(this,i),e.apply(this,arguments)}return Qh(i,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:0},{x:-1,y:.3},{x:-.9,y:0},{x:-1,y:-.3}];return xc.transform(i,e),xc.drawPath(t,i),!0}}]),i}(xc),Ec=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i=[{x:-1,y:0},{x:0,y:.3},{x:-.4,y:0},{x:0,y:-.3}];return xc.transform(i,e),xc.drawPath(t,i),!0}}]),t}(),Dc=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i={x:-.4,y:0};xc.transform(i,e),t.strokeStyle=t.fillStyle,t.fillStyle="rgba(0, 0, 0, 0)";var n=Math.PI,o=e.angle-n/2,r=e.angle+n/2;return t.beginPath(),t.arc(i.x,i.y,.4*e.length,o,r,!1),t.stroke(),!0}}]),t}(),Mc=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i={x:-.3,y:0};xc.transform(i,e),t.strokeStyle=t.fillStyle,t.fillStyle="rgba(0, 0, 0, 0)";var n=Math.PI,o=e.angle+n/2,r=e.angle+3*n/2;return t.beginPath(),t.arc(i.x,i.y,.4*e.length,o,r,!1),t.stroke(),!0}}]),t}(),Cc=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i=[{x:.02,y:0},{x:-1,y:.3},{x:-1,y:-.3}];return xc.transform(i,e),xc.drawPath(t,i),!0}}]),t}(),Tc=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-1,y:0}];return xc.transform(i,e),xc.drawPath(t,i),!0}}]),t}(),Pc=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i={x:-.4,y:0};return xc.transform(i,e),tt(t,i.x,i.y,.4*e.length),!0}}]),t}(),Nc=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.5},{x:0,y:-.5},{x:-.15,y:-.5},{x:-.15,y:.5}];return xc.transform(i,e),xc.drawPath(t,i),!0}}]),t}(),Ic=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:.3},{x:0,y:-.3},{x:-.6,y:-.3},{x:-.6,y:.3}];return xc.transform(i,e),xc.drawPath(t,i),!0}}]),t}(),Ac=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i=[{x:0,y:0},{x:-.5,y:-.3},{x:-1,y:0},{x:-.5,y:.3}];return xc.transform(i,e),xc.drawPath(t,i),!0}}]),t}(),Fc=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i=[{x:-1,y:.3},{x:-.5,y:0},{x:-1,y:-.3},{x:0,y:0}];return xc.transform(i,e),xc.drawPath(t,i),!0}}]),t}(),jc=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"draw",value:function(t,e){var i;switch(e.type&&(i=e.type.toLowerCase()),i){case"image":return Oc.draw(t,e);case"circle":return Pc.draw(t,e);case"box":return Ic.draw(t,e);case"crow":return Ec.draw(t,e);case"curve":return Dc.draw(t,e);case"diamond":return Ac.draw(t,e);case"inv_curve":return Mc.draw(t,e);case"triangle":return Cc.draw(t,e);case"inv_triangle":return Tc.draw(t,e);case"bar":return Nc.draw(t,e);case"vee":return Fc.draw(t,e);case"arrow":default:return Sc.draw(t,e)}}}]),t}();function zc(t,e){var i=Tn(t);if(kn){var n=kn(t);e&&(n=_o(n).call(n,(function(e){return _n(t,e).enumerable}))),i.push.apply(i,n)}return i}function Bc(t){for(var e=1;e<arguments.length;e++){var i,n=null!=arguments[e]?arguments[e]:{};if(e%2)Jn(i=zc(Object(n),!0)).call(i,(function(e){Dn(t,e,n[e])}));else if(yn)vn(t,yn(n));else{var o;Jn(o=zc(Object(n))).call(o,(function(e){pn(t,e,_n(n,e))}))}}return t}var Rc=function(){function t(e,i,n){Kh(this,t),this._body=i,this._labelModule=n,this.color={},this.colorDirty=!0,this.hoverWidth=1.5,this.selectionWidth=2,this.setOptions(e),this.fromPoint=this.from,this.toPoint=this.to}return Qh(t,[{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to]}},{key:"cleanup",value:function(){return!1}},{key:"setOptions",value:function(t){this.options=t,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.id=this.options.id}},{key:"drawLine",value:function(t,e,i,n){var o=arguments.length>4&&void 0!==arguments[4]?arguments[4]:this.getViaNode();t.strokeStyle=this.getColor(t,e),t.lineWidth=e.width,!1!==e.dashes?this._drawDashedLine(t,e,o):this._drawLine(t,e,o)}},{key:"_drawLine",value:function(t,e,i,n,o){if(this.from!=this.to)this._line(t,e,i,n,o);else{var r=this._getCircleData(t),s=vr(r,3),a=s[0],h=s[1],l=s[2];this._circle(t,e,a,h,l)}}},{key:"_drawDashedLine",value:function(t,e,i,n,o){t.lineCap="round";var r=or(e.dashes)?e.dashes:[5,5];if(void 0!==t.setLineDash){if(t.save(),t.setLineDash(r),t.lineDashOffset=0,this.from!=this.to)this._line(t,e,i);else{var s=this._getCircleData(t),a=vr(s,3),h=a[0],l=a[1],d=a[2];this._circle(t,e,h,l,d)}t.setLineDash([0]),t.lineDashOffset=0,t.restore()}else{if(this.from!=this.to)ot(t,this.from.x,this.from.y,this.to.x,this.to.y,r);else{var u=this._getCircleData(t),c=vr(u,3),f=c[0],p=c[1],v=c[2];this._circle(t,e,f,p,v)}this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}}},{key:"findBorderPosition",value:function(t,e,i){return this.from!=this.to?this._findBorderPosition(t,e,i):this._findBorderPositionCircle(t,e,i)}},{key:"findBorderPositions",value:function(t){if(this.from!=this.to)return{from:this._findBorderPosition(this.from,t),to:this._findBorderPosition(this.to,t)};var e,i=Go(e=this._getCircleData(t)).call(e,0,2),n=vr(i,2),o=n[0],r=n[1];return{from:this._findBorderPositionCircle(this.from,t,{x:o,y:r,low:.25,high:.6,direction:-1}),to:this._findBorderPositionCircle(this.from,t,{x:o,y:r,low:.6,high:.8,direction:1})}}},{key:"_getCircleData",value:function(t){var e=this.options.selfReference.size;void 0!==t&&void 0===this.from.shape.width&&this.from.shape.resize(t);var i=cu.getSelfRefCoordinates(t,this.options.selfReference.angle,e,this.from);return[i.x,i.y,e]}},{key:"_pointOnCircle",value:function(t,e,i,n){var o=2*n*Math.PI;return{x:t+i*Math.cos(o),y:e-i*Math.sin(o)}}},{key:"_findBorderPositionCircle",value:function(t,e,i){var n,o=i.x,r=i.y,s=i.low,a=i.high,h=i.direction,l=this.options.selfReference.size,d=.5*(s+a),u=0;do{d=.5*(s+a),n=this._pointOnCircle(o,r,l,d);var c=Math.atan2(t.y-n.y,t.x-n.x),f=t.distanceToBorder(e,c)-Math.sqrt(Math.pow(n.x-t.x,2)+Math.pow(n.y-t.y,2));if(Math.abs(f)<.05)break;f>0?h>0?s=d:a=d:h>0?a=d:s=d,++u}while(s<=a&&u<10);return Bc(Bc({},n),{},{t:d})}},{key:"getLineWidth",value:function(t,e){return!0===t?Math.max(this.selectionWidth,.3/this._body.view.scale):!0===e?Math.max(this.hoverWidth,.3/this._body.view.scale):Math.max(this.options.width,.3/this._body.view.scale)}},{key:"getColor",value:function(t,e){if(!1!==e.inheritsColor){if("both"===e.inheritsColor&&this.from.id!==this.to.id){var i=t.createLinearGradient(this.from.x,this.from.y,this.to.x,this.to.y),n=this.from.options.color.highlight.border,o=this.to.options.color.highlight.border;return!1===this.from.selected&&!1===this.to.selected?(n=Kr(this.from.options.color.border,e.opacity),o=Kr(this.to.options.color.border,e.opacity)):!0===this.from.selected&&!1===this.to.selected?o=this.to.options.color.border:!1===this.from.selected&&!0===this.to.selected&&(n=this.from.options.color.border),i.addColorStop(0,n),i.addColorStop(1,o),i}return"to"===e.inheritsColor?Kr(this.to.options.color.border,e.opacity):Kr(this.from.options.color.border,e.opacity)}return Kr(e.color,e.opacity)}},{key:"_circle",value:function(t,e,i,n,o){this.enableShadow(t,e);var r=0,s=2*Math.PI;if(!this.options.selfReference.renderBehindTheNode){var a=this.options.selfReference.angle,h=this.options.selfReference.angle+Math.PI,l=this._findBorderPositionCircle(this.from,t,{x:i,y:n,low:a,high:h,direction:-1}),d=this._findBorderPositionCircle(this.from,t,{x:i,y:n,low:a,high:h,direction:1});r=Math.atan2(l.y-n,l.x-i),s=Math.atan2(d.y-n,d.x-i)}t.beginPath(),t.arc(i,n,o,r,s,!1),t.stroke(),this.disableShadow(t,e)}},{key:"getDistanceToEdge",value:function(t,e,i,n,o,r){if(this.from!=this.to)return this._getDistanceToEdge(t,e,i,n,o,r);var s=this._getCircleData(void 0),a=vr(s,3),h=a[0],l=a[1],d=a[2],u=h-o,c=l-r;return Math.abs(Math.sqrt(u*u+c*c)-d)}},{key:"_getDistanceToLine",value:function(t,e,i,n,o,r){var s=i-t,a=n-e,h=((o-t)*s+(r-e)*a)/(s*s+a*a);h>1?h=1:h<0&&(h=0);var l=t+h*s-o,d=e+h*a-r;return Math.sqrt(l*l+d*d)}},{key:"getArrowData",value:function(t,e,i,n,o,r){var s,a,h,l,d,u,c,f=r.width;"from"===e?(h=this.from,l=this.to,d=r.fromArrowScale<0,u=Math.abs(r.fromArrowScale),c=r.fromArrowType):"to"===e?(h=this.to,l=this.from,d=r.toArrowScale<0,u=Math.abs(r.toArrowScale),c=r.toArrowType):(h=this.to,l=this.from,d=r.middleArrowScale<0,u=Math.abs(r.middleArrowScale),c=r.middleArrowType);var p=15*u+3*f;if(h!=l){var v=p/_c(h.x-l.x,h.y-l.y);if("middle"!==e)if(!0===this.options.smooth.enabled){var g=this._findBorderPosition(h,t,{via:i}),y=this.getPoint(g.t+v*("from"===e?1:-1),i);s=Math.atan2(g.y-y.y,g.x-y.x),a=g}else s=Math.atan2(h.y-l.y,h.x-l.x),a=this._findBorderPosition(h,t);else{var m=(d?-v:v)/2,b=this.getPoint(.5+m,i),w=this.getPoint(.5-m,i);s=Math.atan2(b.y-w.y,b.x-w.x),a=this.getPoint(.5,i)}}else{var _=this._getCircleData(t),k=vr(_,3),x=k[0],O=k[1],S=k[2];if("from"===e){var E=this.options.selfReference.angle,D=this.options.selfReference.angle+Math.PI,M=this._findBorderPositionCircle(this.from,t,{x:x,y:O,low:E,high:D,direction:-1});s=-2*M.t*Math.PI+1.5*Math.PI+.1*Math.PI,a=M}else if("to"===e){var C=this.options.selfReference.angle,T=this.options.selfReference.angle+Math.PI,P=this._findBorderPositionCircle(this.from,t,{x:x,y:O,low:C,high:T,direction:1});s=-2*P.t*Math.PI+1.5*Math.PI-1.1*Math.PI,a=P}else{var N=this.options.selfReference.angle/(2*Math.PI);a=this._pointOnCircle(x,O,S,N),s=-2*N*Math.PI+1.5*Math.PI+.1*Math.PI}}return{point:a,core:{x:a.x-.9*p*Math.cos(s),y:a.y-.9*p*Math.sin(s)},angle:s,length:p,type:c}}},{key:"drawArrowHead",value:function(t,e,i,n,o){t.strokeStyle=this.getColor(t,e),t.fillStyle=t.strokeStyle,t.lineWidth=e.width,jc.draw(t,o)&&(this.enableShadow(t,e),_u(t).call(t),this.disableShadow(t,e))}},{key:"enableShadow",value:function(t,e){!0===e.shadow&&(t.shadowColor=e.shadowColor,t.shadowBlur=e.shadowSize,t.shadowOffsetX=e.shadowX,t.shadowOffsetY=e.shadowY)}},{key:"disableShadow",value:function(t,e){!0===e.shadow&&(t.shadowColor="rgba(0,0,0,0)",t.shadowBlur=0,t.shadowOffsetX=0,t.shadowOffsetY=0)}},{key:"drawBackground",value:function(t,e){if(!1!==e.background){var i={strokeStyle:t.strokeStyle,lineWidth:t.lineWidth,dashes:t.dashes};t.strokeStyle=e.backgroundColor,t.lineWidth=e.backgroundSize,this.setStrokeDashed(t,e.backgroundDashes),t.stroke(),t.strokeStyle=i.strokeStyle,t.lineWidth=i.lineWidth,t.dashes=i.dashes,this.setStrokeDashed(t,e.dashes)}}},{key:"setStrokeDashed",value:function(t,e){if(!1!==e)if(void 0!==t.setLineDash){var i=or(e)?e:[5,5];t.setLineDash(i)}else console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.");else void 0!==t.setLineDash?t.setLineDash([]):console.warn("setLineDash is not supported in this browser. The dashed stroke cannot be used.")}}]),t}();function Lc(t,e){var i=Tn(t);if(kn){var n=kn(t);e&&(n=_o(n).call(n,(function(e){return _n(t,e).enumerable}))),i.push.apply(i,n)}return i}function Hc(t){for(var e=1;e<arguments.length;e++){var i,n=null!=arguments[e]?arguments[e]:{};if(e%2)Jn(i=Lc(Object(n),!0)).call(i,(function(e){Dn(t,e,n[e])}));else if(yn)vn(t,yn(n));else{var o;Jn(o=Lc(Object(n))).call(o,(function(e){pn(t,e,_n(n,e))}))}}return t}function Wc(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Yc=function(t){Vl(i,t);var e=Wc(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"_findBorderPositionBezier",value:function(t,e){var i,n,o=arguments.length>2&&void 0!==arguments[2]?arguments[2]:this._getViaCoordinates(),r=10,s=.2,a=!1,h=1,l=0,d=this.to;t.id===this.from.id&&(d=this.from,a=!0);var u=0;do{n=.5*(l+h),i=this.getPoint(n,o);var c=Math.atan2(d.y-i.y,d.x-i.x),f=d.distanceToBorder(e,c),p=Math.sqrt(Math.pow(i.x-d.x,2)+Math.pow(i.y-d.y,2)),v=f-p;if(Math.abs(v)<s)break;v<0?!1===a?l=n:h=n:!1===a?h=n:l=n,++u}while(l<=h&&u<r);return Hc(Hc({},i),{},{t:n})}},{key:"_getDistanceToBezierEdge",value:function(t,e,i,n,o,r,s){var a,h,l,d,u,c=1e9,f=t,p=e;for(h=1;h<10;h++)l=.1*h,d=Math.pow(1-l,2)*t+2*l*(1-l)*s.x+Math.pow(l,2)*i,u=Math.pow(1-l,2)*e+2*l*(1-l)*s.y+Math.pow(l,2)*n,h>0&&(c=(a=this._getDistanceToLine(f,p,d,u,o,r))<c?a:c),f=d,p=u;return c}},{key:"_bezierCurve",value:function(t,e,i,n){t.beginPath(),t.moveTo(this.fromPoint.x,this.fromPoint.y),null!=i&&null!=i.x?null!=n&&null!=n.x?t.bezierCurveTo(i.x,i.y,n.x,n.y,this.toPoint.x,this.toPoint.y):t.quadraticCurveTo(i.x,i.y,this.toPoint.x,this.toPoint.y):t.lineTo(this.toPoint.x,this.toPoint.y),this.drawBackground(t,e),this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}}]),i}(Rc);function Vc(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Uc=function(t){Vl(i,t);var e=Vc(i);function i(t,n,o){var r;return Kh(this,i),(r=e.call(this,t,n,o)).via=r.via,r._boundFunction=function(){r.positionBezierNode()},r._body.emitter.on("_repositionBezierNodes",r._boundFunction),r}return Qh(i,[{key:"setOptions",value:function(t){gc(ql(i.prototype),"setOptions",this).call(this,t);var e=!1;this.options.physics!==t.physics&&(e=!0),this.options=t,this.id=this.options.id,this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],this.setupSupportNode(),this.connect(),!0===e&&(this.via.setOptions({physics:this.options.physics}),this.positionBezierNode())}},{key:"connect",value:function(){this.from=this._body.nodes[this.options.from],this.to=this._body.nodes[this.options.to],void 0===this.from||void 0===this.to||!1===this.options.physics||this.from.id===this.to.id?this.via.setOptions({physics:!1}):this.via.setOptions({physics:!0})}},{key:"cleanup",value:function(){return this._body.emitter.off("_repositionBezierNodes",this._boundFunction),void 0!==this.via&&(delete this._body.nodes[this.via.id],this.via=void 0,!0)}},{key:"setupSupportNode",value:function(){if(void 0===this.via){var t="edgeId:"+this.id,e=this._body.functions.createNode({id:t,shape:"circle",physics:!0,hidden:!0});this._body.nodes[t]=e,this.via=e,this.via.parentEdgeId=this.id,this.positionBezierNode()}}},{key:"positionBezierNode",value:function(){void 0!==this.via&&void 0!==this.from&&void 0!==this.to?(this.via.x=.5*(this.from.x+this.to.x),this.via.y=.5*(this.from.y+this.to.y)):void 0!==this.via&&(this.via.x=0,this.via.y=0)}},{key:"_line",value:function(t,e,i){this._bezierCurve(t,e,i)}},{key:"_getViaCoordinates",value:function(){return this.via}},{key:"getViaNode",value:function(){return this.via}},{key:"getPoint",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.via;if(this.from===this.to){var i=this._getCircleData(),n=vr(i,3),o=n[0],r=n[1],s=n[2],a=2*Math.PI*(1-t);return{x:o+s*Math.sin(a),y:r+s-s*(1-Math.cos(a))}}return{x:Math.pow(1-t,2)*this.fromPoint.x+2*t*(1-t)*e.x+Math.pow(t,2)*this.toPoint.x,y:Math.pow(1-t,2)*this.fromPoint.y+2*t*(1-t)*e.y+Math.pow(t,2)*this.toPoint.y}}},{key:"_findBorderPosition",value:function(t,e){return this._findBorderPositionBezier(t,e,this.via)}},{key:"_getDistanceToEdge",value:function(t,e,i,n,o,r){return this._getDistanceToBezierEdge(t,e,i,n,o,r,this.via)}}]),i}(Yc);function Gc(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var qc=function(t){Vl(i,t);var e=Gc(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"_line",value:function(t,e,i){this._bezierCurve(t,e,i)}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_getViaCoordinates",value:function(){var t,e,i=this.options.smooth.roundness,n=this.options.smooth.type,o=Math.abs(this.from.x-this.to.x),r=Math.abs(this.from.y-this.to.y);if("discrete"===n||"diagonalCross"===n){var s,a;s=a=o<=r?i*r:i*o,this.from.x>this.to.x&&(s=-s),this.from.y>=this.to.y&&(a=-a);var h=this.from.x+s,l=this.from.y+a;return"discrete"===n&&(o<=r?h=o<i*r?this.from.x:h:l=r<i*o?this.from.y:l),{x:h,y:l}}if("straightCross"===n){var d=(1-i)*o,u=(1-i)*r;return o<=r?(d=0,this.from.y<this.to.y&&(u=-u)):(this.from.x<this.to.x&&(d=-d),u=0),{x:this.to.x+d,y:this.to.y+u}}if("horizontal"===n){var c=(1-i)*o;return this.from.x<this.to.x&&(c=-c),{x:this.to.x+c,y:this.from.y}}if("vertical"===n){var f=(1-i)*r;return this.from.y<this.to.y&&(f=-f),{x:this.from.x,y:this.to.y+f}}if("curvedCW"===n){o=this.to.x-this.from.x,r=this.from.y-this.to.y;var p=Math.sqrt(o*o+r*r),v=Math.PI,g=(Math.atan2(r,o)+(.5*i+.5)*v)%(2*v);return{x:this.from.x+(.5*i+.5)*p*Math.sin(g),y:this.from.y+(.5*i+.5)*p*Math.cos(g)}}if("curvedCCW"===n){o=this.to.x-this.from.x,r=this.from.y-this.to.y;var y=Math.sqrt(o*o+r*r),m=Math.PI,b=(Math.atan2(r,o)+(.5*-i+.5)*m)%(2*m);return{x:this.from.x+(.5*i+.5)*y*Math.sin(b),y:this.from.y+(.5*i+.5)*y*Math.cos(b)}}t=e=o<=r?i*r:i*o,this.from.x>this.to.x&&(t=-t),this.from.y>=this.to.y&&(e=-e);var w=this.from.x+t,_=this.from.y+e;return o<=r?w=this.from.x<=this.to.x?this.to.x<w?this.to.x:w:this.to.x>w?this.to.x:w:_=this.from.y>=this.to.y?this.to.y>_?this.to.y:_:this.to.y<_?this.to.y:_,{x:w,y:_}}},{key:"_findBorderPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{};return this._findBorderPositionBezier(t,e,i.via)}},{key:"_getDistanceToEdge",value:function(t,e,i,n,o,r){var s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates();return this._getDistanceToBezierEdge(t,e,i,n,o,r,s)}},{key:"getPoint",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),i=t,n=Math.pow(1-i,2)*this.fromPoint.x+2*i*(1-i)*e.x+Math.pow(i,2)*this.toPoint.x,o=Math.pow(1-i,2)*this.fromPoint.y+2*i*(1-i)*e.y+Math.pow(i,2)*this.toPoint.y;return{x:n,y:o}}}]),i}(Yc);function Xc(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}function $c(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Kc=function(t){Vl(i,t);var e=$c(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"_line",value:function(t,e,i){var n=i[0],o=i[1];this._bezierCurve(t,e,n,o)}},{key:"_getViaCoordinates",value:function(){var t,e,i,n,o=this.from.x-this.to.x,r=this.from.y-this.to.y,s=this.options.smooth.roundness;return(Math.abs(o)>Math.abs(r)||!0===this.options.smooth.forceDirection||"horizontal"===this.options.smooth.forceDirection)&&"vertical"!==this.options.smooth.forceDirection?(e=this.from.y,n=this.to.y,t=this.from.x-s*o,i=this.to.x+s*o):(e=this.from.y-s*r,n=this.to.y+s*r,t=this.from.x,i=this.to.x),[{x:t,y:e},{x:i,y:n}]}},{key:"getViaNode",value:function(){return this._getViaCoordinates()}},{key:"_findBorderPosition",value:function(t,e){return this._findBorderPositionBezier(t,e)}},{key:"_getDistanceToEdge",value:function(t,e,i,n,o,r){var s=arguments.length>6&&void 0!==arguments[6]?arguments[6]:this._getViaCoordinates(),a=vr(s,2),h=a[0],l=a[1];return this._getDistanceToBezierEdge2(t,e,i,n,o,r,h,l)}},{key:"getPoint",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this._getViaCoordinates(),i=vr(e,2),n=i[0],o=i[1],r=t,s=[Math.pow(1-r,3),3*r*Math.pow(1-r,2),3*Math.pow(r,2)*(1-r),Math.pow(r,3)],a=s[0]*this.fromPoint.x+s[1]*n.x+s[2]*o.x+s[3]*this.toPoint.x,h=s[0]*this.fromPoint.y+s[1]*n.y+s[2]*o.y+s[3]*this.toPoint.y;return{x:a,y:h}}}]),i}(function(t){Vl(i,t);var e=Xc(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"_getDistanceToBezierEdge2",value:function(t,e,i,n,o,r,s,a){for(var h=1e9,l=t,d=e,u=[0,0,0,0],c=1;c<10;c++){var f=.1*c;u[0]=Math.pow(1-f,3),u[1]=3*f*Math.pow(1-f,2),u[2]=3*Math.pow(f,2)*(1-f),u[3]=Math.pow(f,3);var p=u[0]*t+u[1]*s.x+u[2]*a.x+u[3]*i,v=u[0]*e+u[1]*s.y+u[2]*a.y+u[3]*n;if(c>0){var g=this._getDistanceToLine(l,d,p,v,o,r);h=g<h?g:h}l=p,d=v}return h}}]),i}(Yc));function Zc(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Qc=function(t){Vl(i,t);var e=Zc(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"_line",value:function(t,e){t.beginPath(),t.moveTo(this.fromPoint.x,this.fromPoint.y),t.lineTo(this.toPoint.x,this.toPoint.y),this.enableShadow(t,e),t.stroke(),this.disableShadow(t,e)}},{key:"getViaNode",value:function(){}},{key:"getPoint",value:function(t){return{x:(1-t)*this.fromPoint.x+t*this.toPoint.x,y:(1-t)*this.fromPoint.y+t*this.toPoint.y}}},{key:"_findBorderPosition",value:function(t,e){var i=this.to,n=this.from;t.id===this.from.id&&(i=this.from,n=this.to);var o=Math.atan2(i.y-n.y,i.x-n.x),r=i.x-n.x,s=i.y-n.y,a=Math.sqrt(r*r+s*s),h=(a-t.distanceToBorder(e,o))/a;return{x:(1-h)*n.x+h*i.x,y:(1-h)*n.y+h*i.y,t:0}}},{key:"_getDistanceToEdge",value:function(t,e,i,n,o,r){return this._getDistanceToLine(t,e,i,n,o,r)}}]),i}(Rc),Jc=function(){function t(e,i,n,o,r){if(Kh(this,t),void 0===i)throw new Error("No body provided");this.options=hs(o),this.globalOptions=o,this.defaultOptions=r,this.body=i,this.imagelist=n,this.id=void 0,this.fromId=void 0,this.toId=void 0,this.selected=!1,this.hover=!1,this.labelDirty=!0,this.baseWidth=this.options.width,this.baseFontSize=this.options.font.size,this.from=void 0,this.to=void 0,this.edgeType=void 0,this.connected=!1,this.labelModule=new mu(this.body,this.options,!0),this.setOptions(e)}return Qh(t,[{key:"setOptions",value:function(e){if(e){var i=void 0!==e.physics&&this.options.physics!==e.physics||void 0!==e.hidden&&(this.options.hidden||!1)!==(e.hidden||!1)||void 0!==e.from&&this.options.from!==e.from||void 0!==e.to&&this.options.to!==e.to;t.parseOptions(this.options,e,!0,this.globalOptions),void 0!==e.id&&(this.id=e.id),void 0!==e.from&&(this.fromId=e.from),void 0!==e.to&&(this.toId=e.to),void 0!==e.title&&(this.title=e.title),void 0!==e.value&&(e.value=uu(e.value));var n=[e,this.options,this.defaultOptions];return this.chooser=cu.choosify("edge",n),this.updateLabelModule(e),i=this.updateEdgeType()||i,this._setInteractionWidths(),this.connect(),i}}},{key:"getFormattingValues",value:function(){var t=!0===this.options.arrows.to||!0===this.options.arrows.to.enabled,e=!0===this.options.arrows.from||!0===this.options.arrows.from.enabled,i=!0===this.options.arrows.middle||!0===this.options.arrows.middle.enabled,n=this.options.color.inherit,o={toArrow:t,toArrowScale:this.options.arrows.to.scaleFactor,toArrowType:this.options.arrows.to.type,toArrowSrc:this.options.arrows.to.src,toArrowImageWidth:this.options.arrows.to.imageWidth,toArrowImageHeight:this.options.arrows.to.imageHeight,middleArrow:i,middleArrowScale:this.options.arrows.middle.scaleFactor,middleArrowType:this.options.arrows.middle.type,middleArrowSrc:this.options.arrows.middle.src,middleArrowImageWidth:this.options.arrows.middle.imageWidth,middleArrowImageHeight:this.options.arrows.middle.imageHeight,fromArrow:e,fromArrowScale:this.options.arrows.from.scaleFactor,fromArrowType:this.options.arrows.from.type,fromArrowSrc:this.options.arrows.from.src,fromArrowImageWidth:this.options.arrows.from.imageWidth,fromArrowImageHeight:this.options.arrows.from.imageHeight,arrowStrikethrough:this.options.arrowStrikethrough,color:n?void 0:this.options.color.color,inheritsColor:n,opacity:this.options.color.opacity,hidden:this.options.hidden,length:this.options.length,shadow:this.options.shadow.enabled,shadowColor:this.options.shadow.color,shadowSize:this.options.shadow.size,shadowX:this.options.shadow.x,shadowY:this.options.shadow.y,dashes:this.options.dashes,width:this.options.width,background:this.options.background.enabled,backgroundColor:this.options.background.color,backgroundSize:this.options.background.size,backgroundDashes:this.options.background.dashes};if(this.selected||this.hover)if(!0===this.chooser){if(this.selected){var r=this.options.selectionWidth;"function"==typeof r?o.width=r(o.width):"number"==typeof r&&(o.width+=r),o.width=Math.max(o.width,.3/this.body.view.scale),o.color=this.options.color.highlight,o.shadow=this.options.shadow.enabled}else if(this.hover){var s=this.options.hoverWidth;"function"==typeof s?o.width=s(o.width):"number"==typeof s&&(o.width+=s),o.width=Math.max(o.width,.3/this.body.view.scale),o.color=this.options.color.hover,o.shadow=this.options.shadow.enabled}}else"function"==typeof this.chooser&&(this.chooser(o,this.options.id,this.selected,this.hover),void 0!==o.color&&(o.inheritsColor=!1),!1===o.shadow&&(o.shadowColor===this.options.shadow.color&&o.shadowSize===this.options.shadow.size&&o.shadowX===this.options.shadow.x&&o.shadowY===this.options.shadow.y||(o.shadow=!0)));else o.shadow=this.options.shadow.enabled,o.width=Math.max(o.width,.3/this.body.view.scale);return o}},{key:"updateLabelModule",value:function(t){var e=[t,this.options,this.globalOptions,this.defaultOptions];this.labelModule.update(this.options,e),void 0!==this.labelModule.baseSize&&(this.baseFontSize=this.labelModule.baseSize)}},{key:"updateEdgeType",value:function(){var t=this.options.smooth,e=!1,i=!0;return void 0!==this.edgeType&&((this.edgeType instanceof Uc&&!0===t.enabled&&"dynamic"===t.type||this.edgeType instanceof Kc&&!0===t.enabled&&"cubicBezier"===t.type||this.edgeType instanceof qc&&!0===t.enabled&&"dynamic"!==t.type&&"cubicBezier"!==t.type||this.edgeType instanceof Qc&&!1===t.type.enabled)&&(i=!1),!0===i&&(e=this.cleanup())),!0===i?!0===t.enabled?"dynamic"===t.type?(e=!0,this.edgeType=new Uc(this.options,this.body,this.labelModule)):"cubicBezier"===t.type?this.edgeType=new Kc(this.options,this.body,this.labelModule):this.edgeType=new qc(this.options,this.body,this.labelModule):this.edgeType=new Qc(this.options,this.body,this.labelModule):this.edgeType.setOptions(this.options),e}},{key:"connect",value:function(){this.disconnect(),this.from=this.body.nodes[this.fromId]||void 0,this.to=this.body.nodes[this.toId]||void 0,this.connected=void 0!==this.from&&void 0!==this.to,!0===this.connected?(this.from.attachEdge(this),this.to.attachEdge(this)):(this.from&&this.from.detachEdge(this),this.to&&this.to.detachEdge(this)),this.edgeType.connect()}},{key:"disconnect",value:function(){this.from&&(this.from.detachEdge(this),this.from=void 0),this.to&&(this.to.detachEdge(this),this.to=void 0),this.connected=!1}},{key:"getTitle",value:function(){return this.title}},{key:"isSelected",value:function(){return this.selected}},{key:"getValue",value:function(){return this.options.value}},{key:"setValueRange",value:function(t,e,i){if(void 0!==this.options.value){var n=this.options.scaling.customScalingFunction(t,e,i,this.options.value),o=this.options.scaling.max-this.options.scaling.min;if(!0===this.options.scaling.label.enabled){var r=this.options.scaling.label.max-this.options.scaling.label.min;this.options.font.size=this.options.scaling.label.min+n*r}this.options.width=this.options.scaling.min+n*o}else this.options.width=this.baseWidth,this.options.font.size=this.baseFontSize;this._setInteractionWidths(),this.updateLabelModule()}},{key:"_setInteractionWidths",value:function(){"function"==typeof this.options.hoverWidth?this.edgeType.hoverWidth=this.options.hoverWidth(this.options.width):this.edgeType.hoverWidth=this.options.hoverWidth+this.options.width,"function"==typeof this.options.selectionWidth?this.edgeType.selectionWidth=this.options.selectionWidth(this.options.width):this.edgeType.selectionWidth=this.options.selectionWidth+this.options.width}},{key:"draw",value:function(t){var e=this.getFormattingValues();if(!e.hidden){var i=this.edgeType.getViaNode(),n={};this.edgeType.fromPoint=this.edgeType.from,this.edgeType.toPoint=this.edgeType.to,e.fromArrow&&(n.from=this.edgeType.getArrowData(t,"from",i,this.selected,this.hover,e),!1===e.arrowStrikethrough&&(this.edgeType.fromPoint=n.from.core),e.fromArrowSrc&&(n.from.image=this.imagelist.load(e.fromArrowSrc)),e.fromArrowImageWidth&&(n.from.imageWidth=e.fromArrowImageWidth),e.fromArrowImageHeight&&(n.from.imageHeight=e.fromArrowImageHeight)),e.toArrow&&(n.to=this.edgeType.getArrowData(t,"to",i,this.selected,this.hover,e),!1===e.arrowStrikethrough&&(this.edgeType.toPoint=n.to.core),e.toArrowSrc&&(n.to.image=this.imagelist.load(e.toArrowSrc)),e.toArrowImageWidth&&(n.to.imageWidth=e.toArrowImageWidth),e.toArrowImageHeight&&(n.to.imageHeight=e.toArrowImageHeight)),e.middleArrow&&(n.middle=this.edgeType.getArrowData(t,"middle",i,this.selected,this.hover,e),e.middleArrowSrc&&(n.middle.image=this.imagelist.load(e.middleArrowSrc)),e.middleArrowImageWidth&&(n.middle.imageWidth=e.middleArrowImageWidth),e.middleArrowImageHeight&&(n.middle.imageHeight=e.middleArrowImageHeight)),this.edgeType.drawLine(t,e,this.selected,this.hover,i),this.drawArrows(t,n,e),this.drawLabel(t,i)}}},{key:"drawArrows",value:function(t,e,i){i.fromArrow&&this.edgeType.drawArrowHead(t,i,this.selected,this.hover,e.from),i.middleArrow&&this.edgeType.drawArrowHead(t,i,this.selected,this.hover,e.middle),i.toArrow&&this.edgeType.drawArrowHead(t,i,this.selected,this.hover,e.to)}},{key:"drawLabel",value:function(t,e){if(void 0!==this.options.label){var i=this.from,n=this.to;if(this.labelModule.differentState(this.selected,this.hover)&&this.labelModule.getTextSize(t,this.selected,this.hover),i.id!=n.id){this.labelModule.pointToSelf=!1;var o=this.edgeType.getPoint(.5,e);t.save();var r=this._getRotation(t);0!=r.angle&&(t.translate(r.x,r.y),t.rotate(r.angle)),this.labelModule.draw(t,o.x,o.y,this.selected,this.hover),t.restore()}else{this.labelModule.pointToSelf=!0;var s=cu.getSelfRefCoordinates(t,this.options.selfReference.angle,this.options.selfReference.size,i);o=this._pointOnCircle(s.x,s.y,this.options.selfReference.size,this.options.selfReference.angle),this.labelModule.draw(t,o.x,o.y,this.selected,this.hover)}}}},{key:"getItemsOnPoint",value:function(t){var e=[];if(this.labelModule.visible()){var i=this._getRotation();cu.pointInRect(this.labelModule.getSize(),t,i)&&e.push({edgeId:this.id,labelId:0})}var n={left:t.x,top:t.y};return this.isOverlappingWith(n)&&e.push({edgeId:this.id}),e}},{key:"isOverlappingWith",value:function(t){if(this.connected){var e=this.from.x,i=this.from.y,n=this.to.x,o=this.to.y,r=t.left,s=t.top;return this.edgeType.getDistanceToEdge(e,i,n,o,r,s)<10}return!1}},{key:"_getRotation",value:function(t){var e=this.edgeType.getViaNode(),i=this.edgeType.getPoint(.5,e);void 0!==t&&this.labelModule.calculateLabelSize(t,this.selected,this.hover,i.x,i.y);var n={x:i.x,y:this.labelModule.size.yLine,angle:0};if(!this.labelModule.visible())return n;if("horizontal"===this.options.font.align)return n;var o=this.from.y-this.to.y,r=this.from.x-this.to.x,s=Math.atan2(o,r);return(s<-1&&r<0||s>0&&r<0)&&(s+=Math.PI),n.angle=s,n}},{key:"_pointOnCircle",value:function(t,e,i,n){return{x:t+i*Math.cos(n),y:e-i*Math.sin(n)}}},{key:"select",value:function(){this.selected=!0}},{key:"unselect",value:function(){this.selected=!1}},{key:"cleanup",value:function(){return this.edgeType.cleanup()}},{key:"remove",value:function(){this.cleanup(),this.disconnect(),delete this.body.edges[this.id]}},{key:"endPointsValid",value:function(){return void 0!==this.body.nodes[this.fromId]&&void 0!==this.body.nodes[this.toId]}}],[{key:"parseOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:{},o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],r=["arrowStrikethrough","id","from","hidden","hoverWidth","labelHighlightBold","length","line","opacity","physics","scaling","selectionWidth","selfReferenceSize","selfReference","to","title","value","width","font","chosen","widthConstraint"];if(jr(r,t,e,i),cu.isValidLabel(e.label)?t.label=e.label:cu.isValidLabel(t.label)||(t.label=void 0),ls(t,e,"smooth",n),ls(t,e,"shadow",n),ls(t,e,"background",n),void 0!==e.dashes&&null!==e.dashes?t.dashes=e.dashes:!0===i&&null===e.dashes&&(t.dashes=Sn(n.dashes)),void 0!==e.scaling&&null!==e.scaling?(void 0!==e.scaling.min&&(t.scaling.min=e.scaling.min),void 0!==e.scaling.max&&(t.scaling.max=e.scaling.max),ls(t.scaling,e.scaling,"label",n.scaling)):!0===i&&null===e.scaling&&(t.scaling=Sn(n.scaling)),void 0!==e.arrows&&null!==e.arrows)if("string"==typeof e.arrows){var s=e.arrows.toLowerCase();t.arrows.to.enabled=-1!=nr(s).call(s,"to"),t.arrows.middle.enabled=-1!=nr(s).call(s,"middle"),t.arrows.from.enabled=-1!=nr(s).call(s,"from")}else{if("object"!==ur(e.arrows))throw new Error("The arrow newOptions can only be an object or a string. Refer to the documentation. You used:"+Nl(e.arrows));ls(t.arrows,e.arrows,"to",n.arrows),ls(t.arrows,e.arrows,"middle",n.arrows),ls(t.arrows,e.arrows,"from",n.arrows)}else!0===i&&null===e.arrows&&(t.arrows=Sn(n.arrows));if(void 0!==e.color&&null!==e.color){var a=Pr(e.color)?{color:e.color,highlight:e.color,hover:e.color,inherit:!1,opacity:1}:e.color,h=t.color;if(o)Br(h,n.color,!1,i);else for(var l in h)h.hasOwnProperty(l)&&delete h[l];if(Pr(h))h.color=h,h.highlight=h,h.hover=h,h.inherit=!1,void 0===a.opacity&&(h.opacity=1);else{var d=!1;void 0!==a.color&&(h.color=a.color,d=!0),void 0!==a.highlight&&(h.highlight=a.highlight,d=!0),void 0!==a.hover&&(h.hover=a.hover,d=!0),void 0!==a.inherit&&(h.inherit=a.inherit),void 0!==a.opacity&&(h.opacity=Math.min(1,Math.max(0,a.opacity))),!0===d?h.inherit=!1:void 0===h.inherit&&(h.inherit="from")}}else!0===i&&null===e.color&&(t.color=hs(n.color));!0===i&&null===e.font&&(t.font=hs(n.font)),e.hasOwnProperty("selfReferenceSize")&&(console.log("The selfReferenceSize property has been deprecated. Please use selfReference property instead. The selfReference can be set like thise selfReference:{size:30, angle:Math.PI / 4}"),t.selfReference.size=e.selfReferenceSize)}}]),t}(),tf=function(){function t(e,i,n){var o,r=this;Kh(this,t),this.body=e,this.images=i,this.groups=n,this.body.functions.createEdge=J(o=this.create).call(o,this),this.edgesListeners={add:function(t,e){r.add(e.items)},update:function(t,e){r.update(e.items)},remove:function(t,e){r.remove(e.items)}},this.options={},this.defaultOptions={arrows:{to:{enabled:!1,scaleFactor:1,type:"arrow"},middle:{enabled:!1,scaleFactor:1,type:"arrow"},from:{enabled:!1,scaleFactor:1,type:"arrow"}},arrowStrikethrough:!0,color:{color:"#848484",highlight:"#848484",hover:"#848484",inherit:"from",opacity:1},dashes:!1,font:{color:"#343434",size:14,face:"arial",background:"none",strokeWidth:2,strokeColor:"#ffffff",align:"horizontal",multi:!1,vadjust:0,bold:{mod:"bold"},boldital:{mod:"bold italic"},ital:{mod:"italic"},mono:{mod:"",size:15,face:"courier new",vadjust:2}},hidden:!1,hoverWidth:1.5,label:void 0,labelHighlightBold:!0,length:void 0,physics:!0,scaling:{min:1,max:15,label:{enabled:!0,min:14,max:30,maxVisible:30,drawThreshold:5},customScalingFunction:function(t,e,i,n){if(e===t)return.5;var o=1/(e-t);return Math.max(0,(n-t)*o)}},selectionWidth:1.5,selfReference:{size:20,angle:Math.PI/4,renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:10,x:5,y:5},background:{enabled:!1,color:"rgba(111,111,111,1)",size:10,dashes:!1},smooth:{enabled:!0,type:"dynamic",forceDirection:"none",roundness:.5},title:void 0,width:1,value:void 0},Br(this.options,this.defaultOptions),this.bindEventListeners()}return Qh(t,[{key:"bindEventListeners",value:function(){var t,e,i=this;this.body.emitter.on("_forceDisableDynamicCurves",(function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];"dynamic"===t&&(t="continuous");var n=!1;for(var o in i.body.edges)if(i.body.edges.hasOwnProperty(o)){var r=i.body.edges[o],s=i.body.data.edges.get(o);if(null!=s){var a=s.smooth;void 0!==a&&!0===a.enabled&&"dynamic"===a.type&&(void 0===t?r.setOptions({smooth:!1}):r.setOptions({smooth:{type:t}}),n=!0)}}!0===e&&!0===n&&i.body.emitter.emit("_dataChanged")})),this.body.emitter.on("_dataUpdated",(function(){i.reconnectEdges()})),this.body.emitter.on("refreshEdges",J(t=this.refresh).call(t,this)),this.body.emitter.on("refresh",J(e=this.refresh).call(e,this)),this.body.emitter.on("destroy",(function(){Vr(i.edgesListeners,(function(t,e){i.body.data.edges&&i.body.data.edges.off(e,t)})),delete i.body.functions.createEdge,delete i.edgesListeners.add,delete i.edgesListeners.update,delete i.edgesListeners.remove,delete i.edgesListeners}))}},{key:"setOptions",value:function(t){if(void 0!==t){Jc.parseOptions(this.options,t,!0,this.defaultOptions,!0);var e=!1;if(void 0!==t.smooth)for(var i in this.body.edges)this.body.edges.hasOwnProperty(i)&&(e=this.body.edges[i].updateEdgeType()||e);if(void 0!==t.font)for(var n in this.body.edges)this.body.edges.hasOwnProperty(n)&&this.body.edges[n].updateLabelModule();void 0===t.hidden&&void 0===t.physics&&!0!==e||this.body.emitter.emit("_dataChanged")}}},{key:"setData",value:function(t){var e=this,i=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=this.body.data.edges;if(t instanceof eu||t instanceof iu)this.body.data.edges=t;else if(or(t))this.body.data.edges=new eu,this.body.data.edges.add(t);else{if(t)throw new TypeError("Array or DataSet expected");this.body.data.edges=new eu}if(n&&Vr(this.edgesListeners,(function(t,e){n.off(e,t)})),this.body.edges={},this.body.data.edges){Vr(this.edgesListeners,(function(t,i){e.body.data.edges.on(i,t)}));var o=this.body.data.edges.getIds();this.add(o,!0)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===i&&this.body.emitter.emit("_dataChanged")}},{key:"add",value:function(t){for(var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=this.body.edges,n=this.body.data.edges,o=0;o<t.length;o++){var r=t[o],s=i[r];s&&s.disconnect();var a=n.get(r,{showInternalIds:!0});i[r]=this.create(a)}this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),!1===e&&this.body.emitter.emit("_dataChanged")}},{key:"update",value:function(t){for(var e=this.body.edges,i=this.body.data.edges,n=!1,o=0;o<t.length;o++){var r=t[o],s=i.get(r),a=e[r];void 0!==a?(a.disconnect(),n=a.setOptions(s)||n,a.connect()):(this.body.edges[r]=this.create(s),n=!0)}!0===n?(this.body.emitter.emit("_adjustEdgesForHierarchicalLayout"),this.body.emitter.emit("_dataChanged")):this.body.emitter.emit("_dataUpdated")}},{key:"remove",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(0!==t.length){var i=this.body.edges;Vr(t,(function(t){var e=i[t];void 0!==e&&e.remove()})),e&&this.body.emitter.emit("_dataChanged")}}},{key:"refresh",value:function(){var t=this;Vr(this.body.edges,(function(e,i){var n=t.body.data.edges.get(i);void 0!==n&&e.setOptions(n)}))}},{key:"create",value:function(t){return new Jc(t,this.body,this.images,this.options,this.defaultOptions)}},{key:"reconnectEdges",value:function(){var t,e=this.body.nodes,i=this.body.edges;for(t in e)e.hasOwnProperty(t)&&(e[t].edges=[]);for(t in i)if(i.hasOwnProperty(t)){var n=i[t];n.from=null,n.to=null,n.connect()}}},{key:"getConnectedNodes",value:function(t){var e=[];if(void 0!==this.body.edges[t]){var i=this.body.edges[t];void 0!==i.fromId&&e.push(i.fromId),void 0!==i.toId&&e.push(i.toId)}return e}},{key:"_updateState",value:function(){this._addMissingEdges(),this._removeInvalidEdges()}},{key:"_removeInvalidEdges",value:function(){var t=this,e=[];Vr(this.body.edges,(function(i,n){var o=t.body.nodes[i.toId],r=t.body.nodes[i.fromId];void 0!==o&&!0===o.isCluster||void 0!==r&&!0===r.isCluster||void 0!==o&&void 0!==r||e.push(n)})),this.remove(e,!1)}},{key:"_addMissingEdges",value:function(){var t=this.body.data.edges;if(null!=t){var e=this.body.edges,i=[];Jn(t).call(t,(function(t,n){void 0===e[n]&&i.push(n)})),this.add(i,!0)}}}]),t}(),ef=function(){function t(e,i,n){Kh(this,t),this.body=e,this.physicsBody=i,this.barnesHutTree,this.setOptions(n),this._rng=_r("BARNES HUT SOLVER")}return Qh(t,[{key:"setOptions",value:function(t){this.options=t,this.thetaInversed=1/this.options.theta,this.overlapAvoidanceFactor=1-Math.max(0,Math.min(1,this.options.avoidOverlap))}},{key:"solve",value:function(){if(0!==this.options.gravitationalConstant&&this.physicsBody.physicsNodeIndices.length>0){var t,e=this.body.nodes,i=this.physicsBody.physicsNodeIndices,n=i.length,o=this._formBarnesHutTree(e,i);this.barnesHutTree=o;for(var r=0;r<n;r++)(t=e[i[r]]).options.mass>0&&this._getForceContributions(o.root,t)}}},{key:"_getForceContributions",value:function(t,e){this._getForceContribution(t.children.NW,e),this._getForceContribution(t.children.NE,e),this._getForceContribution(t.children.SW,e),this._getForceContribution(t.children.SE,e)}},{key:"_getForceContribution",value:function(t,e){var i,n,o;t.childrenCount>0&&(i=t.centerOfMass.x-e.x,n=t.centerOfMass.y-e.y,(o=Math.sqrt(i*i+n*n))*t.calcSize>this.thetaInversed?this._calculateForces(o,i,n,e,t):4===t.childrenCount?this._getForceContributions(t,e):t.children.data.id!=e.id&&this._calculateForces(o,i,n,e,t))}},{key:"_calculateForces",value:function(t,e,i,n,o){0===t&&(e=t=.1),this.overlapAvoidanceFactor<1&&n.shape.radius&&(t=Math.max(.1+this.overlapAvoidanceFactor*n.shape.radius,t-n.shape.radius));var r=this.options.gravitationalConstant*o.mass*n.options.mass/Math.pow(t,3),s=e*r,a=i*r;this.physicsBody.forces[n.id].x+=s,this.physicsBody.forces[n.id].y+=a}},{key:"_formBarnesHutTree",value:function(t,e){for(var i,n=e.length,o=t[e[0]].x,r=t[e[0]].y,s=t[e[0]].x,a=t[e[0]].y,h=1;h<n;h++){var l=t[e[h]],d=l.x,u=l.y;l.options.mass>0&&(d<o&&(o=d),d>s&&(s=d),u<r&&(r=u),u>a&&(a=u))}var c=Math.abs(s-o)-Math.abs(a-r);c>0?(r-=.5*c,a+=.5*c):(o+=.5*c,s-=.5*c);var f=Math.max(1e-5,Math.abs(s-o)),p=.5*f,v=.5*(o+s),g=.5*(r+a),y={root:{centerOfMass:{x:0,y:0},mass:0,range:{minX:v-p,maxX:v+p,minY:g-p,maxY:g+p},size:f,calcSize:1/f,children:{data:null},maxWidth:0,level:0,childrenCount:4}};this._splitBranch(y.root);for(var m=0;m<n;m++)(i=t[e[m]]).options.mass>0&&this._placeInTree(y.root,i);return y}},{key:"_updateBranchMass",value:function(t,e){var i=t.centerOfMass,n=t.mass+e.options.mass,o=1/n;i.x=i.x*t.mass+e.x*e.options.mass,i.x*=o,i.y=i.y*t.mass+e.y*e.options.mass,i.y*=o,t.mass=n;var r=Math.max(Math.max(e.height,e.radius),e.width);t.maxWidth=t.maxWidth<r?r:t.maxWidth}},{key:"_placeInTree",value:function(t,e,i){1==i&&void 0!==i||this._updateBranchMass(t,e);var n,o=t.children.NW.range;n=o.maxX>e.x?o.maxY>e.y?"NW":"SW":o.maxY>e.y?"NE":"SE",this._placeInRegion(t,e,n)}},{key:"_placeInRegion",value:function(t,e,i){var n=t.children[i];switch(n.childrenCount){case 0:n.children.data=e,n.childrenCount=1,this._updateBranchMass(n,e);break;case 1:n.children.data.x===e.x&&n.children.data.y===e.y?(e.x+=this._rng(),e.y+=this._rng()):(this._splitBranch(n),this._placeInTree(n,e));break;case 4:this._placeInTree(n,e)}}},{key:"_splitBranch",value:function(t){var e=null;1===t.childrenCount&&(e=t.children.data,t.mass=0,t.centerOfMass.x=0,t.centerOfMass.y=0),t.childrenCount=4,t.children.data=null,this._insertRegion(t,"NW"),this._insertRegion(t,"NE"),this._insertRegion(t,"SW"),this._insertRegion(t,"SE"),null!=e&&this._placeInTree(t,e)}},{key:"_insertRegion",value:function(t,e){var i,n,o,r,s=.5*t.size;switch(e){case"NW":i=t.range.minX,n=t.range.minX+s,o=t.range.minY,r=t.range.minY+s;break;case"NE":i=t.range.minX+s,n=t.range.maxX,o=t.range.minY,r=t.range.minY+s;break;case"SW":i=t.range.minX,n=t.range.minX+s,o=t.range.minY+s,r=t.range.maxY;break;case"SE":i=t.range.minX+s,n=t.range.maxX,o=t.range.minY+s,r=t.range.maxY}t.children[e]={centerOfMass:{x:0,y:0},mass:0,range:{minX:i,maxX:n,minY:o,maxY:r},size:.5*t.size,calcSize:2*t.calcSize,children:{data:null},maxWidth:0,level:t.level+1,childrenCount:0}}},{key:"_debug",value:function(t,e){void 0!==this.barnesHutTree&&(t.lineWidth=1,this._drawBranch(this.barnesHutTree.root,t,e))}},{key:"_drawBranch",value:function(t,e,i){void 0===i&&(i="#FF0000"),4===t.childrenCount&&(this._drawBranch(t.children.NW,e),this._drawBranch(t.children.NE,e),this._drawBranch(t.children.SE,e),this._drawBranch(t.children.SW,e)),e.strokeStyle=i,e.beginPath(),e.moveTo(t.range.minX,t.range.minY),e.lineTo(t.range.maxX,t.range.minY),e.stroke(),e.beginPath(),e.moveTo(t.range.maxX,t.range.minY),e.lineTo(t.range.maxX,t.range.maxY),e.stroke(),e.beginPath(),e.moveTo(t.range.maxX,t.range.maxY),e.lineTo(t.range.minX,t.range.maxY),e.stroke(),e.beginPath(),e.moveTo(t.range.minX,t.range.maxY),e.lineTo(t.range.minX,t.range.minY),e.stroke()}}]),t}(),nf=function(){function t(e,i,n){Kh(this,t),this._rng=_r("REPULSION SOLVER"),this.body=e,this.physicsBody=i,this.setOptions(n)}return Qh(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,n,o,r,s,a,h=this.body.nodes,l=this.physicsBody.physicsNodeIndices,d=this.physicsBody.forces,u=this.options.nodeDistance,c=-2/3/u,f=0;f<l.length-1;f++){s=h[l[f]];for(var p=f+1;p<l.length;p++)t=(a=h[l[p]]).x-s.x,e=a.y-s.y,0===(i=Math.sqrt(t*t+e*e))&&(t=i=.1*this._rng()),i<2*u&&(r=i<.5*u?1:c*i+4/3,n=t*(r/=i),o=e*r,d[s.id].x-=n,d[s.id].y-=o,d[a.id].x+=n,d[a.id].y+=o)}}}]),t}(),of=function(){function t(e,i,n){Kh(this,t),this.body=e,this.physicsBody=i,this.setOptions(n)}return Qh(t,[{key:"setOptions",value:function(t){this.options=t,this.overlapAvoidanceFactor=Math.max(0,Math.min(1,this.options.avoidOverlap||0))}},{key:"solve",value:function(){for(var t=this.body.nodes,e=this.physicsBody.physicsNodeIndices,i=this.physicsBody.forces,n=this.options.nodeDistance,o=0;o<e.length-1;o++)for(var r=t[e[o]],s=o+1;s<e.length;s++){var a=t[e[s]];if(r.level===a.level){var h=n+this.overlapAvoidanceFactor*((r.shape.radius||0)/2+(a.shape.radius||0)/2),l=a.x-r.x,d=a.y-r.y,u=Math.sqrt(l*l+d*d),c=void 0;c=u<h?-Math.pow(.05*u,2)+Math.pow(.05*h,2):0,0!==u&&(c/=u);var f=l*c,p=d*c;i[r.id].x-=f,i[r.id].y-=p,i[a.id].x+=f,i[a.id].y+=p}}}}]),t}(),rf=function(){function t(e,i,n){Kh(this,t),this.body=e,this.physicsBody=i,this.setOptions(n)}return Qh(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,n,o,r=this.physicsBody.physicsEdgeIndices,s=this.body.edges,a=0;a<r.length;a++)!0===(e=s[r[a]]).connected&&e.toId!==e.fromId&&void 0!==this.body.nodes[e.toId]&&void 0!==this.body.nodes[e.fromId]&&(void 0!==e.edgeType.via?(t=void 0===e.options.length?this.options.springLength:e.options.length,i=e.to,n=e.edgeType.via,o=e.from,this._calculateSpringForce(i,n,.5*t),this._calculateSpringForce(n,o,.5*t)):(t=void 0===e.options.length?1.5*this.options.springLength:e.options.length,this._calculateSpringForce(e.from,e.to,t)))}},{key:"_calculateSpringForce",value:function(t,e,i){var n=t.x-e.x,o=t.y-e.y,r=Math.max(Math.sqrt(n*n+o*o),.01),s=this.options.springConstant*(i-r)/r,a=n*s,h=o*s;void 0!==this.physicsBody.forces[t.id]&&(this.physicsBody.forces[t.id].x+=a,this.physicsBody.forces[t.id].y+=h),void 0!==this.physicsBody.forces[e.id]&&(this.physicsBody.forces[e.id].x-=a,this.physicsBody.forces[e.id].y-=h)}}]),t}(),sf=function(){function t(e,i,n){Kh(this,t),this.body=e,this.physicsBody=i,this.setOptions(n)}return Qh(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,n,o,r,s,a,h,l,d=this.body.edges,u=this.physicsBody.physicsEdgeIndices,c=this.physicsBody.physicsNodeIndices,f=this.physicsBody.forces,p=0;p<c.length;p++){var v=c[p];f[v].springFx=0,f[v].springFy=0}for(var g=0;g<u.length;g++)!0===(e=d[u[g]]).connected&&(t=void 0===e.options.length?this.options.springLength:e.options.length,i=e.from.x-e.to.x,n=e.from.y-e.to.y,a=0===(a=Math.sqrt(i*i+n*n))?.01:a,o=i*(s=this.options.springConstant*(t-a)/a),r=n*s,e.to.level!=e.from.level?(void 0!==f[e.toId]&&(f[e.toId].springFx-=o,f[e.toId].springFy-=r),void 0!==f[e.fromId]&&(f[e.fromId].springFx+=o,f[e.fromId].springFy+=r)):(void 0!==f[e.toId]&&(f[e.toId].x-=.5*o,f[e.toId].y-=.5*r),void 0!==f[e.fromId]&&(f[e.fromId].x+=.5*o,f[e.fromId].y+=.5*r)));s=1;for(var y=0;y<c.length;y++){var m=c[y];h=Math.min(s,Math.max(-s,f[m].springFx)),l=Math.min(s,Math.max(-s,f[m].springFy)),f[m].x+=h,f[m].y+=l}for(var b=0,w=0,_=0;_<c.length;_++){var k=c[_];b+=f[k].x,w+=f[k].y}for(var x=b/c.length,O=w/c.length,S=0;S<c.length;S++){var E=c[S];f[E].x-=x,f[E].y-=O}}}]),t}(),af=function(){function t(e,i,n){Kh(this,t),this.body=e,this.physicsBody=i,this.setOptions(n)}return Qh(t,[{key:"setOptions",value:function(t){this.options=t}},{key:"solve",value:function(){for(var t,e,i,n,o=this.body.nodes,r=this.physicsBody.physicsNodeIndices,s=this.physicsBody.forces,a=0;a<r.length;a++){t=-(n=o[r[a]]).x,e=-n.y,i=Math.sqrt(t*t+e*e),this._calculateForces(i,t,e,s,n)}}},{key:"_calculateForces",value:function(t,e,i,n,o){var r=0===t?0:this.options.centralGravity/t;n[o.id].x=e*r,n[o.id].y=i*r}}]),t}();function hf(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var lf=function(t){Vl(i,t);var e=hf(i);function i(t,n,o){var r;return Kh(this,i),(r=e.call(this,t,n,o))._rng=_r("FORCE ATLAS 2 BASED REPULSION SOLVER"),r}return Qh(i,[{key:"_calculateForces",value:function(t,e,i,n,o){0===t&&(e=t=.1*this._rng()),this.overlapAvoidanceFactor<1&&n.shape.radius&&(t=Math.max(.1+this.overlapAvoidanceFactor*n.shape.radius,t-n.shape.radius));var r=n.edges.length+1,s=this.options.gravitationalConstant*o.mass*n.options.mass*r/Math.pow(t,2),a=e*s,h=i*s;this.physicsBody.forces[n.id].x+=a,this.physicsBody.forces[n.id].y+=h}}]),i}(ef);function df(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var uf=function(t){Vl(i,t);var e=df(i);function i(t,n,o){return Kh(this,i),e.call(this,t,n,o)}return Qh(i,[{key:"_calculateForces",value:function(t,e,i,n,o){if(t>0){var r=o.edges.length+1,s=this.options.centralGravity*r*o.options.mass;n[o.id].x=e*s,n[o.id].y=i*s}}}]),i}(af),cf=function(){function t(e){Kh(this,t),this.body=e,this.physicsBody={physicsNodeIndices:[],physicsEdgeIndices:[],forces:{},velocities:{}},this.physicsEnabled=!0,this.simulationInterval=1e3/60,this.requiresTimeout=!0,this.previousStates={},this.referenceState={},this.freezeCache={},this.renderTimer=void 0,this.adaptiveTimestep=!1,this.adaptiveTimestepEnabled=!1,this.adaptiveCounter=0,this.adaptiveInterval=3,this.stabilized=!1,this.startedStabilization=!1,this.stabilizationIterations=0,this.ready=!1,this.options={},this.defaultOptions={enabled:!0,barnesHut:{theta:.5,gravitationalConstant:-2e3,centralGravity:.3,springLength:95,springConstant:.04,damping:.09,avoidOverlap:0},forceAtlas2Based:{theta:.5,gravitationalConstant:-50,centralGravity:.01,springConstant:.08,springLength:100,damping:.4,avoidOverlap:0},repulsion:{centralGravity:.2,springLength:200,springConstant:.05,nodeDistance:100,damping:.09,avoidOverlap:0},hierarchicalRepulsion:{centralGravity:0,springLength:100,springConstant:.01,nodeDistance:120,damping:.09},maxVelocity:50,minVelocity:.75,solver:"barnesHut",stabilization:{enabled:!0,iterations:1e3,updateInterval:50,onlyDynamicEdges:!1,fit:!0},timestep:.5,adaptiveTimestep:!0,wind:{x:0,y:0}},Fr(this.options,this.defaultOptions),this.timestep=.5,this.layoutFailed=!1,this.bindEventListeners()}return Qh(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("initPhysics",(function(){t.initPhysics()})),this.body.emitter.on("_layoutFailed",(function(){t.layoutFailed=!0})),this.body.emitter.on("resetPhysics",(function(){t.stopSimulation(),t.ready=!1})),this.body.emitter.on("disablePhysics",(function(){t.physicsEnabled=!1,t.stopSimulation()})),this.body.emitter.on("restorePhysics",(function(){t.setOptions(t.options),!0===t.ready&&t.startSimulation()})),this.body.emitter.on("startSimulation",(function(){!0===t.ready&&t.startSimulation()})),this.body.emitter.on("stopSimulation",(function(){t.stopSimulation()})),this.body.emitter.on("destroy",(function(){t.stopSimulation(!1),t.body.emitter.off()})),this.body.emitter.on("_dataChanged",(function(){t.updatePhysicsData()}))}},{key:"setOptions",value:function(t){if(void 0!==t)if(!1===t)this.options.enabled=!1,this.physicsEnabled=!1,this.stopSimulation();else if(!0===t)this.options.enabled=!0,this.physicsEnabled=!0,this.startSimulation();else{this.physicsEnabled=!0,zr(["stabilization"],this.options,t),ls(this.options,t,"stabilization"),void 0===t.enabled&&(this.options.enabled=!0),!1===this.options.enabled&&(this.physicsEnabled=!1,this.stopSimulation());var e=this.options.wind;e&&(("number"!=typeof e.x||vl(e.x))&&(e.x=0),("number"!=typeof e.y||vl(e.y))&&(e.y=0)),this.timestep=this.options.timestep}this.init()}},{key:"init",value:function(){var t;"forceAtlas2Based"===this.options.solver?(t=this.options.forceAtlas2Based,this.nodesSolver=new lf(this.body,this.physicsBody,t),this.edgesSolver=new rf(this.body,this.physicsBody,t),this.gravitySolver=new uf(this.body,this.physicsBody,t)):"repulsion"===this.options.solver?(t=this.options.repulsion,this.nodesSolver=new nf(this.body,this.physicsBody,t),this.edgesSolver=new rf(this.body,this.physicsBody,t),this.gravitySolver=new af(this.body,this.physicsBody,t)):"hierarchicalRepulsion"===this.options.solver?(t=this.options.hierarchicalRepulsion,this.nodesSolver=new of(this.body,this.physicsBody,t),this.edgesSolver=new sf(this.body,this.physicsBody,t),this.gravitySolver=new af(this.body,this.physicsBody,t)):(t=this.options.barnesHut,this.nodesSolver=new ef(this.body,this.physicsBody,t),this.edgesSolver=new rf(this.body,this.physicsBody,t),this.gravitySolver=new af(this.body,this.physicsBody,t)),this.modelOptions=t}},{key:"initPhysics",value:function(){!0===this.physicsEnabled&&!0===this.options.enabled?!0===this.options.stabilization.enabled?this.stabilize():(this.stabilized=!1,this.ready=!0,this.body.emitter.emit("fit",{},this.layoutFailed),this.startSimulation()):(this.ready=!0,this.body.emitter.emit("fit"))}},{key:"startSimulation",value:function(){var t;!0===this.physicsEnabled&&!0===this.options.enabled?(this.stabilized=!1,this.adaptiveTimestep=!1,this.body.emitter.emit("_resizeNodes"),void 0===this.viewFunction&&(this.viewFunction=J(t=this.simulationStep).call(t,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering"))):this.body.emitter.emit("_redraw")}},{key:"stopSimulation",value:function(){var t=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];this.stabilized=!0,!0===t&&this._emitStabilized(),void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.viewFunction=void 0,!0===t&&this.body.emitter.emit("_stopRendering"))}},{key:"simulationStep",value:function(){var t=gr();this.physicsTick(),(gr()-t<.4*this.simulationInterval||!0===this.runDoubleSpeed)&&!1===this.stabilized&&(this.physicsTick(),this.runDoubleSpeed=!0),!0===this.stabilized&&this.stopSimulation()}},{key:"_emitStabilized",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.stabilizationIterations;(this.stabilizationIterations>1||!0===this.startedStabilization)&&rl((function(){t.body.emitter.emit("stabilized",{iterations:e}),t.startedStabilization=!1,t.stabilizationIterations=0}),0)}},{key:"physicsStep",value:function(){this.gravitySolver.solve(),this.nodesSolver.solve(),this.edgesSolver.solve(),this.moveNodes()}},{key:"adjustTimeStep",value:function(){!0===this._evaluateStepQuality()?this.timestep=1.2*this.timestep:this.timestep/1.2<this.options.timestep?this.timestep=this.options.timestep:(this.adaptiveCounter=-1,this.timestep=Math.max(this.options.timestep,this.timestep/1.2))}},{key:"physicsTick",value:function(){if(this._startStabilizing(),!0!==this.stabilized){if(!0===this.adaptiveTimestep&&!0===this.adaptiveTimestepEnabled)this.adaptiveCounter%this.adaptiveInterval==0?(this.timestep=2*this.timestep,this.physicsStep(),this.revert(),this.timestep=.5*this.timestep,this.physicsStep(),this.physicsStep(),this.adjustTimeStep()):this.physicsStep(),this.adaptiveCounter+=1;else this.timestep=this.options.timestep,this.physicsStep();!0===this.stabilized&&this.revert(),this.stabilizationIterations++}}},{key:"updatePhysicsData",value:function(){this.physicsBody.forces={},this.physicsBody.physicsNodeIndices=[],this.physicsBody.physicsEdgeIndices=[];var t=this.body.nodes,e=this.body.edges;for(var i in t)t.hasOwnProperty(i)&&!0===t[i].options.physics&&this.physicsBody.physicsNodeIndices.push(t[i].id);for(var n in e)e.hasOwnProperty(n)&&!0===e[n].options.physics&&this.physicsBody.physicsEdgeIndices.push(e[n].id);for(var o=0;o<this.physicsBody.physicsNodeIndices.length;o++){var r=this.physicsBody.physicsNodeIndices[o];this.physicsBody.forces[r]={x:0,y:0},void 0===this.physicsBody.velocities[r]&&(this.physicsBody.velocities[r]={x:0,y:0})}for(var s in this.physicsBody.velocities)void 0===t[s]&&delete this.physicsBody.velocities[s]}},{key:"revert",value:function(){var t=Tn(this.previousStates),e=this.body.nodes,i=this.physicsBody.velocities;this.referenceState={};for(var n=0;n<t.length;n++){var o=t[n];void 0!==e[o]?!0===e[o].options.physics&&(this.referenceState[o]={positions:{x:e[o].x,y:e[o].y}},i[o].x=this.previousStates[o].vx,i[o].y=this.previousStates[o].vy,e[o].x=this.previousStates[o].x,e[o].y=this.previousStates[o].y):delete this.previousStates[o]}}},{key:"_evaluateStepQuality",value:function(){var t,e,i=this.body.nodes,n=this.referenceState;for(var o in this.referenceState)if(this.referenceState.hasOwnProperty(o)&&void 0!==i[o]&&(t=i[o].x-n[o].positions.x,e=i[o].y-n[o].positions.y,Math.sqrt(Math.pow(t,2)+Math.pow(e,2))>.3))return!1;return!0}},{key:"moveNodes",value:function(){for(var t=this.physicsBody.physicsNodeIndices,e=0,i=0,n=0;n<t.length;n++){var o=t[n],r=this._performStep(o);e=Math.max(e,r),i+=r}this.adaptiveTimestepEnabled=i/t.length<5,this.stabilized=e<this.options.minVelocity}},{key:"calculateComponentVelocity",value:function(t,e,i){t+=(e-this.modelOptions.damping*t)/i*this.timestep;var n=this.options.maxVelocity||1e9;return Math.abs(t)>n&&(t=t>0?n:-n),t}},{key:"_performStep",value:function(t){var e=this.body.nodes[t],i=this.physicsBody.forces[t];this.options.wind&&(i.x+=this.options.wind.x,i.y+=this.options.wind.y);var n=this.physicsBody.velocities[t];return this.previousStates[t]={x:e.x,y:e.y,vx:n.x,vy:n.y},!1===e.options.fixed.x?(n.x=this.calculateComponentVelocity(n.x,i.x,e.options.mass),e.x+=n.x*this.timestep):(i.x=0,n.x=0),!1===e.options.fixed.y?(n.y=this.calculateComponentVelocity(n.y,i.y,e.options.mass),e.y+=n.y*this.timestep):(i.y=0,n.y=0),Math.sqrt(Math.pow(n.x,2)+Math.pow(n.y,2))}},{key:"_freezeNodes",value:function(){var t=this.body.nodes;for(var e in t)if(t.hasOwnProperty(e)&&t[e].x&&t[e].y){var i=t[e].options.fixed;this.freezeCache[e]={x:i.x,y:i.y},i.x=!0,i.y=!0}}},{key:"_restoreFrozenNodes",value:function(){var t=this.body.nodes;for(var e in t)t.hasOwnProperty(e)&&void 0!==this.freezeCache[e]&&(t[e].options.fixed.x=this.freezeCache[e].x,t[e].options.fixed.y=this.freezeCache[e].y);this.freezeCache={}}},{key:"stabilize",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.stabilization.iterations;"number"!=typeof e&&(e=this.options.stabilization.iterations,console.log("The stabilize method needs a numeric amount of iterations. Switching to default: ",e)),0!==this.physicsBody.physicsNodeIndices.length?(this.adaptiveTimestep=this.options.adaptiveTimestep,this.body.emitter.emit("_resizeNodes"),this.stopSimulation(),this.stabilized=!1,this.body.emitter.emit("_blockRedraw"),this.targetIterations=e,!0===this.options.stabilization.onlyDynamicEdges&&this._freezeNodes(),this.stabilizationIterations=0,rl((function(){return t._stabilizationBatch()}),0)):this.ready=!0}},{key:"_startStabilizing",value:function(){return!0!==this.startedStabilization&&(this.body.emitter.emit("startStabilizing"),this.startedStabilization=!0,!0)}},{key:"_stabilizationBatch",value:function(){var t=this,e=function(){return!1===t.stabilized&&t.stabilizationIterations<t.targetIterations},i=function(){t.body.emitter.emit("stabilizationProgress",{iterations:t.stabilizationIterations,total:t.targetIterations})};this._startStabilizing()&&i();for(var n,o=0;e()&&o<this.options.stabilization.updateInterval;)this.physicsTick(),o++;(i(),e())?rl(J(n=this._stabilizationBatch).call(n,this),0):this._finalizeStabilization()}},{key:"_finalizeStabilization",value:function(){this.body.emitter.emit("_allowRedraw"),!0===this.options.stabilization.fit&&this.body.emitter.emit("fit"),!0===this.options.stabilization.onlyDynamicEdges&&this._restoreFrozenNodes(),this.body.emitter.emit("stabilizationIterationsDone"),this.body.emitter.emit("_requestRedraw"),!0===this.stabilized?this._emitStabilized():this.startSimulation(),this.ready=!0}},{key:"_drawForces",value:function(t){for(var e=0;e<this.physicsBody.physicsNodeIndices.length;e++){var i=this.physicsBody.physicsNodeIndices[e],n=this.body.nodes[i],o=this.physicsBody.forces[i],r=Math.sqrt(Math.pow(o.x,2)+Math.pow(o.x,2)),s=Math.min(Math.max(5,r),15),a=3*s,h=ns((180-180*Math.min(1,Math.max(0,.03*r)))/360,1,1),l={x:n.x+20*o.x,y:n.y+20*o.y};t.lineWidth=s,t.strokeStyle=h,t.beginPath(),t.moveTo(n.x,n.y),t.lineTo(l.x,l.y),t.stroke();var d=Math.atan2(o.y,o.x);t.fillStyle=h,jc.draw(t,{type:"arrow",point:l,angle:d,length:a}),_u(t).call(t)}}}]),t}(),ff=[].reverse,pf=[1,2];U({target:"Array",proto:!0,forced:String(pf)===String(pf.reverse())},{reverse:function(){return Ke(this)&&(this.length=this.length),ff.call(this)}});var vf=K("Array").reverse,gf=Array.prototype,yf=function(t){var e=t.reverse;return t===gf||t instanceof Array&&e===gf.reverse?vf:e},mf=function(){function t(){Kh(this,t)}return Qh(t,null,[{key:"getRange",value:function(t){var e,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],n=1e9,o=-1e9,r=1e9,s=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)r>(e=t[i[a]]).shape.boundingBox.left&&(r=e.shape.boundingBox.left),s<e.shape.boundingBox.right&&(s=e.shape.boundingBox.right),n>e.shape.boundingBox.top&&(n=e.shape.boundingBox.top),o<e.shape.boundingBox.bottom&&(o=e.shape.boundingBox.bottom);return 1e9===r&&-1e9===s&&1e9===n&&-1e9===o&&(n=0,o=0,r=0,s=0),{minX:r,maxX:s,minY:n,maxY:o}}},{key:"getRangeCore",value:function(t){var e,i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],n=1e9,o=-1e9,r=1e9,s=-1e9;if(i.length>0)for(var a=0;a<i.length;a++)r>(e=t[i[a]]).x&&(r=e.x),s<e.x&&(s=e.x),n>e.y&&(n=e.y),o<e.y&&(o=e.y);return 1e9===r&&-1e9===s&&1e9===n&&-1e9===o&&(n=0,o=0,r=0,s=0),{minX:r,maxX:s,minY:n,maxY:o}}},{key:"findCenter",value:function(t){return{x:.5*(t.maxX+t.minX),y:.5*(t.maxY+t.minY)}}},{key:"cloneOptions",value:function(t,e){var i={};return void 0===e||"node"===e?(Br(i,t.options,!0),i.x=t.x,i.y=t.y,i.amountOfConnections=t.edges.length):Br(i,t.options,!0),i}}]),t}();function bf(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var wf=function(t){Vl(i,t);var e=bf(i);function i(t,n,o,r,s,a){var h;return Kh(this,i),(h=e.call(this,t,n,o,r,s,a)).isCluster=!0,h.containedNodes={},h.containedEdges={},h}return Qh(i,[{key:"_openChildCluster",value:function(t){var e=this,i=this.body.nodes[t];if(void 0===this.containedNodes[t])throw new Error("node with id: "+t+" not in current cluster");if(!i.isCluster)throw new Error("node with id: "+t+" is not a cluster");delete this.containedNodes[t],Vr(i.edges,(function(t){delete e.containedEdges[t.id]})),Vr(i.containedNodes,(function(t,i){e.containedNodes[i]=t})),i.containedNodes={},Vr(i.containedEdges,(function(t,i){e.containedEdges[i]=t})),i.containedEdges={},Vr(i.edges,(function(t){Vr(e.edges,(function(i){var n,o,r=nr(n=i.clusteringEdgeReplacingIds).call(n,t.id);-1!==r&&(Vr(t.clusteringEdgeReplacingIds,(function(t){i.clusteringEdgeReplacingIds.push(t),e.body.edges[t].edgeReplacedById=i.id})),bs(o=i.clusteringEdgeReplacingIds).call(o,r,1))}))})),i.edges=[]}}]),i}(lc),_f=function(){function t(e){var i=this;Kh(this,t),this.body=e,this.clusteredNodes={},this.clusteredEdges={},this.options={},this.defaultOptions={},Fr(this.options,this.defaultOptions),this.body.emitter.on("_resetData",(function(){i.clusteredNodes={},i.clusteredEdges={}}))}return Qh(t,[{key:"clusterByHubsize",value:function(t,e){void 0===t?t=this._getHubSize():"object"===ur(t)&&(e=this._checkOptions(t),t=this._getHubSize());for(var i=[],n=0;n<this.body.nodeIndices.length;n++){var o=this.body.nodes[this.body.nodeIndices[n]];o.edges.length>=t&&i.push(o.id)}for(var r=0;r<i.length;r++)this.clusterByConnection(i[r],e,!0);this.body.emitter.emit("_dataChanged")}},{key:"cluster",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},i=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(void 0===e.joinCondition)throw new Error("Cannot call clusterByNodeData without a joinCondition function in the options.");e=this._checkOptions(e);var n={},o={};Vr(this.body.nodes,(function(i,r){i.options&&!0===e.joinCondition(i.options)&&(n[r]=i,Vr(i.edges,(function(e){void 0===t.clusteredEdges[e.id]&&(o[e.id]=e)})))})),this._cluster(n,o,e,i)}},{key:"clusterByEdgeCount",value:function(t,e){var i=this,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];e=this._checkOptions(e);for(var o,r,s,a=[],h={},l=function(n){var l={},d={},f=i.body.nodeIndices[n],p=i.body.nodes[f];if(void 0===h[f]){s=0,r=[];for(var v=0;v<p.edges.length;v++)o=p.edges[v],void 0===i.clusteredEdges[o.id]&&(o.toId!==o.fromId&&s++,r.push(o));if(s===t){u=function(t){if(void 0===e.joinCondition||null===e.joinCondition)return!0;var i=mf.cloneOptions(t);return e.joinCondition(i)};for(var g=!0,y=0;y<r.length;y++){o=r[y];var m=i._getConnectedId(o,f);if(!u(p)){g=!1;break}d[o.id]=o,l[f]=p,l[m]=i.body.nodes[m],h[f]=!0}if(Tn(l).length>0&&Tn(d).length>0&&!0===g)if(void 0!==(c=function(){for(var t=0;t<a.length;++t)for(var e in l)if(void 0!==a[t].nodes[e])return a[t]}())){for(var b in l)void 0===c.nodes[b]&&(c.nodes[b]=l[b]);for(var w in d)void 0===c.edges[w]&&(c.edges[w]=d[w])}else a.push({nodes:l,edges:d})}}},d=0;d<this.body.nodeIndices.length;d++){var u,c;l(d)}for(var f=0;f<a.length;f++)this._cluster(a[f].nodes,a[f].edges,e,!1);!0===n&&this.body.emitter.emit("_dataChanged")}},{key:"clusterOutliers",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(1,t,e)}},{key:"clusterBridges",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];this.clusterByEdgeCount(2,t,e)}},{key:"clusterByConnection",value:function(t,e){var i,n=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===t)throw new Error("No nodeId supplied to clusterByConnection!");if(void 0===this.body.nodes[t])throw new Error("The nodeId given to clusterByConnection does not exist!");var o=this.body.nodes[t];void 0===(e=this._checkOptions(e,o)).clusterNodeProperties.x&&(e.clusterNodeProperties.x=o.x),void 0===e.clusterNodeProperties.y&&(e.clusterNodeProperties.y=o.y),void 0===e.clusterNodeProperties.fixed&&(e.clusterNodeProperties.fixed={},e.clusterNodeProperties.fixed.x=o.options.fixed.x,e.clusterNodeProperties.fixed.y=o.options.fixed.y);var r={},s={},a=o.id,h=mf.cloneOptions(o);r[a]=o;for(var l=0;l<o.edges.length;l++){var d=o.edges[l];if(void 0===this.clusteredEdges[d.id]){var u=this._getConnectedId(d,a);if(void 0===this.clusteredNodes[u])if(u!==a)if(void 0===e.joinCondition)s[d.id]=d,r[u]=this.body.nodes[u];else{var c=mf.cloneOptions(this.body.nodes[u]);!0===e.joinCondition(h,c)&&(s[d.id]=d,r[u]=this.body.nodes[u])}else s[d.id]=d}}var f=ro(i=Tn(r)).call(i,(function(t){return r[t].id}));for(p in r)if(r.hasOwnProperty(p))for(var p=r[p],v=0;v<p.edges.length;v++){var g=p.edges[v];nr(f).call(f,this._getConnectedId(g,p.id))>-1&&(s[g.id]=g)}this._cluster(r,s,e,n)}},{key:"_createClusterEdges",value:function(t,e,i,n){for(var o,r,s,a,h,l,d=Tn(t),u=[],c=0;c<d.length;c++){s=t[r=d[c]];for(var f=0;f<s.edges.length;f++)o=s.edges[f],void 0===this.clusteredEdges[o.id]&&(o.toId==o.fromId?e[o.id]=o:o.toId==r?(a=i.id,l=h=o.fromId):(a=o.toId,h=i.id,l=a),void 0===t[l]&&u.push({edge:o,fromId:h,toId:a}))}for(var p=[],v=function(t){for(var e=0;e<p.length;e++){var i=p[e],n=t.fromId===i.fromId&&t.toId===i.toId,o=t.fromId===i.toId&&t.toId===i.fromId;if(n||o)return i}return null},g=0;g<u.length;g++){var y=u[g],m=y.edge,b=v(y);null===b?(b=this._createClusteredEdge(y.fromId,y.toId,m,n),p.push(b)):b.clusteringEdgeReplacingIds.push(m.id),this.body.edges[m.id].edgeReplacedById=b.id,this._backupEdgeOptions(m),m.setOptions({physics:!1})}}},{key:"_checkOptions",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};return void 0===t.clusterEdgeProperties&&(t.clusterEdgeProperties={}),void 0===t.clusterNodeProperties&&(t.clusterNodeProperties={}),t}},{key:"_cluster",value:function(t,e,i){var n=!(arguments.length>3&&void 0!==arguments[3])||arguments[3],o=[];for(var r in t)t.hasOwnProperty(r)&&void 0!==this.clusteredNodes[r]&&o.push(r);for(var s=0;s<o.length;++s)delete t[o[s]];if(0!=Tn(t).length&&(1!=Tn(t).length||1==i.clusterNodeProperties.allowSingleNodeCluster)){var a=Br({},i.clusterNodeProperties);if(void 0!==i.processProperties){var h=[];for(var l in t)if(t.hasOwnProperty(l)){var d=mf.cloneOptions(t[l]);h.push(d)}var u=[];for(var c in e)if(e.hasOwnProperty(c)&&"clusterEdge:"!==c.substr(0,12)){var f=mf.cloneOptions(e[c],"edge");u.push(f)}if(!(a=i.processProperties(a,h,u)))throw new Error("The processProperties function does not return properties!")}void 0===a.id&&(a.id="cluster:"+Rd());var p=a.id;void 0===a.label&&(a.label="cluster");var v=void 0;void 0===a.x&&(v=this._getClusterPosition(t),a.x=v.x),void 0===a.y&&(void 0===v&&(v=this._getClusterPosition(t)),a.y=v.y),a.id=p;var g=this.body.functions.createNode(a,wf);g.containedNodes=t,g.containedEdges=e,g.clusterEdgeProperties=i.clusterEdgeProperties,this.body.nodes[a.id]=g,this._clusterEdges(t,e,a,i.clusterEdgeProperties),a.id=void 0,!0===n&&this.body.emitter.emit("_dataChanged")}}},{key:"_backupEdgeOptions",value:function(t){void 0===this.clusteredEdges[t.id]&&(this.clusteredEdges[t.id]={physics:t.options.physics})}},{key:"_restoreEdge",value:function(t){var e=this.clusteredEdges[t.id];void 0!==e&&(t.setOptions({physics:e.physics}),delete this.clusteredEdges[t.id])}},{key:"isCluster",value:function(t){return void 0!==this.body.nodes[t]?!0===this.body.nodes[t].isCluster:(console.log("Node does not exist."),!1)}},{key:"_getClusterPosition",value:function(t){for(var e,i=Tn(t),n=t[i[0]].x,o=t[i[0]].x,r=t[i[0]].y,s=t[i[0]].y,a=1;a<i.length;a++)n=(e=t[i[a]]).x<n?e.x:n,o=e.x>o?e.x:o,r=e.y<r?e.y:r,s=e.y>s?e.y:s;return{x:.5*(n+o),y:.5*(r+s)}}},{key:"openCluster",value:function(t,e){var i=!(arguments.length>2&&void 0!==arguments[2])||arguments[2];if(void 0===t)throw new Error("No clusterNodeId supplied to openCluster.");var n=this.body.nodes[t];if(void 0===n)throw new Error("The clusterNodeId supplied to openCluster does not exist.");if(!0!==n.isCluster||void 0===n.containedNodes||void 0===n.containedEdges)throw new Error("The node:"+t+" is not a valid cluster.");var o=this.findNode(t),r=nr(o).call(o,t)-1;if(r>=0){var s=o[r],a=this.body.nodes[s];return a._openChildCluster(t),delete this.body.nodes[t],void(!0===i&&this.body.emitter.emit("_dataChanged"))}var h=n.containedNodes,l=n.containedEdges;if(void 0!==e&&void 0!==e.releaseFunction&&"function"==typeof e.releaseFunction){var d={},u={x:n.x,y:n.y};for(var c in h)if(h.hasOwnProperty(c)){var f=this.body.nodes[c];d[c]={x:f.x,y:f.y}}var p=e.releaseFunction(u,d);for(var v in h)if(h.hasOwnProperty(v)){var g=this.body.nodes[v];void 0!==p[v]&&(g.x=void 0===p[v].x?n.x:p[v].x,g.y=void 0===p[v].y?n.y:p[v].y)}}else Vr(h,(function(t){!1===t.options.fixed.x&&(t.x=n.x),!1===t.options.fixed.y&&(t.y=n.y)}));for(var y in h)if(h.hasOwnProperty(y)){var m=this.body.nodes[y];m.vx=n.vx,m.vy=n.vy,m.setOptions({physics:!0}),delete this.clusteredNodes[y]}for(var b=[],w=0;w<n.edges.length;w++)b.push(n.edges[w]);for(var _=0;_<b.length;_++){for(var k=b[_],x=this._getConnectedId(k,t),O=this.clusteredNodes[x],S=0;S<k.clusteringEdgeReplacingIds.length;S++){var E=k.clusteringEdgeReplacingIds[S],D=this.body.edges[E];if(void 0!==D)if(void 0!==O){var M=this.body.nodes[O.clusterId];M.containedEdges[D.id]=D,delete l[D.id];var C=D.fromId,T=D.toId;D.toId==x?T=O.clusterId:C=O.clusterId,this._createClusteredEdge(C,T,D,M.clusterEdgeProperties,{hidden:!1,physics:!0})}else this._restoreEdge(D)}k.remove()}for(var P in l)l.hasOwnProperty(P)&&this._restoreEdge(l[P]);delete this.body.nodes[t],!0===i&&this.body.emitter.emit("_dataChanged")}},{key:"getNodesInCluster",value:function(t){var e=[];if(!0===this.isCluster(t)){var i=this.body.nodes[t].containedNodes;for(var n in i)i.hasOwnProperty(n)&&e.push(this.body.nodes[n].id)}return e}},{key:"findNode",value:function(t){for(var e,i=[],n=0;void 0!==this.clusteredNodes[t]&&n<100;){if(void 0===(e=this.body.nodes[t]))return[];i.push(e.id),t=this.clusteredNodes[t].clusterId,n++}return void 0===(e=this.body.nodes[t])?[]:(i.push(e.id),yf(i).call(i),i)}},{key:"updateClusteredNode",value:function(t,e){if(void 0===t)throw new Error("No clusteredNodeId supplied to updateClusteredNode.");if(void 0===e)throw new Error("No newOptions supplied to updateClusteredNode.");if(void 0===this.body.nodes[t])throw new Error("The clusteredNodeId supplied to updateClusteredNode does not exist.");this.body.nodes[t].setOptions(e),this.body.emitter.emit("_dataChanged")}},{key:"updateEdge",value:function(t,e){if(void 0===t)throw new Error("No startEdgeId supplied to updateEdge.");if(void 0===e)throw new Error("No newOptions supplied to updateEdge.");if(void 0===this.body.edges[t])throw new Error("The startEdgeId supplied to updateEdge does not exist.");for(var i=this.getClusteredEdges(t),n=0;n<i.length;n++){this.body.edges[i[n]].setOptions(e)}this.body.emitter.emit("_dataChanged")}},{key:"getClusteredEdges",value:function(t){for(var e=[],i=0;void 0!==t&&void 0!==this.body.edges[t]&&i<100;)e.push(this.body.edges[t].id),t=this.body.edges[t].edgeReplacedById,i++;return yf(e).call(e),e}},{key:"getBaseEdge",value:function(t){return this.getBaseEdges(t)[0]}},{key:"getBaseEdges",value:function(t){for(var e=[t],i=[],n=[],o=0;e.length>0&&o<100;){var r=e.pop();if(void 0!==r){var s=this.body.edges[r];if(void 0!==s){o++;var a=s.clusteringEdgeReplacingIds;if(void 0===a)n.push(r);else for(var h=0;h<a.length;++h){var l=a[h];-1===nr(e).call(e,a)&&-1===nr(i).call(i,a)&&e.push(l)}i.push(r)}}}return n}},{key:"_getConnectedId",value:function(t,e){return t.toId!=e?t.toId:(t.fromId,t.fromId)}},{key:"_getHubSize",value:function(){for(var t=0,e=0,i=0,n=0,o=0;o<this.body.nodeIndices.length;o++){var r=this.body.nodes[this.body.nodeIndices[o]];r.edges.length>n&&(n=r.edges.length),t+=r.edges.length,e+=Math.pow(r.edges.length,2),i+=1}t/=i;var s=(e/=i)-Math.pow(t,2),a=Math.sqrt(s),h=Math.floor(t+2*a);return h>n&&(h=n),h}},{key:"_createClusteredEdge",value:function(t,e,i,n,o){var r=mf.cloneOptions(i,"edge");Br(r,n),r.from=t,r.to=e,r.id="clusterEdge:"+Rd(),void 0!==o&&Br(r,o);var s=this.body.functions.createEdge(r);return s.clusteringEdgeReplacingIds=[i.id],s.connect(),this.body.edges[s.id]=s,s}},{key:"_clusterEdges",value:function(t,e,i,n){if(e instanceof Jc){var o=e,r={};r[o.id]=o,e=r}if(t instanceof lc){var s=t,a={};a[s.id]=s,t=a}if(null==i)throw new Error("_clusterEdges: parameter clusterNode required");for(var h in void 0===n&&(n=i.clusterEdgeProperties),this._createClusterEdges(t,e,i,n),e)if(e.hasOwnProperty(h)&&void 0!==this.body.edges[h]){var l=this.body.edges[h];this._backupEdgeOptions(l),l.setOptions({physics:!1})}for(var d in t)t.hasOwnProperty(d)&&(this.clusteredNodes[d]={clusterId:i.id,node:this.body.nodes[d]},this.body.nodes[d].setOptions({physics:!1}))}},{key:"_getClusterNodeForNode",value:function(t){if(void 0!==t){var e=this.clusteredNodes[t];if(void 0!==e){var i=e.clusterId;if(void 0!==i)return this.body.nodes[i]}}}},{key:"_filter",value:function(t,e){var i=[];return Vr(t,(function(t){e(t)&&i.push(t)})),i}},{key:"_updateState",value:function(){var t,e=this,i=[],n={},o=function(t){Vr(e.body.nodes,(function(e){!0===e.isCluster&&t(e)}))};for(t in this.clusteredNodes){if(this.clusteredNodes.hasOwnProperty(t))void 0===this.body.nodes[t]&&i.push(t)}o((function(t){for(var e=0;e<i.length;e++)delete t.containedNodes[i[e]]}));for(var r=0;r<i.length;r++)delete this.clusteredNodes[i[r]];Vr(this.clusteredEdges,(function(t){var i=e.body.edges[t];void 0!==i&&i.endPointsValid()||(n[t]=t)})),o((function(t){Vr(t.containedEdges,(function(t,e){t.endPointsValid()||n[e]||(n[e]=e)}))})),Vr(this.body.edges,(function(t,i){var o=!0,r=t.clusteringEdgeReplacingIds;if(void 0!==r){var s=0;Vr(r,(function(t){var i=e.body.edges[t];void 0!==i&&i.endPointsValid()&&(s+=1)})),o=s>0}t.endPointsValid()&&o||(n[i]=i)})),o((function(t){Vr(n,(function(i){delete t.containedEdges[i],Vr(t.edges,(function(o,r){o.id!==i?o.clusteringEdgeReplacingIds=e._filter(o.clusteringEdgeReplacingIds,(function(t){return!n[t]})):t.edges[r]=null})),t.edges=e._filter(t.edges,(function(t){return null!==t}))}))})),Vr(n,(function(t){delete e.clusteredEdges[t]})),Vr(n,(function(t){delete e.body.edges[t]})),Vr(Tn(this.body.edges),(function(t){var i=e.body.edges[t],n=e._isClusteredNode(i.fromId)||e._isClusteredNode(i.toId);if(n!==e._isClusteredEdge(i.id))if(n){var o=e._getClusterNodeForNode(i.fromId);void 0!==o&&e._clusterEdges(e.body.nodes[i.fromId],i,o);var r=e._getClusterNodeForNode(i.toId);void 0!==r&&e._clusterEdges(e.body.nodes[i.toId],i,r)}else delete e._clusterEdges[t],e._restoreEdge(i)}));for(var s=!1,a=!0,h=function(){var t=[];o((function(e){var i=Tn(e.containedNodes).length,n=!0===e.options.allowSingleNodeCluster;(n&&i<1||!n&&i<2)&&t.push(e.id)}));for(var i=0;i<t.length;++i)e.openCluster(t[i],{},!1);a=t.length>0,s=s||a};a;)h();s&&this._updateState()}},{key:"_isClusteredNode",value:function(t){return void 0!==this.clusteredNodes[t]}},{key:"_isClusteredEdge",value:function(t){return void 0!==this.clusteredEdges[t]}}]),t}();var kf=function(){function t(e,i){var n;Kh(this,t),void 0!==window&&(n=window.requestAnimationFrame||window.mozRequestAnimationFrame||window.webkitRequestAnimationFrame||window.msRequestAnimationFrame),window.requestAnimationFrame=void 0===n?function(t){t()}:n,this.body=e,this.canvas=i,this.redrawRequested=!1,this.renderTimer=void 0,this.requiresTimeout=!0,this.renderingActive=!1,this.renderRequests=0,this.allowRedraw=!0,this.dragging=!1,this.zooming=!1,this.options={},this.defaultOptions={hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1},Fr(this.options,this.defaultOptions),this._determineBrowserMethod(),this.bindEventListeners()}return Qh(t,[{key:"bindEventListeners",value:function(){var t,e=this;this.body.emitter.on("dragStart",(function(){e.dragging=!0})),this.body.emitter.on("dragEnd",(function(){e.dragging=!1})),this.body.emitter.on("zoom",(function(){e.zooming=!0,window.clearTimeout(e.zoomTimeoutId),e.zoomTimeoutId=window.setTimeout((function(){var t;e.zooming=!1,J(t=e._requestRedraw).call(t,e)()}),250)})),this.body.emitter.on("_resizeNodes",(function(){e._resizeNodes()})),this.body.emitter.on("_redraw",(function(){!1===e.renderingActive&&e._redraw()})),this.body.emitter.on("_blockRedraw",(function(){e.allowRedraw=!1})),this.body.emitter.on("_allowRedraw",(function(){e.allowRedraw=!0,e.redrawRequested=!1})),this.body.emitter.on("_requestRedraw",J(t=this._requestRedraw).call(t,this)),this.body.emitter.on("_startRendering",(function(){e.renderRequests+=1,e.renderingActive=!0,e._startRendering()})),this.body.emitter.on("_stopRendering",(function(){e.renderRequests-=1,e.renderingActive=e.renderRequests>0,e.renderTimer=void 0})),this.body.emitter.on("destroy",(function(){e.renderRequests=0,e.allowRedraw=!1,e.renderingActive=!1,!0===e.requiresTimeout?clearTimeout(e.renderTimer):window.cancelAnimationFrame(e.renderTimer),e.body.emitter.off()}))}},{key:"setOptions",value:function(t){if(void 0!==t){jr(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag"],this.options,t)}}},{key:"_requestNextFrame",value:function(t,e){if("undefined"!=typeof window){var i,n=window;return!0===this.requiresTimeout?i=n.setTimeout(t,e):n.requestAnimationFrame&&(i=n.requestAnimationFrame(t)),i}}},{key:"_startRendering",value:function(){var t;!0===this.renderingActive&&(void 0===this.renderTimer&&(this.renderTimer=this._requestNextFrame(J(t=this._renderStep).call(t,this),this.simulationInterval)))}},{key:"_renderStep",value:function(){!0===this.renderingActive&&(this.renderTimer=void 0,!0===this.requiresTimeout&&this._startRendering(),this._redraw(),!1===this.requiresTimeout&&this._startRendering())}},{key:"redraw",value:function(){this.body.emitter.emit("setSize"),this._redraw()}},{key:"_requestRedraw",value:function(){var t=this;!0!==this.redrawRequested&&!1===this.renderingActive&&!0===this.allowRedraw&&(this.redrawRequested=!0,this._requestNextFrame((function(){t._redraw(!1)}),0))}},{key:"_redraw",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];if(!0===this.allowRedraw){this.body.emitter.emit("initRedraw"),this.redrawRequested=!1,0!==this.canvas.frame.canvas.width&&0!==this.canvas.frame.canvas.height||this.canvas.setSize(),this.canvas.setTransform();var e=this.canvas.getContext(),i=this.canvas.frame.canvas.clientWidth,n=this.canvas.frame.canvas.clientHeight;if(e.clearRect(0,0,i,n),0===this.canvas.frame.clientWidth)return;e.save(),e.translate(this.body.view.translation.x,this.body.view.translation.y),e.scale(this.body.view.scale,this.body.view.scale),e.beginPath(),this.body.emitter.emit("beforeDrawing",e),e.closePath(),!1===t&&(!1===this.dragging||!0===this.dragging&&!1===this.options.hideEdgesOnDrag)&&(!1===this.zooming||!0===this.zooming&&!1===this.options.hideEdgesOnZoom)&&this._drawEdges(e),(!1===this.dragging||!0===this.dragging&&!1===this.options.hideNodesOnDrag)&&this._drawNodes(e,t),e.beginPath(),this.body.emitter.emit("afterDrawing",e),e.closePath(),e.restore(),!0===t&&e.clearRect(0,0,i,n)}}},{key:"_resizeNodes",value:function(){this.canvas.setTransform();var t=this.canvas.getContext();t.save(),t.translate(this.body.view.translation.x,this.body.view.translation.y),t.scale(this.body.view.scale,this.body.view.scale);var e,i=this.body.nodes;for(var n in i)i.hasOwnProperty(n)&&((e=i[n]).resize(t),e.updateBoundingBox(t,e.selected));t.restore()}},{key:"_drawNodes",value:function(t){for(var e,i,n=arguments.length>1&&void 0!==arguments[1]&&arguments[1],o=this.body.nodes,r=this.body.nodeIndices,s=[],a=[],h=20,l=this.canvas.DOMtoCanvas({x:-h,y:-h}),d=this.canvas.DOMtoCanvas({x:this.canvas.frame.canvas.clientWidth+h,y:this.canvas.frame.canvas.clientHeight+h}),u={top:l.y,left:l.x,bottom:d.y,right:d.x},c=0;c<r.length;c++)(e=o[r[c]]).hover?a.push(r[c]):e.isSelected()?s.push(r[c]):!0===n||!0===e.isBoundingBoxOverlappingWith(u)?e.draw(t):e.updateBoundingBox(t,e.selected);var f=s.length,p=a.length;for(i=0;i<f;i++)(e=o[s[i]]).draw(t);for(i=0;i<p;i++)(e=o[a[i]]).draw(t)}},{key:"_drawEdges",value:function(t){for(var e,i=this.body.edges,n=this.body.edgeIndices,o=0;o<n.length;o++)!0===(e=i[n[o]]).connected&&e.draw(t)}},{key:"_determineBrowserMethod",value:function(){if("undefined"!=typeof window){var t=navigator.userAgent.toLowerCase();this.requiresTimeout=!1,(-1!=nr(t).call(t,"msie 9.0")||-1!=nr(t).call(t,"safari")&&nr(t).call(t,"chrome")<=-1)&&(this.requiresTimeout=!0)}else this.requiresTimeout=!0}}]),t}(),xf=j.setInterval,Of=o((function(t,e){e.onTouch=function(t,e){e.inputHandler=function(t){t.isFirst&&e(t)},t.on("hammer.input",e.inputHandler)},e.onRelease=function(t,e){return e.inputHandler=function(t){t.isFinal&&e(t)},t.on("hammer.input",e.inputHandler)},e.offTouch=function(t,e){t.off("hammer.input",e.inputHandler)},e.offRelease=e.offTouch,e.disablePreventDefaultVertically=function(t){return t.getTouchAction=function(){return["pan-y"]},t}})),Sf=(Of.onTouch,Of.onRelease,Of.offTouch,Of.offRelease,Of.disablePreventDefaultVertically,function(){function t(e){var i;Kh(this,t),this.body=e,this.pixelRatio=1,this.resizeTimer=void 0,this.resizeFunction=J(i=this._onResize).call(i,this),this.cameraState={},this.initialized=!1,this.canvasViewCenter={},this.options={},this.defaultOptions={autoResize:!0,height:"100%",width:"100%"},Fr(this.options,this.defaultOptions),this.bindEventListeners()}return Qh(t,[{key:"bindEventListeners",value:function(){var t,e=this;this.body.emitter.once("resize",(function(t){0!==t.width&&(e.body.view.translation.x=.5*t.width),0!==t.height&&(e.body.view.translation.y=.5*t.height)})),this.body.emitter.on("setSize",J(t=this.setSize).call(t,this)),this.body.emitter.on("destroy",(function(){e.hammerFrame.destroy(),e.hammer.destroy(),e._cleanUp()}))}},{key:"setOptions",value:function(t){var e,i=this;if(void 0!==t){jr(["width","height","autoResize"],this.options,t)}!0===this.options.autoResize&&(this._cleanUp(),this.resizeTimer=xf((function(){!0===i.setSize()&&i.body.emitter.emit("_requestRedraw")}),1e3),this.resizeFunction=J(e=this._onResize).call(e,this),Gr(window,"resize",this.resizeFunction))}},{key:"_cleanUp",value:function(){void 0!==this.resizeTimer&&clearInterval(this.resizeTimer),qr(window,"resize",this.resizeFunction),this.resizeFunction=void 0}},{key:"_onResize",value:function(){this.setSize(),this.body.emitter.emit("_redraw")}},{key:"_getCameraState",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.pixelRatio;!0===this.initialized&&(this.cameraState.previousWidth=this.frame.canvas.width/t,this.cameraState.previousHeight=this.frame.canvas.height/t,this.cameraState.scale=this.body.view.scale,this.cameraState.position=this.DOMtoCanvas({x:.5*this.frame.canvas.width/t,y:.5*this.frame.canvas.height/t}))}},{key:"_setCameraState",value:function(){if(void 0!==this.cameraState.scale&&0!==this.frame.canvas.clientWidth&&0!==this.frame.canvas.clientHeight&&0!==this.pixelRatio&&this.cameraState.previousWidth>0&&this.cameraState.previousHeight>0){var t=this.frame.canvas.width/this.pixelRatio/this.cameraState.previousWidth,e=this.frame.canvas.height/this.pixelRatio/this.cameraState.previousHeight,i=this.cameraState.scale;1!=t&&1!=e?i=.5*this.cameraState.scale*(t+e):1!=t?i=this.cameraState.scale*t:1!=e&&(i=this.cameraState.scale*e),this.body.view.scale=i;var n=this.DOMtoCanvas({x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight}),o={x:n.x-this.cameraState.position.x,y:n.y-this.cameraState.position.y};this.body.view.translation.x+=o.x*this.body.view.scale,this.body.view.translation.y+=o.y*this.body.view.scale}}},{key:"_prepareValue",value:function(t){if("number"==typeof t)return t+"px";if("string"==typeof t){if(-1!==nr(t).call(t,"%")||-1!==nr(t).call(t,"px"))return t;if(-1===nr(t).call(t,"%"))return t+"px"}throw new Error("Could not use the value supplied for width or height:"+t)}},{key:"_create",value:function(){for(;this.body.container.hasChildNodes();)this.body.container.removeChild(this.body.container.firstChild);if(this.frame=document.createElement("div"),this.frame.className="vis-network",this.frame.style.position="relative",this.frame.style.overflow="hidden",this.frame.tabIndex=900,this.frame.canvas=document.createElement("canvas"),this.frame.canvas.style.position="relative",this.frame.appendChild(this.frame.canvas),this.frame.canvas.getContext)this._setPixelRatio(),this.setTransform();else{var t=document.createElement("DIV");t.style.color="red",t.style.fontWeight="bold",t.style.padding="10px",t.innerHTML="Error: your browser does not support HTML canvas",this.frame.canvas.appendChild(t)}this.body.container.appendChild(this.frame),this.body.view.scale=1,this.body.view.translation={x:.5*this.frame.canvas.clientWidth,y:.5*this.frame.canvas.clientHeight},this._bindHammer()}},{key:"_bindHammer",value:function(){var t=this;void 0!==this.hammer&&this.hammer.destroy(),this.drag={},this.pinch={},this.hammer=new Vh(this.frame.canvas),this.hammer.get("pinch").set({enable:!0}),this.hammer.get("pan").set({threshold:5,direction:Vh.DIRECTION_ALL}),Of.onTouch(this.hammer,(function(e){t.body.eventListeners.onTouch(e)})),this.hammer.on("tap",(function(e){t.body.eventListeners.onTap(e)})),this.hammer.on("doubletap",(function(e){t.body.eventListeners.onDoubleTap(e)})),this.hammer.on("press",(function(e){t.body.eventListeners.onHold(e)})),this.hammer.on("panstart",(function(e){t.body.eventListeners.onDragStart(e)})),this.hammer.on("panmove",(function(e){t.body.eventListeners.onDrag(e)})),this.hammer.on("panend",(function(e){t.body.eventListeners.onDragEnd(e)})),this.hammer.on("pinch",(function(e){t.body.eventListeners.onPinch(e)})),this.frame.canvas.addEventListener("wheel",(function(e){t.body.eventListeners.onMouseWheel(e)})),this.frame.canvas.addEventListener("mousemove",(function(e){t.body.eventListeners.onMouseMove(e)})),this.frame.canvas.addEventListener("contextmenu",(function(e){t.body.eventListeners.onContext(e)})),this.hammerFrame=new Vh(this.frame),Of.onRelease(this.hammerFrame,(function(e){t.body.eventListeners.onRelease(e)}))}},{key:"setSize",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.options.width,e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.height;t=this._prepareValue(t),e=this._prepareValue(e);var i=!1,n=this.frame.canvas.width,o=this.frame.canvas.height,r=this.pixelRatio;if(this._setPixelRatio(),t!=this.options.width||e!=this.options.height||this.frame.style.width!=t||this.frame.style.height!=e)this._getCameraState(r),this.frame.style.width=t,this.frame.style.height=e,this.frame.canvas.style.width="100%",this.frame.canvas.style.height="100%",this.frame.canvas.width=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),this.frame.canvas.height=Math.round(this.frame.canvas.clientHeight*this.pixelRatio),this.options.width=t,this.options.height=e,this.canvasViewCenter={x:.5*this.frame.clientWidth,y:.5*this.frame.clientHeight},i=!0;else{var s=Math.round(this.frame.canvas.clientWidth*this.pixelRatio),a=Math.round(this.frame.canvas.clientHeight*this.pixelRatio);this.frame.canvas.width===s&&this.frame.canvas.height===a||this._getCameraState(r),this.frame.canvas.width!==s&&(this.frame.canvas.width=s,i=!0),this.frame.canvas.height!==a&&(this.frame.canvas.height=a,i=!0)}return!0===i&&(this.body.emitter.emit("resize",{width:Math.round(this.frame.canvas.width/this.pixelRatio),height:Math.round(this.frame.canvas.height/this.pixelRatio),oldWidth:Math.round(n/this.pixelRatio),oldHeight:Math.round(o/this.pixelRatio)}),this._setCameraState()),this.initialized=!0,i}},{key:"getContext",value:function(){return this.frame.canvas.getContext("2d")}},{key:"_determinePixelRatio",value:function(){var t=this.getContext();if(void 0===t)throw new Error("Could not get canvax context");var e=1;return"undefined"!=typeof window&&(e=window.devicePixelRatio||1),e/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)}},{key:"_setPixelRatio",value:function(){this.pixelRatio=this._determinePixelRatio()}},{key:"setTransform",value:function(){var t=this.getContext();if(void 0===t)throw new Error("Could not get canvax context");t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}},{key:"_XconvertDOMtoCanvas",value:function(t){return(t-this.body.view.translation.x)/this.body.view.scale}},{key:"_XconvertCanvasToDOM",value:function(t){return t*this.body.view.scale+this.body.view.translation.x}},{key:"_YconvertDOMtoCanvas",value:function(t){return(t-this.body.view.translation.y)/this.body.view.scale}},{key:"_YconvertCanvasToDOM",value:function(t){return t*this.body.view.scale+this.body.view.translation.y}},{key:"canvasToDOM",value:function(t){return{x:this._XconvertCanvasToDOM(t.x),y:this._YconvertCanvasToDOM(t.y)}}},{key:"DOMtoCanvas",value:function(t){return{x:this._XconvertDOMtoCanvas(t.x),y:this._YconvertDOMtoCanvas(t.y)}}}]),t}()),Ef=function(){function t(e,i){var n,o,r=this;Kh(this,t),this.body=e,this.canvas=i,this.animationSpeed=1/this.renderRefreshRate,this.animationEasingFunction="easeInOutQuint",this.easingTime=0,this.sourceScale=0,this.targetScale=0,this.sourceTranslation=0,this.targetTranslation=0,this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0,this.touchTime=0,this.viewFunction=void 0,this.body.emitter.on("fit",J(n=this.fit).call(n,this)),this.body.emitter.on("animationFinished",(function(){r.body.emitter.emit("_stopRendering")})),this.body.emitter.on("unlockNode",J(o=this.releaseNode).call(o,this))}return Qh(t,[{key:"setOptions",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};this.options=t}},{key:"fit",value:function(){var t,e,i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{nodes:[]},n=arguments.length>1&&void 0!==arguments[1]&&arguments[1];void 0!==(i=hr({},i)).nodes&&0!==i.nodes.length||(i.nodes=this.body.nodeIndices);var o=this.canvas.frame.canvas.clientWidth,r=this.canvas.frame.canvas.clientHeight;if(0===o||0===r)e=1,t=mf.getRange(this.body.nodes,i.nodes);else if(!0===n){var s=0;for(var a in this.body.nodes)if(this.body.nodes.hasOwnProperty(a)){var h=this.body.nodes[a];!0===h.predefinedPosition&&(s+=1)}if(s>.5*this.body.nodeIndices.length)return void this.fit(i,!1);t=mf.getRange(this.body.nodes,i.nodes);var l=this.body.nodeIndices.length;e=12.662/(l+7.4147)+.0964822;var d=Math.min(o/600,r/600);e*=d}else{this.body.emitter.emit("_resizeNodes"),t=mf.getRange(this.body.nodes,i.nodes);var u=1.1*Math.abs(t.maxX-t.minX),c=1.1*Math.abs(t.maxY-t.minY),f=o/u,p=r/c;e=f<=p?f:p}(e>1||0===e)&&(e=1);var v=mf.findCenter(t),g={position:v,scale:e,animation:i.animation};this.moveTo(g)}},{key:"focus",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(void 0!==this.body.nodes[t]){var i={x:this.body.nodes[t].x,y:this.body.nodes[t].y};e.position=i,e.lockedOnNode=t,this.moveTo(e)}else console.log("Node: "+t+" cannot be found.")}},{key:"moveTo",value:function(t){if(void 0!==t){if(null!=t.offset){if(null!=t.offset.x){if(t.offset.x=+t.offset.x,!pl(t.offset.x))throw new TypeError('The option "offset.x" has to be a finite number.')}else t.offset.x=0;if(null!=t.offset.y){if(t.offset.y=+t.offset.y,!pl(t.offset.y))throw new TypeError('The option "offset.y" has to be a finite number.')}else t.offset.x=0}else t.offset={x:0,y:0};if(null!=t.position){if(null!=t.position.x){if(t.position.x=+t.position.x,!pl(t.position.x))throw new TypeError('The option "position.x" has to be a finite number.')}else t.position.x=0;if(null!=t.position.y){if(t.position.y=+t.position.y,!pl(t.position.y))throw new TypeError('The option "position.y" has to be a finite number.')}else t.position.x=0}else t.position=this.getViewPosition();if(null!=t.scale){if(t.scale=+t.scale,!(t.scale>0))throw new TypeError('The option "scale" has to be a number greater than zero.')}else t.scale=this.body.view.scale;void 0===t.animation&&(t.animation={duration:0}),!1===t.animation&&(t.animation={duration:0}),!0===t.animation&&(t.animation={}),void 0===t.animation.duration&&(t.animation.duration=1e3),void 0===t.animation.easingFunction&&(t.animation.easingFunction="easeInOutQuad"),this.animateView(t)}else t={}}},{key:"animateView",value:function(t){if(void 0!==t){this.animationEasingFunction=t.animation.easingFunction,this.releaseNode(),!0===t.locked&&(this.lockedOnNodeId=t.lockedOnNode,this.lockedOnNodeOffset=t.offset),0!=this.easingTime&&this._transitionRedraw(!0),this.sourceScale=this.body.view.scale,this.sourceTranslation=this.body.view.translation,this.targetScale=t.scale,this.body.view.scale=this.targetScale;var e,i,n=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),o=n.x-t.position.x,r=n.y-t.position.y;if(this.targetTranslation={x:this.sourceTranslation.x+o*this.targetScale+t.offset.x,y:this.sourceTranslation.y+r*this.targetScale+t.offset.y},0===t.animation.duration)if(null!=this.lockedOnNodeId)this.viewFunction=J(e=this._lockedRedraw).call(e,this),this.body.emitter.on("initRedraw",this.viewFunction);else this.body.view.scale=this.targetScale,this.body.view.translation=this.targetTranslation,this.body.emitter.emit("_requestRedraw");else this.animationSpeed=1/(60*t.animation.duration*.001)||1/60,this.animationEasingFunction=t.animation.easingFunction,this.viewFunction=J(i=this._transitionRedraw).call(i,this),this.body.emitter.on("initRedraw",this.viewFunction),this.body.emitter.emit("_startRendering")}}},{key:"_lockedRedraw",value:function(){var t=this.body.nodes[this.lockedOnNodeId].x,e=this.body.nodes[this.lockedOnNodeId].y,i=this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight}),n=i.x-t,o=i.y-e,r=this.body.view.translation,s={x:r.x+n*this.body.view.scale+this.lockedOnNodeOffset.x,y:r.y+o*this.body.view.scale+this.lockedOnNodeOffset.y};this.body.view.translation=s}},{key:"releaseNode",value:function(){void 0!==this.lockedOnNodeId&&void 0!==this.viewFunction&&(this.body.emitter.off("initRedraw",this.viewFunction),this.lockedOnNodeId=void 0,this.lockedOnNodeOffset=void 0)}},{key:"_transitionRedraw",value:function(){var t=arguments.length>0&&void 0!==arguments[0]&&arguments[0];this.easingTime+=this.animationSpeed,this.easingTime=!0===t?1:this.easingTime;var e=ds[this.animationEasingFunction](this.easingTime);if(this.body.view.scale=this.sourceScale+(this.targetScale-this.sourceScale)*e,this.body.view.translation={x:this.sourceTranslation.x+(this.targetTranslation.x-this.sourceTranslation.x)*e,y:this.sourceTranslation.y+(this.targetTranslation.y-this.sourceTranslation.y)*e},this.easingTime>=1){var i;if(this.body.emitter.off("initRedraw",this.viewFunction),this.easingTime=0,null!=this.lockedOnNodeId)this.viewFunction=J(i=this._lockedRedraw).call(i,this),this.body.emitter.on("initRedraw",this.viewFunction);this.body.emitter.emit("animationFinished")}}},{key:"getScale",value:function(){return this.body.view.scale}},{key:"getViewPosition",value:function(){return this.canvas.DOMtoCanvas({x:.5*this.canvas.frame.canvas.clientWidth,y:.5*this.canvas.frame.canvas.clientHeight})}}]),t}(),Df=function(){function t(e,i){var n=this;Kh(this,t),this.body=e,this.canvas=i,this.iconsCreated=!1,this.navigationHammers=[],this.boundFunctions={},this.touchTime=0,this.activated=!1,this.body.emitter.on("activate",(function(){n.activated=!0,n.configureKeyboardBindings()})),this.body.emitter.on("deactivate",(function(){n.activated=!1,n.configureKeyboardBindings()})),this.body.emitter.on("destroy",(function(){void 0!==n.keycharm&&n.keycharm.destroy()})),this.options={}}return Qh(t,[{key:"setOptions",value:function(t){void 0!==t&&(this.options=t,this.create())}},{key:"create",value:function(){!0===this.options.navigationButtons?!1===this.iconsCreated&&this.loadNavigationElements():!0===this.iconsCreated&&this.cleanNavigation(),this.configureKeyboardBindings()}},{key:"cleanNavigation",value:function(){if(0!=this.navigationHammers.length){for(var t=0;t<this.navigationHammers.length;t++)this.navigationHammers[t].destroy();this.navigationHammers=[]}this.navigationDOM&&this.navigationDOM.wrapper&&this.navigationDOM.wrapper.parentNode&&this.navigationDOM.wrapper.parentNode.removeChild(this.navigationDOM.wrapper),this.iconsCreated=!1}},{key:"loadNavigationElements",value:function(){var t=this;this.cleanNavigation(),this.navigationDOM={};var e=["up","down","left","right","zoomIn","zoomOut","zoomExtends"],i=["_moveUp","_moveDown","_moveLeft","_moveRight","_zoomIn","_zoomOut","_fit"];this.navigationDOM.wrapper=document.createElement("div"),this.navigationDOM.wrapper.className="vis-navigation",this.canvas.frame.appendChild(this.navigationDOM.wrapper);for(var n=0;n<e.length;n++){this.navigationDOM[e[n]]=document.createElement("div"),this.navigationDOM[e[n]].className="vis-button vis-"+e[n],this.navigationDOM.wrapper.appendChild(this.navigationDOM[e[n]]);var o,r,s=new Vh(this.navigationDOM[e[n]]);if("_fit"===i[n])Of.onTouch(s,J(o=this._fit).call(o,this));else Of.onTouch(s,J(r=this.bindToRedraw).call(r,this,i[n]));this.navigationHammers.push(s)}var a=new Vh(this.canvas.frame);Of.onRelease(a,(function(){t._stopMovement()})),this.navigationHammers.push(a),this.iconsCreated=!0}},{key:"bindToRedraw",value:function(t){var e;void 0===this.boundFunctions[t]&&(this.boundFunctions[t]=J(e=this[t]).call(e,this),this.body.emitter.on("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_startRendering"))}},{key:"unbindFromRedraw",value:function(t){void 0!==this.boundFunctions[t]&&(this.body.emitter.off("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_stopRendering"),delete this.boundFunctions[t])}},{key:"_fit",value:function(){(new Date).valueOf()-this.touchTime>700&&(this.body.emitter.emit("fit",{duration:700}),this.touchTime=(new Date).valueOf())}},{key:"_stopMovement",value:function(){for(var t in this.boundFunctions)this.boundFunctions.hasOwnProperty(t)&&(this.body.emitter.off("initRedraw",this.boundFunctions[t]),this.body.emitter.emit("_stopRendering"));this.boundFunctions={}}},{key:"_moveUp",value:function(){this.body.view.translation.y+=this.options.keyboard.speed.y}},{key:"_moveDown",value:function(){this.body.view.translation.y-=this.options.keyboard.speed.y}},{key:"_moveLeft",value:function(){this.body.view.translation.x+=this.options.keyboard.speed.x}},{key:"_moveRight",value:function(){this.body.view.translation.x-=this.options.keyboard.speed.x}},{key:"_zoomIn",value:function(){var t=this.body.view.scale,e=this.body.view.scale*(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,n=e/t,o=(1-n)*this.canvas.canvasViewCenter.x+i.x*n,r=(1-n)*this.canvas.canvasViewCenter.y+i.y*n;this.body.view.scale=e,this.body.view.translation={x:o,y:r},this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:null})}},{key:"_zoomOut",value:function(){var t=this.body.view.scale,e=this.body.view.scale/(1+this.options.keyboard.speed.zoom),i=this.body.view.translation,n=e/t,o=(1-n)*this.canvas.canvasViewCenter.x+i.x*n,r=(1-n)*this.canvas.canvasViewCenter.y+i.y*n;this.body.view.scale=e,this.body.view.translation={x:o,y:r},this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:null})}},{key:"configureKeyboardBindings",value:function(){var t,e,i,n,o,r,s,a,h,l,d,u,c,f,p,v,g,y,m,b,w,_,k,x,O=this;(void 0!==this.keycharm&&this.keycharm.destroy(),!0===this.options.keyboard.enabled)&&(!0===this.options.keyboard.bindToWindow?this.keycharm=va({container:window,preventDefault:!0}):this.keycharm=va({container:this.canvas.frame,preventDefault:!0}),this.keycharm.reset(),!0===this.activated&&(J(t=this.keycharm).call(t,"up",(function(){O.bindToRedraw("_moveUp")}),"keydown"),J(e=this.keycharm).call(e,"down",(function(){O.bindToRedraw("_moveDown")}),"keydown"),J(i=this.keycharm).call(i,"left",(function(){O.bindToRedraw("_moveLeft")}),"keydown"),J(n=this.keycharm).call(n,"right",(function(){O.bindToRedraw("_moveRight")}),"keydown"),J(o=this.keycharm).call(o,"=",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),J(r=this.keycharm).call(r,"num+",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),J(s=this.keycharm).call(s,"num-",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),J(a=this.keycharm).call(a,"-",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),J(h=this.keycharm).call(h,"[",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),J(l=this.keycharm).call(l,"]",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),J(d=this.keycharm).call(d,"pageup",(function(){O.bindToRedraw("_zoomIn")}),"keydown"),J(u=this.keycharm).call(u,"pagedown",(function(){O.bindToRedraw("_zoomOut")}),"keydown"),J(c=this.keycharm).call(c,"up",(function(){O.unbindFromRedraw("_moveUp")}),"keyup"),J(f=this.keycharm).call(f,"down",(function(){O.unbindFromRedraw("_moveDown")}),"keyup"),J(p=this.keycharm).call(p,"left",(function(){O.unbindFromRedraw("_moveLeft")}),"keyup"),J(v=this.keycharm).call(v,"right",(function(){O.unbindFromRedraw("_moveRight")}),"keyup"),J(g=this.keycharm).call(g,"=",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),J(y=this.keycharm).call(y,"num+",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),J(m=this.keycharm).call(m,"num-",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup"),J(b=this.keycharm).call(b,"-",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup"),J(w=this.keycharm).call(w,"[",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup"),J(_=this.keycharm).call(_,"]",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),J(k=this.keycharm).call(k,"pageup",(function(){O.unbindFromRedraw("_zoomIn")}),"keyup"),J(x=this.keycharm).call(x,"pagedown",(function(){O.unbindFromRedraw("_zoomOut")}),"keyup")))}}]),t}(),Mf=function(){function t(e,i){Kh(this,t),this.container=e,this.overflowMethod=i||"cap",this.x=0,this.y=0,this.padding=5,this.hidden=!1,this.frame=document.createElement("div"),this.frame.className="vis-tooltip",this.container.appendChild(this.frame)}return Qh(t,[{key:"setPosition",value:function(t,e){this.x=uo(t),this.y=uo(e)}},{key:"setText",value:function(t){t instanceof Element?(this.frame.innerHTML="",this.frame.appendChild(t)):this.frame.innerHTML=t}},{key:"show",value:function(t){if(void 0===t&&(t=!0),!0===t){var e=this.frame.clientHeight,i=this.frame.clientWidth,n=this.frame.parentNode.clientHeight,o=this.frame.parentNode.clientWidth,r=0,s=0;if("flip"==this.overflowMethod){var a=!1,h=!0;this.y-e<this.padding&&(h=!1),this.x+i>o-this.padding&&(a=!0),r=a?this.x-i:this.x,s=h?this.y-e:this.y}else(s=this.y-e)+e+this.padding>n&&(s=n-e-this.padding),s<this.padding&&(s=this.padding),(r=this.x)+i+this.padding>o&&(r=o-i-this.padding),r<this.padding&&(r=this.padding);this.frame.style.left=r+"px",this.frame.style.top=s+"px",this.frame.style.visibility="visible",this.hidden=!1}else this.hide()}},{key:"hide",value:function(){this.hidden=!0,this.frame.style.left="0",this.frame.style.top="0",this.frame.style.visibility="hidden"}},{key:"destroy",value:function(){this.frame.parentNode.removeChild(this.frame)}}]),t}(),Cf=function(){function t(e,i,n){var o,r,s,a,h,l,d,u,c,f,p,v,g;Kh(this,t),this.body=e,this.canvas=i,this.selectionHandler=n,this.navigationHandler=new Df(e,i),this.body.eventListeners.onTap=J(o=this.onTap).call(o,this),this.body.eventListeners.onTouch=J(r=this.onTouch).call(r,this),this.body.eventListeners.onDoubleTap=J(s=this.onDoubleTap).call(s,this),this.body.eventListeners.onHold=J(a=this.onHold).call(a,this),this.body.eventListeners.onDragStart=J(h=this.onDragStart).call(h,this),this.body.eventListeners.onDrag=J(l=this.onDrag).call(l,this),this.body.eventListeners.onDragEnd=J(d=this.onDragEnd).call(d,this),this.body.eventListeners.onMouseWheel=J(u=this.onMouseWheel).call(u,this),this.body.eventListeners.onPinch=J(c=this.onPinch).call(c,this),this.body.eventListeners.onMouseMove=J(f=this.onMouseMove).call(f,this),this.body.eventListeners.onRelease=J(p=this.onRelease).call(p,this),this.body.eventListeners.onContext=J(v=this.onContext).call(v,this),this.touchTime=0,this.drag={},this.pinch={},this.popup=void 0,this.popupObj=void 0,this.popupTimer=void 0,this.body.functions.getPointer=J(g=this.getPointer).call(g,this),this.options={},this.defaultOptions={dragNodes:!0,dragView:!0,hover:!1,keyboard:{enabled:!1,speed:{x:10,y:10,zoom:.02},bindToWindow:!0},navigationButtons:!1,tooltipDelay:300,zoomView:!0,zoomSpeed:1},Fr(this.options,this.defaultOptions),this.bindEventListeners()}return Qh(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("destroy",(function(){clearTimeout(t.popupTimer),delete t.body.functions.getPointer}))}},{key:"setOptions",value:function(t){if(void 0!==t){zr(["hideEdgesOnDrag","hideEdgesOnZoom","hideNodesOnDrag","keyboard","multiselect","selectable","selectConnectedEdges"],this.options,t),ls(this.options,t,"keyboard"),t.tooltip&&(Fr(this.options.tooltip,t.tooltip),t.tooltip.color&&(this.options.tooltip.color=Qr(t.tooltip.color)))}this.navigationHandler.setOptions(this.options)}},{key:"getPointer",value:function(t){return{x:t.x-Wr(this.canvas.frame.canvas),y:t.y-Yr(this.canvas.frame.canvas)}}},{key:"onTouch",value:function(t){(new Date).valueOf()-this.touchTime>50&&(this.drag.pointer=this.getPointer(t.center),this.drag.pinched=!1,this.pinch.scale=this.body.view.scale,this.touchTime=(new Date).valueOf())}},{key:"onTap",value:function(t){var e=this.getPointer(t.center),i=this.selectionHandler.options.multiselect&&(t.changedPointers[0].ctrlKey||t.changedPointers[0].metaKey);this.checkSelectionChanges(e,t,i),this.selectionHandler._generateClickEvent("click",t,e)}},{key:"onDoubleTap",value:function(t){var e=this.getPointer(t.center);this.selectionHandler._generateClickEvent("doubleClick",t,e)}},{key:"onHold",value:function(t){var e=this.getPointer(t.center),i=this.selectionHandler.options.multiselect;this.checkSelectionChanges(e,t,i),this.selectionHandler._generateClickEvent("click",t,e),this.selectionHandler._generateClickEvent("hold",t,e)}},{key:"onRelease",value:function(t){if((new Date).valueOf()-this.touchTime>10){var e=this.getPointer(t.center);this.selectionHandler._generateClickEvent("release",t,e),this.touchTime=(new Date).valueOf()}}},{key:"onContext",value:function(t){var e=this.getPointer({x:t.clientX,y:t.clientY});this.selectionHandler._generateClickEvent("oncontext",t,e)}},{key:"checkSelectionChanges",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=this.selectionHandler.getSelection(),o=!1;o=!0===i?this.selectionHandler.selectAdditionalOnPoint(t):this.selectionHandler.selectOnPoint(t);var r=this.selectionHandler.getSelection(),s=this._determineDifference(n,r),a=this._determineDifference(r,n);s.edges.length>0&&(this.selectionHandler._generateClickEvent("deselectEdge",e,t,n),o=!0),s.nodes.length>0&&(this.selectionHandler._generateClickEvent("deselectNode",e,t,n),o=!0),a.nodes.length>0&&(this.selectionHandler._generateClickEvent("selectNode",e,t),o=!0),a.edges.length>0&&(this.selectionHandler._generateClickEvent("selectEdge",e,t),o=!0),!0===o&&this.selectionHandler._generateClickEvent("select",e,t)}},{key:"_determineDifference",value:function(t,e){var i=function(t,e){for(var i=[],n=0;n<t.length;n++){var o=t[n];-1===nr(e).call(e,o)&&i.push(o)}return i};return{nodes:i(t.nodes,e.nodes),edges:i(t.edges,e.edges)}}},{key:"onDragStart",value:function(t){void 0===this.drag.pointer&&this.onTouch(t);var e=this.selectionHandler.getNodeAt(this.drag.pointer);if(this.drag.dragging=!0,this.drag.selection=[],this.drag.translation=Fr({},this.body.view.translation),this.drag.nodeId=void 0,void 0!==e&&!0===this.options.dragNodes){this.drag.nodeId=e.id,!1===e.isSelected()&&(this.selectionHandler.unselectAll(),this.selectionHandler.selectObject(e)),this.selectionHandler._generateClickEvent("dragStart",t,this.drag.pointer);var i=this.selectionHandler.selectionObj.nodes;for(var n in i)if(i.hasOwnProperty(n)){var o=i[n],r={id:o.id,node:o,x:o.x,y:o.y,xFixed:o.options.fixed.x,yFixed:o.options.fixed.y};o.options.fixed.x=!0,o.options.fixed.y=!0,this.drag.selection.push(r)}}else this.selectionHandler._generateClickEvent("dragStart",t,this.drag.pointer,void 0,!0)}},{key:"onDrag",value:function(t){var e=this;if(!0!==this.drag.pinched){this.body.emitter.emit("unlockNode");var i=this.getPointer(t.center),n=this.drag.selection;if(n&&n.length&&!0===this.options.dragNodes){this.selectionHandler._generateClickEvent("dragging",t,i);var o=i.x-this.drag.pointer.x,r=i.y-this.drag.pointer.y;Jn(n).call(n,(function(t){var i=t.node;!1===t.xFixed&&(i.x=e.canvas._XconvertDOMtoCanvas(e.canvas._XconvertCanvasToDOM(t.x)+o)),!1===t.yFixed&&(i.y=e.canvas._YconvertDOMtoCanvas(e.canvas._YconvertCanvasToDOM(t.y)+r))})),this.body.emitter.emit("startSimulation")}else if(!0===this.options.dragView){if(this.selectionHandler._generateClickEvent("dragging",t,i,void 0,!0),void 0===this.drag.pointer)return void this.onDragStart(t);var s=i.x-this.drag.pointer.x,a=i.y-this.drag.pointer.y;this.body.view.translation={x:this.drag.translation.x+s,y:this.drag.translation.y+a},this.body.emitter.emit("_requestRedraw")}}}},{key:"onDragEnd",value:function(t){this.drag.dragging=!1;var e=this.drag.selection;e&&e.length?(Jn(e).call(e,(function(t){t.node.options.fixed.x=t.xFixed,t.node.options.fixed.y=t.yFixed})),this.selectionHandler._generateClickEvent("dragEnd",t,this.getPointer(t.center)),this.body.emitter.emit("startSimulation")):(this.selectionHandler._generateClickEvent("dragEnd",t,this.getPointer(t.center),void 0,!0),this.body.emitter.emit("_requestRedraw"))}},{key:"onPinch",value:function(t){var e=this.getPointer(t.center);this.drag.pinched=!0,void 0===this.pinch.scale&&(this.pinch.scale=1);var i=this.pinch.scale*t.scale;this.zoom(i,e)}},{key:"zoom",value:function(t,e){if(!0===this.options.zoomView){var i=this.body.view.scale;t<1e-5&&(t=1e-5),t>10&&(t=10);var n=void 0;void 0!==this.drag&&!0===this.drag.dragging&&(n=this.canvas.DOMtoCanvas(this.drag.pointer));var o=this.body.view.translation,r=t/i,s=(1-r)*e.x+o.x*r,a=(1-r)*e.y+o.y*r;if(this.body.view.scale=t,this.body.view.translation={x:s,y:a},null!=n){var h=this.canvas.canvasToDOM(n);this.drag.pointer.x=h.x,this.drag.pointer.y=h.y}this.body.emitter.emit("_requestRedraw"),i<t?this.body.emitter.emit("zoom",{direction:"+",scale:this.body.view.scale,pointer:e}):this.body.emitter.emit("zoom",{direction:"-",scale:this.body.view.scale,pointer:e})}}},{key:"onMouseWheel",value:function(t){if(!0===this.options.zoomView){if(0!==t.deltaY){var e=this.body.view.scale;e*=1+(t.deltaY<0?1:-1)*(.1*this.options.zoomSpeed);var i=this.getPointer({x:t.clientX,y:t.clientY});this.zoom(e,i)}t.preventDefault()}}},{key:"onMouseMove",value:function(t){var e=this,i=this.getPointer({x:t.clientX,y:t.clientY}),n=!1;void 0!==this.popup&&(!1===this.popup.hidden&&this._checkHidePopup(i),!1===this.popup.hidden&&(n=!0,this.popup.setPosition(i.x+3,i.y-5),this.popup.show())),!1===this.options.keyboard.bindToWindow&&!0===this.options.keyboard.enabled&&this.canvas.frame.focus(),!1===n&&(void 0!==this.popupTimer&&(clearInterval(this.popupTimer),this.popupTimer=void 0),this.drag.dragging||(this.popupTimer=rl((function(){return e._checkShowPopup(i)}),this.options.tooltipDelay))),!0===this.options.hover&&this.selectionHandler.hoverObject(t,i)}},{key:"_checkShowPopup",value:function(t){var e=this.canvas._XconvertDOMtoCanvas(t.x),i=this.canvas._YconvertDOMtoCanvas(t.y),n={left:e,top:i,right:e,bottom:i},o=void 0===this.popupObj?void 0:this.popupObj.id,r=!1,s="node";if(void 0===this.popupObj){for(var a,h=this.body.nodeIndices,l=this.body.nodes,d=[],u=0;u<h.length;u++)!0===(a=l[h[u]]).isOverlappingWith(n)&&(r=!0,void 0!==a.getTitle()&&d.push(h[u]));d.length>0&&(this.popupObj=l[d[d.length-1]],r=!0)}if(void 0===this.popupObj&&!1===r){for(var c,f=this.body.edgeIndices,p=this.body.edges,v=[],g=0;g<f.length;g++)!0===(c=p[f[g]]).isOverlappingWith(n)&&!0===c.connected&&void 0!==c.getTitle()&&v.push(f[g]);v.length>0&&(this.popupObj=p[v[v.length-1]],s="edge")}void 0!==this.popupObj?this.popupObj.id!==o&&(void 0===this.popup&&(this.popup=new Mf(this.canvas.frame)),this.popup.popupTargetType=s,this.popup.popupTargetId=this.popupObj.id,this.popup.setPosition(t.x+3,t.y-5),this.popup.setText(this.popupObj.getTitle()),this.popup.show(),this.body.emitter.emit("showPopup",this.popupObj.id)):void 0!==this.popup&&(this.popup.hide(),this.body.emitter.emit("hidePopup"))}},{key:"_checkHidePopup",value:function(t){var e=this.selectionHandler._pointerToPositionObject(t),i=!1;if("node"===this.popup.popupTargetType){if(void 0!==this.body.nodes[this.popup.popupTargetId]&&!0===(i=this.body.nodes[this.popup.popupTargetId].isOverlappingWith(e))){var n=this.selectionHandler.getNodeAt(t);i=void 0!==n&&n.id===this.popup.popupTargetId}}else void 0===this.selectionHandler.getNodeAt(t)&&void 0!==this.body.edges[this.popup.popupTargetId]&&(i=this.body.edges[this.popup.popupTargetId].isOverlappingWith(e));!1===i&&(this.popupObj=void 0,this.popup.hide(),this.body.emitter.emit("hidePopup"))}}]),t}(),Tf=function(){function t(e,i){var n=this;Kh(this,t),this.body=e,this.canvas=i,this.selectionObj={nodes:[],edges:[]},this.hoverObj={nodes:{},edges:{}},this.options={},this.defaultOptions={multiselect:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0},Fr(this.options,this.defaultOptions),this.body.emitter.on("_dataChanged",(function(){n.updateSelection()}))}return Qh(t,[{key:"setOptions",value:function(t){if(void 0!==t){jr(["multiselect","hoverConnectedEdges","selectable","selectConnectedEdges"],this.options,t)}}},{key:"selectOnPoint",value:function(t){var e=!1;if(!0===this.options.selectable){var i=this.getNodeAt(t)||this.getEdgeAt(t);this.unselectAll(),void 0!==i&&(e=this.selectObject(i)),this.body.emitter.emit("_requestRedraw")}return e}},{key:"selectAdditionalOnPoint",value:function(t){var e=!1;if(!0===this.options.selectable){var i=this.getNodeAt(t)||this.getEdgeAt(t);void 0!==i&&(e=!0,!0===i.isSelected()?this.deselectObject(i):this.selectObject(i),this.body.emitter.emit("_requestRedraw"))}return e}},{key:"_initBaseEvent",value:function(t,e){var i={};return i.pointer={DOM:{x:e.x,y:e.y},canvas:this.canvas.DOMtoCanvas(e)},i.event=t,i}},{key:"_generateClickEvent",value:function(t,e,i,n){var o=arguments.length>4&&void 0!==arguments[4]&&arguments[4],r=this._initBaseEvent(e,i);if(!0===o)r.nodes=[],r.edges=[];else{var s=this.getSelection();r.nodes=s.nodes,r.edges=s.edges}void 0!==n&&(r.previousSelection=n),"click"==t&&(r.items=this.getClickedItems(i)),void 0!==e.controlEdge&&(r.controlEdge=e.controlEdge),this.body.emitter.emit(t,r)}},{key:"selectObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:this.options.selectConnectedEdges;return void 0!==t&&(t instanceof lc&&!0===e&&this._selectConnectedEdges(t),t.select(),this._addToSelection(t),!0)}},{key:"deselectObject",value:function(t){!0===t.isSelected()&&(t.selected=!1,this._removeFromSelection(t))}},{key:"_getAllNodesOverlappingWith",value:function(t){for(var e=[],i=this.body.nodes,n=0;n<this.body.nodeIndices.length;n++){var o=this.body.nodeIndices[n];i[o].isOverlappingWith(t)&&e.push(o)}return e}},{key:"_pointerToPositionObject",value:function(t){var e=this.canvas.DOMtoCanvas(t);return{left:e.x-1,top:e.y+1,right:e.x+1,bottom:e.y-1}}},{key:"getNodeAt",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this._pointerToPositionObject(t),n=this._getAllNodesOverlappingWith(i);return n.length>0?!0===e?this.body.nodes[n[n.length-1]]:n[n.length-1]:void 0}},{key:"_getEdgesOverlappingWith",value:function(t,e){for(var i=this.body.edges,n=0;n<this.body.edgeIndices.length;n++){var o=this.body.edgeIndices[n];i[o].isOverlappingWith(t)&&e.push(o)}}},{key:"_getAllEdgesOverlappingWith",value:function(t){var e=[];return this._getEdgesOverlappingWith(t,e),e}},{key:"getEdgeAt",value:function(t){for(var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1],i=this.canvas.DOMtoCanvas(t),n=10,o=null,r=this.body.edges,s=0;s<this.body.edgeIndices.length;s++){var a=this.body.edgeIndices[s],h=r[a];if(h.connected){var l=h.from.x,d=h.from.y,u=h.to.x,c=h.to.y,f=h.edgeType.getDistanceToEdge(l,d,u,c,i.x,i.y);f<n&&(o=a,n=f)}}return null!==o?!0===e?this.body.edges[o]:o:void 0}},{key:"_addToSelection",value:function(t){t instanceof lc?this.selectionObj.nodes[t.id]=t:this.selectionObj.edges[t.id]=t}},{key:"_addToHover",value:function(t){t instanceof lc?this.hoverObj.nodes[t.id]=t:this.hoverObj.edges[t.id]=t}},{key:"_removeFromSelection",value:function(t){t instanceof lc?(delete this.selectionObj.nodes[t.id],this._unselectConnectedEdges(t)):delete this.selectionObj.edges[t.id]}},{key:"unselectAll",value:function(){for(var t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&this.selectionObj.nodes[t].unselect();for(var e in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(e)&&this.selectionObj.edges[e].unselect();this.selectionObj={nodes:{},edges:{}}}},{key:"_getSelectedNodeCount",value:function(){var t=0;for(var e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&(t+=1);return t}},{key:"_getSelectedNode",value:function(){for(var t in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(t))return this.selectionObj.nodes[t]}},{key:"_getSelectedEdge",value:function(){for(var t in this.selectionObj.edges)if(this.selectionObj.edges.hasOwnProperty(t))return this.selectionObj.edges[t]}},{key:"_getSelectedEdgeCount",value:function(){var t=0;for(var e in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(e)&&(t+=1);return t}},{key:"_getSelectedObjectCount",value:function(){var t=0;for(var e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&(t+=1);for(var i in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(i)&&(t+=1);return t}},{key:"_selectionIsEmpty",value:function(){for(var t in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(t))return!1;for(var e in this.selectionObj.edges)if(this.selectionObj.edges.hasOwnProperty(e))return!1;return!0}},{key:"_clusterInSelection",value:function(){for(var t in this.selectionObj.nodes)if(this.selectionObj.nodes.hasOwnProperty(t)&&this.selectionObj.nodes[t].clusterSize>1)return!0;return!1}},{key:"_selectConnectedEdges",value:function(t){for(var e=0;e<t.edges.length;e++){var i=t.edges[e];i.select(),this._addToSelection(i)}}},{key:"_hoverConnectedEdges",value:function(t){for(var e=0;e<t.edges.length;e++){var i=t.edges[e];i.hover=!0,this._addToHover(i)}}},{key:"_unselectConnectedEdges",value:function(t){for(var e=0;e<t.edges.length;e++){var i=t.edges[e];i.unselect(),this._removeFromSelection(i)}}},{key:"emitBlurEvent",value:function(t,e,i){var n=this._initBaseEvent(t,e);!0===i.hover&&(i.hover=!1,i instanceof lc?(n.node=i.id,this.body.emitter.emit("blurNode",n)):(n.edge=i.id,this.body.emitter.emit("blurEdge",n)))}},{key:"emitHoverEvent",value:function(t,e,i){var n=this._initBaseEvent(t,e),o=!1;return!1===i.hover&&(i.hover=!0,this._addToHover(i),o=!0,i instanceof lc?(n.node=i.id,this.body.emitter.emit("hoverNode",n)):(n.edge=i.id,this.body.emitter.emit("hoverEdge",n))),o}},{key:"hoverObject",value:function(t,e){var i=this.getNodeAt(e);void 0===i&&(i=this.getEdgeAt(e));var n=!1;for(var o in this.hoverObj.nodes)this.hoverObj.nodes.hasOwnProperty(o)&&(void 0===i||i instanceof lc&&i.id!=o||i instanceof Jc)&&(this.emitBlurEvent(t,e,this.hoverObj.nodes[o]),delete this.hoverObj.nodes[o],n=!0);for(var r in this.hoverObj.edges)this.hoverObj.edges.hasOwnProperty(r)&&(!0===n?(this.hoverObj.edges[r].hover=!1,delete this.hoverObj.edges[r]):(void 0===i||i instanceof Jc&&i.id!=r||i instanceof lc&&!i.hover)&&(this.emitBlurEvent(t,e,this.hoverObj.edges[r]),delete this.hoverObj.edges[r],n=!0));if(void 0!==i){var s=Tn(this.hoverObj.edges).length,a=Tn(this.hoverObj.nodes).length;(n||i instanceof Jc&&0===s&&0===a||i instanceof lc&&0===s&&0===a)&&(n=this.emitHoverEvent(t,e,i)),i instanceof lc&&!0===this.options.hoverConnectedEdges&&this._hoverConnectedEdges(i)}!0===n&&this.body.emitter.emit("_requestRedraw")}},{key:"getSelection",value:function(){return{nodes:this.getSelectedNodes(),edges:this.getSelectedEdges()}}},{key:"getSelectedNodes",value:function(){var t=[];if(!0===this.options.selectable)for(var e in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(e)&&t.push(this.selectionObj.nodes[e].id);return t}},{key:"getSelectedEdges",value:function(){var t=[];if(!0===this.options.selectable)for(var e in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(e)&&t.push(this.selectionObj.edges[e].id);return t}},{key:"setSelection",value:function(t){var e,i,n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:{};if(!t||!t.nodes&&!t.edges)throw"Selection must be an object with nodes and/or edges properties";if((n.unselectAll||void 0===n.unselectAll)&&this.unselectAll(),t.nodes)for(e=0;e<t.nodes.length;e++){i=t.nodes[e];var o=this.body.nodes[i];if(!o)throw new RangeError('Node with id "'+i+'" not found');this.selectObject(o,n.highlightEdges)}if(t.edges)for(e=0;e<t.edges.length;e++){i=t.edges[e];var r=this.body.edges[i];if(!r)throw new RangeError('Edge with id "'+i+'" not found');this.selectObject(r)}this.body.emitter.emit("_requestRedraw")}},{key:"selectNodes",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if(!t||void 0===t.length)throw"Selection must be an array with ids";this.setSelection({nodes:t},{highlightEdges:e})}},{key:"selectEdges",value:function(t){if(!t||void 0===t.length)throw"Selection must be an array with ids";this.setSelection({edges:t})}},{key:"updateSelection",value:function(){for(var t in this.selectionObj.nodes)this.selectionObj.nodes.hasOwnProperty(t)&&(this.body.nodes.hasOwnProperty(t)||delete this.selectionObj.nodes[t]);for(var e in this.selectionObj.edges)this.selectionObj.edges.hasOwnProperty(e)&&(this.body.edges.hasOwnProperty(e)||delete this.selectionObj.edges[e])}},{key:"getClickedItems",value:function(t){for(var e=this.canvas.DOMtoCanvas(t),i=[],n=this.body.nodeIndices,o=this.body.nodes,r=n.length-1;r>=0;r--){var s=o[n[r]].getItemsOnPoint(e);i.push.apply(i,s)}for(var a=this.body.edgeIndices,h=this.body.edges,l=a.length-1;l>=0;l--){var d=h[a[l]].getItemsOnPoint(e);i.push.apply(i,d)}return i}}]),t}(),Pf=o((function(t,e){!function(t){t.__esModule=!0,t.sort=function(t,e,i,s){if(!Array.isArray(t))throw new TypeError("Can only sort arrays");e?"function"!=typeof e&&(s=i,i=e,e=n):e=n,i||(i=0),s||(s=t.length);var a=s-i;if(!(a<2)){var l=0;if(a<32)return l=o(t,i,s,e),void r(t,i,s,i+l,e);var d=new h(t,e),u=function(t){for(var e=0;t>=32;)e|=1&t,t>>=1;return t+e}(a);do{if((l=o(t,i,s,e))<u){var c=a;c>u&&(c=u),r(t,i,i+c,i+l,e),l=c}d.pushRun(i,l),d.mergeRuns(),a-=l,i+=l}while(0!==a);d.forceMergeRuns()}};var e=[1,10,100,1e3,1e4,1e5,1e6,1e7,1e8,1e9];function i(t){return t<1e5?t<100?t<10?0:1:t<1e4?t<1e3?2:3:4:t<1e7?t<1e6?5:6:t<1e9?t<1e8?7:8:9}function n(t,n){if(t===n)return 0;if(~~t===t&&~~n===n){if(0===t||0===n)return t<n?-1:1;if(t<0||n<0){if(n>=0)return-1;if(t>=0)return 1;t=-t,n=-n}var o=i(t),r=i(n),s=0;return o<r?(t*=e[r-o-1],n/=10,s=-1):o>r&&(n*=e[o-r-1],t/=10,s=1),t===n?s:t<n?-1:1}var a=String(t),h=String(n);return a===h?0:a<h?-1:1}function o(t,e,i,n){var o=e+1;if(o===i)return 1;if(n(t[o++],t[e])<0){for(;o<i&&n(t[o],t[o-1])<0;)o++;!function(t,e,i){for(i--;e<i;){var n=t[e];t[e++]=t[i],t[i--]=n}}(t,e,o)}else for(;o<i&&n(t[o],t[o-1])>=0;)o++;return o-e}function r(t,e,i,n,o){for(n===e&&n++;n<i;n++){for(var r=t[n],s=e,a=n;s<a;){var h=s+a>>>1;o(r,t[h])<0?a=h:s=h+1}var l=n-s;switch(l){case 3:t[s+3]=t[s+2];case 2:t[s+2]=t[s+1];case 1:t[s+1]=t[s];break;default:for(;l>0;)t[s+l]=t[s+l-1],l--}t[s]=r}}function s(t,e,i,n,o,r){var s=0,a=0,h=1;if(r(t,e[i+o])>0){for(a=n-o;h<a&&r(t,e[i+o+h])>0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),s+=o,h+=o}else{for(a=o+1;h<a&&r(t,e[i+o-h])<=0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var l=s;s=o-h,h=o-l}for(s++;s<h;){var d=s+(h-s>>>1);r(t,e[i+d])>0?s=d+1:h=d}return h}function a(t,e,i,n,o,r){var s=0,a=0,h=1;if(r(t,e[i+o])<0){for(a=o+1;h<a&&r(t,e[i+o-h])<0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a);var l=s;s=o-h,h=o-l}else{for(a=n-o;h<a&&r(t,e[i+o+h])>=0;)s=h,(h=1+(h<<1))<=0&&(h=a);h>a&&(h=a),s+=o,h+=o}for(s++;s<h;){var d=s+(h-s>>>1);r(t,e[i+d])<0?h=d:s=d+1}return h}var h=function(){function t(e,i){!function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")}(this,t),this.array=null,this.compare=null,this.minGallop=7,this.length=0,this.tmpStorageLength=256,this.stackLength=0,this.runStart=null,this.runLength=null,this.stackSize=0,this.array=e,this.compare=i,this.length=e.length,this.length<512&&(this.tmpStorageLength=this.length>>>1),this.tmp=new Array(this.tmpStorageLength),this.stackLength=this.length<120?5:this.length<1542?10:this.length<119151?19:40,this.runStart=new Array(this.stackLength),this.runLength=new Array(this.stackLength)}return t.prototype.pushRun=function(t,e){this.runStart[this.stackSize]=t,this.runLength[this.stackSize]=e,this.stackSize+=1},t.prototype.mergeRuns=function(){for(;this.stackSize>1;){var t=this.stackSize-2;if(t>=1&&this.runLength[t-1]<=this.runLength[t]+this.runLength[t+1]||t>=2&&this.runLength[t-2]<=this.runLength[t]+this.runLength[t-1])this.runLength[t-1]<this.runLength[t+1]&&t--;else if(this.runLength[t]>this.runLength[t+1])break;this.mergeAt(t)}},t.prototype.forceMergeRuns=function(){for(;this.stackSize>1;){var t=this.stackSize-2;t>0&&this.runLength[t-1]<this.runLength[t+1]&&t--,this.mergeAt(t)}},t.prototype.mergeAt=function(t){var e=this.compare,i=this.array,n=this.runStart[t],o=this.runLength[t],r=this.runStart[t+1],h=this.runLength[t+1];this.runLength[t]=o+h,t===this.stackSize-3&&(this.runStart[t+1]=this.runStart[t+2],this.runLength[t+1]=this.runLength[t+2]),this.stackSize--;var l=a(i[r],i,n,o,0,e);n+=l,0!=(o-=l)&&0!==(h=s(i[n+o-1],i,r,h,h-1,e))&&(o<=h?this.mergeLow(n,o,r,h):this.mergeHigh(n,o,r,h))},t.prototype.mergeLow=function(t,e,i,n){var o=this.compare,r=this.array,h=this.tmp,l=0;for(l=0;l<e;l++)h[l]=r[t+l];var d=0,u=i,c=t;if(r[c++]=r[u++],0!=--n)if(1!==e){for(var f=this.minGallop;;){var p=0,v=0,g=!1;do{if(o(r[u],h[d])<0){if(r[c++]=r[u++],v++,p=0,0==--n){g=!0;break}}else if(r[c++]=h[d++],p++,v=0,1==--e){g=!0;break}}while((p|v)<f);if(g)break;do{if(0!==(p=a(r[u],h,d,e,0,o))){for(l=0;l<p;l++)r[c+l]=h[d+l];if(c+=p,d+=p,(e-=p)<=1){g=!0;break}}if(r[c++]=r[u++],0==--n){g=!0;break}if(0!==(v=s(h[d],r,u,n,0,o))){for(l=0;l<v;l++)r[c+l]=r[u+l];if(c+=v,u+=v,0==(n-=v)){g=!0;break}}if(r[c++]=h[d++],1==--e){g=!0;break}f--}while(p>=7||v>=7);if(g)break;f<0&&(f=0),f+=2}if(this.minGallop=f,f<1&&(this.minGallop=1),1===e){for(l=0;l<n;l++)r[c+l]=r[u+l];r[c+n]=h[d]}else{if(0===e)throw new Error("mergeLow preconditions were not respected");for(l=0;l<e;l++)r[c+l]=h[d+l]}}else{for(l=0;l<n;l++)r[c+l]=r[u+l];r[c+n]=h[d]}else for(l=0;l<e;l++)r[c+l]=h[d+l]},t.prototype.mergeHigh=function(t,e,i,n){var o=this.compare,r=this.array,h=this.tmp,l=0;for(l=0;l<n;l++)h[l]=r[i+l];var d=t+e-1,u=n-1,c=i+n-1,f=0,p=0;if(r[c--]=r[d--],0!=--e)if(1!==n){for(var v=this.minGallop;;){var g=0,y=0,m=!1;do{if(o(h[u],r[d])<0){if(r[c--]=r[d--],g++,y=0,0==--e){m=!0;break}}else if(r[c--]=h[u--],y++,g=0,1==--n){m=!0;break}}while((g|y)<v);if(m)break;do{if(0!=(g=e-a(h[u],r,t,e,e-1,o))){for(e-=g,p=1+(c-=g),f=1+(d-=g),l=g-1;l>=0;l--)r[p+l]=r[f+l];if(0===e){m=!0;break}}if(r[c--]=h[u--],1==--n){m=!0;break}if(0!=(y=n-s(r[d],h,0,n,n-1,o))){for(n-=y,p=1+(c-=y),f=1+(u-=y),l=0;l<y;l++)r[p+l]=h[f+l];if(n<=1){m=!0;break}}if(r[c--]=r[d--],0==--e){m=!0;break}v--}while(g>=7||y>=7);if(m)break;v<0&&(v=0),v+=2}if(this.minGallop=v,v<1&&(this.minGallop=1),1===n){for(p=1+(c-=e),f=1+(d-=e),l=e-1;l>=0;l--)r[p+l]=r[f+l];r[c]=h[u]}else{if(0===n)throw new Error("mergeHigh preconditions were not respected");for(f=c-(n-1),l=0;l<n;l++)r[f+l]=h[l]}}else{for(p=1+(c-=e),f=1+(d-=e),l=e-1;l>=0;l--)r[p+l]=r[f+l];r[c]=h[u]}else for(f=c-(n-1),l=0;l<n;l++)r[f+l]=h[l]},t}()}(e)}));n(Pf);var Nf=Pf,If=Nf.sort;function Af(t){var e=function(){if("undefined"==typeof Reflect||!_l)return!1;if(_l.sham)return!1;if("function"==typeof Proxy)return!0;try{return Date.prototype.toString.call(_l(Date,[],(function(){}))),!0}catch(t){return!1}}();return function(){var i,n=ql(t);if(e){var o=ql(this).constructor;i=_l(n,arguments,o)}else i=n.apply(this,arguments);return Ul(this,i)}}var Ff=function(){function t(){Kh(this,t)}return Qh(t,[{key:"abstract",value:function(){throw new Error("Can't instantiate abstract class!")}},{key:"fake_use",value:function(){}},{key:"curveType",value:function(){return this.abstract()}},{key:"getPosition",value:function(t){return this.fake_use(t),this.abstract()}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;this.fake_use(t,e,i),this.abstract()}},{key:"getTreeSize",value:function(t){return this.fake_use(t),this.abstract()}},{key:"sort",value:function(t){this.fake_use(t),this.abstract()}},{key:"fix",value:function(t,e){this.fake_use(t,e),this.abstract()}},{key:"shift",value:function(t,e){this.fake_use(t,e),this.abstract()}}]),t}(),jf=function(t){Vl(i,t);var e=Af(i);function i(t){var n;return Kh(this,i),(n=e.call(this)).layout=t,n}return Qh(i,[{key:"curveType",value:function(){return"horizontal"}},{key:"getPosition",value:function(t){return t.x}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(t,i),t.x=e}},{key:"getTreeSize",value:function(t){var e=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,t);return{min:e.min_x,max:e.max_x}}},{key:"sort",value:function(t){If(t,(function(t,e){return t.x-e.x}))}},{key:"fix",value:function(t,e){t.y=this.layout.options.hierarchical.levelSeparation*e,t.options.fixed.y=!0}},{key:"shift",value:function(t,e){this.layout.body.nodes[t].x+=e}}]),i}(Ff),zf=function(t){Vl(i,t);var e=Af(i);function i(t){var n;return Kh(this,i),(n=e.call(this)).layout=t,n}return Qh(i,[{key:"curveType",value:function(){return"vertical"}},{key:"getPosition",value:function(t){return t.y}},{key:"setPosition",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:void 0;void 0!==i&&this.layout.hierarchical.addToOrdering(t,i),t.y=e}},{key:"getTreeSize",value:function(t){var e=this.layout.hierarchical.getTreeSize(this.layout.body.nodes,t);return{min:e.min_y,max:e.max_y}}},{key:"sort",value:function(t){If(t,(function(t,e){return t.y-e.y}))}},{key:"fix",value:function(t,e){t.x=this.layout.options.hierarchical.levelSeparation*e,t.options.fixed.x=!0}},{key:"shift",value:function(t,e){this.layout.body.nodes[t].y+=e}}]),i}(Ff),Bf=xi.every,Rf=Hn("every"),Lf=Un("every");U({target:"Array",proto:!0,forced:!Rf||!Lf},{every:function(t){return Bf(this,t,arguments.length>1?arguments[1]:void 0)}});var Hf=K("Array").every,Wf=Array.prototype,Yf=function(t){var e=t.every;return t===Wf||t instanceof Array&&e===Wf.every?Hf:e};function Vf(t){if(void 0===tn||null==$e(t)){if(or(t)||(t=function(t,e){var i;if(!t)return;if("string"==typeof t)return Uf(t,e);var n=Go(i=Object.prototype.toString.call(t)).call(i,8,-1);"Object"===n&&t.constructor&&(n=t.constructor.name);if("Map"===n||"Set"===n)return cn(t);if("Arguments"===n||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n))return Uf(t,e)}(t))){var e=0,i=function(){};return{s:i,n:function(){return e>=t.length?{done:!0}:{done:!1,value:t[e++]}},e:function(t){throw t},f:i}}throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")}var n,o,r=!0,s=!1;return{s:function(){n=Xe(t)},n:function(){var t=n.next();return r=t.done,t},e:function(t){s=!0,o=t},f:function(){try{r||null==n.return||n.return()}finally{if(s)throw o}}}}function Uf(t,e){(null==e||e>t.length)&&(e=t.length);for(var i=0,n=new Array(e);i<e;i++)n[i]=t[i];return n}function Gf(t,e){var i=new md;return Jn(t).call(t,(function(t){var e;Jn(e=t.edges).call(e,(function(t){t.connected&&i.add(t)}))})),Jn(i).call(i,(function(t){var i=t.from.id,n=t.to.id;null==e[i]&&(e[i]=0),(null==e[n]||e[i]>=e[n])&&(e[n]=e[i]+1)})),e}function qf(t,e,i,n,o){var r,s=n.size,a=i+"Id",h="to"===i?1:-1,l=Vf(n);try{var d=function(){var l=vr(r.value,2),d=l[0],u=l[1];if(!n.has(d)||!t(u))return"continue";o[d]=0;for(var c=[u],f=0,p=void 0,v=function(){var t,r;if(!n.has(d))return"continue";var l=o[p.id]+h;if(Jn(t=_o(r=p.edges).call(r,(function(t){return t.connected&&t.to!==t.from&&t[i]!==p&&n.has(t.toId)&&n.has(t.fromId)}))).call(t,(function(t){var n=t[a],r=o[n];(null==r||e(l,r))&&(o[n]=l,c.push(t[i]))})),f>s)return{v:{v:Gf(n,o)}};++f};p=c.pop();){var g=v();switch(g){case"continue":continue;default:if("object"===ur(g))return g.v}}};for(l.s();!(r=l.n()).done;){var u=d();switch(u){case"continue":continue;default:if("object"===ur(u))return u.v}}}catch(t){l.e(t)}finally{l.f()}return o}var Xf=function(){function t(){Kh(this,t),this.childrenReference={},this.parentReference={},this.trees={},this.distributionOrdering={},this.levels={},this.distributionIndex={},this.isTree=!1,this.treeIndex=-1}return Qh(t,[{key:"addRelation",value:function(t,e){void 0===this.childrenReference[t]&&(this.childrenReference[t]=[]),this.childrenReference[t].push(e),void 0===this.parentReference[e]&&(this.parentReference[e]=[]),this.parentReference[e].push(t)}},{key:"checkIfTree",value:function(){for(var t in this.parentReference)if(this.parentReference[t].length>1)return void(this.isTree=!1);this.isTree=!0}},{key:"numTrees",value:function(){return this.treeIndex+1}},{key:"setTreeIndex",value:function(t,e){void 0!==e&&void 0===this.trees[t.id]&&(this.trees[t.id]=e,this.treeIndex=Math.max(e,this.treeIndex))}},{key:"ensureLevel",value:function(t){void 0===this.levels[t]&&(this.levels[t]=0)}},{key:"getMaxLevel",value:function(t){var e=this,i={};return function t(n){if(void 0!==i[n])return i[n];var o=e.levels[n];if(e.childrenReference[n]){var r=e.childrenReference[n];if(r.length>0)for(var s=0;s<r.length;s++)o=Math.max(o,t(r[s]))}return i[n]=o,o}(t)}},{key:"levelDownstream",value:function(t,e){void 0===this.levels[e.id]&&(void 0===this.levels[t.id]&&(this.levels[t.id]=0),this.levels[e.id]=this.levels[t.id]+1)}},{key:"setMinLevelToZero",value:function(t){var e=1e9;for(var i in t)t.hasOwnProperty(i)&&void 0!==this.levels[i]&&(e=Math.min(this.levels[i],e));for(var n in t)t.hasOwnProperty(n)&&void 0!==this.levels[n]&&(this.levels[n]-=e)}},{key:"getTreeSize",value:function(t,e){var i=1e9,n=-1e9,o=1e9,r=-1e9;for(var s in this.trees)if(this.trees.hasOwnProperty(s)&&this.trees[s]===e){var a=t[s];i=Math.min(a.x,i),n=Math.max(a.x,n),o=Math.min(a.y,o),r=Math.max(a.y,r)}return{min_x:i,max_x:n,min_y:o,max_y:r}}},{key:"hasSameParent",value:function(t,e){var i=this.parentReference[t.id],n=this.parentReference[e.id];if(void 0===i||void 0===n)return!1;for(var o=0;o<i.length;o++)for(var r=0;r<n.length;r++)if(i[o]==n[r])return!0;return!1}},{key:"inSameSubNetwork",value:function(t,e){return this.trees[t.id]===this.trees[e.id]}},{key:"getLevels",value:function(){return Tn(this.distributionOrdering)}},{key:"addToOrdering",value:function(t,e){void 0===this.distributionOrdering[e]&&(this.distributionOrdering[e]=[]);var i=!1,n=this.distributionOrdering[e];for(var o in n)if(n[o]===t){i=!0;break}i||(this.distributionOrdering[e].push(t),this.distributionIndex[t.id]=this.distributionOrdering[e].length-1)}}]),t}(),$f=function(){function t(e){Kh(this,t),this.body=e,this._resetRNG(Math.random()+":"+gr()),this.setPhysics=!1,this.options={},this.optionsBackup={physics:{}},this.defaultOptions={randomSeed:void 0,improvedLayout:!0,clusterThreshold:150,hierarchical:{enabled:!1,levelSeparation:150,nodeSpacing:100,treeSpacing:200,blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:"UD",sortMethod:"hubsize"}},Fr(this.options,this.defaultOptions),this.bindEventListeners()}return Qh(t,[{key:"bindEventListeners",value:function(){var t=this;this.body.emitter.on("_dataChanged",(function(){t.setupHierarchicalLayout()})),this.body.emitter.on("_dataLoaded",(function(){t.layoutNetwork()})),this.body.emitter.on("_resetHierarchicalLayout",(function(){t.setupHierarchicalLayout()})),this.body.emitter.on("_adjustEdgesForHierarchicalLayout",(function(){if(!0===t.options.hierarchical.enabled){var e=t.direction.curveType();t.body.emitter.emit("_forceDisableDynamicCurves",e,!1)}}))}},{key:"setOptions",value:function(t,e){if(void 0!==t){var i=this.options.hierarchical,n=i.enabled;if(jr(["randomSeed","improvedLayout","clusterThreshold"],this.options,t),ls(this.options,t,"hierarchical"),void 0!==t.randomSeed&&this._resetRNG(t.randomSeed),!0===i.enabled)return!0===n&&this.body.emitter.emit("refresh",!0),"RL"===i.direction||"DU"===i.direction?i.levelSeparation>0&&(i.levelSeparation*=-1):i.levelSeparation<0&&(i.levelSeparation*=-1),this.setDirectionStrategy(),this.body.emitter.emit("_resetHierarchicalLayout"),this.adaptAllOptionsForHierarchicalLayout(e);if(!0===n)return this.body.emitter.emit("refresh"),Br(e,this.optionsBackup)}return e}},{key:"_resetRNG",value:function(t){this.initialRandomSeed=t,this._rng=_r(this.initialRandomSeed)}},{key:"adaptAllOptionsForHierarchicalLayout",value:function(t){if(!0===this.options.hierarchical.enabled){var e=this.optionsBackup.physics;void 0===t.physics||!0===t.physics?(t.physics={enabled:void 0===e.enabled||e.enabled,solver:"hierarchicalRepulsion"},e.enabled=void 0===e.enabled||e.enabled,e.solver=e.solver||"barnesHut"):"object"===ur(t.physics)?(e.enabled=void 0===t.physics.enabled||t.physics.enabled,e.solver=t.physics.solver||"barnesHut",t.physics.solver="hierarchicalRepulsion"):!1!==t.physics&&(e.solver="barnesHut",t.physics={solver:"hierarchicalRepulsion"});var i=this.direction.curveType();if(void 0===t.edges)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},t.edges={smooth:!1};else if(void 0===t.edges.smooth)this.optionsBackup.edges={smooth:{enabled:!0,type:"dynamic"}},t.edges.smooth=!1;else if("boolean"==typeof t.edges.smooth)this.optionsBackup.edges={smooth:t.edges.smooth},t.edges.smooth={enabled:t.edges.smooth,type:i};else{var n=t.edges.smooth;void 0!==n.type&&"dynamic"!==n.type&&(i=n.type),this.optionsBackup.edges={smooth:{enabled:void 0===n.enabled||n.enabled,type:void 0===n.type?"dynamic":n.type,roundness:void 0===n.roundness?.5:n.roundness,forceDirection:void 0!==n.forceDirection&&n.forceDirection}},t.edges.smooth={enabled:void 0===n.enabled||n.enabled,type:i,roundness:void 0===n.roundness?.5:n.roundness,forceDirection:void 0!==n.forceDirection&&n.forceDirection}}this.body.emitter.emit("_forceDisableDynamicCurves",i)}return t}},{key:"positionInitially",value:function(t){if(!0!==this.options.hierarchical.enabled){this._resetRNG(this.initialRandomSeed);for(var e=t.length+50,i=0;i<t.length;i++){var n=t[i],o=2*Math.PI*this._rng();void 0===n.x&&(n.x=e*Math.cos(o)),void 0===n.y&&(n.y=e*Math.sin(o))}}}},{key:"layoutNetwork",value:function(){if(!0!==this.options.hierarchical.enabled&&!0===this.options.improvedLayout){for(var t=this.body.nodeIndices,e=0,i=0;i<t.length;i++){!0===this.body.nodes[t[i]].predefinedPosition&&(e+=1)}if(e<.5*t.length){var n=0,o=this.options.clusterThreshold,r={clusterNodeProperties:{shape:"ellipse",label:"",group:"",font:{multi:!1}},clusterEdgeProperties:{label:"",font:{multi:!1},smooth:{enabled:!1}}};if(t.length>o){for(var s=t.length;t.length>o&&n<=10;){n+=1;var a=t.length;if(n%3==0?this.body.modules.clustering.clusterBridges(r):this.body.modules.clustering.clusterOutliers(r),a==t.length&&n%3!=0)return this._declusterAll(),this.body.emitter.emit("_layoutFailed"),void console.info("This network could not be positioned by this version of the improved layout algorithm. Please disable improvedLayout for better performance.")}this.body.modules.kamadaKawai.setOptions({springLength:Math.max(150,2*s)})}n>10&&console.info("The clustering didn't succeed within the amount of interations allowed, progressing with partial result."),this.body.modules.kamadaKawai.solve(t,this.body.edgeIndices,!0),this._shiftToCenter();for(var h=0;h<t.length;h++){var l=this.body.nodes[t[h]];!1===l.predefinedPosition&&(l.x+=70*(.5-this._rng()),l.y+=70*(.5-this._rng()))}this._declusterAll(),this.body.emitter.emit("_repositionBezierNodes")}}}},{key:"_shiftToCenter",value:function(){for(var t=mf.getRangeCore(this.body.nodes,this.body.nodeIndices),e=mf.findCenter(t),i=0;i<this.body.nodeIndices.length;i++){var n=this.body.nodes[this.body.nodeIndices[i]];n.x-=e.x,n.y-=e.y}}},{key:"_declusterAll",value:function(){for(var t=!0;!0===t;){t=!1;for(var e=0;e<this.body.nodeIndices.length;e++)!0===this.body.nodes[this.body.nodeIndices[e]].isCluster&&(t=!0,this.body.modules.clustering.openCluster(this.body.nodeIndices[e],{},!1));!0===t&&this.body.emitter.emit("_dataChanged")}}},{key:"getSeed",value:function(){return this.initialRandomSeed}},{key:"setupHierarchicalLayout",value:function(){if(!0===this.options.hierarchical.enabled&&this.body.nodeIndices.length>0){var t,e,i=!1,n=!1;for(e in this.lastNodeOnLevel={},this.hierarchical=new Xf,this.body.nodes)this.body.nodes.hasOwnProperty(e)&&(void 0!==(t=this.body.nodes[e]).options.level?(i=!0,this.hierarchical.levels[e]=t.options.level):n=!0);if(!0===n&&!0===i)throw new Error("To use the hierarchical layout, nodes require either no predefined levels or levels have to be defined for all nodes.");if(!0===n){var o=this.options.hierarchical.sortMethod;"hubsize"===o?this._determineLevelsByHubsize():"directed"===o?this._determineLevelsDirected():"custom"===o&&this._determineLevelsCustomCallback()}for(var r in this.body.nodes)this.body.nodes.hasOwnProperty(r)&&this.hierarchical.ensureLevel(r);var s=this._getDistribution();this._generateMap(),this._placeNodesByHierarchy(s),this._condenseHierarchy(),this._shiftToCenter()}}},{key:"_condenseHierarchy",value:function(){var t=this,e=!1,i={},n=function(e,i){var n=t.hierarchical.trees;for(var o in n)n.hasOwnProperty(o)&&n[o]===e&&t.direction.shift(o,i)},o=function(){for(var e=[],i=0;i<t.hierarchical.numTrees();i++)e.push(t.direction.getTreeSize(i));return e},r=function e(i,n){if(!n[i.id]&&(n[i.id]=!0,t.hierarchical.childrenReference[i.id])){var o=t.hierarchical.childrenReference[i.id];if(o.length>0)for(var r=0;r<o.length;r++)e(t.body.nodes[o[r]],n)}},s=function(e){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:1e9,n=1e9,o=1e9,r=1e9,s=-1e9;for(var a in e)if(e.hasOwnProperty(a)){var h=t.body.nodes[a],l=t.hierarchical.levels[h.id],d=t.direction.getPosition(h),u=t._getSpaceAroundNode(h,e),c=vr(u,2),f=c[0],p=c[1];n=Math.min(f,n),o=Math.min(p,o),l<=i&&(r=Math.min(d,r),s=Math.max(d,s))}return[r,s,n,o]},a=function(e,i){var n=t.hierarchical.getMaxLevel(e.id),o=t.hierarchical.getMaxLevel(i.id);return Math.min(n,o)},h=function(e,i,n){for(var o=t.hierarchical,r=0;r<i.length;r++){var s=i[r],a=o.distributionOrdering[s];if(a.length>1)for(var h=0;h<a.length-1;h++){var l=a[h],d=a[h+1];o.hasSameParent(l,d)&&o.inSameSubNetwork(l,d)&&e(l,d,n)}}},l=function(i,n){var o=arguments.length>2&&void 0!==arguments[2]&&arguments[2],h=t.direction.getPosition(i),l=t.direction.getPosition(n),d=Math.abs(l-h),u=t.options.hierarchical.nodeSpacing;if(d>u){var c={},f={};r(i,c),r(n,f);var p=a(i,n),v=s(c,p),g=s(f,p),y=v[1],m=g[0],b=g[2],w=Math.abs(y-m);if(w>u){var _=y-m+u;_<-b+u&&(_=-b+u),_<0&&(t._shiftBlock(n.id,_),e=!0,!0===o&&t._centerParent(n))}}},d=function(n,o){for(var a=o.id,h=o.edges,l=t.hierarchical.levels[o.id],d=t.options.hierarchical.levelSeparation*t.options.hierarchical.levelSeparation,u={},c=[],f=0;f<h.length;f++){var p=h[f];if(p.toId!=p.fromId){var v=p.toId==a?p.from:p.to;u[h[f].id]=v,t.hierarchical.levels[v.id]<l&&c.push(p)}}var g=function(e,i){for(var n=0,o=0;o<i.length;o++)if(void 0!==u[i[o].id]){var r=t.direction.getPosition(u[i[o].id])-e;n+=r/Math.sqrt(r*r+d)}return n},y=function(e,i){for(var n=0,o=0;o<i.length;o++)if(void 0!==u[i[o].id]){var r=t.direction.getPosition(u[i[o].id])-e;n-=d*Math.pow(r*r+d,-1.5)}return n},m=function(e,i){for(var n=t.direction.getPosition(o),r={},s=0;s<e;s++){var a=g(n,i),h=y(n,i);if(void 0!==r[n-=Math.max(-40,Math.min(40,Math.round(a/h)))])break;r[n]=s}return n},b=m(n,c);!function(n){var a=t.direction.getPosition(o);if(void 0===i[o.id]){var h={};r(o,h),i[o.id]=h}var l=s(i[o.id]),d=l[2],u=l[3],c=n-a,f=0;c>0?f=Math.min(c,u-t.options.hierarchical.nodeSpacing):c<0&&(f=-Math.min(-c,d-t.options.hierarchical.nodeSpacing)),0!=f&&(t._shiftBlock(o.id,f),e=!0)}(b),function(i){var n=t.direction.getPosition(o),r=t._getSpaceAroundNode(o),s=vr(r,2),a=s[0],h=s[1],l=i-n,d=n;l>0?d=Math.min(n+(h-t.options.hierarchical.nodeSpacing),i):l<0&&(d=Math.max(n-(a-t.options.hierarchical.nodeSpacing),i)),d!==n&&(t.direction.setPosition(o,d),e=!0)}(b=m(n,h))};!0===this.options.hierarchical.blockShifting&&(function(i){var n=t.hierarchical.getLevels();n=yf(n).call(n);for(var o=0;o<i&&(e=!1,h(l,n,!0),!0===e);o++);}(5),function(){for(var e in t.body.nodes)t.body.nodes.hasOwnProperty(e)&&t._centerParent(t.body.nodes[e])}()),!0===this.options.hierarchical.edgeMinimization&&function(i){var n=t.hierarchical.getLevels();n=yf(n).call(n);for(var o=0;o<i;o++){e=!1;for(var r=0;r<n.length;r++)for(var s=n[r],a=t.hierarchical.distributionOrdering[s],h=0;h<a.length;h++)d(1e3,a[h]);if(!0!==e)break}}(20),!0===this.options.hierarchical.parentCentralization&&function(){var e=t.hierarchical.getLevels();e=yf(e).call(e);for(var i=0;i<e.length;i++)for(var n=e[i],o=t.hierarchical.distributionOrdering[n],r=0;r<o.length;r++)t._centerParent(o[r])}(),function(){for(var e=o(),i=0,r=0;r<e.length-1;r++){i+=e[r].max-e[r+1].min+t.options.hierarchical.treeSpacing,n(r+1,i)}}()}},{key:"_getSpaceAroundNode",value:function(t,e){var i=!0;void 0===e&&(i=!1);var n=this.hierarchical.levels[t.id];if(void 0!==n){var o=this.hierarchical.distributionIndex[t.id],r=this.direction.getPosition(t),s=this.hierarchical.distributionOrdering[n],a=1e9,h=1e9;if(0!==o){var l=s[o-1];if(!0===i&&void 0===e[l.id]||!1===i)a=r-this.direction.getPosition(l)}if(o!=s.length-1){var d=s[o+1];if(!0===i&&void 0===e[d.id]||!1===i){var u=this.direction.getPosition(d);h=Math.min(h,u-r)}}return[a,h]}return[0,0]}},{key:"_centerParent",value:function(t){if(this.hierarchical.parentReference[t.id])for(var e=this.hierarchical.parentReference[t.id],i=0;i<e.length;i++){var n=e[i],o=this.body.nodes[n],r=this.hierarchical.childrenReference[n];if(void 0!==r){var s=this._getCenterPosition(r),a=this.direction.getPosition(o),h=this._getSpaceAroundNode(o),l=vr(h,2),d=l[0],u=l[1],c=a-s;(c<0&&Math.abs(c)<u-this.options.hierarchical.nodeSpacing||c>0&&Math.abs(c)<d-this.options.hierarchical.nodeSpacing)&&this.direction.setPosition(o,s)}}}},{key:"_placeNodesByHierarchy",value:function(t){for(var e in this.positionedNodes={},t)if(t.hasOwnProperty(e)){var i,n=Tn(t[e]);n=this._indexArrayToNodes(n),ed(i=this.direction).call(i,n);for(var o=0,r=0;r<n.length;r++){var s=n[r];if(void 0===this.positionedNodes[s.id]){var a=this.options.hierarchical.nodeSpacing,h=a*o;o>0&&(h=this.direction.getPosition(n[r-1])+a),this.direction.setPosition(s,h,e),this._validatePositionAndContinue(s,e,h),o++}}}}},{key:"_placeBranchNodes",value:function(t,e){var i,n=this.hierarchical.childrenReference[t];if(void 0!==n){for(var o=[],r=0;r<n.length;r++)o.push(this.body.nodes[n[r]]);ed(i=this.direction).call(i,o);for(var s=0;s<o.length;s++){var a=o[s],h=this.hierarchical.levels[a.id];if(!(h>e&&void 0===this.positionedNodes[a.id]))return;var l=this.options.hierarchical.nodeSpacing,d=void 0;d=0===s?this.direction.getPosition(this.body.nodes[t]):this.direction.getPosition(o[s-1])+l,this.direction.setPosition(a,d,h),this._validatePositionAndContinue(a,h,d)}var u=this._getCenterPosition(o);this.direction.setPosition(this.body.nodes[t],u,e)}}},{key:"_validatePositionAndContinue",value:function(t,e,i){if(this.hierarchical.isTree){if(void 0!==this.lastNodeOnLevel[e]){var n=this.direction.getPosition(this.body.nodes[this.lastNodeOnLevel[e]]);if(i-n<this.options.hierarchical.nodeSpacing){var o=n+this.options.hierarchical.nodeSpacing-i,r=this._findCommonParent(this.lastNodeOnLevel[e],t.id);this._shiftBlock(r.withChild,o)}}this.lastNodeOnLevel[e]=t.id,this.positionedNodes[t.id]=!0,this._placeBranchNodes(t.id,e)}}},{key:"_indexArrayToNodes",value:function(t){for(var e=[],i=0;i<t.length;i++)e.push(this.body.nodes[t[i]]);return e}},{key:"_getDistribution",value:function(){var t,e,i={};for(t in this.body.nodes)if(this.body.nodes.hasOwnProperty(t)){e=this.body.nodes[t];var n=void 0===this.hierarchical.levels[t]?0:this.hierarchical.levels[t];this.direction.fix(e,n),void 0===i[n]&&(i[n]={}),i[n][t]=e}return i}},{key:"_getActiveEdges",value:function(t){var e=this,i=[];return Vr(t.edges,(function(t){var n;-1!==nr(n=e.body.edgeIndices).call(n,t.id)&&i.push(t)})),i}},{key:"_getHubSizes",value:function(){var t=this,e={};Vr(this.body.nodeIndices,(function(i){var n=t.body.nodes[i],o=t._getActiveEdges(n).length;e[o]=!0}));var i=[];return Vr(e,(function(t){i.push(Number(t))})),ed(Nf).call(Nf,i,(function(t,e){return e-t})),i}},{key:"_determineLevelsByHubsize",value:function(){for(var t=this,e=function(e,i){t.hierarchical.levelDownstream(e,i)},i=this._getHubSizes(),n=function(n){var o=i[n];if(0===o)return"break";Vr(t.body.nodeIndices,(function(i){var n=t.body.nodes[i];o===t._getActiveEdges(n).length&&t._crawlNetwork(e,i)}))},o=0;o<i.length;++o){if("break"===n(o))break}}},{key:"_determineLevelsCustomCallback",value:function(){var t=this;this._crawlNetwork((function(e,i,n){var o=t.hierarchical.levels[e.id];void 0===o&&(o=t.hierarchical.levels[e.id]=1e5);var r=(mf.cloneOptions(e,"node"),mf.cloneOptions(i,"node"),void mf.cloneOptions(n,"edge"));t.hierarchical.levels[i.id]=o+r})),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_determineLevelsDirected",value:function(){var t,e=this,i=Id(t=this.body.nodeIndices).call(t,(function(t,i){return t.set(i,e.body.nodes[i]),t}),new bd),n=this.hierarchical.levels;"roots"===this.options.hierarchical.shakeTowards?this.hierarchical.levels=function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Sn(null);return qf((function(e){var i,n;return Yf(i=_o(n=e.edges).call(n,(function(e){return t.has(e.toId)}))).call(i,(function(t){return t.from===e}))}),(function(t,e){return e<t}),"to",t,e)}(i,n):this.hierarchical.levels=function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:Sn(null);return qf((function(e){var i,n;return Yf(i=_o(n=e.edges).call(n,(function(e){return t.has(e.toId)}))).call(i,(function(t){return t.to===e}))}),(function(t,e){return e>t}),"from",t,e)}(i,n),this.hierarchical.setMinLevelToZero(this.body.nodes)}},{key:"_generateMap",value:function(){var t=this;this._crawlNetwork((function(e,i){t.hierarchical.levels[i.id]>t.hierarchical.levels[e.id]&&t.hierarchical.addRelation(e.id,i.id)})),this.hierarchical.checkIfTree()}},{key:"_crawlNetwork",value:function(){var t=this,e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:function(){},i=arguments.length>1?arguments[1]:void 0,n={},o=function i(o,r){if(void 0===n[o.id]){var s;t.hierarchical.setTreeIndex(o,r),n[o.id]=!0;for(var a=t._getActiveEdges(o),h=0;h<a.length;h++){var l=a[h];!0===l.connected&&(s=l.toId==o.id?l.from:l.to,o.id!=s.id&&(e(o,s,l),i(s,r)))}}};if(void 0===i)for(var r=0,s=0;s<this.body.nodeIndices.length;s++){var a=this.body.nodeIndices[s];if(void 0===n[a]){var h=this.body.nodes[a];o(h,r),r+=1}}else{var l=this.body.nodes[i];if(void 0===l)return void console.error("Node not found:",i);o(l)}}},{key:"_shiftBlock",value:function(t,e){var i=this,n={};!function t(o){if(!n[o]){n[o]=!0,i.direction.shift(o,e);var r=i.hierarchical.childrenReference[o];if(void 0!==r)for(var s=0;s<r.length;s++)t(r[s])}}(t)}},{key:"_findCommonParent",value:function(t,e){var i=this,n={};return function t(e,n){var o=i.hierarchical.parentReference[n];if(void 0!==o)for(var r=0;r<o.length;r++){var s=o[r];e[s]=!0,t(e,s)}}(n,t),function t(e,n){var o=i.hierarchical.parentReference[n];if(void 0!==o)for(var r=0;r<o.length;r++){var s=o[r];if(void 0!==e[s])return{foundParent:s,withChild:n};var a=t(e,s);if(null!==a.foundParent)return a}return{foundParent:null,withChild:n}}(n,e)}},{key:"setDirectionStrategy",value:function(){var t="UD"===this.options.hierarchical.direction||"DU"===this.options.hierarchical.direction;this.direction=t?new jf(this):new zf(this)}},{key:"_getCenterPosition",value:function(t){for(var e=1e9,i=-1e9,n=0;n<t.length;n++){var o=void 0;if(void 0!==t[n].id)o=t[n];else{var r=t[n];o=this.body.nodes[r]}var s=this.direction.getPosition(o);e=Math.min(e,s),i=Math.max(i,s)}return.5*(e+i)}}]),t}(),Kf=function(){function t(e,i,n,o){var r,s,a=this;Kh(this,t),this.body=e,this.canvas=i,this.selectionHandler=n,this.interactionHandler=o,this.editMode=!1,this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0,this.manipulationHammers=[],this.temporaryUIFunctions={},this.temporaryEventFunctions=[],this.touchTime=0,this.temporaryIds={nodes:[],edges:[]},this.guiEnabled=!1,this.inMode=!1,this.selectedControlNode=void 0,this.options={},this.defaultOptions={enabled:!1,initiallyActive:!1,addNode:!0,addEdge:!0,editNode:void 0,editEdge:!0,deleteNode:!0,deleteEdge:!0,controlNodeStyle:{shape:"dot",size:6,color:{background:"#ff0000",border:"#3c3c3c",highlight:{background:"#07f968",border:"#3c3c3c"}},borderWidth:2,borderWidthSelected:2}},Fr(this.options,this.defaultOptions),this.body.emitter.on("destroy",(function(){a._clean()})),this.body.emitter.on("_dataChanged",J(r=this._restore).call(r,this)),this.body.emitter.on("_resetData",J(s=this._restore).call(s,this))}return Qh(t,[{key:"_restore",value:function(){!1!==this.inMode&&(!0===this.options.initiallyActive?this.enableEditMode():this.disableEditMode())}},{key:"setOptions",value:function(t,e,i){void 0!==e&&(void 0!==e.locale?this.options.locale=e.locale:this.options.locale=i.locale,void 0!==e.locales?this.options.locales=e.locales:this.options.locales=i.locales),void 0!==t&&("boolean"==typeof t?this.options.enabled=t:(this.options.enabled=!0,Br(this.options,t)),!0===this.options.initiallyActive&&(this.editMode=!0),this._setup())}},{key:"toggleEditMode",value:function(){!0===this.editMode?this.disableEditMode():this.enableEditMode()}},{key:"enableEditMode",value:function(){this.editMode=!0,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="block",this.closeDiv.style.display="block",this.editModeDiv.style.display="none",this.showManipulatorToolbar())}},{key:"disableEditMode",value:function(){this.editMode=!1,this._clean(),!0===this.guiEnabled&&(this.manipulationDiv.style.display="none",this.closeDiv.style.display="none",this.editModeDiv.style.display="block",this._createEditButton())}},{key:"showManipulatorToolbar",value:function(){if(this._clean(),this.manipulationDOM={},!0===this.guiEnabled){var t,e;this.editMode=!0,this.manipulationDiv.style.display="block",this.closeDiv.style.display="block";var i=this.selectionHandler._getSelectedNodeCount(),n=this.selectionHandler._getSelectedEdgeCount(),o=i+n,r=this.options.locales[this.options.locale],s=!1;!1!==this.options.addNode&&(this._createAddNodeButton(r),s=!0),!1!==this.options.addEdge&&(!0===s?this._createSeperator(1):s=!0,this._createAddEdgeButton(r)),1===i&&"function"==typeof this.options.editNode?(!0===s?this._createSeperator(2):s=!0,this._createEditNodeButton(r)):1===n&&0===i&&!1!==this.options.editEdge&&(!0===s?this._createSeperator(3):s=!0,this._createEditEdgeButton(r)),0!==o&&(i>0&&!1!==this.options.deleteNode||0===i&&!1!==this.options.deleteEdge)&&(!0===s&&this._createSeperator(4),this._createDeleteButton(r)),this._bindHammerToDiv(this.closeDiv,J(t=this.toggleEditMode).call(t,this)),this._temporaryBindEvent("select",J(e=this.showManipulatorToolbar).call(e,this))}this.body.emitter.emit("_redraw")}},{key:"addNodeMode",value:function(){var t;if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addNode",!0===this.guiEnabled){var e,i=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(i),this._createSeperator(),this._createDescription(i.addDescription||this.options.locales.en.addDescription),this._bindHammerToDiv(this.closeDiv,J(e=this.toggleEditMode).call(e,this))}this._temporaryBindEvent("click",J(t=this._performAddNode).call(t,this))}},{key:"editNode",value:function(){var t=this;!0!==this.editMode&&this.enableEditMode(),this._clean();var e=this.selectionHandler._getSelectedNode();if(void 0!==e){if(this.inMode="editNode","function"!=typeof this.options.editNode)throw new Error("No function has been configured to handle the editing of nodes.");if(!0!==e.isCluster){var i=Br({},e.options,!1);if(i.x=e.x,i.y=e.y,2!==this.options.editNode.length)throw new Error("The function for edit does not support two arguments (data, callback)");this.options.editNode(i,(function(e){null!=e&&"editNode"===t.inMode&&t.body.data.nodes.getDataSet().update(e),t.showManipulatorToolbar()}))}else alert(this.options.locales[this.options.locale].editClusterError||this.options.locales.en.editClusterError)}else this.showManipulatorToolbar()}},{key:"addEdgeMode",value:function(){var t,e,i,n,o;if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="addEdge",!0===this.guiEnabled){var r,s=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(s),this._createSeperator(),this._createDescription(s.edgeDescription||this.options.locales.en.edgeDescription),this._bindHammerToDiv(this.closeDiv,J(r=this.toggleEditMode).call(r,this))}this._temporaryBindUI("onTouch",J(t=this._handleConnect).call(t,this)),this._temporaryBindUI("onDragEnd",J(e=this._finishConnect).call(e,this)),this._temporaryBindUI("onDrag",J(i=this._dragControlNode).call(i,this)),this._temporaryBindUI("onRelease",J(n=this._finishConnect).call(n,this)),this._temporaryBindUI("onDragStart",J(o=this._dragStartEdge).call(o,this)),this._temporaryBindUI("onHold",(function(){}))}},{key:"editEdgeMode",value:function(){if(!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="editEdge","object"!==ur(this.options.editEdge)||"function"!=typeof this.options.editEdge.editWithoutDrag||(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdges()[0],void 0===this.edgeBeingEditedId)){if(!0===this.guiEnabled){var t,e=this.options.locales[this.options.locale];this.manipulationDOM={},this._createBackButton(e),this._createSeperator(),this._createDescription(e.editEdgeDescription||this.options.locales.en.editEdgeDescription),this._bindHammerToDiv(this.closeDiv,J(t=this.toggleEditMode).call(t,this))}if(this.edgeBeingEditedId=this.selectionHandler.getSelectedEdges()[0],void 0!==this.edgeBeingEditedId){var i,n,o,r,s=this.body.edges[this.edgeBeingEditedId],a=this._getNewTargetNode(s.from.x,s.from.y),h=this._getNewTargetNode(s.to.x,s.to.y);this.temporaryIds.nodes.push(a.id),this.temporaryIds.nodes.push(h.id),this.body.nodes[a.id]=a,this.body.nodeIndices.push(a.id),this.body.nodes[h.id]=h,this.body.nodeIndices.push(h.id),this._temporaryBindUI("onTouch",J(i=this._controlNodeTouch).call(i,this)),this._temporaryBindUI("onTap",(function(){})),this._temporaryBindUI("onHold",(function(){})),this._temporaryBindUI("onDragStart",J(n=this._controlNodeDragStart).call(n,this)),this._temporaryBindUI("onDrag",J(o=this._controlNodeDrag).call(o,this)),this._temporaryBindUI("onDragEnd",J(r=this._controlNodeDragEnd).call(r,this)),this._temporaryBindUI("onMouseMove",(function(){})),this._temporaryBindEvent("beforeDrawing",(function(t){var e=s.edgeType.findBorderPositions(t);!1===a.selected&&(a.x=e.from.x,a.y=e.from.y),!1===h.selected&&(h.x=e.to.x,h.y=e.to.y)})),this.body.emitter.emit("_redraw")}else this.showManipulatorToolbar()}else{var l=this.body.edges[this.edgeBeingEditedId];this._performEditEdge(l.from.id,l.to.id)}}},{key:"deleteSelected",value:function(){var t=this;!0!==this.editMode&&this.enableEditMode(),this._clean(),this.inMode="delete";var e=this.selectionHandler.getSelectedNodes(),i=this.selectionHandler.getSelectedEdges(),n=void 0;if(e.length>0){for(var o=0;o<e.length;o++)if(!0===this.body.nodes[e[o]].isCluster)return void alert(this.options.locales[this.options.locale].deleteClusterError||this.options.locales.en.deleteClusterError);"function"==typeof this.options.deleteNode&&(n=this.options.deleteNode)}else i.length>0&&"function"==typeof this.options.deleteEdge&&(n=this.options.deleteEdge);if("function"==typeof n){var r={nodes:e,edges:i};if(2!==n.length)throw new Error("The function for delete does not support two arguments (data, callback)");n(r,(function(e){null!=e&&"delete"===t.inMode?(t.body.data.edges.getDataSet().remove(e.edges),t.body.data.nodes.getDataSet().remove(e.nodes),t.body.emitter.emit("startSimulation"),t.showManipulatorToolbar()):(t.body.emitter.emit("startSimulation"),t.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().remove(i),this.body.data.nodes.getDataSet().remove(e),this.body.emitter.emit("startSimulation"),this.showManipulatorToolbar()}},{key:"_setup",value:function(){!0===this.options.enabled?(this.guiEnabled=!0,this._createWrappers(),!1===this.editMode?this._createEditButton():this.showManipulatorToolbar()):(this._removeManipulationDOM(),this.guiEnabled=!1)}},{key:"_createWrappers",value:function(){void 0===this.manipulationDiv&&(this.manipulationDiv=document.createElement("div"),this.manipulationDiv.className="vis-manipulation",!0===this.editMode?this.manipulationDiv.style.display="block":this.manipulationDiv.style.display="none",this.canvas.frame.appendChild(this.manipulationDiv)),void 0===this.editModeDiv&&(this.editModeDiv=document.createElement("div"),this.editModeDiv.className="vis-edit-mode",!0===this.editMode?this.editModeDiv.style.display="none":this.editModeDiv.style.display="block",this.canvas.frame.appendChild(this.editModeDiv)),void 0===this.closeDiv&&(this.closeDiv=document.createElement("div"),this.closeDiv.className="vis-close",this.closeDiv.style.display=this.manipulationDiv.style.display,this.canvas.frame.appendChild(this.closeDiv))}},{key:"_getNewTargetNode",value:function(t,e){var i=Br({},this.options.controlNodeStyle);i.id="targetNode"+Rd(),i.hidden=!1,i.physics=!1,i.x=t,i.y=e;var n=this.body.functions.createNode(i);return n.shape.boundingBox={left:t,right:t,top:e,bottom:e},n}},{key:"_createEditButton",value:function(){var t;this._clean(),this.manipulationDOM={},Tr(this.editModeDiv);var e=this.options.locales[this.options.locale],i=this._createButton("editMode","vis-button vis-edit vis-edit-mode",e.edit||this.options.locales.en.edit);this.editModeDiv.appendChild(i),this._bindHammerToDiv(i,J(t=this.toggleEditMode).call(t,this))}},{key:"_clean",value:function(){this.inMode=!1,!0===this.guiEnabled&&(Tr(this.editModeDiv),Tr(this.manipulationDiv),this._cleanManipulatorHammers()),this._cleanupTemporaryNodesAndEdges(),this._unbindTemporaryUIs(),this._unbindTemporaryEvents(),this.body.emitter.emit("restorePhysics")}},{key:"_cleanManipulatorHammers",value:function(){if(0!=this.manipulationHammers.length){for(var t=0;t<this.manipulationHammers.length;t++)this.manipulationHammers[t].destroy();this.manipulationHammers=[]}}},{key:"_removeManipulationDOM",value:function(){this._clean(),Tr(this.manipulationDiv),Tr(this.editModeDiv),Tr(this.closeDiv),this.manipulationDiv&&this.canvas.frame.removeChild(this.manipulationDiv),this.editModeDiv&&this.canvas.frame.removeChild(this.editModeDiv),this.closeDiv&&this.canvas.frame.removeChild(this.closeDiv),this.manipulationDiv=void 0,this.editModeDiv=void 0,this.closeDiv=void 0}},{key:"_createSeperator",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;this.manipulationDOM["seperatorLineDiv"+t]=document.createElement("div"),this.manipulationDOM["seperatorLineDiv"+t].className="vis-separator-line",this.manipulationDiv.appendChild(this.manipulationDOM["seperatorLineDiv"+t])}},{key:"_createAddNodeButton",value:function(t){var e,i=this._createButton("addNode","vis-button vis-add",t.addNode||this.options.locales.en.addNode);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,J(e=this.addNodeMode).call(e,this))}},{key:"_createAddEdgeButton",value:function(t){var e,i=this._createButton("addEdge","vis-button vis-connect",t.addEdge||this.options.locales.en.addEdge);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,J(e=this.addEdgeMode).call(e,this))}},{key:"_createEditNodeButton",value:function(t){var e,i=this._createButton("editNode","vis-button vis-edit",t.editNode||this.options.locales.en.editNode);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,J(e=this.editNode).call(e,this))}},{key:"_createEditEdgeButton",value:function(t){var e,i=this._createButton("editEdge","vis-button vis-edit",t.editEdge||this.options.locales.en.editEdge);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,J(e=this.editEdgeMode).call(e,this))}},{key:"_createDeleteButton",value:function(t){var e,i;i=this.options.rtl?"vis-button vis-delete-rtl":"vis-button vis-delete";var n=this._createButton("delete",i,t.del||this.options.locales.en.del);this.manipulationDiv.appendChild(n),this._bindHammerToDiv(n,J(e=this.deleteSelected).call(e,this))}},{key:"_createBackButton",value:function(t){var e,i=this._createButton("back","vis-button vis-back",t.back||this.options.locales.en.back);this.manipulationDiv.appendChild(i),this._bindHammerToDiv(i,J(e=this.showManipulatorToolbar).call(e,this))}},{key:"_createButton",value:function(t,e,i){var n=arguments.length>3&&void 0!==arguments[3]?arguments[3]:"vis-label";return this.manipulationDOM[t+"Div"]=document.createElement("div"),this.manipulationDOM[t+"Div"].className=e,this.manipulationDOM[t+"Label"]=document.createElement("div"),this.manipulationDOM[t+"Label"].className=n,this.manipulationDOM[t+"Label"].innerHTML=i,this.manipulationDOM[t+"Div"].appendChild(this.manipulationDOM[t+"Label"]),this.manipulationDOM[t+"Div"]}},{key:"_createDescription",value:function(t){this.manipulationDiv.appendChild(this._createButton("description","vis-button vis-none",t))}},{key:"_temporaryBindEvent",value:function(t,e){this.temporaryEventFunctions.push({event:t,boundFunction:e}),this.body.emitter.on(t,e)}},{key:"_temporaryBindUI",value:function(t,e){if(void 0===this.body.eventListeners[t])throw new Error("This UI function does not exist. Typo? You tried: "+t+" possible are: "+Nl(Tn(this.body.eventListeners)));this.temporaryUIFunctions[t]=this.body.eventListeners[t],this.body.eventListeners[t]=e}},{key:"_unbindTemporaryUIs",value:function(){for(var t in this.temporaryUIFunctions)this.temporaryUIFunctions.hasOwnProperty(t)&&(this.body.eventListeners[t]=this.temporaryUIFunctions[t],delete this.temporaryUIFunctions[t]);this.temporaryUIFunctions={}}},{key:"_unbindTemporaryEvents",value:function(){for(var t=0;t<this.temporaryEventFunctions.length;t++){var e=this.temporaryEventFunctions[t].event,i=this.temporaryEventFunctions[t].boundFunction;this.body.emitter.off(e,i)}this.temporaryEventFunctions=[]}},{key:"_bindHammerToDiv",value:function(t,e){var i=new Vh(t,{});Of.onTouch(i,e),this.manipulationHammers.push(i)}},{key:"_cleanupTemporaryNodesAndEdges",value:function(){for(var t=0;t<this.temporaryIds.edges.length;t++){var e;this.body.edges[this.temporaryIds.edges[t]].disconnect(),delete this.body.edges[this.temporaryIds.edges[t]];var i,n=nr(e=this.body.edgeIndices).call(e,this.temporaryIds.edges[t]);if(-1!==n)bs(i=this.body.edgeIndices).call(i,n,1)}for(var o=0;o<this.temporaryIds.nodes.length;o++){var r;delete this.body.nodes[this.temporaryIds.nodes[o]];var s,a=nr(r=this.body.nodeIndices).call(r,this.temporaryIds.nodes[o]);if(-1!==a)bs(s=this.body.nodeIndices).call(s,a,1)}this.temporaryIds={nodes:[],edges:[]}}},{key:"_controlNodeTouch",value:function(t){this.selectionHandler.unselectAll(),this.lastTouch=this.body.functions.getPointer(t.center),this.lastTouch.translation=Fr({},this.body.view.translation)}},{key:"_controlNodeDragStart",value:function(t){var e=this.lastTouch,i=this.selectionHandler._pointerToPositionObject(e),n=this.body.nodes[this.temporaryIds.nodes[0]],o=this.body.nodes[this.temporaryIds.nodes[1]],r=this.body.edges[this.edgeBeingEditedId];this.selectedControlNode=void 0;var s=n.isOverlappingWith(i),a=o.isOverlappingWith(i);!0===s?(this.selectedControlNode=n,r.edgeType.from=n):!0===a&&(this.selectedControlNode=o,r.edgeType.to=o),void 0!==this.selectedControlNode&&this.selectionHandler.selectObject(this.selectedControlNode),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDrag",value:function(t){this.body.emitter.emit("disablePhysics");var e=this.body.functions.getPointer(t.center),i=this.canvas.DOMtoCanvas(e);void 0!==this.selectedControlNode?(this.selectedControlNode.x=i.x,this.selectedControlNode.y=i.y):this.interactionHandler.onDrag(t),this.body.emitter.emit("_redraw")}},{key:"_controlNodeDragEnd",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),n=this.body.edges[this.edgeBeingEditedId];if(void 0!==this.selectedControlNode){this.selectionHandler.unselectAll();for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),r=void 0,s=o.length-1;s>=0;s--)if(o[s]!==this.selectedControlNode.id){r=this.body.nodes[o[s]];break}if(void 0!==r&&void 0!==this.selectedControlNode)if(!0===r.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var a=this.body.nodes[this.temporaryIds.nodes[0]];this.selectedControlNode.id===a.id?this._performEditEdge(r.id,n.to.id):this._performEditEdge(n.from.id,r.id)}else n.updateEdgeType(),this.body.emitter.emit("restorePhysics");this.body.emitter.emit("_redraw")}}},{key:"_handleConnect",value:function(t){if((new Date).valueOf()-this.touchTime>100){this.lastTouch=this.body.functions.getPointer(t.center),this.lastTouch.translation=Fr({},this.body.view.translation),this.interactionHandler.drag.pointer=this.lastTouch,this.interactionHandler.drag.translation=this.lastTouch.translation;var e=this.lastTouch,i=this.selectionHandler.getNodeAt(e);if(void 0!==i)if(!0===i.isCluster)alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError);else{var n=this._getNewTargetNode(i.x,i.y);this.body.nodes[n.id]=n,this.body.nodeIndices.push(n.id);var o=this.body.functions.createEdge({id:"connectionEdge"+Rd(),from:i.id,to:n.id,physics:!1,smooth:{enabled:!0,type:"continuous",roundness:.5}});this.body.edges[o.id]=o,this.body.edgeIndices.push(o.id),this.temporaryIds.nodes.push(n.id),this.temporaryIds.edges.push(o.id)}this.touchTime=(new Date).valueOf()}}},{key:"_dragControlNode",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),n=void 0;void 0!==this.temporaryIds.edges[0]&&(n=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),r=void 0,s=o.length-1;s>=0;s--){var a;if(-1===nr(a=this.temporaryIds.nodes).call(a,o[s])){r=this.body.nodes[o[s]];break}}if(t.controlEdge={from:n,to:r?r.id:void 0},this.selectionHandler._generateClickEvent("controlNodeDragging",t,e),void 0!==this.temporaryIds.nodes[0]){var h=this.body.nodes[this.temporaryIds.nodes[0]];h.x=this.canvas._XconvertDOMtoCanvas(e.x),h.y=this.canvas._YconvertDOMtoCanvas(e.y),this.body.emitter.emit("_redraw")}else this.interactionHandler.onDrag(t)}},{key:"_finishConnect",value:function(t){var e=this.body.functions.getPointer(t.center),i=this.selectionHandler._pointerToPositionObject(e),n=void 0;void 0!==this.temporaryIds.edges[0]&&(n=this.body.edges[this.temporaryIds.edges[0]].fromId);for(var o=this.selectionHandler._getAllNodesOverlappingWith(i),r=void 0,s=o.length-1;s>=0;s--){var a;if(-1===nr(a=this.temporaryIds.nodes).call(a,o[s])){r=this.body.nodes[o[s]];break}}this._cleanupTemporaryNodesAndEdges(),void 0!==r&&(!0===r.isCluster?alert(this.options.locales[this.options.locale].createEdgeError||this.options.locales.en.createEdgeError):void 0!==this.body.nodes[n]&&void 0!==this.body.nodes[r.id]&&this._performAddEdge(n,r.id)),t.controlEdge={from:n,to:r?r.id:void 0},this.selectionHandler._generateClickEvent("controlNodeDragEnd",t,e),this.body.emitter.emit("_redraw")}},{key:"_dragStartEdge",value:function(t){var e=this.lastTouch;this.selectionHandler._generateClickEvent("dragStart",t,e,void 0,!0)}},{key:"_performAddNode",value:function(t){var e=this,i={id:Rd(),x:t.pointer.canvas.x,y:t.pointer.canvas.y,label:"new"};if("function"==typeof this.options.addNode){if(2!==this.options.addNode.length)throw this.showManipulatorToolbar(),new Error("The function for add does not support two arguments (data,callback)");this.options.addNode(i,(function(t){null!=t&&"addNode"===e.inMode&&e.body.data.nodes.getDataSet().add(t),e.showManipulatorToolbar()}))}else this.body.data.nodes.getDataSet().add(i),this.showManipulatorToolbar()}},{key:"_performAddEdge",value:function(t,e){var i=this,n={from:t,to:e};if("function"==typeof this.options.addEdge){if(2!==this.options.addEdge.length)throw new Error("The function for connect does not support two arguments (data,callback)");this.options.addEdge(n,(function(t){null!=t&&"addEdge"===i.inMode&&(i.body.data.edges.getDataSet().add(t),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().add(n),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}},{key:"_performEditEdge",value:function(t,e){var i=this,n={id:this.edgeBeingEditedId,from:t,to:e,label:this.body.data.edges.get(this.edgeBeingEditedId).label},o=this.options.editEdge;if("object"===ur(o)&&(o=o.editWithoutDrag),"function"==typeof o){if(2!==o.length)throw new Error("The function for edit does not support two arguments (data, callback)");o(n,(function(t){null==t||"editEdge"!==i.inMode?(i.body.edges[n.id].updateEdgeType(),i.body.emitter.emit("_redraw"),i.showManipulatorToolbar()):(i.body.data.edges.getDataSet().update(t),i.selectionHandler.unselectAll(),i.showManipulatorToolbar())}))}else this.body.data.edges.getDataSet().update(n),this.selectionHandler.unselectAll(),this.showManipulatorToolbar()}}]),t}(),Zf={black:"#000000",navy:"#000080",darkblue:"#00008B",mediumblue:"#0000CD",blue:"#0000FF",darkgreen:"#006400",green:"#008000",teal:"#008080",darkcyan:"#008B8B",deepskyblue:"#00BFFF",darkturquoise:"#00CED1",mediumspringgreen:"#00FA9A",lime:"#00FF00",springgreen:"#00FF7F",aqua:"#00FFFF",cyan:"#00FFFF",midnightblue:"#191970",dodgerblue:"#1E90FF",lightseagreen:"#20B2AA",forestgreen:"#228B22",seagreen:"#2E8B57",darkslategray:"#2F4F4F",limegreen:"#32CD32",mediumseagreen:"#3CB371",turquoise:"#40E0D0",royalblue:"#4169E1",steelblue:"#4682B4",darkslateblue:"#483D8B",mediumturquoise:"#48D1CC",indigo:"#4B0082",darkolivegreen:"#556B2F",cadetblue:"#5F9EA0",cornflowerblue:"#6495ED",mediumaquamarine:"#66CDAA",dimgray:"#696969",slateblue:"#6A5ACD",olivedrab:"#6B8E23",slategray:"#708090",lightslategray:"#778899",mediumslateblue:"#7B68EE",lawngreen:"#7CFC00",chartreuse:"#7FFF00",aquamarine:"#7FFFD4",maroon:"#800000",purple:"#800080",olive:"#808000",gray:"#808080",skyblue:"#87CEEB",lightskyblue:"#87CEFA",blueviolet:"#8A2BE2",darkred:"#8B0000",darkmagenta:"#8B008B",saddlebrown:"#8B4513",darkseagreen:"#8FBC8F",lightgreen:"#90EE90",mediumpurple:"#9370D8",darkviolet:"#9400D3",palegreen:"#98FB98",darkorchid:"#9932CC",yellowgreen:"#9ACD32",sienna:"#A0522D",brown:"#A52A2A",darkgray:"#A9A9A9",lightblue:"#ADD8E6",greenyellow:"#ADFF2F",paleturquoise:"#AFEEEE",lightsteelblue:"#B0C4DE",powderblue:"#B0E0E6",firebrick:"#B22222",darkgoldenrod:"#B8860B",mediumorchid:"#BA55D3",rosybrown:"#BC8F8F",darkkhaki:"#BDB76B",silver:"#C0C0C0",mediumvioletred:"#C71585",indianred:"#CD5C5C",peru:"#CD853F",chocolate:"#D2691E",tan:"#D2B48C",lightgrey:"#D3D3D3",palevioletred:"#D87093",thistle:"#D8BFD8",orchid:"#DA70D6",goldenrod:"#DAA520",crimson:"#DC143C",gainsboro:"#DCDCDC",plum:"#DDA0DD",burlywood:"#DEB887",lightcyan:"#E0FFFF",lavender:"#E6E6FA",darksalmon:"#E9967A",violet:"#EE82EE",palegoldenrod:"#EEE8AA",lightcoral:"#F08080",khaki:"#F0E68C",aliceblue:"#F0F8FF",honeydew:"#F0FFF0",azure:"#F0FFFF",sandybrown:"#F4A460",wheat:"#F5DEB3",beige:"#F5F5DC",whitesmoke:"#F5F5F5",mintcream:"#F5FFFA",ghostwhite:"#F8F8FF",salmon:"#FA8072",antiquewhite:"#FAEBD7",linen:"#FAF0E6",lightgoldenrodyellow:"#FAFAD2",oldlace:"#FDF5E6",red:"#FF0000",fuchsia:"#FF00FF",magenta:"#FF00FF",deeppink:"#FF1493",orangered:"#FF4500",tomato:"#FF6347",hotpink:"#FF69B4",coral:"#FF7F50",darkorange:"#FF8C00",lightsalmon:"#FFA07A",orange:"#FFA500",lightpink:"#FFB6C1",pink:"#FFC0CB",gold:"#FFD700",peachpuff:"#FFDAB9",navajowhite:"#FFDEAD",moccasin:"#FFE4B5",bisque:"#FFE4C4",mistyrose:"#FFE4E1",blanchedalmond:"#FFEBCD",papayawhip:"#FFEFD5",lavenderblush:"#FFF0F5",seashell:"#FFF5EE",cornsilk:"#FFF8DC",lemonchiffon:"#FFFACD",floralwhite:"#FFFAF0",snow:"#FFFAFA",yellow:"#FFFF00",lightyellow:"#FFFFE0",ivory:"#FFFFF0",white:"#FFFFFF"},Qf=function(){function t(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:1;Kh(this,t),this.pixelRatio=e,this.generated=!1,this.centerCoordinates={x:144.5,y:144.5},this.r=289*.49,this.color={r:255,g:255,b:255,a:1},this.hueCircle=void 0,this.initialColor={r:255,g:255,b:255,a:1},this.previousColor=void 0,this.applied=!1,this.updateCallback=function(){},this.closeCallback=function(){},this._create()}return Qh(t,[{key:"insertTo",value:function(t){void 0!==this.hammer&&(this.hammer.destroy(),this.hammer=void 0),this.container=t,this.container.appendChild(this.frame),this._bindHammer(),this._setSize()}},{key:"setUpdateCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker update callback is not a function.");this.updateCallback=t}},{key:"setCloseCallback",value:function(t){if("function"!=typeof t)throw new Error("Function attempted to set as colorPicker closing callback is not a function.");this.closeCallback=t}},{key:"_isColorString",value:function(t){if("string"==typeof t)return Zf[t]}},{key:"setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];if("none"!==t){var i,n=this._isColorString(t);if(void 0!==n&&(t=n),!0===Pr(t)){if(!0===ss(t)){var o=t.substr(4).substr(0,t.length-5).split(",");i={r:o[0],g:o[1],b:o[2],a:1}}else if(!0===as(t)){var r=t.substr(5).substr(0,t.length-6).split(",");i={r:r[0],g:r[1],b:r[2],a:r[3]}}else if(!0===rs(t)){var s=$r(t);i={r:s.r,g:s.g,b:s.b,a:1}}}else if(t instanceof Object&&void 0!==t.r&&void 0!==t.g&&void 0!==t.b){var a=void 0!==t.a?t.a:"1.0";i={r:t.r,g:t.g,b:t.b,a:a}}if(void 0===i)throw new Error("Unknown color passed to the colorPicker. Supported are strings: rgb, hex, rgba. Object: rgb ({r:r,g:g,b:b,[a:a]}). Supplied: "+Nl(t));this._setColor(i,e)}}},{key:"show",value:function(){void 0!==this.closeCallback&&(this.closeCallback(),this.closeCallback=void 0),this.applied=!1,this.frame.style.display="block",this._generateHueCircle()}},{key:"_hide",value:function(){var t=this,e=!(arguments.length>0&&void 0!==arguments[0])||arguments[0];!0===e&&(this.previousColor=Fr({},this.color)),!0===this.applied&&this.updateCallback(this.initialColor),this.frame.style.display="none",rl((function(){void 0!==t.closeCallback&&(t.closeCallback(),t.closeCallback=void 0)}),0)}},{key:"_save",value:function(){this.updateCallback(this.color),this.applied=!1,this._hide()}},{key:"_apply",value:function(){this.applied=!0,this.updateCallback(this.color),this._updatePicker(this.color)}},{key:"_loadLast",value:function(){void 0!==this.previousColor?this.setColor(this.previousColor,!1):alert("There is no last color to load...")}},{key:"_setColor",value:function(t){var e=!(arguments.length>1&&void 0!==arguments[1])||arguments[1];!0===e&&(this.initialColor=Fr({},t)),this.color=t;var i=Jr(t.r,t.g,t.b),n=2*Math.PI,o=this.r*i.s,r=this.centerCoordinates.x+o*Math.sin(n*i.h),s=this.centerCoordinates.y+o*Math.cos(n*i.h);this.colorPickerSelector.style.left=r-.5*this.colorPickerSelector.clientWidth+"px",this.colorPickerSelector.style.top=s-.5*this.colorPickerSelector.clientHeight+"px",this._updatePicker(t)}},{key:"_setOpacity",value:function(t){this.color.a=t/100,this._updatePicker(this.color)}},{key:"_setBrightness",value:function(t){var e=Jr(this.color.r,this.color.g,this.color.b);e.v=t/100;var i=is(e.h,e.s,e.v);i.a=this.color.a,this.color=i,this._updatePicker()}},{key:"_updatePicker",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:this.color,e=Jr(t.r,t.g,t.b),i=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(i.webkitBackingStorePixelRatio||i.mozBackingStorePixelRatio||i.msBackingStorePixelRatio||i.oBackingStorePixelRatio||i.backingStorePixelRatio||1)),i.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var n=this.colorPickerCanvas.clientWidth,o=this.colorPickerCanvas.clientHeight;i.clearRect(0,0,n,o),i.putImageData(this.hueCircle,0,0),i.fillStyle="rgba(0,0,0,"+(1-e.v)+")",i.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),_u(i).call(i),this.brightnessRange.value=100*e.v,this.opacityRange.value=100*t.a,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}},{key:"_setSize",value:function(){this.colorPickerCanvas.style.width="100%",this.colorPickerCanvas.style.height="100%",this.colorPickerCanvas.width=289*this.pixelRatio,this.colorPickerCanvas.height=289*this.pixelRatio}},{key:"_create",value:function(){var t,e,i,n;if(this.frame=document.createElement("div"),this.frame.className="vis-color-picker",this.colorPickerDiv=document.createElement("div"),this.colorPickerSelector=document.createElement("div"),this.colorPickerSelector.className="vis-selector",this.colorPickerDiv.appendChild(this.colorPickerSelector),this.colorPickerCanvas=document.createElement("canvas"),this.colorPickerDiv.appendChild(this.colorPickerCanvas),this.colorPickerCanvas.getContext){var o=this.colorPickerCanvas.getContext("2d");this.pixelRatio=(window.devicePixelRatio||1)/(o.webkitBackingStorePixelRatio||o.mozBackingStorePixelRatio||o.msBackingStorePixelRatio||o.oBackingStorePixelRatio||o.backingStorePixelRatio||1),this.colorPickerCanvas.getContext("2d").setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0)}else{var r=document.createElement("DIV");r.style.color="red",r.style.fontWeight="bold",r.style.padding="10px",r.innerHTML="Error: your browser does not support HTML canvas",this.colorPickerCanvas.appendChild(r)}this.colorPickerDiv.className="vis-color",this.opacityDiv=document.createElement("div"),this.opacityDiv.className="vis-opacity",this.brightnessDiv=document.createElement("div"),this.brightnessDiv.className="vis-brightness",this.arrowDiv=document.createElement("div"),this.arrowDiv.className="vis-arrow",this.opacityRange=document.createElement("input");try{this.opacityRange.type="range",this.opacityRange.min="0",this.opacityRange.max="100"}catch(t){}this.opacityRange.value="100",this.opacityRange.className="vis-range",this.brightnessRange=document.createElement("input");try{this.brightnessRange.type="range",this.brightnessRange.min="0",this.brightnessRange.max="100"}catch(t){}this.brightnessRange.value="100",this.brightnessRange.className="vis-range",this.opacityDiv.appendChild(this.opacityRange),this.brightnessDiv.appendChild(this.brightnessRange);var s=this;this.opacityRange.onchange=function(){s._setOpacity(this.value)},this.opacityRange.oninput=function(){s._setOpacity(this.value)},this.brightnessRange.onchange=function(){s._setBrightness(this.value)},this.brightnessRange.oninput=function(){s._setBrightness(this.value)},this.brightnessLabel=document.createElement("div"),this.brightnessLabel.className="vis-label vis-brightness",this.brightnessLabel.innerHTML="brightness:",this.opacityLabel=document.createElement("div"),this.opacityLabel.className="vis-label vis-opacity",this.opacityLabel.innerHTML="opacity:",this.newColorDiv=document.createElement("div"),this.newColorDiv.className="vis-new-color",this.newColorDiv.innerHTML="new",this.initialColorDiv=document.createElement("div"),this.initialColorDiv.className="vis-initial-color",this.initialColorDiv.innerHTML="initial",this.cancelButton=document.createElement("div"),this.cancelButton.className="vis-button vis-cancel",this.cancelButton.innerHTML="cancel",this.cancelButton.onclick=J(t=this._hide).call(t,this,!1),this.applyButton=document.createElement("div"),this.applyButton.className="vis-button vis-apply",this.applyButton.innerHTML="apply",this.applyButton.onclick=J(e=this._apply).call(e,this),this.saveButton=document.createElement("div"),this.saveButton.className="vis-button vis-save",this.saveButton.innerHTML="save",this.saveButton.onclick=J(i=this._save).call(i,this),this.loadButton=document.createElement("div"),this.loadButton.className="vis-button vis-load",this.loadButton.innerHTML="load last",this.loadButton.onclick=J(n=this._loadLast).call(n,this),this.frame.appendChild(this.colorPickerDiv),this.frame.appendChild(this.arrowDiv),this.frame.appendChild(this.brightnessLabel),this.frame.appendChild(this.brightnessDiv),this.frame.appendChild(this.opacityLabel),this.frame.appendChild(this.opacityDiv),this.frame.appendChild(this.newColorDiv),this.frame.appendChild(this.initialColorDiv),this.frame.appendChild(this.cancelButton),this.frame.appendChild(this.applyButton),this.frame.appendChild(this.saveButton),this.frame.appendChild(this.loadButton)}},{key:"_bindHammer",value:function(){var t=this;this.drag={},this.pinch={},this.hammer=new Vh(this.colorPickerCanvas),this.hammer.get("pinch").set({enable:!0}),Of.onTouch(this.hammer,(function(e){t._moveSelector(e)})),this.hammer.on("tap",(function(e){t._moveSelector(e)})),this.hammer.on("panstart",(function(e){t._moveSelector(e)})),this.hammer.on("panmove",(function(e){t._moveSelector(e)})),this.hammer.on("panend",(function(e){t._moveSelector(e)}))}},{key:"_generateHueCircle",value:function(){if(!1===this.generated){var t=this.colorPickerCanvas.getContext("2d");void 0===this.pixelRation&&(this.pixelRatio=(window.devicePixelRatio||1)/(t.webkitBackingStorePixelRatio||t.mozBackingStorePixelRatio||t.msBackingStorePixelRatio||t.oBackingStorePixelRatio||t.backingStorePixelRatio||1)),t.setTransform(this.pixelRatio,0,0,this.pixelRatio,0,0);var e,i,n,o,r=this.colorPickerCanvas.clientWidth,s=this.colorPickerCanvas.clientHeight;t.clearRect(0,0,r,s),this.centerCoordinates={x:.5*r,y:.5*s},this.r=.49*r;var a,h=2*Math.PI/360,l=1/this.r;for(n=0;n<360;n++)for(o=0;o<this.r;o++)e=this.centerCoordinates.x+o*Math.sin(h*n),i=this.centerCoordinates.y+o*Math.cos(h*n),a=is(n*(1/360),o*l,1),t.fillStyle="rgb("+a.r+","+a.g+","+a.b+")",t.fillRect(e-.5,i-.5,2,2);t.strokeStyle="rgba(0,0,0,1)",t.circle(this.centerCoordinates.x,this.centerCoordinates.y,this.r),t.stroke(),this.hueCircle=t.getImageData(0,0,r,s)}this.generated=!0}},{key:"_moveSelector",value:function(t){var e=this.colorPickerDiv.getBoundingClientRect(),i=t.center.x-e.left,n=t.center.y-e.top,o=.5*this.colorPickerDiv.clientHeight,r=.5*this.colorPickerDiv.clientWidth,s=i-r,a=n-o,h=Math.atan2(s,a),l=.98*Math.min(Math.sqrt(s*s+a*a),r),d=Math.cos(h)*l+o,u=Math.sin(h)*l+r;this.colorPickerSelector.style.top=d-.5*this.colorPickerSelector.clientHeight+"px",this.colorPickerSelector.style.left=u-.5*this.colorPickerSelector.clientWidth+"px";var c=h/(2*Math.PI);c=c<0?c+1:c;var f=l/this.r,p=Jr(this.color.r,this.color.g,this.color.b);p.h=c,p.s=f;var v=is(p.h,p.s,p.v);v.a=this.color.a,this.color=v,this.initialColorDiv.style.backgroundColor="rgba("+this.initialColor.r+","+this.initialColor.g+","+this.initialColor.b+","+this.initialColor.a+")",this.newColorDiv.style.backgroundColor="rgba("+this.color.r+","+this.color.g+","+this.color.b+","+this.color.a+")"}}]),t}(),Jf=function(){function t(e,i,n){var o=arguments.length>3&&void 0!==arguments[3]?arguments[3]:1;Kh(this,t),this.parent=e,this.changedOptions=[],this.container=i,this.allowCreation=!1,this.options={},this.initialized=!1,this.popupCounter=0,this.defaultOptions={enabled:!1,filter:!0,container:void 0,showButton:!0},Fr(this.options,this.defaultOptions),this.configureOptions=n,this.moduleOptions={},this.domElements=[],this.popupDiv={},this.popupLimit=5,this.popupHistory={},this.colorPicker=new Qf(o),this.wrapper=void 0}return Qh(t,[{key:"setOptions",value:function(t){if(void 0!==t){this.popupHistory={},this._removePopup();var e=!0;if("string"==typeof t)this.options.filter=t;else if(t instanceof Array)this.options.filter=t.join();else if("object"===ur(t)){if(null==t)throw new TypeError("options cannot be null");void 0!==t.container&&(this.options.container=t.container),void 0!==_o(t)&&(this.options.filter=_o(t)),void 0!==t.showButton&&(this.options.showButton=t.showButton),void 0!==t.enabled&&(e=t.enabled)}else"boolean"==typeof t?(this.options.filter=!0,e=t):"function"==typeof t&&(this.options.filter=t,e=!0);!1===_o(this.options)&&(e=!1),this.options.enabled=e}this._clean()}},{key:"setModuleOptions",value:function(t){this.moduleOptions=t,!0===this.options.enabled&&(this._clean(),void 0!==this.options.container&&(this.container=this.options.container),this._create())}},{key:"_create",value:function(){this._clean(),this.changedOptions=[];var t=_o(this.options),e=0,i=!1;for(var n in this.configureOptions)this.configureOptions.hasOwnProperty(n)&&(this.allowCreation=!1,i=!1,"function"==typeof t?i=(i=t(n,[]))||this._handleObject(this.configureOptions[n],[n],!0):!0!==t&&-1===nr(t).call(t,n)||(i=!0),!1!==i&&(this.allowCreation=!0,e>0&&this._makeItem([]),this._makeHeader(n),this._handleObject(this.configureOptions[n],[n])),e++);this._makeButton(),this._push()}},{key:"_push",value:function(){this.wrapper=document.createElement("div"),this.wrapper.className="vis-configuration-wrapper",this.container.appendChild(this.wrapper);for(var t=0;t<this.domElements.length;t++)this.wrapper.appendChild(this.domElements[t]);this._showPopupIfNeeded()}},{key:"_clean",value:function(){for(var t=0;t<this.domElements.length;t++)this.wrapper.removeChild(this.domElements[t]);void 0!==this.wrapper&&(this.container.removeChild(this.wrapper),this.wrapper=void 0),this.domElements=[],this._removePopup()}},{key:"_getValue",value:function(t){for(var e=this.moduleOptions,i=0;i<t.length;i++){if(void 0===e[t[i]]){e=void 0;break}e=e[t[i]]}return e}},{key:"_makeItem",value:function(t){if(!0===this.allowCreation){var e=document.createElement("div");e.className="vis-configuration vis-config-item vis-config-s"+t.length;for(var i=arguments.length,n=new Array(i>1?i-1:0),o=1;o<i;o++)n[o-1]=arguments[o];return Jn(n).call(n,(function(t){e.appendChild(t)})),this.domElements.push(e),this.domElements.length}return 0}},{key:"_makeHeader",value:function(t){var e=document.createElement("div");e.className="vis-configuration vis-config-header",e.innerHTML=t,this._makeItem([],e)}},{key:"_makeLabel",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=document.createElement("div");return n.className="vis-configuration vis-config-label vis-config-s"+e.length,n.innerHTML=!0===i?"<i><b>"+t+":</b></i>":t+":",n}},{key:"_makeDropdown",value:function(t,e,i){var n=document.createElement("select");n.className="vis-configuration vis-config-select";var o=0;void 0!==e&&-1!==nr(t).call(t,e)&&(o=nr(t).call(t,e));for(var r=0;r<t.length;r++){var s=document.createElement("option");s.value=t[r],r===o&&(s.selected="selected"),s.innerHTML=t[r],n.appendChild(s)}var a=this;n.onchange=function(){a._update(this.value,i)};var h=this._makeLabel(i[i.length-1],i);this._makeItem(i,h,n)}},{key:"_makeRange",value:function(t,e,i){var n=t[0],o=t[1],r=t[2],s=t[3],a=document.createElement("input");a.className="vis-configuration vis-config-range";try{a.type="range",a.min=o,a.max=r}catch(t){}a.step=s;var h="",l=0;if(void 0!==e){e<0&&1.2*e<o?(a.min=Math.ceil(1.2*e),l=a.min,h="range increased"):e/1.2<o&&(a.min=Math.ceil(e/1.2),l=a.min,h="range increased"),1.2*e>r&&1!==r&&(a.max=Math.ceil(1.2*e),l=a.max,h="range increased"),a.value=e}else a.value=n;var d=document.createElement("input");d.className="vis-configuration vis-config-rangeinput",d.value=a.value;var u=this;a.onchange=function(){d.value=this.value,u._update(Number(this.value),i)},a.oninput=function(){d.value=this.value};var c=this._makeLabel(i[i.length-1],i),f=this._makeItem(i,c,a,d);""!==h&&this.popupHistory[f]!==l&&(this.popupHistory[f]=l,this._setupPopup(h,f))}},{key:"_makeButton",value:function(){var t=this;if(!0===this.options.showButton){var e=document.createElement("div");e.className="vis-configuration vis-config-button",e.innerHTML="generate options",e.onclick=function(){t._printOptions()},e.onmouseover=function(){e.className="vis-configuration vis-config-button hover"},e.onmouseout=function(){e.className="vis-configuration vis-config-button"},this.optionsContainer=document.createElement("div"),this.optionsContainer.className="vis-configuration vis-config-option-container",this.domElements.push(this.optionsContainer),this.domElements.push(e)}}},{key:"_setupPopup",value:function(t,e){var i=this;if(!0===this.initialized&&!0===this.allowCreation&&this.popupCounter<this.popupLimit){var n=document.createElement("div");n.id="vis-configuration-popup",n.className="vis-configuration-popup",n.innerHTML=t,n.onclick=function(){i._removePopup()},this.popupCounter+=1,this.popupDiv={html:n,index:e}}}},{key:"_removePopup",value:function(){void 0!==this.popupDiv.html&&(this.popupDiv.html.parentNode.removeChild(this.popupDiv.html),clearTimeout(this.popupDiv.hideTimeout),clearTimeout(this.popupDiv.deleteTimeout),this.popupDiv={})}},{key:"_showPopupIfNeeded",value:function(){var t=this;if(void 0!==this.popupDiv.html){var e=this.domElements[this.popupDiv.index].getBoundingClientRect();this.popupDiv.html.style.left=e.left+"px",this.popupDiv.html.style.top=e.top-30+"px",document.body.appendChild(this.popupDiv.html),this.popupDiv.hideTimeout=rl((function(){t.popupDiv.html.style.opacity=0}),1500),this.popupDiv.deleteTimeout=rl((function(){t._removePopup()}),1800)}}},{key:"_makeCheckbox",value:function(t,e,i){var n=document.createElement("input");n.type="checkbox",n.className="vis-configuration vis-config-checkbox",n.checked=t,void 0!==e&&(n.checked=e,e!==t&&("object"===ur(t)?e!==t.enabled&&this.changedOptions.push({path:i,value:e}):this.changedOptions.push({path:i,value:e})));var o=this;n.onchange=function(){o._update(this.checked,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,n)}},{key:"_makeTextInput",value:function(t,e,i){var n=document.createElement("input");n.type="text",n.className="vis-configuration vis-config-text",n.value=e,e!==t&&this.changedOptions.push({path:i,value:e});var o=this;n.onchange=function(){o._update(this.value,i)};var r=this._makeLabel(i[i.length-1],i);this._makeItem(i,r,n)}},{key:"_makeColorField",value:function(t,e,i){var n=this,o=t[1],r=document.createElement("div");"none"!==(e=void 0===e?o:e)?(r.className="vis-configuration vis-config-colorBlock",r.style.backgroundColor=e):r.className="vis-configuration vis-config-colorBlock none",e=void 0===e?o:e,r.onclick=function(){n._showColorPicker(e,r,i)};var s=this._makeLabel(i[i.length-1],i);this._makeItem(i,s,r)}},{key:"_showColorPicker",value:function(t,e,i){var n=this;e.onclick=function(){},this.colorPicker.insertTo(e),this.colorPicker.show(),this.colorPicker.setColor(t),this.colorPicker.setUpdateCallback((function(t){var o="rgba("+t.r+","+t.g+","+t.b+","+t.a+")";e.style.backgroundColor=o,n._update(o,i)})),this.colorPicker.setCloseCallback((function(){e.onclick=function(){n._showColorPicker(t,e,i)}}))}},{key:"_handleObject",value:function(t){var e=arguments.length>1&&void 0!==arguments[1]?arguments[1]:[],i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=!1,o=_o(this.options),r=!1;for(var s in t)if(t.hasOwnProperty(s)){n=!0;var a=t[s],h=Lr(e,s);if("function"==typeof o&&!1===(n=o(s,e))&&!(a instanceof Array)&&"string"!=typeof a&&"boolean"!=typeof a&&a instanceof Object&&(this.allowCreation=!1,n=this._handleObject(a,h,!0),this.allowCreation=!1===i),!1!==n){r=!0;var l=this._getValue(h);if(a instanceof Array)this._handleArray(a,l,h);else if("string"==typeof a)this._makeTextInput(a,l,h);else if("boolean"==typeof a)this._makeCheckbox(a,l,h);else if(a instanceof Object){var d=!0;if(-1!==nr(e).call(e,"physics")&&this.moduleOptions.physics.solver!==s&&"wind"!==s&&(d=!1),!0===d)if(void 0!==a.enabled){var u=Lr(h,"enabled"),c=this._getValue(u);if(!0===c){var f=this._makeLabel(s,h,!0);this._makeItem(h,f),r=this._handleObject(a,h)||r}else this._makeCheckbox(a,c,h)}else{var p=this._makeLabel(s,h,!0);this._makeItem(h,p),r=this._handleObject(a,h)||r}}else console.error("dont know how to handle",a,s,h)}}return r}},{key:"_handleArray",value:function(t,e,i){"string"==typeof t[0]&&"color"===t[0]?(this._makeColorField(t,e,i),t[1]!==e&&this.changedOptions.push({path:i,value:e})):"string"==typeof t[0]?(this._makeDropdown(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:e})):"number"==typeof t[0]&&(this._makeRange(t,e,i),t[0]!==e&&this.changedOptions.push({path:i,value:Number(e)}))}},{key:"_update",value:function(t,e){var i=this._constructOptions(t,e);this.parent.body&&this.parent.body.emitter&&this.parent.body.emitter.emit&&this.parent.body.emitter.emit("configChange",i),this.initialized=!0,this.parent.setOptions(i)}},{key:"_constructOptions",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]?arguments[2]:{},n=i;t="false"!==(t="true"===t||t)&&t;for(var o=0;o<e.length;o++)"global"!==e[o]&&(void 0===n[e[o]]&&(n[e[o]]={}),o!==e.length-1?n=n[e[o]]:n[e[o]]=t);return i}},{key:"_printOptions",value:function(){var t=this.getOptions();this.optionsContainer.innerHTML="<pre>var options = "+Nl(t,null,2)+"</pre>"}},{key:"getOptions",value:function(){for(var t={},e=0;e<this.changedOptions.length;e++)this._constructOptions(this.changedOptions[e].value,this.changedOptions[e].path,t);return t}}]),t}(),tp="string",ep="boolean",ip="number",np="object",op=["arrow","bar","box","circle","crow","curve","diamond","image","inv_curve","inv_triangle","triangle","vee"],rp={configure:{enabled:{boolean:ep},filter:{boolean:ep,string:tp,array:"array",function:"function"},container:{dom:"dom"},showButton:{boolean:ep},__type__:{object:np,boolean:ep,string:tp,array:"array",function:"function"}},edges:{arrows:{to:{enabled:{boolean:ep},scaleFactor:{number:ip},type:{string:op},imageHeight:{number:ip},imageWidth:{number:ip},src:{string:tp},__type__:{object:np,boolean:ep}},middle:{enabled:{boolean:ep},scaleFactor:{number:ip},type:{string:op},imageWidth:{number:ip},imageHeight:{number:ip},src:{string:tp},__type__:{object:np,boolean:ep}},from:{enabled:{boolean:ep},scaleFactor:{number:ip},type:{string:op},imageWidth:{number:ip},imageHeight:{number:ip},src:{string:tp},__type__:{object:np,boolean:ep}},__type__:{string:["from","to","middle"],object:np}},arrowStrikethrough:{boolean:ep},background:{enabled:{boolean:ep},color:{string:tp},size:{number:ip},dashes:{boolean:ep,array:"array"},__type__:{object:np,boolean:ep}},chosen:{label:{boolean:ep,function:"function"},edge:{boolean:ep,function:"function"},__type__:{object:np,boolean:ep}},color:{color:{string:tp},highlight:{string:tp},hover:{string:tp},inherit:{string:["from","to","both"],boolean:ep},opacity:{number:ip},__type__:{object:np,string:tp}},dashes:{boolean:ep,array:"array"},font:{color:{string:tp},size:{number:ip},face:{string:tp},background:{string:tp},strokeWidth:{number:ip},strokeColor:{string:tp},align:{string:["horizontal","top","middle","bottom"]},vadjust:{number:ip},multi:{boolean:ep,string:tp},bold:{color:{string:tp},size:{number:ip},face:{string:tp},mod:{string:tp},vadjust:{number:ip},__type__:{object:np,string:tp}},boldital:{color:{string:tp},size:{number:ip},face:{string:tp},mod:{string:tp},vadjust:{number:ip},__type__:{object:np,string:tp}},ital:{color:{string:tp},size:{number:ip},face:{string:tp},mod:{string:tp},vadjust:{number:ip},__type__:{object:np,string:tp}},mono:{color:{string:tp},size:{number:ip},face:{string:tp},mod:{string:tp},vadjust:{number:ip},__type__:{object:np,string:tp}},__type__:{object:np,string:tp}},hidden:{boolean:ep},hoverWidth:{function:"function",number:ip},label:{string:tp,undefined:"undefined"},labelHighlightBold:{boolean:ep},length:{number:ip,undefined:"undefined"},physics:{boolean:ep},scaling:{min:{number:ip},max:{number:ip},label:{enabled:{boolean:ep},min:{number:ip},max:{number:ip},maxVisible:{number:ip},drawThreshold:{number:ip},__type__:{object:np,boolean:ep}},customScalingFunction:{function:"function"},__type__:{object:np}},selectionWidth:{function:"function",number:ip},selfReferenceSize:{number:ip},selfReference:{size:{number:ip},angle:{number:ip},renderBehindTheNode:{boolean:ep},__type__:{object:np}},shadow:{enabled:{boolean:ep},color:{string:tp},size:{number:ip},x:{number:ip},y:{number:ip},__type__:{object:np,boolean:ep}},smooth:{enabled:{boolean:ep},type:{string:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"]},roundness:{number:ip},forceDirection:{string:["horizontal","vertical","none"],boolean:ep},__type__:{object:np,boolean:ep}},title:{string:tp,undefined:"undefined"},width:{number:ip},widthConstraint:{maximum:{number:ip},__type__:{object:np,boolean:ep,number:ip}},value:{number:ip,undefined:"undefined"},__type__:{object:np}},groups:{useDefaultGroups:{boolean:ep},__any__:"get from nodes, will be overwritten below",__type__:{object:np}},interaction:{dragNodes:{boolean:ep},dragView:{boolean:ep},hideEdgesOnDrag:{boolean:ep},hideEdgesOnZoom:{boolean:ep},hideNodesOnDrag:{boolean:ep},hover:{boolean:ep},keyboard:{enabled:{boolean:ep},speed:{x:{number:ip},y:{number:ip},zoom:{number:ip},__type__:{object:np}},bindToWindow:{boolean:ep},__type__:{object:np,boolean:ep}},multiselect:{boolean:ep},navigationButtons:{boolean:ep},selectable:{boolean:ep},selectConnectedEdges:{boolean:ep},hoverConnectedEdges:{boolean:ep},tooltipDelay:{number:ip},zoomView:{boolean:ep},zoomSpeed:{number:ip},__type__:{object:np}},layout:{randomSeed:{undefined:"undefined",number:ip,string:tp},improvedLayout:{boolean:ep},clusterThreshold:{number:ip},hierarchical:{enabled:{boolean:ep},levelSeparation:{number:ip},nodeSpacing:{number:ip},treeSpacing:{number:ip},blockShifting:{boolean:ep},edgeMinimization:{boolean:ep},parentCentralization:{boolean:ep},direction:{string:["UD","DU","LR","RL"]},sortMethod:{string:["hubsize","directed"]},shakeTowards:{string:["leaves","roots"]},__type__:{object:np,boolean:ep}},__type__:{object:np}},manipulation:{enabled:{boolean:ep},initiallyActive:{boolean:ep},addNode:{boolean:ep,function:"function"},addEdge:{boolean:ep,function:"function"},editNode:{function:"function"},editEdge:{editWithoutDrag:{function:"function"},__type__:{object:np,boolean:ep,function:"function"}},deleteNode:{boolean:ep,function:"function"},deleteEdge:{boolean:ep,function:"function"},controlNodeStyle:"get from nodes, will be overwritten below",__type__:{object:np,boolean:ep}},nodes:{borderWidth:{number:ip},borderWidthSelected:{number:ip,undefined:"undefined"},brokenImage:{string:tp,undefined:"undefined"},chosen:{label:{boolean:ep,function:"function"},node:{boolean:ep,function:"function"},__type__:{object:np,boolean:ep}},color:{border:{string:tp},background:{string:tp},highlight:{border:{string:tp},background:{string:tp},__type__:{object:np,string:tp}},hover:{border:{string:tp},background:{string:tp},__type__:{object:np,string:tp}},__type__:{object:np,string:tp}},opacity:{number:ip,undefined:"undefined"},fixed:{x:{boolean:ep},y:{boolean:ep},__type__:{object:np,boolean:ep}},font:{align:{string:tp},color:{string:tp},size:{number:ip},face:{string:tp},background:{string:tp},strokeWidth:{number:ip},strokeColor:{string:tp},vadjust:{number:ip},multi:{boolean:ep,string:tp},bold:{color:{string:tp},size:{number:ip},face:{string:tp},mod:{string:tp},vadjust:{number:ip},__type__:{object:np,string:tp}},boldital:{color:{string:tp},size:{number:ip},face:{string:tp},mod:{string:tp},vadjust:{number:ip},__type__:{object:np,string:tp}},ital:{color:{string:tp},size:{number:ip},face:{string:tp},mod:{string:tp},vadjust:{number:ip},__type__:{object:np,string:tp}},mono:{color:{string:tp},size:{number:ip},face:{string:tp},mod:{string:tp},vadjust:{number:ip},__type__:{object:np,string:tp}},__type__:{object:np,string:tp}},group:{string:tp,number:ip,undefined:"undefined"},heightConstraint:{minimum:{number:ip},valign:{string:tp},__type__:{object:np,boolean:ep,number:ip}},hidden:{boolean:ep},icon:{face:{string:tp},code:{string:tp},size:{number:ip},color:{string:tp},weight:{string:tp,number:ip},__type__:{object:np}},id:{string:tp,number:ip},image:{selected:{string:tp,undefined:"undefined"},unselected:{string:tp,undefined:"undefined"},__type__:{object:np,string:tp}},imagePadding:{top:{number:ip},right:{number:ip},bottom:{number:ip},left:{number:ip},__type__:{object:np,number:ip}},label:{string:tp,undefined:"undefined"},labelHighlightBold:{boolean:ep},level:{number:ip,undefined:"undefined"},margin:{top:{number:ip},right:{number:ip},bottom:{number:ip},left:{number:ip},__type__:{object:np,number:ip}},mass:{number:ip},physics:{boolean:ep},scaling:{min:{number:ip},max:{number:ip},label:{enabled:{boolean:ep},min:{number:ip},max:{number:ip},maxVisible:{number:ip},drawThreshold:{number:ip},__type__:{object:np,boolean:ep}},customScalingFunction:{function:"function"},__type__:{object:np}},shadow:{enabled:{boolean:ep},color:{string:tp},size:{number:ip},x:{number:ip},y:{number:ip},__type__:{object:np,boolean:ep}},shape:{string:["ellipse","circle","database","box","text","image","circularImage","diamond","dot","star","triangle","triangleDown","square","icon","hexagon"]},shapeProperties:{borderDashes:{boolean:ep,array:"array"},borderRadius:{number:ip},interpolation:{boolean:ep},useImageSize:{boolean:ep},useBorderWithImage:{boolean:ep},__type__:{object:np}},size:{number:ip},title:{string:tp,dom:"dom",undefined:"undefined"},value:{number:ip,undefined:"undefined"},widthConstraint:{minimum:{number:ip},maximum:{number:ip},__type__:{object:np,boolean:ep,number:ip}},x:{number:ip},y:{number:ip},__type__:{object:np}},physics:{enabled:{boolean:ep},barnesHut:{theta:{number:ip},gravitationalConstant:{number:ip},centralGravity:{number:ip},springLength:{number:ip},springConstant:{number:ip},damping:{number:ip},avoidOverlap:{number:ip},__type__:{object:np}},forceAtlas2Based:{theta:{number:ip},gravitationalConstant:{number:ip},centralGravity:{number:ip},springLength:{number:ip},springConstant:{number:ip},damping:{number:ip},avoidOverlap:{number:ip},__type__:{object:np}},repulsion:{centralGravity:{number:ip},springLength:{number:ip},springConstant:{number:ip},nodeDistance:{number:ip},damping:{number:ip},__type__:{object:np}},hierarchicalRepulsion:{centralGravity:{number:ip},springLength:{number:ip},springConstant:{number:ip},nodeDistance:{number:ip},damping:{number:ip},avoidOverlap:{number:ip},__type__:{object:np}},maxVelocity:{number:ip},minVelocity:{number:ip},solver:{string:["barnesHut","repulsion","hierarchicalRepulsion","forceAtlas2Based"]},stabilization:{enabled:{boolean:ep},iterations:{number:ip},updateInterval:{number:ip},onlyDynamicEdges:{boolean:ep},fit:{boolean:ep},__type__:{object:np,boolean:ep}},timestep:{number:ip},adaptiveTimestep:{boolean:ep},wind:{x:{number:ip},y:{number:ip},__type__:{object:np}},__type__:{object:np,boolean:ep}},autoResize:{boolean:ep},clickToUse:{boolean:ep},locale:{string:tp},locales:{__any__:{any:"any"},__type__:{object:np}},height:{string:tp},width:{string:tp},__type__:{object:np}};rp.groups.__any__=rp.nodes,rp.manipulation.controlNodeStyle=rp.nodes;var sp={nodes:{borderWidth:[1,0,10,1],borderWidthSelected:[2,0,10,1],color:{border:["color","#2B7CE9"],background:["color","#97C2FC"],highlight:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]},hover:{border:["color","#2B7CE9"],background:["color","#D2E5FF"]}},opacity:[0,0,1,.1],fixed:{x:!1,y:!1},font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[0,0,50,1],strokeColor:["color","#ffffff"]},hidden:!1,labelHighlightBold:!0,physics:!0,scaling:{min:[10,0,200,1],max:[30,0,200,1],label:{enabled:!1,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},shape:["ellipse","box","circle","database","diamond","dot","square","star","text","triangle","triangleDown","hexagon"],shapeProperties:{borderDashes:!1,borderRadius:[6,0,20,1],interpolation:!0,useImageSize:!1},size:[25,0,200,1]},edges:{arrows:{to:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},middle:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"},from:{enabled:!1,scaleFactor:[1,0,3,.05],type:"arrow"}},arrowStrikethrough:!0,color:{color:["color","#848484"],highlight:["color","#848484"],hover:["color","#848484"],inherit:["from","to","both",!0,!1],opacity:[1,0,1,.05]},dashes:!1,font:{color:["color","#343434"],size:[14,0,100,1],face:["arial","verdana","tahoma"],background:["color","none"],strokeWidth:[2,0,50,1],strokeColor:["color","#ffffff"],align:["horizontal","top","middle","bottom"]},hidden:!1,hoverWidth:[1.5,0,5,.1],labelHighlightBold:!0,physics:!0,scaling:{min:[1,0,100,1],max:[15,0,100,1],label:{enabled:!0,min:[14,0,200,1],max:[30,0,200,1],maxVisible:[30,0,200,1],drawThreshold:[5,0,20,1]}},selectionWidth:[1.5,0,5,.1],selfReferenceSize:[20,0,200,1],selfReference:{size:[20,0,200,1],angle:[Math.PI/2,-6*Math.PI,6*Math.PI,Math.PI/8],renderBehindTheNode:!0},shadow:{enabled:!1,color:"rgba(0,0,0,0.5)",size:[10,0,20,1],x:[5,-30,30,1],y:[5,-30,30,1]},smooth:{enabled:!0,type:["dynamic","continuous","discrete","diagonalCross","straightCross","horizontal","vertical","curvedCW","curvedCCW","cubicBezier"],forceDirection:["horizontal","vertical","none"],roundness:[.5,0,1,.05]},width:[1,0,30,1]},layout:{hierarchical:{enabled:!1,levelSeparation:[150,20,500,5],nodeSpacing:[100,20,500,5],treeSpacing:[200,20,500,5],blockShifting:!0,edgeMinimization:!0,parentCentralization:!0,direction:["UD","DU","LR","RL"],sortMethod:["hubsize","directed"],shakeTowards:["leaves","roots"]}},interaction:{dragNodes:!0,dragView:!0,hideEdgesOnDrag:!1,hideEdgesOnZoom:!1,hideNodesOnDrag:!1,hover:!1,keyboard:{enabled:!1,speed:{x:[10,0,40,1],y:[10,0,40,1],zoom:[.02,0,.1,.005]},bindToWindow:!0},multiselect:!1,navigationButtons:!1,selectable:!0,selectConnectedEdges:!0,hoverConnectedEdges:!0,tooltipDelay:[300,0,1e3,25],zoomView:!0,zoomSpeed:[1,.1,2,.1]},manipulation:{enabled:!1,initiallyActive:!1},physics:{enabled:!0,barnesHut:{theta:[.5,.1,1,.05],gravitationalConstant:[-2e3,-3e4,0,50],centralGravity:[.3,0,10,.05],springLength:[95,0,500,5],springConstant:[.04,0,1.2,.005],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},forceAtlas2Based:{theta:[.5,.1,1,.05],gravitationalConstant:[-50,-500,0,1],centralGravity:[.01,0,1,.005],springLength:[95,0,500,5],springConstant:[.08,0,1.2,.005],damping:[.4,0,1,.01],avoidOverlap:[0,0,1,.01]},repulsion:{centralGravity:[.2,0,10,.05],springLength:[200,0,500,5],springConstant:[.05,0,1.2,.005],nodeDistance:[100,0,500,5],damping:[.09,0,1,.01]},hierarchicalRepulsion:{centralGravity:[.2,0,10,.05],springLength:[100,0,500,5],springConstant:[.01,0,1.2,.005],nodeDistance:[120,0,500,5],damping:[.09,0,1,.01],avoidOverlap:[0,0,1,.01]},maxVelocity:[50,0,150,1],minVelocity:[.1,.01,.5,.01],solver:["barnesHut","forceAtlas2Based","repulsion","hierarchicalRepulsion"],timestep:[.5,.01,1,.01],wind:{x:[0,-10,10,.1],y:[0,-10,10,.1]}}},ap=Object.freeze({__proto__:null,allOptions:rp,configureOptions:sp}),hp=function(){function t(){Kh(this,t)}return Qh(t,[{key:"getDistances",value:function(t,e,i){for(var n={},o=t.edges,r=0;r<e.length;r++){var s={};n[e[r]]=s;for(var a=0;a<e.length;a++)s[e[a]]=r==a?0:1e9}for(var h=0;h<i.length;h++){var l=o[i[h]];!0===l.connected&&void 0!==n[l.fromId]&&void 0!==n[l.toId]&&(n[l.fromId][l.toId]=1,n[l.toId][l.fromId]=1)}for(var d=e.length,u=0;u<d;u++)for(var c=e[u],f=n[c],p=0;p<d-1;p++)for(var v=e[p],g=n[v],y=p+1;y<d;y++){var m=e[y],b=n[m],w=Math.min(g[m],g[c]+f[m]);g[m]=w,b[v]=w}return n}}]),t}(),lp=function(){function t(e,i,n){Kh(this,t),this.body=e,this.springLength=i,this.springConstant=n,this.distanceSolver=new hp}return Qh(t,[{key:"setOptions",value:function(t){t&&(t.springLength&&(this.springLength=t.springLength),t.springConstant&&(this.springConstant=t.springConstant))}},{key:"solve",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=this.distanceSolver.getDistances(this.body,t,e);this._createL_matrix(n),this._createK_matrix(n),this._createE_matrix();for(var o=.01,r=1,s=0,a=Math.max(1e3,Math.min(10*this.body.nodeIndices.length,6e3)),h=5,l=1e9,d=0,u=0,c=0,f=0,p=0;l>o&&s<a;){s+=1;var v=this._getHighestEnergyNode(i),g=vr(v,4);for(d=g[0],l=g[1],u=g[2],c=g[3],f=l,p=0;f>r&&p<h;){p+=1,this._moveNode(d,u,c);var y=this._getEnergy(d),m=vr(y,3);f=m[0],u=m[1],c=m[2]}}}},{key:"_getHighestEnergyNode",value:function(t){for(var e=this.body.nodeIndices,i=this.body.nodes,n=0,o=e[0],r=0,s=0,a=0;a<e.length;a++){var h=e[a];if(!1===i[h].predefinedPosition||!0===i[h].isCluster&&!0===t||!0===i[h].options.fixed.x||!0===i[h].options.fixed.y){var l=this._getEnergy(h),d=vr(l,3),u=d[0],c=d[1],f=d[2];n<u&&(n=u,o=h,r=c,s=f)}}return[o,n,r,s]}},{key:"_getEnergy",value:function(t){var e=vr(this.E_sums[t],2),i=e[0],n=e[1];return[Math.sqrt(Math.pow(i,2)+Math.pow(n,2)),i,n]}},{key:"_moveNode",value:function(t,e,i){for(var n=this.body.nodeIndices,o=this.body.nodes,r=0,s=0,a=0,h=o[t].x,l=o[t].y,d=this.K_matrix[t],u=this.L_matrix[t],c=0;c<n.length;c++){var f=n[c];if(f!==t){var p=o[f].x,v=o[f].y,g=d[f],y=u[f],m=1/Math.pow(Math.pow(h-p,2)+Math.pow(l-v,2),1.5);r+=g*(1-y*Math.pow(l-v,2)*m),s+=g*(y*(h-p)*(l-v)*m),a+=g*(1-y*Math.pow(h-p,2)*m)}}var b=(e/r+i/s)/(s/r-a/s),w=-(s*b+e)/r;o[t].x+=w,o[t].y+=b,this._updateE_matrix(t)}},{key:"_createL_matrix",value:function(t){var e=this.body.nodeIndices,i=this.springLength;this.L_matrix=[];for(var n=0;n<e.length;n++){this.L_matrix[e[n]]={};for(var o=0;o<e.length;o++)this.L_matrix[e[n]][e[o]]=i*t[e[n]][e[o]]}}},{key:"_createK_matrix",value:function(t){var e=this.body.nodeIndices,i=this.springConstant;this.K_matrix=[];for(var n=0;n<e.length;n++){this.K_matrix[e[n]]={};for(var o=0;o<e.length;o++)this.K_matrix[e[n]][e[o]]=i*Math.pow(t[e[n]][e[o]],-2)}}},{key:"_createE_matrix",value:function(){var t=this.body.nodeIndices,e=this.body.nodes;this.E_matrix={},this.E_sums={};for(var i=0;i<t.length;i++)this.E_matrix[t[i]]=[];for(var n=0;n<t.length;n++){for(var o=t[n],r=e[o].x,s=e[o].y,a=0,h=0,l=n;l<t.length;l++){var d=t[l];if(d!==o){var u=e[d].x,c=e[d].y,f=1/Math.sqrt(Math.pow(r-u,2)+Math.pow(s-c,2));this.E_matrix[o][l]=[this.K_matrix[o][d]*(r-u-this.L_matrix[o][d]*(r-u)*f),this.K_matrix[o][d]*(s-c-this.L_matrix[o][d]*(s-c)*f)],this.E_matrix[d][n]=this.E_matrix[o][l],a+=this.E_matrix[o][l][0],h+=this.E_matrix[o][l][1]}}this.E_sums[o]=[a,h]}}},{key:"_updateE_matrix",value:function(t){for(var e=this.body.nodeIndices,i=this.body.nodes,n=this.E_matrix[t],o=this.K_matrix[t],r=this.L_matrix[t],s=i[t].x,a=i[t].y,h=0,l=0,d=0;d<e.length;d++){var u=e[d];if(u!==t){var c=n[d],f=c[0],p=c[1],v=i[u].x,g=i[u].y,y=1/Math.sqrt(Math.pow(s-v,2)+Math.pow(a-g,2)),m=o[u]*(s-v-r[u]*(s-v)*y),b=o[u]*(a-g-r[u]*(a-g)*y);n[d]=[m,b],h+=m,l+=b;var w=this.E_sums[u];w[0]+=m-f,w[1]+=b-p}}this.E_sums[t]=[h,l]}}]),t}();function dp(t,e,i){var n,o,r,s,a=this;if(!(this instanceof dp))throw new SyntaxError("Constructor must be called with the new operator");this.options={},this.defaultOptions={locale:"en",locales:$h,clickToUse:!1},Fr(this.options,this.defaultOptions),this.body={container:t,nodes:{},nodeIndices:[],edges:{},edgeIndices:[],emitter:{on:J(n=this.on).call(n,this),off:J(o=this.off).call(o,this),emit:J(r=this.emit).call(r,this),once:J(s=this.once).call(s,this)},eventListeners:{onTap:function(){},onTouch:function(){},onDoubleTap:function(){},onHold:function(){},onDragStart:function(){},onDrag:function(){},onDragEnd:function(){},onMouseWheel:function(){},onPinch:function(){},onMouseMove:function(){},onRelease:function(){},onContext:function(){}},data:{nodes:null,edges:null},functions:{createNode:function(){},createEdge:function(){},getPointer:function(){}},modules:{},view:{scale:1,translation:{x:0,y:0}}},this.bindEventListeners(),this.images=new tl((function(){return a.body.emitter.emit("_requestRedraw")})),this.groups=new el,this.canvas=new Sf(this.body),this.selectionHandler=new Tf(this.body,this.canvas),this.interactionHandler=new Cf(this.body,this.canvas,this.selectionHandler),this.view=new Ef(this.body,this.canvas),this.renderer=new kf(this.body,this.canvas),this.physics=new cf(this.body),this.layoutEngine=new $f(this.body),this.clustering=new _f(this.body),this.manipulation=new Kf(this.body,this.canvas,this.selectionHandler,this.interactionHandler),this.nodesHandler=new cc(this.body,this.images,this.groups,this.layoutEngine),this.edgesHandler=new tf(this.body,this.images,this.groups),this.body.modules.kamadaKawai=new lp(this.body,150,.05),this.body.modules.clustering=this.clustering,this.canvas._create(),this.setOptions(i),this.setData(e)}st(dp.prototype),dp.prototype.setOptions=function(t){var e=this;if(null===t&&(t=void 0),void 0!==t){!0===sc.validate(t,rp)&&console.log("%cErrors have been found in the supplied options object.",rc);if(jr(["locale","locales","clickToUse"],this.options,t),void 0!==t.locale&&(t.locale=function(t,e){try{var i=e.split(/[-_ \/]/,2),n=vr(i,2),o=n[0],r=n[1],s=null!=o?o.toLowerCase():null,a=null!=r?r.toUpperCase():null;if(s&&a){var h,l=s+"-"+a;if(Object.prototype.hasOwnProperty.call(t,l))return l;console.warn(Oo(h="Unknown variant ".concat(a," of language ")).call(h,s,"."))}if(s){var d=s;if(Object.prototype.hasOwnProperty.call(t,d))return d;console.warn("Unknown language ".concat(s))}return console.warn("Unknown locale ".concat(e,", falling back to English.")),"en"}catch(t){return console.error(t),console.warn("Unexpected error while normalizing locale ".concat(e,", falling back to English.")),"en"}}(t.locales||this.options.locales,t.locale)),t=this.layoutEngine.setOptions(t.layout,t),this.canvas.setOptions(t),this.groups.setOptions(t.groups),this.nodesHandler.setOptions(t.nodes),this.edgesHandler.setOptions(t.edges),this.physics.setOptions(t.physics),this.manipulation.setOptions(t.manipulation,t,this.options),this.interactionHandler.setOptions(t.interaction),this.renderer.setOptions(t.interaction),this.selectionHandler.setOptions(t.interaction),void 0!==t.groups&&this.body.emitter.emit("refreshNodes"),"configure"in t&&(this.configurator||(this.configurator=new Jf(this,this.body.container,sp,this.canvas.pixelRatio)),this.configurator.setOptions(t.configure)),this.configurator&&!0===this.configurator.options.enabled){var i={nodes:{},edges:{},layout:{},interaction:{},manipulation:{},physics:{},global:{}};Br(i.nodes,this.nodesHandler.options),Br(i.edges,this.edgesHandler.options),Br(i.layout,this.layoutEngine.options),Br(i.interaction,this.selectionHandler.options),Br(i.interaction,this.renderer.options),Br(i.interaction,this.interactionHandler.options),Br(i.manipulation,this.manipulation.options),Br(i.physics,this.physics.options),Br(i.global,this.canvas.options),Br(i.global,this.options),this.configurator.setModuleOptions(i)}void 0!==t.clickToUse?!0===t.clickToUse?void 0===this.activator&&(this.activator=new Xh(this.canvas.frame),this.activator.on("change",(function(){e.body.emitter.emit("activate")}))):(void 0!==this.activator&&(this.activator.destroy(),delete this.activator),this.body.emitter.emit("activate")):this.body.emitter.emit("activate"),this.canvas.setSize(),this.body.emitter.emit("startSimulation")}},dp.prototype._updateVisibleIndices=function(){var t=this.body.nodes,e=this.body.edges;for(var i in this.body.nodeIndices=[],this.body.edgeIndices=[],t)t.hasOwnProperty(i)&&(this.clustering._isClusteredNode(i)||!1!==t[i].options.hidden||this.body.nodeIndices.push(t[i].id));for(var n in e)if(e.hasOwnProperty(n)){var o=e[n],r=t[o.fromId],s=t[o.toId],a=void 0!==r&&void 0!==s;!this.clustering._isClusteredEdge(n)&&!1===o.options.hidden&&a&&!1===r.options.hidden&&!1===s.options.hidden&&this.body.edgeIndices.push(o.id)}},dp.prototype.bindEventListeners=function(){var t=this;this.body.emitter.on("_dataChanged",(function(){t.edgesHandler._updateState(),t.body.emitter.emit("_dataUpdated")})),this.body.emitter.on("_dataUpdated",(function(){t.clustering._updateState(),t._updateVisibleIndices(),t._updateValueRange(t.body.nodes),t._updateValueRange(t.body.edges),t.body.emitter.emit("startSimulation"),t.body.emitter.emit("_requestRedraw")}))},dp.prototype.setData=function(t){if(this.body.emitter.emit("resetPhysics"),this.body.emitter.emit("_resetData"),this.selectionHandler.unselectAll(),t&&t.dot&&(t.nodes||t.edges))throw new SyntaxError('Data must contain either parameter "dot" or  parameter pair "nodes" and "edges", but not both.');if(this.setOptions(t&&t.options),t&&t.dot){console.log("The dot property has been deprecated. Please use the static convertDot method to convert DOT into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertDot(dotString);");var e=da.DOTToGraph(t.dot);this.setData(e)}else if(t&&t.gephi){console.log("The gephi property has been deprecated. Please use the static convertGephi method to convert gephi into vis.network format and use the normal data format with nodes and edges. This converter is used like this: var data = vis.network.convertGephi(gephiJson);");var i=ca(t.gephi);this.setData(i)}else this.nodesHandler.setData(t&&t.nodes,!0),this.edgesHandler.setData(t&&t.edges,!0),this.body.emitter.emit("_dataChanged"),this.body.emitter.emit("_dataLoaded"),this.body.emitter.emit("initPhysics")},dp.prototype.destroy=function(){for(var t in this.body.emitter.emit("destroy"),this.body.emitter.off(),this.off(),delete this.groups,delete this.canvas,delete this.selectionHandler,delete this.interactionHandler,delete this.view,delete this.renderer,delete this.physics,delete this.layoutEngine,delete this.clustering,delete this.manipulation,delete this.nodesHandler,delete this.edgesHandler,delete this.configurator,delete this.images,this.body.nodes)this.body.nodes.hasOwnProperty(t)&&delete this.body.nodes[t];for(var e in this.body.edges)this.body.edges.hasOwnProperty(e)&&delete this.body.edges[e];Tr(this.body.container)},dp.prototype._updateValueRange=function(t){var e,i=void 0,n=void 0,o=0;for(e in t)if(t.hasOwnProperty(e)){var r=t[e].getValue();void 0!==r&&(i=void 0===i?r:Math.min(r,i),n=void 0===n?r:Math.max(r,n),o+=r)}if(void 0!==i&&void 0!==n)for(e in t)t.hasOwnProperty(e)&&t[e].setValueRange(i,n,o)},dp.prototype.isActive=function(){return!this.activator||this.activator.active},dp.prototype.setSize=function(){return this.canvas.setSize.apply(this.canvas,arguments)},dp.prototype.canvasToDOM=function(){return this.canvas.canvasToDOM.apply(this.canvas,arguments)},dp.prototype.DOMtoCanvas=function(){return this.canvas.DOMtoCanvas.apply(this.canvas,arguments)},dp.prototype.findNode=function(){return this.clustering.findNode.apply(this.clustering,arguments)},dp.prototype.isCluster=function(){return this.clustering.isCluster.apply(this.clustering,arguments)},dp.prototype.openCluster=function(){return this.clustering.openCluster.apply(this.clustering,arguments)},dp.prototype.cluster=function(){return this.clustering.cluster.apply(this.clustering,arguments)},dp.prototype.getNodesInCluster=function(){return this.clustering.getNodesInCluster.apply(this.clustering,arguments)},dp.prototype.clusterByConnection=function(){return this.clustering.clusterByConnection.apply(this.clustering,arguments)},dp.prototype.clusterByHubsize=function(){return this.clustering.clusterByHubsize.apply(this.clustering,arguments)},dp.prototype.updateClusteredNode=function(){return this.clustering.updateClusteredNode.apply(this.clustering,arguments)},dp.prototype.getClusteredEdges=function(){return this.clustering.getClusteredEdges.apply(this.clustering,arguments)},dp.prototype.getBaseEdge=function(){return this.clustering.getBaseEdge.apply(this.clustering,arguments)},dp.prototype.getBaseEdges=function(){return this.clustering.getBaseEdges.apply(this.clustering,arguments)},dp.prototype.updateEdge=function(){return this.clustering.updateEdge.apply(this.clustering,arguments)},dp.prototype.clusterOutliers=function(){return this.clustering.clusterOutliers.apply(this.clustering,arguments)},dp.prototype.getSeed=function(){return this.layoutEngine.getSeed.apply(this.layoutEngine,arguments)},dp.prototype.enableEditMode=function(){return this.manipulation.enableEditMode.apply(this.manipulation,arguments)},dp.prototype.disableEditMode=function(){return this.manipulation.disableEditMode.apply(this.manipulation,arguments)},dp.prototype.addNodeMode=function(){return this.manipulation.addNodeMode.apply(this.manipulation,arguments)},dp.prototype.editNode=function(){return this.manipulation.editNode.apply(this.manipulation,arguments)},dp.prototype.editNodeMode=function(){return console.log("Deprecated: Please use editNode instead of editNodeMode."),this.manipulation.editNode.apply(this.manipulation,arguments)},dp.prototype.addEdgeMode=function(){return this.manipulation.addEdgeMode.apply(this.manipulation,arguments)},dp.prototype.editEdgeMode=function(){return this.manipulation.editEdgeMode.apply(this.manipulation,arguments)},dp.prototype.deleteSelected=function(){return this.manipulation.deleteSelected.apply(this.manipulation,arguments)},dp.prototype.getPositions=function(){return this.nodesHandler.getPositions.apply(this.nodesHandler,arguments)},dp.prototype.getPosition=function(){return this.nodesHandler.getPosition.apply(this.nodesHandler,arguments)},dp.prototype.storePositions=function(){return this.nodesHandler.storePositions.apply(this.nodesHandler,arguments)},dp.prototype.moveNode=function(){return this.nodesHandler.moveNode.apply(this.nodesHandler,arguments)},dp.prototype.getBoundingBox=function(){return this.nodesHandler.getBoundingBox.apply(this.nodesHandler,arguments)},dp.prototype.getConnectedNodes=function(t){return void 0!==this.body.nodes[t]?this.nodesHandler.getConnectedNodes.apply(this.nodesHandler,arguments):this.edgesHandler.getConnectedNodes.apply(this.edgesHandler,arguments)},dp.prototype.getConnectedEdges=function(){return this.nodesHandler.getConnectedEdges.apply(this.nodesHandler,arguments)},dp.prototype.startSimulation=function(){return this.physics.startSimulation.apply(this.physics,arguments)},dp.prototype.stopSimulation=function(){return this.physics.stopSimulation.apply(this.physics,arguments)},dp.prototype.stabilize=function(){return this.physics.stabilize.apply(this.physics,arguments)},dp.prototype.getSelection=function(){return this.selectionHandler.getSelection.apply(this.selectionHandler,arguments)},dp.prototype.setSelection=function(){return this.selectionHandler.setSelection.apply(this.selectionHandler,arguments)},dp.prototype.getSelectedNodes=function(){return this.selectionHandler.getSelectedNodes.apply(this.selectionHandler,arguments)},dp.prototype.getSelectedEdges=function(){return this.selectionHandler.getSelectedEdges.apply(this.selectionHandler,arguments)},dp.prototype.getNodeAt=function(){var t=this.selectionHandler.getNodeAt.apply(this.selectionHandler,arguments);return void 0!==t&&void 0!==t.id?t.id:t},dp.prototype.getEdgeAt=function(){var t=this.selectionHandler.getEdgeAt.apply(this.selectionHandler,arguments);return void 0!==t&&void 0!==t.id?t.id:t},dp.prototype.selectNodes=function(){return this.selectionHandler.selectNodes.apply(this.selectionHandler,arguments)},dp.prototype.selectEdges=function(){return this.selectionHandler.selectEdges.apply(this.selectionHandler,arguments)},dp.prototype.unselectAll=function(){this.selectionHandler.unselectAll.apply(this.selectionHandler,arguments),this.redraw()},dp.prototype.redraw=function(){return this.renderer.redraw.apply(this.renderer,arguments)},dp.prototype.getScale=function(){return this.view.getScale.apply(this.view,arguments)},dp.prototype.getViewPosition=function(){return this.view.getViewPosition.apply(this.view,arguments)},dp.prototype.fit=function(){return this.view.fit.apply(this.view,arguments)},dp.prototype.moveTo=function(){return this.view.moveTo.apply(this.view,arguments)},dp.prototype.focus=function(){return this.view.focus.apply(this.view,arguments)},dp.prototype.releaseNode=function(){return this.view.releaseNode.apply(this.view,arguments)},dp.prototype.getOptionsFromConfigurator=function(){var t={};return this.configurator&&(t=this.configurator.getOptions.apply(this.configurator)),t};var up=o((function(t,e){e.prepareElements=function(t){for(var e in t)t.hasOwnProperty(e)&&(t[e].redundant=t[e].used,t[e].used=[])},e.cleanupElements=function(t){for(var e in t)if(t.hasOwnProperty(e)&&t[e].redundant){for(var i=0;i<t[e].redundant.length;i++)t[e].redundant[i].parentNode.removeChild(t[e].redundant[i]);t[e].redundant=[]}},e.resetElements=function(t){e.prepareElements(t),e.cleanupElements(t),e.prepareElements(t)},e.getSVGElement=function(t,e,i){var n;return e.hasOwnProperty(t)?e[t].redundant.length>0?(n=e[t].redundant[0],e[t].redundant.shift()):(n=document.createElementNS("http://www.w3.org/2000/svg",t),i.appendChild(n)):(n=document.createElementNS("http://www.w3.org/2000/svg",t),e[t]={used:[],redundant:[]},i.appendChild(n)),e[t].used.push(n),n},e.getDOMElement=function(t,e,i,n){var o;return e.hasOwnProperty(t)?e[t].redundant.length>0?(o=e[t].redundant[0],e[t].redundant.shift()):(o=document.createElement(t),void 0!==n?i.insertBefore(o,n):i.appendChild(o)):(o=document.createElement(t),e[t]={used:[],redundant:[]},void 0!==n?i.insertBefore(o,n):i.appendChild(o)),e[t].used.push(o),o},e.drawPoint=function(t,i,n,o,r,s){var a;if("circle"==n.style?((a=e.getSVGElement("circle",o,r)).setAttributeNS(null,"cx",t),a.setAttributeNS(null,"cy",i),a.setAttributeNS(null,"r",.5*n.size)):((a=e.getSVGElement("rect",o,r)).setAttributeNS(null,"x",t-.5*n.size),a.setAttributeNS(null,"y",i-.5*n.size),a.setAttributeNS(null,"width",n.size),a.setAttributeNS(null,"height",n.size)),void 0!==n.styles&&a.setAttributeNS(null,"style",n.styles),a.setAttributeNS(null,"class",n.className+" vis-point"),s){var h=e.getSVGElement("text",o,r);s.xOffset&&(t+=s.xOffset),s.yOffset&&(i+=s.yOffset),s.content&&(h.textContent=s.content),s.className&&h.setAttributeNS(null,"class",s.className+" vis-label"),h.setAttributeNS(null,"x",t),h.setAttributeNS(null,"y",i)}return a},e.drawBar=function(t,i,n,o,r,s,a,h){if(0!=o){o<0&&(i-=o*=-1);var l=e.getSVGElement("rect",s,a);l.setAttributeNS(null,"x",t-.5*n),l.setAttributeNS(null,"y",i),l.setAttributeNS(null,"width",n),l.setAttributeNS(null,"height",o),l.setAttributeNS(null,"class",r),h&&l.setAttributeNS(null,"style",h)}}})),cp=up.prepareElements,fp=up.cleanupElements,pp=up.resetElements,vp=up.getSVGElement,gp=up.getDOMElement,yp=up.drawPoint,mp=up.drawBar,bp=Object.freeze({__proto__:null,default:up,__moduleExports:up,prepareElements:cp,cleanupElements:fp,resetElements:pp,getSVGElement:vp,getDOMElement:gp,drawPoint:yp,drawBar:mp}),wp="undefined"!=typeof window&&window.moment||Ld,_p=Object.freeze({__proto__:null,default:wp,__moduleExports:wp}),kp={Images:tl,dotparser:ua,gephiParser:fa,allOptions:ap,convertDot:la,convertGephi:ca},xp=Object.freeze({__proto__:null,network:kp,DOMutil:bp,util:cs,data:nu,moment:_p,Hammer:Uh,keycharm:ga,DataSet:eu,DataView:iu,Queue:Zd,Network:dp});t.DOMutil=bp,t.DataSet=eu,t.DataView=iu,t.Hammer=Uh,t.Network=dp,t.Queue=Zd,t.data=nu,t.default=xp,t.keycharm=ga,t.moment=_p,t.network=kp,t.util=cs,Object.defineProperty(t,"__esModule",{value:!0})}));
//# sourceMappingURL=vis-network.min.js.map
